
 package provide autoscroll 1.0

 namespace eval autoscroll {
     namespace export autoscroll

     bind Autoscroll <Delete> [namespace code [list delete %W]]
     bind Autoscroll <Map> [namespace code [list map %W]]
 }


 proc autoscroll::autoscroll { args } {

     variable grid
     variable needed

     set w [lindex $args 0]
     set j [join [lrange $args 1 end]]

     catch {rename $w [namespace current]::renamed$w}

     proc ::$w {args} "
         return \[eval \[list autoscroll::widgetCommand $w\] \$args\]
     "

     set i [grid info $w]
     if {[string match {} $i]&&$j==""} {
         error "$w is not gridded"
     } elseif {$j!=""} {
       set i $j
     } else {
       #set needed($w) 1
     }
     set grid($w) $i


     bindtags $w [linsert [bindtags $w] 1 Autoscroll]

     eval [list ::$w set] [renamed$w get]

     return
 }


 proc autoscroll::widgetCommand { w command args } {
     variable grid
     variable needed

     if {$args=="" && $command != "get"} {set args "0 0"}

     switch -exact -- $command {
         set {
             foreach { min max } $args {}
             if {$min==0 &&$max==0} {return}
             if { $min <= 0 && $max >= 1 } {
                     grid forget $w
             } else {                     
                     eval grid $w $grid($w)
             }
         }
     }

     return [eval [list renamed$w $command] $args]
 }


 proc autoscroll::delete { w } {
     variable grid
     variable needed

     catch { unset grid($w) }
     catch { unset needed($w) }
     catch { rename renamed$w {} }

     return
 }


 proc autoscroll::map { w } {
     wm geometry [winfo toplevel $w] \
             [wm geometry [winfo toplevel $w]]
 }

