proc xbutton {w args} {
    global font GUI
    set a(-background) $GUI(widgets_color)
    set a(-activebackground) [shade $GUI(widgets_color) "#000000" 0.1]
    set a(-font) $font(button)
    array set a [concat {
	-side top -relief raised -borderwidth 2 -command {} -expand 1
    } $args]
    if {[info exists a(-task)]} {
      set task $a(-task)
    } else { 
      set task 0
    }
    frame $w -relief $a(-relief) -borderwidth $a(-borderwidth)
    if [info exists a(-image)] {
	label $w.b -image $a(-image) -bg $a(-background)
    } elseif [info exists a(-bitmap)] {
	label $w.b -bitmap $a(-bitmap) -bg $a(-background)
    }
    if [info exists a(-text)] {
	label $w.t -text $a(-text) -font $a(-font) -bg $a(-background)
        if {[info exists a(-width)]} {$w.t config -width $a(-width)}
    }
    eval pack [winfo children $w] -side $a(-side) -fill both \
	    -expand $a(-expand)
    xbind $w <Enter> "xconfigure %W -bg $a(-activebackground);
    if {!$task} {$w configure -relief raised}; update"
    xbind $w <Leave> "xconfigure %W -bg $a(-background);
    if {!$task} {$w configure -relief $a(-relief)}; update"

    xbind $w <ButtonPress-1> \
	    "$w configure -relief sunken; update; eval [list $a(-command)]"
    if {!$task} {
      xbind $w <ButtonRelease-1> "$w configure -relief raised"
    }
 }

 proc xbind {w event body} {
    if ![llength [winfo children $w]] {set w [winfo parent $w]}
    foreach i [concat $w [winfo children $w]] {
	bind $i $event $body
    }
 } 

 proc xconfigure {w args} {
    if ![llength [winfo children $w]] {set w [winfo parent $w]}
    foreach i [concat $w [winfo children $w]] {
	eval $i configure $args
    }
 }
