package require Metawidget

metawidget create Document {
  global GUI wid
  if { ! [ourinfo exists lAllDocs] } {
    our lAllDocs {}          ;# list of all document windows
    our wFocus {}            ;# topmost window (drawn active)
    our wHistory {}
      ourarray set aColors {gray50 gray50 white white darkblue darkblue gray gray}
      ourarray set aCursors {{} {} nw top_left_corner ne top_right_corner sw bottom_left_corner se bottom_right_corner n sb_v_double_arrow s sb_v_double_arrow w sb_h_double_arrow e sb_h_double_arrow}



    our iOffset 16

    icon_vars

  }

  xmenu $this.menu
  $this.menu add command -label Minimize -command "$this set_laststate"
  $this.menu add command -label Maximize -command "$this Arrange maximize"
  $this.menu add separator
  $this.menu add command -label Close -command "$this close_win"

  pack [frame $this.head -border 0] -padx 2 -pady 2 -fill x
  pack [label $this.head.icon -border 0] -side left -padx 1
  pack [label $this.head.clob -border 0 -relief raised -image [our pIconClose]] -side right -pady 2 -padx 1
  pack [label $this.head.maxb -border 0 -relief raised -image [our pIconMax]] -side right -pady 2 -padx 1
  pack [label $this.head.minb -border 0 -relief raised -image [our pIconMin]] -side right -pady 2
  pack [label $this.head.text -border 0 -anchor w] -side left -fill x -expand 1

  bind $this.head.minb <Enter> "$this.head.minb config -image [our pIconMin_over]"
  bind $this.head.minb <Leave> "$this.head.minb config -image [our pIconMin]"

  bind $this.head.clob <Enter> "$this.head.clob config -image [our pIconClose_over]"
  bind $this.head.clob <Leave> "$this.head.clob config -image [our pIconClose]"

  bind $this.head.maxb <Enter> "$this.head.maxb config -image [our pIconMax_over]"
  bind $this.head.maxb <Leave> "$this.head.maxb config -image [our pIconMax]"


  pack [frame $this.work -border 0] -fill both -expand 1 -padx 2

  bind $this.work <Enter> "$this config -cursor {}"
  bind $this.head <Enter> "$this config -cursor {}"

  my -title $this
  my -foreground [our aColors(white)]
  my -background [our aColors(darkblue)]
  catch {my -background $GUI(titlebar)}
  catch {my -foreground $GUI(tforeground)}
  my -font [$this.head.text cget -font]
  my -minsize {100 30}
  my -icontext {}
  my -state "normal"
  my -image {}
  my -laststate "normal"
  my -callback {}
  my -closable 1
  my -active 0
  my -callmenu {}
  my -tooltip {}


   if {$wid(width)!=""} {
     my -width $wid(width)
     my -height $wid(height)
     set wid(width) ""
     set wid(height) ""
   } else {
     my -width  250
     my -height 150
   }

   if {$wid(x)!=""} {
     my iNormX $wid(x)
     my iNormY $wid(y)
     set wid(x) ""
     set wid(y) ""
   } else {
     my iNormX [our iOffset]
     my iNormY [our iOffset]
   }


  bind $this.head.icon <1>        "$this _showMenu"
  bind $this.head.icon <Double-1> "$this.menu invoke Close"
  bind $this.head.icon <Button-2> "$this.menu invoke Close"
  bind $this.head.icon <Button-3> "$this.menu invoke Close"

  bind $this.head.clob <ButtonPress-1>        "$this.head.clob config -image [our pIconClose_pressed]"
  bind $this.head.clob <ButtonRelease-1> "$this.head.clob config -image [our pIconClose];if {%x<[winfo reqwidth $this.head.clob]&&%x>0&&%y<[winfo reqheight $this.head.clob]&&%y>0} {$this.menu invoke Close}"

  our iOffset [expr [our iOffset]+16]
  if { [expr [our iOffset]+300] > [winfo height [winfo parent $this]] } {
    our iOffset 16
  }

  _restore
  if {$GUI(maximized)} {_maximize}
  raise_
  _register

} {
  if { [our wFocus] == $this } {
    our wFocus {}
  }

  _unregister
} -border 2 -relief raised


metawidget proc Document icon_vars {} {
    global GUI
    our pIconMin $GUI(IconMin)
    our pIconMax $GUI(IconMax) 
    our pIconRestore $GUI(IconRestore) 
    our pIconClose $GUI(IconClose)

    CheckEventIcons

    our pIconMin_pressed $GUI(IconMin_pressed)
    our pIconMax_pressed $GUI(IconMax_pressed) 
    our pIconRestore_pressed $GUI(IconRestore_pressed) 
    our pIconClose_pressed $GUI(IconClose_pressed)

    our pIconMin_over $GUI(IconMin_over)
    our pIconMax_over $GUI(IconMax_over) 
    our pIconRestore_over $GUI(IconRestore_over) 
    our pIconClose_over $GUI(IconClose_over)
}

metawidget proc Document _register {} {
  global wid
  our lAllDocs [linsert [our lAllDocs] end $this]
  set wid(winlist) [our lAllDocs]
}

metawidget proc Document _unregister {} {
  global wid
  $this raise_last
  our lAllDocs [mkw.lshrink [our lAllDocs] $this]
  set wid(winlist) [our lAllDocs]
  set w [$this get_win]
  destroy .buttonbar.buttonbar.$w
  UpdateScrollBox
  eval [my -callback]
}

metawidget proc Document _showMenu {} {
  tk_popup $this.menu [winfo rootx $this.head.icon] [expr [winfo height $this.head.icon] + [winfo rooty $this.head.icon]]
}

metawidget proc Document _getEdge { iXp iYp } {
  incr iXp -[winfo rootx $this]
  incr iYp -[winfo rooty $this]

  set iXEdge [expr ([my -width ] < 32)?[my -width ]>>1:16]
  set iYEdge [expr ([my -height] < 32)?[my -height]>>1:16]

  if { $iXp < $iXEdge } {
    set sPosH w
  } elseif { $iXp > [expr [my -width]-$iXEdge] } {
    set sPosH e
  } else {
    set sPosH {}
  }

  if { $iYp < $iYEdge } {
    set sPosV n
  } elseif { $iYp > [expr [my -height]-$iYEdge] } {
    set sPosV s
  } else {
    set sPosV {}
  }

  return $sPosV$sPosH
}

metawidget proc Document _motion { iXp iYp } {
  $this config -cursor [our aCursors([_getEdge $iXp $iYp])]
}

metawidget proc Document _move1 { iXp iYp } {
  raise_

  set wParent [winfo parent $this]
  my iXr1 [winfo rootx $wParent]
  my iYr1 [winfo rooty $wParent]
  my iXr2 [expr [my iXr1]+[winfo width  $wParent]]
  my iYr2 [expr [my iYr1]+[winfo height $wParent]]

  my iXp0 $iXp
  my iYp0 $iYp
}

metawidget proc Document _move2 { iXp iYp } {
 catch {
  if { $iXp < [my iXr1] } { set iXp [my iXr1] }
 }
 catch {
  if { $iYp < [my iYr1] } { set iYp [my iYr1] }
 }
 catch {
  if { $iXp > [my iXr2] } { set iXp [my iXr2] }
 }
 catch {
  if { $iYp > [my iYr2] } { set iYp [my iYr2] }
 }
 catch {
   place $this -x [expr [my -x]-[my iXp0]+$iXp] -y [expr [my -y]-[my iYp0]+$iYp]
 }
}

metawidget proc Document _move3 {} {
  my -x [winfo x $this]
  my -y [winfo y $this]
}

metawidget proc Document _resize1 { iXp iYp } {
  raise_

  my iWMin [lindex [my -minsize] 0]
  my iHMin [lindex [my -minsize] 1]

  my iXMax [expr [my -x]+[my -width] -[my iWMin]]
  my iYMax [expr [my -y]+[my -height]-[my iHMin]]

  my iXp0 $iXp
  my iYp0 $iYp

  set sPos [_getEdge $iXp $iYp]
  set sXPos {}; regexp {[we]} $sPos sXPos; my sXPos $sXPos
  set sYPos {}; regexp {[ns]} $sPos sYPos; my sYPos $sYPos
}

metawidget proc Document _resize2 { iXp iYp } {
  if { ! [myinfo exists sXPos] } {
    return
  }

  if { [my sXPos] == "w" } {
    set iX [expr [my -x]-[my iXp0]+$iXp]
    if { $iX > [my iXMax] } { set iX [my iXMax] }

    set iW [expr [my -width]+[my iXp0]-$iXp]
    if { $iW < [my iWMin] } { set iW [my iWMin] }

    place $this -x $iX -width $iW
  } elseif { [my sXPos] == "e" } {
    set iW [expr [my -width]-[my iXp0]+$iXp]
    if { $iW < [my iWMin] } { set iW [my iWMin] }

    place $this -width $iW
  }

  if { [my sYPos] == "n" } {
    set iY [expr [my -y]-[my iYp0]+$iYp]
    if { $iY > [my iYMax] } { set iY [my iYMax] }

    set iH [expr [my -height]+[my iYp0]-$iYp]
    if { $iH < [my iHMin] } { set iH [my iHMin] }

    place $this -y $iY -height $iH
  } elseif { [my sYPos] == "s" } {
    set iH [expr [my -height]-[my iYp0]+$iYp]
    if { $iH < [my iHMin] } { set iH [my iHMin] }

    place $this -height $iH
  }


}

metawidget proc Document _resize3 {} {
  global wid
  my -x      [winfo x      $this]
  my -y      [winfo y      $this]
  my -width  [winfo width  $this]
  my -height [winfo height $this]
  if {$this==$wid(status)} {$wid(status,tab) invoke [$wid(status,tab) get active]}
}

metawidget proc Document _withdraw {} {
  global wid
  place forget $this
  my -state withdrawn
  catch {.buttonbar.buttonbar.[$this get_win] configure -relief raised}
  $wid(status) raise_last

}



metawidget proc Document _minimize {} {
  if { [my -state] == "normal" } {
    my iNormX [my -x]
    my iNormY [my -y]
  } else {
    _restore
  }

  if { [myinfo exists iIconX] } {
    my -x [my iIconX]
    my -y [my iIconY]
  } else {
    my -x [my iNormX]
    my -y [my iNormY]
  }

  pack forget $this.work
  $this.head.minb configure -image [our pIconRestore]
  $this.menu entryconf Minimize -state disabled

  if { [my -icontext] != {} } {
    $this.head.text configure -text [my -icontext]
  }

  place $this -x [my -x] -y [my -y] -width 128 -height [expr [winfo reqheight $this.head] + 8] -relwidth 0 -relheight 0

  bind $this <1> {}
  bind $this <B1-Motion> {}
  bind $this <ButtonRelease-1> {}

  bind $this <Motion> {}

  bind $this.head.text <Double-1> "$this _restore"
  bind $this.head.minb <1> "$this _restore"

  my -state minimized
}


metawidget proc Document _maximize {} {
  if { [my -state] == "normal" } {
    my iNormX [my -x]
    my iNormY [my -y]
  } else {
    _restore
  }

  place $this -x 0 -y 0 -width 0 -height 0 -relwidth 1 -relheight 1
  $this.head.maxb configure -image [our pIconRestore]
  $this.menu entryconf Maximize -state disabled
  $this configure -border 0

  bind $this <1> {}
  bind $this <B1-Motion> {}
  bind $this <ButtonRelease-1> {}

  bind $this.head.text <1> "$this raise"
  bind $this.head.text <B1-Motion> {}
  bind $this.head.text <ButtonRelease-1> {}

  bind $this <Motion> {}

  bind $this.head.text <Double-1> "$this restore_all"


  bind $this.head.maxb <Enter> "$this.head.maxb config -image [our pIconRestore_over]"
  bind $this.head.maxb <Leave> "$this.head.maxb config -image [our pIconRestore]"

  bind $this.head.maxb <ButtonPress-1>        "$this.head.maxb config -image [our pIconRestore_pressed]"
  bind $this.head.maxb <ButtonRelease-1> "$this.head.maxb config -image [our pIconRestore];if {%x<[winfo reqwidth $this.head.maxb]&&%x>0&&%y<[winfo reqheight $this.head.maxb]&&%y>0} {$this restore_all}"

  my -state maximized

}


metawidget proc Document _restore {} {
  global wid
  if { [my -state] == "minimized" } {
    my iIconX [my -x]
    my iIconY [my -y]
  }

  my -x [my iNormX]
  my -y [my iNormY]

  pack  $this.work -fill both -expand 1 -padx 2 -pady 2
  place $this -x [my -x] -y [my -y] -width [my -width] -height [my -height] -relwidth 0 -relheight 0

  $this.head.minb configure -image [our pIconMin]
  $this.head.maxb configure -image [our pIconMax]
  bind $this.head.maxb <Enter> "$this.head.maxb config -image [our pIconMax_over]"
  bind $this.head.maxb <Leave> "$this.head.maxb config -image [our pIconMax]"


  $this.head.text configure -text [my -title]
  $this.menu entryconf Minimize -state normal
  $this.menu entryconf Maximize -state normal
  ::${this}::$this config -border 2

  bind $this <1>               "$this _resize1 %X %Y"
  bind $this <B1-Motion>       "$this _resize2 %X %Y"
  bind $this <ButtonRelease-1> "$this _resize3"

  bind $this.head.text <1>               "$this _move1 %X %Y"
  bind $this.head.text <B1-Motion>       "$this _move2 %X %Y"
  bind $this.head.text <ButtonRelease-1> "$this _move3"


  bind $this.head.maxb <ButtonPress-1>        "$this.head.maxb config -image [our pIconMax_pressed]"
  bind $this.head.maxb <ButtonRelease-1> "$this.head.maxb config -image [our pIconMax];if {%x<[winfo reqwidth $this.head.maxb]&&%x>0&&%y<[winfo reqheight $this.head.maxb]&&%y>0} {$this Arrange maximize}"


  bind $this.head.minb <ButtonPress-1>        "$this.head.minb config -image [our pIconMin_pressed]"
  bind $this.head.minb <ButtonRelease-1> "$this.head.minb config -image [our pIconMin];if {%x<[winfo reqwidth $this.head.minb]&&%x>0&&%y<[winfo reqheight $this.head.minb]&&%y>0} {$this set_laststate}"
  bind $this.head.text <Double-1> "$this Arrange maximize"

  bind $this <Motion> "$this _motion %X %Y"
  my -state normal
  set w [$this get_win]
  if {[info exists wid($w,text)]} {
    after 300 "Scroll_Text $w $wid($w,text)"
  }
}



metawidget proc Document -callmenu { menu } {
  my -callmenu $menu
}

metawidget proc Document -laststate { state } {
  my -laststate $state
}

metawidget proc Document -tooltip { tip } {
  my -tooltip [Reverse $tip]
}


metawidget proc Document -x { iX } {
  my -x $iX
  place $this -x [my -x]
}
metawidget proc Document -y { iY } {
  my -y $iY
  place $this -y [my -y]
}
metawidget proc Document -width { iWidth } {
  my -width $iWidth

  if { [my -state] == "normal" } {
    place $this -width [my -width]
  }
}
metawidget proc Document -height { iHeight } {
  my -height $iHeight

  if { [my -state] == "normal" } {
    place $this -height [my -height]
  }
}

metawidget proc Document -closable { b } {
   my -closable $b

}

metawidget proc Document -active { b } {
   my -active $b
}

metawidget proc Document -callback { sCallback } {
  my -callback $sCallback
}

metawidget proc Document -font { sFont } {
  my -font $sFont
  $this.head.text configure -font $sFont
}

metawidget proc Document -image { sImage } {
  my -image $sImage
  $this.head.icon configure -image $sImage
  $this addbutton
  if {[my -callmenu]!=""} {
   [my -callmenu] $this.menu [$this get_win]
  }
}

metawidget proc Document -title { sTitle } {
  my -title $sTitle
  $this.head.text configure -text $sTitle
}

metawidget proc Document -background { sColor } {
  my -background $sColor
  $this.head configure -background $sColor
}

metawidget proc Document -state { sState } {
  global wid
  switch -- [mkw.complete $sState {normal minimized maximized withdrawn}] {
    normal    { _restore  }
    minimized { _minimize }
    maximized { _maximize }
    withdrawn { _withdraw }
  }
}

metawidget proc Document menu_ { args } {
  eval $this.menu $args
}

metawidget proc Document lower_ {} {
  $this.head configure -bg [our aColors(gray50)]
  $this.head.icon configure -bg [our aColors(gray50)]
  $this.head.text configure -bg [our aColors(gray50)] -fg [our aColors(gray)]
}

metawidget proc Document raise_ {} {
  global me active wid
  variable wHistory
  if {$this==[our wFocus]} return
  catch {
     [our wFocus] lower
     .buttonbar.buttonbar.[[our wFocus] get_win] config -relief raised
  }
  our wFocus $this

  $this.head configure -bg [my -background]
  $this.head.icon configure -bg [my -background]
  $this.head.text configure -bg [my -background] -fg [my -foreground]
  lappend wHistory $this
  set wHistory [lrange $wHistory end-20 end]
  set w [$this get_win]
  switch -glob $w {
     "status" {
       set active($me(id)) $w
       IfNotColorButton $w
       set active(status) 1
     }

     "canale*-*" {
       RaiseWin $w
     }

     "query*-*" {
       RaiseWin $w
     }

     "chat*-*" {
       RaiseWin $w
     }

     "default" {
     }
  }
  raise $this
  if {[info exists wid($w,text)]} {focus $wid($w,command)}
  catch {.buttonbar.buttonbar.$w config -relief sunken}
}

metawidget proc Document pack_ { sWindow args } {
  eval pack $sWindow -in $this.work $args

  if { [winfo parent $sWindow] == $this } {
    bind $sWindow <Enter> "+$this config -cursor {}"
  }
}

metawidget proc Document grid_ { sWindow args } {
  eval grid $sWindow -in $this.work $args

  if { [winfo parent $sWindow] == $this } {
    bind $sWindow <Enter> "+$this config -cursor {}"
  }
}

metawidget proc Document place_ { sWindow args } {
  eval place $sWindow -in $this.work $args

  if { [winfo parent $sWindow] == $this } {
    bind $sWindow <Enter> "+$this config -cursor {}"
  }
}


metawidget proc Document wFocus {} {
  variable wFocus
  return [our wFocus] 
}

metawidget proc Document Alldocs {} {
  variable lAllDocs  
  return $lAllDocs 
}


metawidget proc Document Arrange { sHow } {
  variable lAllDocs
  global wid GUI
  set sHow [mkw.complete $sHow {horizontally vertically cascade tile icons maximize minimize}]

  if { ! [info exists lAllDocs] || ! [llength $lAllDocs] } return

  set lDocs {}
  set lIcon {}
  foreach sDoc $lAllDocs {
    if { [$sDoc cget -state] == "minimized" } {
      lappend lIcon $sDoc
    } elseif { [$sDoc cget -state] != "withdrawn" } {
      lappend lDocs $sDoc
    }
  }

  set sParent [winfo parent [lindex $lAllDocs 0]]
  set iW [winfo width  $sParent]
  set iH [winfo height $sParent]

  set iXd 0
  foreach sDoc $lIcon {
    set iWd [winfo width $sDoc]
    if { [expr $iXd+$iWd] > $iW } {
      set iXd 0
    }
    if { $iXd == 0 } {
      incr iH -[winfo height $sDoc]
    }
    $sDoc configure -x $iXd -y $iH
    incr iXd $iWd
  }

  set iDocs [llength $lDocs]
  if { $iDocs == 0 } return

  switch $sHow {
    horizontally {
      set iStep [expr $iH/$iDocs]
      for { set i 0 } { $i < $iDocs } { incr i } {
        set sDoc [lindex $lDocs $i]
        $sDoc configure -x 0 -y [expr $i*$iStep] -width $iW -height $iStep
        if {$sDoc==$wid(status)} { $wid(status,tab) invoke [$wid(status,tab) get active] }
      }
    }

    vertically {
      set iStep [expr $iW/$iDocs]
      for { set i 0 } { $i < $iDocs } { incr i } {
        set sDoc [lindex $lDocs $i]
         $sDoc configure -x [expr $i*$iStep] -y 0 -width $iStep -height $iH
         if {$sDoc==$wid(status)} { $wid(status,tab) invoke [$wid(status,tab) get active] }
      }
    }

    cascade {
      set iStep 24
      for { set i 0 } { $i < $iDocs } { incr i } {
        set sDoc [lindex $lDocs $i]
         set delta [expr $i*$iStep]          
         incr delta 30
         $sDoc configure -x $delta -y $delta -width [expr $iW*2.5/3] -height [expr $iH*2.5/3]
         $sDoc raise
         if {$sDoc==$wid(status)} { $wid(status,tab) invoke [$wid(status,tab) get active] }
      }
    }

    tile {
      for { set i 0 } { $i <= 100 } { incr i } {
        set iHor [expr ($i+3)/2]
        set iVer [expr ($i+2)/2]
        if { [expr $iHor*$iVer] >= $iDocs } break
      }

      set iXStep [expr $iW/$iHor]
      set iYStep [expr $iH/$iVer]
      for { set i 0 } { $i < $iDocs } { incr i } {
         set sDoc [lindex $lDocs $i]
          $sDoc configure -x [expr ($i%$iHor)*$iXStep] -y [expr ($i/$iHor)*$iYStep] -width $iXStep -height $iYStep
          if {$sDoc==$wid(status)} { $wid(status,tab) invoke [$wid(status,tab) get active] }
      }
    }

    maximize {
      foreach sDoc $lAllDocs {
        if {[$sDoc cget -state]!="withdrawn"} {
          $sDoc _maximize
          $sDoc configure -state "maximized"
        }
      }
      $wid(status,tab) invoke [$wid(status,tab) get active]
      set GUI(maximized) 1
      .menubar.win config -state disabled
    }

    minimize {
      foreach sDoc $lDocs {
        $sDoc _minimize
      }
    }
  }
}

metawidget proc Document restore_all {} {
  variable lAllDocs
  global wid GUI
  foreach sDoc $lAllDocs {
    if { [$sDoc cget -state] == "maximized" } {
      $sDoc _restore
      $sDoc configure -state "normal"
      set w [$sDoc get_win]
      if {[info exists wid($w,text)]} {
        $wid($w,text) see end
        focus $wid($w,command)
      }
    }
  }
  $wid(status,tab) invoke [$wid(status,tab) get active]
  set GUI(maximized) 0
  .menubar.win config -state normal
}


metawidget proc Document set_laststate {} {
  global active
  my -laststate [my -state]
  my iNormX [my -x]
  my iNormY [my -y]
  $this configure -state "withdrawn"
  $this raise_last
}


metawidget proc Document raise_last {} {
  variable wHistory
  global me active wid
    set i [llength $wHistory]
    incr i -1
    set raised 0
    while {$i>=0} {
      set current [lindex $wHistory $i]
      if {[winfo exists $current]&&[$current cget -state]!="withdrawn"} {
        $current raise
        set raised 1
        break
      }
      incr i -1
    }

    if {!$raised} {
       foreach slave $wid(winlist) {
          if {![winfo exists $slave]} {continue}
          if {[$slave cget -active]&&[$slave cget -state]!="withdrawn"} {$slave raise; break}
       }
    }
}


metawidget proc Document icon_cmd {} {
   variable wFocus
   global wid GUI
   IfNotColorButton [$this get_win]
   switch [my -state] {
     "maximized" {
       if {$wFocus==$this} {
         my -laststate "maximized"
         $this configure -state "withdrawn"
         $this raise_last
         .buttonbar.buttonbar.[$this get_win] config -relief raised
       } else {
         $this raise
       }
     }
     "withdrawn" {
         if {[$wid(status) cget -state]=="maximized"} {
           set laststate "maximized"
         } else {
           set laststate [my -laststate]
         }
         if {$laststate=="normal"} {
          $this _restore
         } else {
           $this configure -state $laststate
         }

         if {$GUI(maximized)} {    
           $this configure -state maximized
           if {$this==$wid(status)} {$wid(status,tab) invoke [$wid(status,tab) get active]}
         } else {
           $this configure -state "normal"
         }
         $this raise
     }
     "normal" {
       if {$wFocus==$this} {
         my iNormX [my -x]
         my iNormY [my -y]
         my -laststate "normal"
         $this configure -state "withdrawn"
         $this raise_last
         .buttonbar.buttonbar.[$this get_win] config -relief raised
       } else {
         $this raise
       }
     }
   }
}



metawidget proc Document close_win {} {
  global wid position GUI
  if {![catch {$this cget -closable} e]} {
    if {![$this cget -closable]} return
  }
  set w [$this get_win]
  if {([info exists position($w)]&&$position($w))||$GUI(properties)} {
    catch {
      regsub { } [Convert [my -icontext]] {} name
      puts $wid(winsettings) "$name [my -x] [my -y] [my -width] [my -height]"
    }
  }
  kill_balloon
  destroy $this
  GroupButtons
  $wid(status) raise_last

}

metawidget proc Document image_conf {label varname image} {
    
    our $varname $image
    if {[string first "pIconRestore" $varname]==0&&[$this cget -state]=="maximized"} {
      if {$varname=="pIconRestore"} {$this.$label configure -image $image}
      bind $this.$label <Enter> "$this.$label config -image [our pIconRestore_over]"
      bind $this.$label <Leave> "$this.$label config -image [our pIconRestore]"
      bind $this.$label <ButtonPress-1> "$this.$label config -image [our pIconRestore_pressed]"
      bind $this.$label <ButtonRelease-1> "$this.$label config -image [our pIconRestore];if {%x<[winfo reqwidth $this.$label]&&%x>0&&%y<[winfo reqheight $this.$label]&&%y>0} {$this restore_all}"
    } elseif {[string first "pIconMax" $varname]==0&&[$this cget -state]=="normal"} {
      if {$varname=="pIconMax"} {$this.$label configure -image $image}
      bind $this.$label <Enter> "$this.$label config -image [our pIconMax_over]"
      bind $this.$label <Leave> "$this.$label config -image [our pIconMax]"
      bind $this.$label <ButtonPress-1> "$this.$label config -image [our pIconMax_pressed]"
      bind $this.$label <ButtonRelease-1> "$this.$label config -image [our pIconMax];if {%x<[winfo reqwidth $this.$label]&&%x>0&&%y<[winfo reqheight $this.$label]&&%y>0} {$this Arrange maximize}"
    } elseif {[string first "pIconClose" $varname]==0} {
      if {$varname=="pIconClose"} {$this.$label configure -image $image}
      bind $this.$label <Enter> "$this.$label config -image [our pIconClose_over]"
      bind $this.$label <Leave> "$this.$label config -image [our pIconClose]"
      bind $this.$label <ButtonPress-1> "$this.$label config -image [our pIconClose_pressed]"
      bind $this.$label <ButtonRelease-1> "$this.$label config -image [our pIconClose];if {%x<[winfo reqwidth $this.$label]&&%x>0&&%y<[winfo reqheight $this.$label]&&%y>0} {$this.menu invoke Close}"

    } elseif {[string first "pIconMin" $varname]==0} {
      if {$varname=="pIconMin"} {$this.$label configure -image $image  }
      bind $this.$label <ButtonPress-1> "$this.$label config -image [our pIconMin_pressed]"
      bind $this.$label <ButtonRelease-1> "$this.$label config -image [our pIconMin];if {%x<[winfo reqwidth $this.$label]&&%x>0&&%y<[winfo reqheight $this.$label]&&%y>0} {$this set_laststate}"
      bind $this.$label <Enter> "$this.$label config -image [our pIconMin_over]"
      bind $this.$label <Leave> "$this.$label config -image [our pIconMin]"

    }
}


metawidget proc Document get_win {} {
  return [string range $this 6 end]
}

metawidget proc Document addbutton {} {
   global me font GUI
   set w [$this get_win]
   if {[my -state]=="withdrawn"} {
     set relief "raised"
   } else {
     set relief "sunken"
   }
   xbutton .buttonbar.buttonbar.$w -font $font(button) -task 1 -side left -relief $relief -text [Reverse [Convert [my -icontext]]] -image [my -image] -command "$this icon_cmd"
   GroupButtons
   pack .buttonbar.buttonbar.$w -side left -padx 0 -pady 0
   bind .buttonbar.buttonbar.$w <Button-2> "$this close_win"
   bind .buttonbar.buttonbar.$w <Button-3> "$this close_win"
   bind .buttonbar.buttonbar.$w.t <Button-2> "$this close_win"
   bind .buttonbar.buttonbar.$w.t <Button-3> "$this close_win"
   bind .buttonbar.buttonbar.$w.b <Button-2> "$this close_win"
   bind .buttonbar.buttonbar.$w.b <Button-3> "$this close_win"

   if {$GUI(tooltips)} {set_balloon .buttonbar.buttonbar.$w [my -tooltip]}

   UpdateScrollBox
}


metawidget proc Document active {cmd} {  
  [our wFocus] $cmd
}

metawidget command Document icon_vars icon_vars
metawidget command Document image_conf image_conf
metawidget command Document active active
metawidget command Document close_win close_win
metawidget command Document get_win get_win
metawidget command Document raise_last raise_last
metawidget command Document addbutton addbutton
metawidget command Document set_laststate set_laststate
metawidget command Document icon_cmd icon_cmd
metawidget command Document restore_all restore_all
metawidget command Document _showMenu _showMenu
metawidget command Document _move1    _move1
metawidget command Document _move2    _move2
metawidget command Document _move3    _move3
metawidget command Document _resize1  _resize1
metawidget command Document _resize2  _resize2
metawidget command Document _resize3  _resize3
metawidget command Document _withdraw _withdraw
metawidget command Document _maximize _maximize
metawidget command Document _minimize _minimize
metawidget command Document _restore  _restore
metawidget command Document _motion   _motion

metawidget command Document menu      menu_
metawidget command Document lower     lower_
metawidget command Document raise     raise_
metawidget command Document pack      pack_
metawidget command Document grid      grid_
metawidget command Document place     place_
metawidget command Document Arrange   Arrange
metawidget command Document Alldocs   Alldocs
metawidget command Document wFocus   wFocus

metawidget option  Document -closable -closable
metawidget option  Document -active -active
metawidget option  Document -tooltip  -tooltip
metawidget option  Document -callback   -callback
metawidget option  Document -callmenu   -callmenu
metawidget option  Document -laststate   -laststate
metawidget option  Document -x          -x
metawidget option  Document -y          -y
metawidget option  Document -width      -width
metawidget option  Document -height     -height
metawidget option  Document -font       -font
metawidget option  Document -image      -image
metawidget option  Document -title      -title
metawidget option  Document -state      -state
metawidget option  Document -foreground
metawidget option  Document -background
metawidget option  Document -minsize
metawidget option  Document -icontext

