package require Metawidget

metawidget create Spinentry {
  if { ! [ourinfo exists pDown] } {
    our pDown [image create bitmap -data {
      #define _width 8
      #define _height 3
      static char _bits[] = { 0x7c, 0x38, 0x10 };
    }]
    our pUp [image create bitmap -data {
      #define _width 8
      #define _height 3
      static char _bits[] = { 0x10, 0x38, 0x7c };
    }]

    foreach sBind [bind Entry] {
      bind Spinentry $sBind [bind Entry $sBind]
    }
  }

  entry $this.entr
  label $this.entr.stup -border 2 -relief raised -image [our pUp]   -cursor arrow
  label $this.entr.stdn -border 2 -relief raised -image [our pDown] -cursor arrow

  pack  $this.entr -fill both -expand 1
  place $this.entr.stup -relx 1 -rely 0 -w 16 -relh .5 -anchor ne
  place $this.entr.stdn -relx 1 -rely 1 -w 16 -relh .5 -anchor se

  bind $this.entr <Up>   "$this _step +"
  bind $this.entr <Down> "$this _step -"
  bind $this.entr.stup <Button-1> "$this _press %W +"
  bind $this.entr.stdn <Button-1> "$this _press %W -"
  bind $this.entr.stup <ButtonRelease-1> "$this _press %W"
  bind $this.entr.stdn <ButtonRelease-1> "$this _press %W"

  my -step    1
  my -speed   100
  my -maximum {}
  my -minimum {}
  my -onerror {}
  my -value   {}
} {} -default entr

metawidget proc Spinentry _spin { sDir } {
  $this _step $sDir
  my iJob1 [after [my -speed] $this _spin $sDir]
}

metawidget proc Spinentry _press { sWindow {sDir {}} } {
  if { $sDir == {} } {
    $sWindow config -relief raised
    catch { after cancel [my iJob1] }
  } else {
    $sWindow config -relief sunken
    $this _spin $sDir
  }
}

metawidget proc Spinentry _step { sDir } {
  set fValue [$this get]

  if { [catch {expr $fValue $sDir [my -step]} fValue] } {
    if { [my -onerror] != {} } {
      eval [my -onerror]
    } else {
      error $fValue
    }
  }

  if { [my -minimum] != {} && $fValue < [my -minimum]} {
    set fValue [my -minimum]
  }
  if { [my -maximum] != {} && $fValue > [my -maximum]} {
    set fValue [my -maximum]
  }

  $this.entr delete 0 end
  $this.entr insert 0 $fValue
}

metawidget proc Spinentry -value { fValue } {
  if { [catch { expr $fValue + [my -step] }] } {
    throw "Value $fValue is not numeric"
  }

  $this.entr delete 0 end
  $this.entr insert 0 $fValue

  my -value $fValue
}

metawidget command Spinentry _step    _step
metawidget command Spinentry _spin    _spin
metawidget command Spinentry _press   _press

metawidget option Spinentry  -step
metawidget option Spinentry  -speed
metawidget option Spinentry  -maximum
metawidget option Spinentry  -minimum
metawidget option Spinentry  -onerror
metawidget option Spinentry  -value   -value

