package require Metawidget

metawidget create Tooltip {
  pack [label $this.text -bg #FFC -border 1 -relief solid -padx 2] -fill x

  wm withdraw $this
  wm overrideredirect $this 1

  bind Tooltip-$this <Enter>  "$this _start %W"
  bind Tooltip-$this <Leave>  "$this _hide"
  bind Tooltip-$this <Button> "$this _hide"

  my bNowait 0
  my -delay 1000
  my -yoffset 16
  my -xoffset 2
} {
}  -default text -type toplevel

metawidget proc Tooltip add { sWindow sText } {
  bindtags $sWindow [mkw.lextend [bindtags $sWindow] Tooltip-$this]
  my $sWindow $sText
}

metawidget proc Tooltip forget { sWindow } {
  bindtags $sWindow [mkw.lshrink [bindtags $sWindow] Tooltip-$this]
  unmy $sWindow
}

metawidget proc Tooltip _start { sWindow } {
  if { [my bNowait] } {        ;# if bubblehelp was active...
    _show $sWindow             ;# ... then no new waiting time
  } else {                     ;# otherwise start timer
    our hJobID [after [my -delay] $this _show $sWindow]
  }
}

metawidget proc Tooltip _show { sWindow } {
  catch { after cancel [our hWaitID] }
  my bNowait 1

  $this.text config -text [my $sWindow]
  wm deiconify $this
  raise $this
  wm geometry $this +[expr [my -xoffset]+[winfo pointerx .]]+[expr [my -yoffset]+[winfo pointery .]]
}

metawidget proc Tooltip _hide {} {
  our hWaitID [after 500 set bNowait 0]

  catch { after cancel [our hJobID] }
  wm withdraw $this
}

metawidget command Tooltip _start _start
metawidget command Tooltip _show  _show
metawidget command Tooltip _hide  _hide

metawidget command Tooltip add    add
metawidget command Tooltip forget forget

metawidget option  Tooltip -delay
metawidget option  Tooltip -yoffset
metawidget option  Tooltip -xoffset
