catch {
 tk::unsupported::ExposePrivateCommand tkTabToWindow
 tk::unsupported::ExposePrivateCommand tkCancelRepeat
 tk::unsupported::ExposePrivateCommand tkTextSetCursor
}

array set me ""
set me(version) "savIRC - v1.99"
set me(year) 2004

set me(path) "[file join [pwd] [file dirname "$::argv0"]]" 

;#"  kate syntax highlighting kludge (hmm)

# are we FreeWrapped? (http://freewrap.sourceforge.net)
# (win32 assumed to always be freewrapped)
if { [catch {set dummy $::freewrap::patchLevel} out] } {
  set me(freewrapped) false
} else {
  set me(freewrapped) true
  catch {console hide}
}

# languages
source [file join $me(path) lang language.tcl]
package require msgcat
namespace import msgcat::mc

# fundamentals
source [file join $me(path) platform platform.tcl]
source [file join $me(path) tcl savirc_api.tcl]

package require platform
package require savirc

# standard widgets (provided by Tk 8.4, but included separately for Tk 8.3)
lappend auto_path [file join $me(path) mkWidgets1.3]
source [file join $me(path) mkWidgets1.3 pkgIndex.tcl]


set me(home) "[::platform::savircDir]"
set me(tempdir) "[::platform::tempDir]"



array set mp3 ""
array set wid ""
array set topic ""
array set scroll ""
array set chan ""
array set canali ""
array set mark ""
array set query  ""
array set chat ""
array set dccchat ""
array set ison ""
array set isonMSG ""
array set topicdate ""
array set colsTXT ""
array set MIRCcols ""
array set font ""
array set whois ""
array set LIST ""
array set ping ""
array set cur ""
array set tl ""
array set CHATsk ""
array set files ""
array set act ""
array set clientMSG ""
array set misc ""
array set DCC ""
array set GUI ""
array set chanlist ""
array set createdate ""
array set timestamp ""
array set position ""
array set history ""
array set icons ""
array set script ""
array set active ""
array set links ""
array set modes ""
array set who ""
array set whols ""
array set task ""
array set logchan ""
array set chan366 ""

set GUI(cursor) "hand2"
set me(platform) 0

set files(license) [file join $me(path) gpl.txt]
set task(chan) 0
set task(chat) 0
set complist ""
set preview ""
set compini ""
set debug 0
set gw ""
set wholist 0
set history(status) ""
set timestamp() 0
set timestamp(.) 0
set colsTXT(default) black
set bps 0
set ignore ""
set tempignore ""
set showtopic 1
set info "Not Connected"
set me(ip) ""
set me(host) ""
set me(sock) ""
set me(sock5svr) ""
set me(sock5port) ""
set me(sock5user) ""
set me(sock5pass) ""
set me(0,conn) 0
set me(,conn) 0
set me(network) ""
set me(started) 0
set me(icony) 0
set me(url) "http://www.savirc.com"
set whois(309) 1
set whois(330) 1
set whois(311) 1
set whois(312) 1
set whois(319) 1
set whois(317) 1
set whois(318) 1
set whois(352) 1
set hostnick ""
set usernick ""
set me(cmd) ""
set me(id) 0
set me(cput) 1
set active() "status"
set active(0) "status"
set active(status) 1
set lactive ""
set filename ""
set blinks ""
set tlinks ""
set destroycan 1
set chanmenu 1
set bool 0
set me(socksnum) 0
set me(sockslist) ""
set files(defaultdir) ""
set wid(x) ""
set wid(y) ""
set wid(height) ""
set wid(width) ""
set mp3(lists) ""
set mp3(list) ""
set mp3(playing) 0
set me(ident_active) 0
set me(profile) "default"
set me(profiles) "default"


if {[::platform::isPlatformUnix]} {
  set files(nslookup) "host"
} 
if {[::platform::isPlatformWindows]} {
  catch {load [file join $me(path) platform win32 lib libsnack.dll]}
  set files(nslookup) "[file join $me(path) platform win32 bin nslookup.exe]"
  set GUI(tk_theme) -1
}


# make sure filesystem is prepared
file mkdir [file join $me(home) config]
file mkdir [file join $me(home) config default]
file mkdir [file join $me(home) config default Downloads]
file mkdir [file join $me(home) config default scripts]
file mkdir [file join $me(home) config default logs]

# Remove /channels, /queries, /chats
# When writing a log file out, make: $serverName/$chan,$query,$chat/LogFileName
file mkdir [file join $me(home) config default logs Channels]
file mkdir [file join $me(home) config default logs Queries]
file mkdir [file join $me(home) config default logs Chats]

# setup for default profile
set files(settings) "[file join $me(home) config default default.ini]"
set files(notify) "[file join $me(home) config default notify.ini]"
set files(ignore) "[file join $me(home) config default ignore.ini]"
set files(channels) "[file join $me(home) config default channels.ini]"
set files(history) "[file join $me(home) config default history.ini]"
set files(winfile) "[file join $me(home) config default winfile.ini]"
set script(popups) "[file join $me(home) config default scripts popups.tcl]"

# shouldn't these be $me(home) instead?
set files(profiles) [file join $me(home) config profiles.ini]
set files(servers) [file join $me(home) config servers.ini]
set files(socks) [file join $me(home) config socks.ini]

if {![file exist $files(servers)]} {
  catch {[file copy [file join $me(path) config servers.ini] $files(servers)]}
}

proc LoadProfiles {} {
  global files me
  if {![file exists $files(profiles)]} {return}
  if {[catch {open $files(profiles)} fd]} {return}
  set c [split [read $fd] "\n"]
  set me(profiles) [lindex $c 1]
  set me(profile) [lindex $c 0]
  
  if {![file exists [file join $me(home) config $me(profile)]]} {
    set me(profile) "default"
  }
  
  set files(settings) [file join $me(home) config $me(profile) $me(profile).ini]
  set files(notify) "[file join $me(home) config $me(profile) notify.ini]"
  set files(ignore) "[file join $me(home) config $me(profile) ignore.ini]"
  set files(channels) "[file join $me(home) config $me(profile) channels.ini]"
  set files(history) "[file join $me(home) config $me(profile) history.ini]"
  set files(winfile) "[file join $me(home) config $me(profile) winfile.ini]"
  set script(popups) "[file join $me(home) config $me(profile) scripts/popups.tcl]"

  # These are made in LoadProfile, in config.tcl .... Duplicate?
  file mkdir [file join $me(home) config $me(profile) Downloads]
  file mkdir [file join $me(home) config $me(profile) scripts]
  file mkdir [file join $me(home) config $me(profile) logs]
  file mkdir [file join $me(home) config $me(profile) logs Channels]
  file mkdir [file join $me(home) config $me(profile) logs Queries]
  file mkdir [file join $me(home) config $me(profile) logs Chats]
}

#ifndef PLATFORM_WIN
proc Tk_Theme {} {
	global GUI me misc

if {![file exists [file join $me(path) Tk_Theme "theme.so"]]} {
	set GUI(tk_theme) -1
} else {
	if {![catch {load [file join $me(path) Tk_Theme "theme.so"]}]} {
		set GUI(tk_theme) 1
		return
	} else {
		set GUI(tk_theme) 0
	}

}
	set misc(traymin) 0
	set misc(trayuse) 0
}

#endif /* ! PLATFORM_WIN */



if {[::platform::isPlatformUnix]} {
  Tk_Theme
}

source "[file join $me(path) tcl socks.tcl]"
source "[file join $me(path) tcl identd.tcl]"
source "[file join $me(path) tcl config.tcl]"
source "[file join $me(path) tcl settings.tcl]"
source "[file join $me(path) tcl commands.tcl]"
source "[file join $me(path) tcl images.tcl]"
source "[file join $me(path) tcl ctcp.tcl]"
source "[file join $me(path) tcl colors.tcl]"


LoadProfiles
LoadSettings
LoadGUISettings
LoadLanguage $me(lang)


set fontTMP $font(n)
set font(b) [lappend fontTMP bold]
set me(cnick) $me(nick)
set me(cserver) $me(server)
set me(command) $me(nick)

source "[file join $me(path) tcl windows.tcl]"
source "[file join $me(path) tcl dcc.tcl]"
source "[file join $me(path) tcl script.tcl]"
source "[file join $me(path) tcl menus.tcl]"
source "[file join $me(path) tcl gui.tcl]"

proc Connect {} {
 global me info colsTXT active query canali chat icons wid
   if {!$active(status)} {
       Switch status
       $wid(status,tab) invoke main
   }
   set id [incr me(socksnum)]
   set me($id,chnick) 0
   set me($id,registered) 0
   set active($id) "status"
   set canali($id) ""
   set query($id) ""
   set chat($id) ""
   if {$me(server)==""} {
      IRC::echo [mc "No server selected!"]
      IRC::server
      return
   }
   set me($id,server) $me(server)
   if {$me(network)!= [mc +Random]} {
     set me($id,net) $me(network)
   } else {
     if {[string first ".dal." $me(server)]!=-1} {
	set me($id,net) "DALnet"
     } elseif {[string first ".efnet." $me(server)]!=-1} {
	set me($id,net) "EFnet"
     } elseif {[string first ".ircnet." $me(server)]!=-1} {
	set me($id,net) "IRCnet"
     } elseif {[string first ".undernet." $me(server)]!=-1} {
	set me($id,net) "Undernet"
     } else {
	set me($id,net) [mc Unknown]
     }
   }
   if {$me(ident_use)&&$me(ident_active)==0} {
      Identd_Create
   }

   if {!$me(sock5use)} {
     if {$icons(show)} {ImageText status prog}
     NormalText status "[format [mc "Connecting to %s on %s"] $me(server) $me(port)]" $colsTXT(prog) 1
     if {[catch {socket -async $me(server) $me(port)} me($id,sock)]} {
       if {$icons(show)} {ImageText status prog}
       NormalText status $me($id,sock) $colsTXT(prog) 1
       return
     }
   } else {
     if {$me(sock5svr)==""} {
       if {$icons(show)} {ImageText status prog}
       NormalText status [mc "Can not connect to SOCK5 server, no server has been selected."] $colsTXT(prog) 1
       return
     }
     if {$icons(show)} {ImageText status prog}
     NormalText status "\[SOCK5\] [format [mc "Connecting to %s %s"] $me(sock5svr) $me(sock5port)]" $colsTXT(prog) 1
     if {[catch {socket -async $me(sock5svr) $me(sock5port)} me($id,sock)]} {
       if {$icons(show)} {ImageText status prog}
       NormalText status "\[SOCK5\] [format [mc "Connection Error: %s"] $me($id,sock)]" $colsTXT(prog) 1
       return
     }
     if {$icons(show)} {ImageText status prog}
     NormalText status "\[SOCK5\] [mc Connected]" $colsTXT(prog) 1
     set me($id,conn) 1
     set me(id) $id
     if {$me(sock5user)==""&&$me(sock5pass)==""} {
        set auth 0
     } else {
        set auth 1
     }
     if {$icons(show)} {ImageText status prog}
     NormalText status "\[SOCK5\] [format [mc "Connecting to %s on %s"] $me(server) $me(port)]" $colsTXT(prog) 1
     if {[catch {socks:init $me($id,sock) $me(server) $me(port) $auth "$me(sock5user)" "$me(sock5pass)"} sock5]} {
       return
     }
     if {$sock5!="OK"} {
        if {$icons(show)} {ImageText status prog}
        NormalText status "\[SOCK5\] $sock5" $colsTXT(prog) 1
        catch {close $me($id,sock)}
        return
     } else {
        if {$icons(show)} {ImageText status prog}
        NormalText status "\[SOCK5\] [mc "Connected to IRC server"]" $colsTXT(prog) 1
        NormalText status "" $colsTXT(prog) 1
     }
   }

   lappend me(sockslist) $id

   fconfigure $me($id,sock) -blocking 0
   fconfigure $me($id,sock) -buffering line
   fconfigure $me($id,sock) -encoding $me(encoding)
   
   
   set me(host) [lindex [fconfigure $me($id,sock) -sockname] 1]
   set me($id,conn) 1
   set me(id) $id
   set info "[format [mc "Connected to %s"] $me(server)]"
   ::savirc::setNick $id $me(nick)
   if {[catch {puts $me($id,sock) "USER $me(userid) $me(host) $me(server) :[FormatColors $me(realname)]"}]} {
      Disconnect $id
      return
   }
   puts $me($id,sock) "NICK $me(nick)"
   fileevent $me($id,sock) readable [list IRC $id]

   UpdateServerList
   SetCurrents $id
}

proc SetCurrents {id} {
   global me info
   if {$me(sockslist)==""} {
      ::savirc::setNick $id $me(nick)
      set me($id,server) $me(server)
      set me(command) [Reverse [Convert $me(nick)]]
      .menubar.bservers config -state disabled
      set me(cnick) [::savirc::getNick $id]
      set me(cserver) $me($id,server)
      return
   }
   set me(cnick) [::savirc::getNick $id]
   set me(cserver) $me($id,server)
   if {[llength $me(sockslist)]>1} {
     set me(command) [Reverse [Convert "$me(cnick) \[$me(cserver)\]"]]
   } else {
     set me(command) [Reverse [Convert $me(cnick)]]
   }
   set me(id) $id
   .menubar.bservers config -state normal
   destroy .menubar.bservers.m
   set m [menu .menubar.bservers.m -tearoff 0]
   MakeServerMenu $m
   set info "[format [mc "Connected to %s %s %s %s"] $me(cserver) \[[Reverse [Convert $me(cnick)]] - $me(host)\]]"
}

proc Notify {update} {
 global me misc ison
 foreach id $me(sockslist) {
     if {!$misc(notify)} { break }
     if {[catch {set conn $me($id,conn)}]} {
        RemoveFromSocklist $id
        continue
     }
     if {!$conn} {
        RemoveFromSocklist $id
        continue
     }
     set nlist ""
     set num [array size ison]
     for { set i 0 } { $i < $num } { incr i } {
        lappend nlist $ison($i)
     }
     if {$nlist!=""} {
        if {[catch {puts $me($id,sock) "ISON $nlist"} err]} {
           Disconnect $id
        }
     }
 }
 if {$update} {
   after [expr $misc(notifyupdate)*60000] { Notify 1 }
 }
}

proc Debug { msg } {
  global debug
   if {$debug==1} {
     .debug.fr.text config -state normal;
     .debug.fr.text insert end "$msg \n";
     .debug.fr.text see end;
   }
}

proc CloseWindows {id} {
 global active chat query canali log timestamp history scroll wid

 catch {
   $wid(chanlist$id) config -closable 1
   $wid(chanlist$id) close_win
 }
 foreach item $canali($id) {
    array unset scroll $item
    array unset history $item
    array unset timestamp $item
    array unset log $item
 }
 foreach item $query($id) {
    array unset scroll $item
    array unset history $item
    array unset timestamp $item
    array unset log $item

 }

 foreach slave $wid(winlist) {
    set w [$slave get_win]
    if {[string match "*canale$id-*" $w]==1||[string match "*query$id-*" $w]==1} {
       $slave close_win
    }
 }

 set canali($id) ""
 set query($id) ""
}

proc RemoveFromSocklist {id} {
  global me
  set templist ""
  foreach item $me(sockslist) {
     if {$item!=$id} { lappend templist $item }
  }
  set me(sockslist) $templist
}

proc UpdateCurrentServer {} {
  global info me wid
  foreach id $me(sockslist) {
    if {$me($id,server)==[lindex [Convert $info] 0]} {
      SetCurrents $id
      break
    }
  }
  focus $wid(status,command)
}

proc UpdateServerList {} {
  global me wid
  set svrlist ""
  foreach id $me(sockslist) {
    lappend svrlist "$me($id,server) [::savirc::getNick $id]"
  }
  $wid(status,info) list delete 0 end
  eval $wid(status,info) list insert end $svrlist
}

proc Disconnect {id} {
 global me info active colsTXT chat query canali clientMSG icons wid
       set me($id,conn) 0
       catch {puts $me($id,sock) "QUIT :$clientMSG(quit)"}
       catch {close $me($id,sock)}
       IRC::Event000 disconnect $me($id,net) id $id	
       if {$icons(show)} {ImageText status prog}
       NormalText status "[format [mc "Disconnected from %s"] $me($id,server)]" $colsTXT(prog) 1
       RemoveFromSocklist $id

       CloseWindows $id
       set data [$wid(status,notify) get 0 end]
       set size [llength $data]
       set r_num 0
       for {set i 0 } { $i < $size } { incr i } {
         set server [lindex [lindex $data $i] 1]
         if {$server==$me($id,server)} {
             $wid(status,notify) delete [expr $i-$r_num]
             incr r_num
         }
       }

       if {$me(id)==$id&&[llength $me(sockslist)]!=0} {
         $wid(status) raise
         SetCurrents [lindex $me(sockslist) 0]
       } elseif {[llength $me(sockslist)]==0} {
         if {!$active(status)} {$wid(status) raise}
         set info [mc "Not Connected"] ;# removed quotes
         $wid(status,notify) delete 0 end
       }
       UpdateServerList
       UpdateScrollBox
}

proc RegEvent {event buffer} {
  if {[regexp -nocase ":(.*).* $event" $buffer]==1&&[lindex $buffer 1]==[lindex $event 0]} {
    return 1
  } else {
    return 0
  }
}



proc IRC {id} {
   global me bps colsTXT active misc icons
   if {[eof $me($id,sock)]} {
     Disconnect $id
     return
   }
   if {[catch {set buffer [gets $me($id,sock)]} r]} {
     Disconnect $id
     return
   }

   if {$buffer=="\x00"} {return}
   set cbuffer [Convert $buffer]
   set len_buff [string length $buffer]
   incr bps $len_buff
    if {![catch {lindex $cbuffer 1} raw]&&[Isinteger $raw]} {
      RAW $cbuffer $raw [string length $buffer] $id
    
    } elseif {[string match ":*!*@* PRIVMSG [Convert [::savirc::getNick $id]] :\001ACTION *\001" $cbuffer]==1&&[lindex $cbuffer 2]==[Convert [::savirc::getNick $id]]&&[lindex $cbuffer 1]=="PRIVMSG"} { 
     IRCquery $buffer $len_buff 1 $id
    
    } elseif {[RegEvent "PRIVMSG (.*) :\001ACTION (.*)\001" $cbuffer]} {
     IRCaction $buffer $len_buff $id
    
    } elseif {[string match ":*!*@* NOTICE [Convert [::savirc::getNick $id]] :\001*\001" $cbuffer]==1&&[lindex $cbuffer 2]==[Convert [::savirc::getNick $id]]&&[lindex $cbuffer 1]=="NOTICE"} {
      showCTCP $id $buffer $len_buff
    
    } elseif {[string match ":*!*@* PRIVMSG * :\001*\001" $cbuffer]==1&&[lindex $cbuffer 1]=="PRIVMSG"} {
      workoutCTCP $buffer $len_buff $id
    
    } elseif {[string match ":*!*@* PRIVMSG [Convert [::savirc::getNick $id]] :*" $cbuffer]==1&&[lindex $cbuffer 2]==[Convert [::savirc::getNick $id]]&&[lindex $cbuffer 1]=="PRIVMSG"} {
     IRCquery $buffer $len_buff 0 $id
    
    } elseif {[RegEvent "JOIN (.*)" $cbuffer]} {
     IRCjoin $buffer $id
    
    } elseif {[RegEvent "PART (.*)" $cbuffer]} {
     IRCpart $cbuffer $len_buff $id
    
    } elseif {[RegEvent "PRIVMSG (.*) :(.*)" $cbuffer]} {
     IRCprivchan $buffer $len_buff $id
    
    } elseif {[regexp -nocase ":(.*) MODE (.*)" $cbuffer]==1&&[lindex $cbuffer 1]=="MODE"} {
     IRCmode $cbuffer $id
    
    } elseif {[RegEvent "TOPIC (.*) :(.*)" $cbuffer]}  {
     IRCtopic $buffer $len_buff $id
    
    } elseif {[RegEvent "KICK (.*)" $cbuffer]} {
     IRCkick $buffer $len_buff $id
    
    } elseif {[RegEvent "NICK :" $cbuffer]} {
     IRCnick $buffer $id
    
    } elseif {[RegEvent "QUIT (.*)" $cbuffer]} {
     IRCquit $cbuffer $len_buff $id
    
    } elseif {[string match ":*!*@* NOTICE [Convert [::savirc::getNick $id]] *" $cbuffer]==1&&[lindex $cbuffer 2]==[Convert [::savirc::getNick $id]]&&[lindex $cbuffer 1]=="NOTICE"} {
      IRCnotice $buffer $id
    
    } elseif {[string match ":*!*@* NOTICE *" $cbuffer]==1&&[lindex $cbuffer 1]=="NOTICE"} {
      IRCchannotice $buffer $id
    
    } elseif {[regexp -nocase ":(.*) NOTICE (.*)" $cbuffer]==1} {
      IRCsvrnotice $cbuffer $id
    
    } elseif {[string first "NOTICE" $buffer]==0||[string first "ERROR" $buffer]==0} {
      IRCauth $buffer $id
    
    } elseif {[string match ":*!*@* INVITE [Convert [::savirc::getNick $id]] :*" $cbuffer]==1&&[lindex $cbuffer 2]==[Convert [::savirc::getNick $id]]&&[lindex $cbuffer 1]=="INVITE"} {
      IRCinvite $buffer $id
    
    } else {
      if {![catch {lindex $buffer 0} ping]} {
       if {$ping=="PING"} {
         set pong [lindex $buffer 1]
         if {[catch {puts $me($id,sock) "PONG $pong"} err]} {
            Disconnect $id
            return
         }
         if {$misc(ping)} {
              if {$icons(show)} {
                ImageText status ping
              }
              NormalText status "[format [mc "Ping request from %s PONG!"] $me($id,server)]" $colsTXT(prog) 1
         }
         IRC::Event000 serverping $me($id,net) id $id pong $pong
         return
       }
      }
      set txt [string trimleft $buffer ":"]
      if {$txt==""} return
      if {$icons(show)} {ImageText status raw}
      NormalText status $txt $colsTXT(serv) 1
    }
}

proc RAW {buffer raw len_buff id} {
         global me active colsTXT icons misc
         IRC::Event000 raw $me($id,net) id $id raw $raw msg [Reverse [join [lrange $buffer 3 end]]]
	 switch $raw {
	  "001" {
	     set me($id,registered) 1
             IRCraw $buffer $id
             catch { ::savirc::setNick $id [Reverse [lindex $buffer 2]]}
             SetMyIp $id
             if {$me(id)==$id} {
               set me(cnick) [::savirc::getNick $id]
               set me(cserver) $me($id,server)

               if {[llength $me(sockslist)]>1} {
                 set me(command) [Reverse [Convert "$me(cnick) \[$me(cserver)\]"]]
               } else {
                 set me(command) [Reverse [Convert $me(cnick)]]
               }
             }
             Notify 0
             IRC::Event000 connect $me($id,net) id $id
             if {$misc(chanpopup)} {ChanFolder}
             catch {FindNet $id}
	  }
	
          "305" {
	      if {$icons(show)} {ImageText $active($id) away}
	      ColorText $active($id) "[string trimleft [join [lrange $buffer 3 end]] ":"]" $colsTXT(raw) 1
          }
          "306" {
	      if {$icons(show)} {ImageText $active($id) away}
	      ColorText $active($id) "[string trimleft [join [lrange $buffer 3 end]] ":"]" $colsTXT(raw) 1
          }

          "376" {
	      if {$icons(show)} {ImageText $active($id) motd}
	      ColorText $active($id) "[string trimleft [join [lrange $buffer 3 end]] ":"]" $colsTXT(motd) 1
          }
          "377" {
	      if {$icons(show)} {ImageText $active($id) motd}
	      ColorText $active($id) "[string trimleft [join [lrange $buffer 3 end]] ":"]" $colsTXT(motd) 1
          }
          "372" {
	      if {$icons(show)} {ImageText $active($id) motd}
	      ColorText $active($id) "[string trimleft [join [lrange $buffer 3 end]] ":"]" $colsTXT(motd) 1
          }
          "332" {
      	      get_topic $buffer $id 0
          }
          "333" {
              get_topicdate $buffer $id 0
          }
          "329" {
              catch {get_creation [Reverse $buffer] $id}
          }
          "353" {
	      get_channicks $buffer $id
	  }
          "437" {
              altern_nick $id
              IRCraw $buffer $id
	  }
          "341" {
	      IRCinvitereply [Reverse $buffer] $id
	  }
          "433" {
              altern_nick $id
              IRCraw $buffer $id
	  }
          "324" {
              get_chanmodes $buffer $len_buff $id
	  }
          "319" {
              active_whois $buffer $len_buff 319 $id
	  }
          "312" {
              active_whois $buffer $len_buff 312 $id
	  }
          "313" {
              active_whois $buffer $len_buff 309 $id
	  }
          "317" {
              active_whois $buffer $len_buff 317 $id
	  }
          "318" {
              active_whois $buffer $len_buff 318 $id
	  }
          "301" {
              active_whois $buffer $len_buff 309 $id
	  }
          "307" {
              active_whois $buffer $len_buff 309 $id
	  }
          "309" {
              active_whois $buffer $len_buff 309 $id
	  }
          "311" {
              active_whois $buffer $len_buff 311 $id
	  }
          "330" {
              active_whois $buffer $len_buff 330 $id
	  }

          "366" {
	      put_list [Reverse $buffer] $id
          }
          "401" {
	      IRCNonick [Reverse $buffer] $id
          }
          "303" {
	      IRCnotify [Reverse $buffer] $id
          }
          "331" {
              IRCnotopic [Reverse $buffer] $id
          }
          "364" {
              IRClinks [Reverse $buffer] $id
          }
          "321" {
          }

          "322" {
              IRClist $buffer $id
          }
          "323" {
              IRCendlist $buffer $id
          }

          "365" {
              IRCendlinks $id
          }
          "367" {
              IRCbanlist [Reverse $buffer]
          }
          "352" {
             IRCwho $id $buffer
          }
          "315" {
             IRCwhoend $id $buffer
          }
          "368" {
          }
	  "328" {
	    IRCurl $buffer $id
	  }
          default {
            IRCraw $buffer $id
          }
         }
}


proc IRCraw {buffer id} {
  global me active colsTXT icons
  set raw [lindex $buffer 1]
  set txt [Reverse [join [lrange $buffer 3 end]]]
  if {$icons(show)} {
     ImageText $active($id) raw
  }
  ColorText $active($id) "$me($id,server) \[$raw\] $txt" $colsTXT(raw) 1
}

proc IRCurl {buffer id} {
	global me icons active colsTXT
	set txt [Reverse [string range [lrange $buffer 4 end] 1 end]]
	set chan [lindex $buffer 3]
        if {$icons(show)} {
	     ImageText $active($id) url
        }
        ColorText $active($id) "[format [mc "URL for %s: %s"] $chan $txt]" $colsTXT(raw) 1
}


proc IRClist {buffer id} {
  global wid LIST 
  if {![info exists wid(chanlist$id)]} {
     ShowLIST $id
     
  }

  set chan [lindex $buffer 3]
  if {$chan=="*"} {return}
  set users [lindex $buffer 4]
  set topic [CleanTopic [string range [join [lrange $buffer 5 end]] 1 end]]
  if {[info exists LIST(channel-match-$id)]} {
    if {[string match $LIST(channel-match-$id) [string tolower $chan]]!=1||[string match $LIST(topic-match-$id) [string tolower $topic]]!=1} {
      catch {
        set num [$wid(chanlist$id,info2) cget -text]
        set n [lindex $num 0]
        if {[Isinteger $n]} {
          incr n
          $wid(chanlist$id,info2) config -text "$n [mc "channels filtered out"]."
        } else {
          $wid(chanlist$id,info2) config -text "1 [mc "channel filtered out"]."
        }    
      }    
      return 
    }
  }  

  if {![info exists wid(chanlist$id,list)]} { 
    if {![info exists LIST(chanlist$id)]} { set LIST(chanlist$id) ""}
      catch {lappend LIST(chanlist$id) "{$chan} {$users} {$topic}"}  
  } else {
      catch {$wid(chanlist$id,list) insert end "{$chan} {$users} {$topic}"}
  } 
}

proc IRCendlist {buffer id} {
  global LIST wid
 
  catch {
     set num [$wid(chanlist$id,list) size]
     $wid(chanlist$id,info) config -text "[format [mc "List complete, %s channels found."] $num]"
     $wid(chanlist$id) config -closable 1
  }
  array unset LIST "topic-match-$id"
  array unset LIST "channel-match-$id"
  array unset LIST "chanlist$id" 
}

proc IRCwho {id buffer} {
  global wid chan whois hostnick
  set chann [Convert [lindex $buffer 3]]
  set user [Reverse [lindex $buffer 4]]
  set host [lindex $buffer 5]
  set server [lindex $buffer 6]
  set nick [Reverse [lindex $buffer 7]]
  set mode [lindex $buffer 9]
  set name [Reverse [join [lrange $buffer 10 end]]]
  if {!$whois(352)} {
     set hostnick $host
     set whois(352) 1
     return
  }
  set w [GetWindow $chann $id]
  if {![info exists wid($w,text)]||$chann=="*"} {
   set w "x@normal"
  }
  ShowWHO $w
  set win ".showWHO$w"

  catch {
   $win.f.list insert end [list $nick $user $host [CleanTopic $name] $server]
  }
  catch {
   set tot [lindex $chan($w,stat) 0]
   set cur [$win.f.list size]
   UpdateProgress [proportion $tot $cur] $win.f.bar.progress 0
  }
}

proc IRCwhoend {id buffer} {
  global wholist 
  set wholist 1
  set chan [Convert [lindex $buffer 3]]
  set w [GetWindow $chan $id]
  set win ".showWHO$w"
  UpdateProgress 100 $win.f.bar.progress 0
}


proc IRClinks {buffer id} {
 global links tlinks blinks
 if {[winfo exists .links]} {destroy .links}
 set buffer [string trimleft $buffer ":"]
 set ind [string first ":" $buffer]
 set servers [lrange [string range $buffer 0 $ind] 3 end]
 set servers [string trimright $servers ":"]
 set hop [lindex [Convert [string range $buffer $ind end]] 0]
 set hop [string trimleft $hop ":"]
 if {$hop>$blinks} { set blinks $hop }
 if {![info exists links($hop)]} {set links(hop) ""}
 lappend links($hop) "$servers"
 lappend tlinks "[lrange $buffer 3 end]"

}


proc IRCendlinks {id} {
  global links blinks tlinks
  if {![winfo exists .links]} {ShowLinks $id}
  set tree ".links.f.tree"
  set insert ""
  for {set i 0 } { $i <= $blinks } { incr i } {
    catch {
      foreach s $links($i) {
        if {$i==0} {
          Tree:newitem $tree [lindex "/$s" 0]
          lappend insert [lindex "/$s" 0]
        } else {
          set path ""
          set last [lindex $s end]
          for {set j [expr $i-1]} {$j>=0} { incr j -1} {
            foreach ss $links($j) {
              if {[lindex $ss 0]==$last} {
                set path "/$last$path"
                break
              } 
            }
            set last [lindex $ss end]
          }
 
          Tree:newitem $tree "$path/[lindex $s 0]"
          lappend insert "$path/[lindex $s 0]"
        }
      }
    }
  }
  foreach item $insert {
    Tree:open $tree $item
  } 
  for {set i 0 } { $i <= $blinks } { incr i } {
    set links($i) ""
  }
  set blinks 0
 
  return
}


proc LinksInfo {server} {
  global tlinks
  set server [file tail $server]
  set ind ""
  set i 0
  foreach svr $tlinks {
    set svr [lindex $svr 0]
    if {$svr==$server} {
      set ind $i
      break
    }
    incr i
  }

  if {$ind==""} return
  set info [lindex $tlinks $ind]
  set g [string first ":" $info]
  incr g
  set info [string range $info $g end]
  set info [CleanTopic $info]

  set hops [lindex $info 0]
  set info [join [lrange $info 1 end]]
  .links.f.list delete 0 end
  .links.f.list insert $ind [list "  $hops" " $info"]
}



proc id {id command args} {
  global me
  set old $me(id)
  set me(id) $id
  eval IRC::$command $args
  set me(id) $old
}

proc IRCauth {buffer id} {
  global colsTXT icons
  if {$icons(show)} {ImageText status notice}
  ColorText status "$buffer" $colsTXT(notice) 1
}

proc IRCinvite { buffer id } {
 global me active act misc colsTXT icons
 if {$act(invite)} {
  set w $active($me(id))
 } else {
  set w status
 }
 set nick [get_nick $buffer]
 set channel [Convert [lindex $buffer 3]]
 set channel [string range $channel 1 end]
 if {$icons(show)} {
   ImageText $w invite
 }
 NormalText $w "$nick \[$me($id,server)\] [format [mc "invites you to join %s"] $channel]" $colsTXT(invite) 1
 IRC::Event000 invite $me($id,net) id $id nick $nick chan $channel
 if {$misc(join)} {
   if {[catch {puts $me($me(id),sock) "JOIN [Reverse $channel]"} err]} {
     Disconnect $id
   }
 } else {
   set msg "$nick \[$me($id,server)\] \n[format [mc "invites you to join %s"] $channel] \n[format [mc "Join %s?"] $channel]"
   if {[catch {tk_messageBox -message $msg -type yesno} r]} {
     return
   }
   if {$r=="yes"} {
     if {[catch {puts $me($id,sock) "JOIN [Reverse $channel]"} err]} {
       Disconnect $id
     }
   }
 }
}


proc GetNotifyMSG {nick} {
 global ison isonMSG
 set msg ""
 set num [array size ison]
 for {set i 0} {$i<$num} {incr i} {
    if {[string tolower $ison($i)]==[string tolower $nick]} {
      set msg $isonMSG($i)
    }
 }
 return $msg
}

proc IRCnotify {buffer id} {
  global act misc active colsTXT ison me icons wid
  if {!$misc(notify)} {return}
  if {$act(notify)} {
    set win $active($me(id))
  } else {
    set win status
  }
  
  set duep [string last ":" $buffer]
  set nlist [string range $buffer [expr $duep+1] end]
  set count [$wid(status,notify) size]
  set nicklist ""
  for {set j 0} {$j < $count } {incr j} {
    if {[lindex [$wid(status,notify) get $j] 1]==$me($id,server)} {
      lappend nicklist [lindex [$wid(status,notify) get $j] 0]
    }
  }

  set len1 [llength $nlist]
  set len2 [llength $nicklist]
  for {set i 0 } { $i < $count } { incr i } {
     if {[lindex [$wid(status,notify) get $i] 1]==$me($id,server)} {
         set nick [lindex [$wid(status,notify) get $i] 0]
         set currentlist [array get ison]
         set isthere [lsearch -exact $nlist $nick]
         if {$isthere==-1&&[lsearch $currentlist $nick]!=-1} {
           $wid(status,notify) delete $i
           set desc "([GetNotifyMSG $nick]) [mc has]"
           if {$desc=="{}{}"} {set desc [mc has]}
           if {$icons(show)} {ImageText $win info}
           NormalText $win "\[$me($id,server)\] [format [mc "%s %s left IRC"] $nick $desc]" $colsTXT(notify) 1
           IRC::Event000 unotify $me($id,net) id $id nick $nick 
         }
     }
  }

  for {set i 0 } { $i < $len1 } { incr i } {
     set nick [lindex $nlist $i]
     set isthere [lsearch -exact $nicklist $nick]
     if {$isthere==-1} {
        $wid(status,notify) insert end [list $nick $me($id,server)]
        set desc "([GetNotifyMSG $nick]) [mc is]"
        if {$desc=="{}{}"} {set desc [mc is]}
	if {$icons(show)} {ImageText $win info}

        NormalText $win "\[$me($id,server)\] [format [mc "%s %s on IRC"] $nick $desc]" $colsTXT(notify) 1
        IRC::Event000 notify $me($id,net) id $id nick $nick 
     }
  }
}

proc IRCnotice { buffer id } {
 global me colsTXT active act icons misc
 if {[Ignore $buffer n]} { return }

 if {$act(notice)} {
   set win $active($me(id))
 } else {
   set win status
 }

 set tnick [get_nick $buffer]
 set userid [get_userid $buffer]
 set host [get_host $buffer]
 set text [string trimleft [Reverse [join [lrange [Convert $buffer] 3 end]]] ":"]

 # This needs [mc..] code. Will modify for 2.*
 set msg "NOTICE from $tnick"
 if {$misc(address)} {append msg " \[$userid@$host\]"}
 append msg " : $text"
 if {$icons(show)} {ImageText $win notice}
 ColorText $win "$msg" $colsTXT(notice) 1
 IRC::Event000 notice $me($id,net) id $id nick [Reverse $tnick] user $userid host $host text $text
}

proc IRCchannotice { buffer id } {
 global colsTXT icons misc wid
 
 	set nick [get_nick $buffer]
 	set userid [get_userid $buffer]
 	set host [get_host $buffer]
 	set chan [lindex [Convert $buffer] 2]
 	set txt [Reverse [join [lrange [Convert $buffer] 3 end]]]
 	set w [GetWindow [string tolower $chan] $id]
 
 		if {![info exists wid($w,text)]||$w==""} {return}
 	
	set msg "CHANNEL NOTICE from $nick"
 
 		if {$misc(address)} {append msg " \[$userid@$host\]"}
 	
	append msg " : $txt"
 
 		if {$icons(show)} {ImageText $w notice}
 	
	ColorText $w "$msg" $colsTXT(notice) 1
	IfColorButton $w $id

}


proc IRCsvrnotice {buffer id} {
  global me colsTXT active act icons

  set svr [string range [lindex $buffer 0] 1 end]
  set txt [join [lrange $buffer 3 end]]

  if {$act(notice)} {
    set win $active($me(id))
  } else {
    set win status
  }

  if {$icons(show)} {ImageText $win notice}
  ColorText $win "\[$svr\] [Reverse $txt]" $colsTXT(notice) 1
  IRC::Event000 servernotice $me($id,net) id $id text [Reverse $txt]
}

proc IsQuery { win } {
 set isquery [string first ".query*" $win]
 if {$isquery==0} {
  return 1
 } else {
  return 0
 }
}



proc IRCNonick { buffer id } {
 global active colsTXT act me icons
 if {$act(whois)} {
   set win $active($me(id))
 } else {
   set win status
 }
 set buffer [Convert $buffer]
 set nonick [lindex $buffer 3]
 if {$icons(show)} {ImageText $win info}
 NormalText $win "[Reverse $nonick] :[mc "No such nick/channel"]" $colsTXT(whois) 1
}

proc altern_nick {id} {
 global me wid

 if {!$me($id,registered)} {
   if {$me($id,chnick)==0} {
      if {[catch {puts $me($id,sock) "NICK $me(altnick)"} err]} {
         Disconnect $id
         return
      }
      ::savirc::setNick $id $me(altnick)
      incr me($id,chnick)
      UpdateServerList
      if {$id==$me(id)} {SetCurrents $id}
   } else {
     $wid(status,command) delete 0 end
     $wid(status,command) insert 0 "/nick "
     focus $wid(status,command)
   }
 }
}

proc DelAtIndex {i string} {
   set s1 [string range $string 0 [expr $i-1]]
   set s2 [string range $string [expr $i+1] end]
   return "$s1$s2"
}


proc get_chanmodes { buffer len_buff id } {
	global canali wid
	set modes [lrange $buffer 4 end]
	set canale [string tolower [Convert [lindex $buffer 3]]]
        #set canale [string tolower $canale]
        set w [GetWindow $canale $id]
        if {[info exists wid($w,text)]&&[info exists wid($w,modes)]&&$w!=""} {
           if {$modes=="+"} {
              if {[catch {$wid($w,modes) configure -text ""}]} {return}
           } else {
              set pindex 5
              set l [string first l $modes]
              set k [string first k $modes]
              set mode [lindex $buffer 4]
              if {$l!=-1} {
                set limit [lindex $buffer 5]
                set mode [DelAtIndex [string first l $mode] $mode]
                set mode "$mode l:$limit"
                incr pindex
              }
              if {$k!=-1} {
                set pass [lindex $buffer $pindex]
                set mode [DelAtIndex [string first k $mode] $mode]
                set mode "$mode k:[Reverse $pass]"
              }
              catch {
                $wid($w,modes) configure -width [string length $mode]
                $wid($w,modes) configure -text "$mode"
              }
           }
        }
}


proc IRCkick { buffer len_buff  id}  {
 	global canali colsTXT destroycan me nick misc icons wid
	set buffer [Convert $buffer]
	set canale [string tolower [Convert [lindex $buffer 2]]]
	set w [GetWindow $canale $id]
	set kicker [get_nick $buffer]
	set kicknick [lindex $buffer 3]
        set reason [string trimleft [join [lrange $buffer 4 end]] ":"]
	if {[Convert $kicknick]==[Convert [::savirc::getNick $id]]} {
                set destroycan 0
                catch {$wid($w) close_win}
		if {$icons(show)} {
		     ImageText status kick
		}
		ColorText status "[format [mc "You have been kicked from %s by %s %s"] $canale [Reverse $kicker] ([Reverse $reason]\x096)]" $colsTXT(kick) 1
		autorejoin $canale $id
 	} else {
             if {[info exists wid($w,text)]&&$w!=""&&[winfo exists $wid($w,text)]} {

                reduce_numnicks $w
           	remov_nick $w [Reverse $kicknick]
		if {$icons(show)} {
		     ImageText $w kick
		}
		ColorText $w "[format [mc "%s has been kicked from %s by %s %s"] [Reverse $kicknick] $canale [Reverse $kicker] ([Reverse $reason]\x096)]" $colsTXT(kick) 1
                IfColorButton $w $id
	     }
	}
        IRC::Event000 kick $me($id,net) id $id nick [Reverse $kicknick] chan $canale kicker [Reverse $kicker] reason [Reverse $reason]

}



proc MakeChanlist { id } {
  global canali
  set lista $canali($id)
  set chanlist ""
  foreach element $canali($id) {
   if {[string first "canale" $element]!=0} {
    set chanlist "$chanlist $element"
   }
  }
  return $chanlist
}

proc MakeQuerylist {id} {
  global query
  set lista
  set querylist ""
  foreach element $query($id) {
   if {[string first "query" $element]!=0} {
    set querylist "$querylist $element"
   }
  }
  return $querylist
}

proc IRCquit { buffer len_buff id } {
 global canali colsTXT icons misc wid me
 set listcan [MakeChanlist $id]
 foreach can $listcan {
    set can [string tolower $can]
    set w [GetWindow $can $id]

    if {[info exists wid($w,text)]&&$w!=""&&[winfo exists $wid($w,text)]} {
       set nicklist [$wid($w,list) get 0 end]
       set quitnick [Reverse [get_nick $buffer]]
       set numelem [lsearch -exact $nicklist $quitnick]
       set host [Reverse [get_host $buffer]]
       set userid [Reverse [get_userid $buffer]]
       set quitnickc "@$quitnick"
       set quitnickv "+$quitnick"
       set numelemc [lsearch -exact $nicklist $quitnickc]
       set numelemv [lsearch -exact $nicklist $quitnickv]
       if {$numelem!=-1||$numelemc!=-1||$numelemv!=-1} {
         set duepn [string first " :" $buffer]
         set motivo [join [lrange $buffer 2 end]]
         set motivo [string trimleft $motivo ":"]


         remov_nick $w $quitnick
         reduce_numnicks $w
         if {!$misc(short)} {
             set msg "$quitnick"
             if {$misc(address)} {
                append msg " \[$userid@$host\]"
             }
	     # The quote is to correctly format the string when someone quits IRC
             append msg " [mc "has quit IRC"]"
         } else {
             set msg "[format [mc "Quits: %s"] $quitnick]"
         }
         if {$icons(show)} {
           ImageText $w quit
         }
         ColorText $w "$msg ($motivo\x096)" $colsTXT(quit) 1
         IfColorButton $w $id
         IRC::Event000 quit $me($id,net) id $id nick $quitnick user $userid host $host
       }
    }
 }
}



proc IRCquery { buffer len_buff action id } {
  global query colsTXT qprivcolor icons task me misc wid GUI
  if {[Ignore $buffer q]} { return }

  set nick [get_nick $buffer]
  set querynick [Convert $nick]
  set buffer [string trimleft $buffer ":"]
  set ini [expr [string first "PRIVMSG [::savirc::getNick $id] :" $buffer]+10+[string length [::savirc::getNick $id]]]
  set text [string range $buffer $ini end]
  set userid [get_userid $buffer]
  set host [get_host $buffer]
  set listquery [string tolower $query($id)]
  set qnicklow [string tolower $querynick]
  if {[lsearch $listquery $qnicklow]==-1} {
   winquery $querynick 1 $userid $host $id
  }

  set w [GetWinQuery $querynick $id]
  catch {$wid($w,titlebar) config -text "[format [mc "%s %s %s on %s"] $nick - \[$userid@$host\] $me($id,server)]"}
  
  set stringa $text
  if {$action} {
    set ini [string first "ACTION" $buffer]
    set txt [string range $buffer [expr $ini+7] [expr $len_buff-3]]
    if {$icons(show)} {ImageText $w action}
    ColorText $w "[Reverse $querynick] $txt" $colsTXT(action) 1
    IRC::Event000 queryaction $me($id,net) id $id nick [Reverse $querynick] user $userid host $host text $text
  } else {
    if {$icons(show)} {
	ImageText $w text
    }
    ColorText $w "<[Reverse $querynick]> $stringa" $colsTXT(query) 1
    IRC::Event000 querytext $me($id,net) id $id nick [Reverse $querynick] user $userid host $host text $text
  }

  if {[::platform::isPlatformUnix]} {
    if {$GUI(tk_theme)==1} {
      if {$me(icony)&&$misc(trayuse)} {
        if {$task(chat)==0&&$task(chan)==0} {
          incr task(chat)
	  $GUI(tray) configure -image $icons(tray2)

          .f.tip add $GUI(tray) "savIRC \[$task(chat) msgs - $task(chan) msgs in channels\]"
        } else {
          incr task(chat)
          .f.tip add $GUI(tray) "savIRC \[$task(chat) msgs - $task(chan) msgs in channels\]"
        }
      }
    }
  }
  
  if {[::platform::isPlatformWindows]} {
    if {$me(icony)&&$misc(trayuse)} {
      if {$task(chat)==0&&$task(chan)==0} {
        incr task(chat)
        winico taskbar delete $icons(ico_savirc) 
        winico taskbar add $icons(ico_savred) -callback "TaskMenu %m %i %X %Y" -text "savIRC \[$task(chat) msgs - $task(chan) msgs in channels\]"
      } else {
        incr task(chat)
        winico taskbar modify $icons(ico_savred) -text "savIRC \[$task(chat) msgs - $task(chan) msgs in channels\]"
      }
    }
  }

  IfColorButton $w $id
}

proc CleanCmd { topic } {
#ifndef PLATFORM_WIN
  regsub -all "(.)(.),(.)(.)" $topic "" topic
  regsub -all "(.)(.),(.)" $topic "" topic
  regsub -all "(.),(.)(.)" $topic "" topic
  regsub -all "(.),(.)" $topic "" topic
  regsub -all "(.)(.)" $topic "" topic
  regsub -all "(.)" $topic "" topic
  regsub -all "" $topic "" topic
#else /* PLATFORM_WIN */
  regsub -all "
(.)(.),(.)(.)" $topic "" topic
  regsub -all "
(.)(.),(.)" $topic "" topic
  regsub -all "
(.),(.)(.)" $topic "" topic
  regsub -all "
(.),(.)" $topic "" topic
  regsub -all "
(.)(.)" $topic "" topic
  regsub -all "
(.)" $topic "" topic
  regsub -all "
" $topic "" topic
#endif /* PLATFORM_WIN */
  regsub -all "" $topic "" topic
  regsub -all "" $topic "" topic

  return $topic
}


proc CleanTopic { topic } {
  regsub -all {\x03[0-9][0-9],[0-9][0-9]} $topic "" topic
  regsub -all {\x03[0-9][0-9],[0-9]} $topic "" topic
  regsub -all {\x03[0-9],[0-9][0-9]} $topic "" topic
  regsub -all {\x03[0-9],[0-9]} $topic "" topic
  regsub -all {\x03[0-9][0-9]} $topic "" topic
  regsub -all {\x03[0-9]} $topic "" topic
  regsub -all {[\x096\x86\x16\x02\x0f\x0f1\x7f\x1f\x03]} $topic "" topic
  return $topic
}


proc IRCtopic { buffer len_buff id } {
  global canali colsTXT icons gw wid me
  set canale [string tolower [lindex [Convert $buffer] 2]]
  #set canale [string tolower $canale]
  set topicnick [get_nick $buffer]
  set ini_t [string first " :" $buffer]
  set topic [string range $buffer [expr $ini_t+2] [expr $len_buff-1]]
  set w [GetWindow $canale $id]
  if {!([info exists wid($w,text)]&&$w!=""&&[winfo exists $wid($w,text)])} {return}
  if {$icons(show)} {ImageText $w mode}
  ColorText $w "[format [mc "%s changed topic to: %s"] $topicnick $topic]" $colsTXT(topic) 1
  catch {
    set gw $w
    $wid($w,topic) delete 1.0 end
    ColorText $wid($w,topic) $topic $colsTXT(prog) 0
    $wid($w,topic) see 1.0
  }
  IfColorButton $w $id
  IRC::Event000 topic $me($id,net) id $id nick $topicnick chan $canale topic $topic
}


proc EventError {event err} {
 tk_messageBox -icon error -message "$event [format [mc "event error: %s"] $err]"
}



proc IRCmode { buffer id } {
  global me active colsTXT canali icons wid
  
  # Since both 'canale's' are up here, maybe we can remove the ones lower down.
  set canale [lindex $buffer 2] ;# New 
  #set canale [Reverse [string tolower $canale]] ;# New
  set canale [string tolower [Convert $canale]]
  
  set iniz [string first $canale $buffer]
  
  #set iniz [string first " MODE " $buffer]
  # This allows us to see in a channel: X sets mode: #j-world +o sqwerl
  # Now if we increase 5 to 14, we would see: X sets mode: +o sqwerl <-- this is what looks nicer, and is more common sense.
  # Since we already know what channel we are on!\

  set stringa_ [string length $canale] ;# We don't want to see the channel name in the mode, so lets capture the chanName.
  set stringa [string range $buffer [expr $iniz+$stringa_+1] end] ;# Need to add the 1, to remove an extra space.

  if {[string first "!" [lindex $buffer 0]]!=-1} {
   set modenick [get_nick $buffer]
   set modehostnick [get_host $buffer]
  } else {
   set modenick [string trimleft [lindex $buffer 0] ":"]
  }
  
  set w [GetWindow $canale $id]
  if {[info exists wid($w,text)]&&$w!=""&&[winfo exists $wid($w,text)]} {
   if {$icons(show)} {
     ImageText $w mode
   }
   ColorText $w [Reverse [Convert "[format [mc "%s sets mode %s"] $modenick $stringa]"]] $colsTXT(mode) 1
   if {[catch {puts $me($id,sock) "MODE [Reverse $canale]"} err]} {
      Disconnect $id
      return
   }
   IfColorButton $w $id
   ana_mode $buffer $canale $w $id
   IRC::Event000 mode $me($id,net) id $id nick $modenick chan [Reverse $canale] params $stringa
  } else {
    set buffer [string trimleft $buffer ":"]
    if {[string match "[Convert [::savirc::getNick $id]] MODE [Convert [::savirc::getNick $id]] :*" $buffer]==1} {
       if {$icons(show)} {
         ImageText status info
       }
       NormalText status "[format [mc "%s sets mode: %s"] [::savirc::getNick $id] [lindex $buffer 3]]" $colsTXT(prog) 1
    }
  }
}


proc IRCjoin { buffer id} {
  global me createdate canali active colsTXT icons misc wid
  set canale [lindex [Convert $buffer] 2]
  set canale [string trimleft $canale ":"]

  if {[string first "[Convert :[::savirc::getNick $id]!]" [Convert $buffer]]==0} {
      wincan $canale $id
  }
  
  set w [GetWindow $canale $id]
  set joinnick [get_nick $buffer]
  set joinhostnick [get_host $buffer]
  set userid [get_userid $buffer]


  if {[info exists wid($w,text)]&&$w!=""} {

   if {$icons(show)} {
     ImageText $w join
   }

   if {!$misc(short)} {
     set msg "$joinnick"
     if {$misc(address)} {
        append msg " \[$userid@$joinhostnick\]"
     }
     append msg " [format [mc "has joined %s"] $canale]"
   } else {
     set msg "[format [mc "Joins: %s"] $joinnick]"
   }
   NormalText $w "$msg" $colsTXT(join) 1

   IfColorButton $w $id
  }

  IRC::Event000 join $me($id,net) id $id nick $joinnick user $userid host $joinhostnick chan [Reverse $canale]

  if {[Convert $joinnick]!=[Convert [::savirc::getNick $id]]&&$joinnick!=""&&[info exists wid($w,text)]&&$w!=""} {
   addnick $w $joinnick
   increase_numnicks $w
  }
}

proc noCase {t1 t2} {
    regsub {@} $t1 {#} t1
    regsub {@} $t2 {#} t2
    return [string compare [string tolower $t1] [string tolower $t2]]
}

proc llsort {lst} { return [lsort -command noCase $lst] }


proc addnick {w nick} {
    global wid chan
    set label $chan($w,stat)
    set op [string trimleft [lindex $label 1] "\[o:"]
    set voice [string trim [lindex $label 2] "v:\]"]
    switch -glob $nick {
       "@*" {
          set a 0
          set b [expr $op-1]
       }
       "+*" {
          set a $op
          set b [expr $op+$voice-1]
       }
       "default" {
          set a [expr $op+$voice]
          set b end
       }
    }
    set nicks [$wid($w,list) get $a $b]
    set nick [Convert $nick]
    set i 0
    foreach n $nicks {
      set n [Convert $n]
      if {[string compare -nocase $n $nick]==1} {
        break
      }
      incr i
    }
    incr i $a
    $wid($w,list) insert $i [Reverse $nick]
    return
}



proc IRCpart { buffer len_buff id} {
  global me colsTXT canali icons misc wid

  set motivo [join [lrange $buffer 3 end]]
  set motivo [Reverse $motivo]
  set motivo [string trimleft $motivo ":"]
  set canale [lindex $buffer 2]
  set canale [string trim $canale "]:" ]
  set canale [string tolower [Convert $canale]]
  set w [GetWindow $canale $id]

  set joinnick [Reverse [get_nick $buffer]]
  set userid [Reverse [get_userid $buffer]]
  set joinhostnick [Reverse [get_host $buffer]]

  if {[Convert $joinnick]!=[Convert [::savirc::getNick $id]]&&[info exists wid($w,text)]&&$w!=""&&[winfo exists $wid($w,text)]} {
   if {!$misc(short)} {
     set msg "$joinnick"
     if {$misc(address)} {
        append msg " \[$userid@$joinhostnick\]"
     }
     # the extra space is needed to allow correct formatting when a user leaves a channel.
     append msg " [format [mc "has left %s"] $canale]"
   } else {
     set msg "[format [mc "Parts: %s"] $joinnick]"
   }

   remov_nick $w $joinnick
   reduce_numnicks $w
   if {$icons(show)} {
     ImageText $w part
   }
   ColorText $w "$msg ($motivo\x096)" $colsTXT(part) 1
   IfColorButton $w $id

  }
  IRC::Event000 part $me($id,net) id $id nick $joinnick user $userid host $joinhostnick chan [Reverse $canale]
}



proc IRCinvitereply {buffer id} {
  global me active colsTXT icons
  if {$icons(show)} {ImageText $active($me(id)) invite}
  NormalText $active($me(id)) "[format [mc "You have invited %s to %s"] [lindex $buffer 3] [lindex $buffer 4]]" $colsTXT(invite) 1
}

proc remov_nick { w joinnick } {
 global wid
 if {![info exists wid($w,text)]} return
 set lista [$wid($w,list) get 0 end]
 set num [lsearch -exact $lista $joinnick]
 if {$num!=-1} {
    $wid($w,list) delete $num
    return   
 }
 set cnum [lsearch -exact $lista "@$joinnick"]
 if {$cnum!=-1} {
    $wid($w,list) delete $cnum
    decrease_opnum $w
    return
 }
 set vnum [lsearch -exact $lista "+$joinnick"]
 if {$vnum!=-1} {
    $wid($w,list) delete $vnum
    decrease_voicenum $w
    return   
 }
 set hnum [lsearch -exact $lista "%$joinnick"]
 if {$hnum!=-1} {
    $wid($w,list) delete $hnum
    return   
 }
 set fnum [lsearch -exact $lista "!$joinnick"]
 if {$fnum!=-1} {
    $wid($w,list) delete $fnum
    return   
 }
}



proc IRCprivchan { buffer len_buff id } {
  global canali colsTXT icons wid me
  set iniz [string first "PRIVMSG " $buffer]
  set finiz [string first " :" $buffer]
  set escla [string first "!" $buffer]
  set canale [string range $buffer [expr $iniz+8] [expr $finiz-1]]
  set canale [string trim $canale]
  set canale [string tolower $canale]
  set canale [Convert $canale]
  
  set w [GetWindow $canale $id]

  set priv_nick [get_nick $buffer]
  set priv_host [get_host $buffer]
  set priv_user [get_userid $buffer]
  set priv_nick [string trim $priv_nick]
  set priv_text [string range $buffer [expr $finiz+2] [expr $len_buff-1]]
  if {!([info exists wid($w,text)]&&$w!=""&&[winfo exists $wid($w,text)])} {return}

  if {$icons(show)} {
	ImageText $w text
  }

  ColorText $w "<[NickMode $priv_nick $w]$priv_nick> $priv_text" $colsTXT(chan) 1
  IRC::Event000 chantext $me($id,net) id $id nick $priv_nick user $priv_user host $priv_host chan [Reverse $canale] text $priv_text
  IfColorButton $w $id
}




proc IRCbanlist {buffer} {
   set ban [lindex [Convert $buffer] 4]
   if {[winfo exists .chanset]} {
      set banlist [.chanset.f.bans.f.f.listbox get 0 end]
      if {[lsearch [Convert $banlist] $ban]==-1} {
        .chanset.f.bans.f.f.listbox insert end [Reverse $ban]
      }
   }
}




proc IRCnotopic { buffer id } {
  global colsTXT
  set chan [Convert [lindex $buffer 3]]
  set w [GetWindow $chan $id]
  NormalText $w [mc "Topic is not set"] $colsTXT(topic) 1
}


proc get_channicks { buffer id } {
 global chanlist createdate colsTXT icons chan366
 set canale [lindex [Convert $buffer] 4]
 set canale [string tolower $canale]
 set w [GetWindow $canale $id]
 set nicks [string trimleft [lrange [Convert $buffer] 5 end] :]
 set createdate($w) 1
 eval lappend chanlist($w) $nicks

 if {$w==""||([info exists chan366($w)]&&$chan366($w)==1)} {
   if {$icons(show)} {ImageText status raw}
   ColorText status " \x02$canale\x02: [Reverse $nicks]" $colsTXT(serv) 1
 }
}



proc put_list { buffer id } {
 global canali chanlist wid chan366 colsTXT icons

 set canale [lindex [Convert $buffer] 3]
 set canale [string tolower $canale]
 set w [GetWindow $canale $id]

 if {$w==""||([info exists chan366($w)]&&$chan366($w)==1)} {
  if {$icons(show)} {ImageText status raw} 
  ColorText status " \x02$canale\x02: [format [mc "End of %s list."] /NAMES]" $colsTXT(serv) 1
  #ColorText status " " $colsTXT(serv) 1
 }

 if {![info exists wid($w,list)]} {
    set chan366($w) 1
    return
 } else {
   set chanlist($w) [llsort $chanlist($w)]
   if {![info exists chan366($w)]} {
     eval $wid($w,list) insert end [split [Reverse $chanlist($w)]]
   }
   set chanlist($w) ""
   set chan366($w) 1
   catch {count_vc $w}
 }
}

proc put_list2 {w} {
  global wid chanlist chan366
  if {[info exists chanlist($w)]&&$chanlist($w)!=""&&[info exists chan366($w)]} {
     $wid($w,list) delete 0 end
     set chanlist($w) [llsort $chanlist($w)]
     eval $wid($w,list) insert end [split [Reverse $chanlist($w)]]
     set chan366($w) 1
     array unset chanlist $w
     catch {count_vc $w}
  }
}



proc get_topic { buffer id put } {
  global me canali colsTXT misc icons gw wid topic
  if {!$put} {
    set canale [lindex $buffer 3]
    set canale [string tolower [Convert $canale]]
    set w [GetWindow $canale $id]
    set i [string first ":" [string range $buffer 1 end]]
    set topic($w) [string range $buffer [expr $i+2] end]
    set topic($w) [Reverse $topic($w)]
  } else {
    set w $buffer
  }

  if {![info exists topic($w)]||![info exists wid($w,topic)]} {return}
  set gw $w
  $wid($w,topic) delete 1.0 end
  ColorText $wid($w,topic) $topic($w) $colsTXT(prog) 0
  $wid($w,topic) see 1.0

  if {$misc(showtopic)} {
    catch {
      if {$icons(show)} {ImageText $w info}
      ColorText $w "[format [mc "Topic is: %s"] $topic($w)]" $colsTXT(mode) 1
      #ColorText $w " " $colsTXT(mode) 1
    }
  }
}


proc get_creation {buffer id} {
  global createdate canali colsTXT icons
  
  set when [lindex $buffer 4]
  set giorno [clock format $when -format %A]
  set mese [clock format $when -format %B]
  set ora [clock format $when -format %T]
  set ngiorno [clock format $when -format %d]
  
  set canale [lindex $buffer 3]
  set canale [string tolower [Convert $canale]]
  set w [GetWindow $canale $id]
  if {[catch { set v $createdate($w) }]} {
     return
  }
  if {!$createdate($w)} {return}
  if {$icons(show)} {ImageText $w info}
  NormalText $w "[format [mc "Channel was created on %s %s %s at %s"] $giorno $ngiorno $mese $ora]" $colsTXT(mode) 1
  set createdate($w) 0
}


proc get_topicdate {buffer id put } {
  global canali colsTXT icons misc wid topicdate
  if {!$put} {
   set nick [lindex $buffer 4]
   set when [lindex $buffer 5]
   if {![Isinteger $when]} { return }
   set giorno [clock format $when -format %A]
   set mese [clock format $when -format %B]
   set ora [clock format $when -format %T]
   set ngiorno [clock format $when -format %d]
   set canale [lindex $buffer 3]
   set canale [string tolower [Convert $canale]]
   set w [GetWindow $canale $id]
   set text "[format [mc "Set by %s on %s %s %s at %s"] [Reverse $nick] $giorno $ngiorno $mese $ora]"
   if {$misc(showtopic)} {
     set text "$text"
   } else {
     set text "[format [mc "Topic was %s"] $text]"
   }
   set topicdate($w) "$text"
  } else { 
    set w $buffer
    if {[info exists wid($w,text)]&&$w!=""&&[info exists topicdate($w)]} {
      if {$icons(show)} {ImageText $w info}
      NormalText $w $topicdate($w) $colsTXT(mode) 1
      array unset topicdate $w
    }
  }
}

proc IRCaction { buffer l id } {
  global canali colsTXT icons wid me
  set ini [string first "ACTION" $buffer]
  set txt [string range $buffer [expr $ini+7] [expr $l-2]]

  set canale [lindex [Convert $buffer] 2]
  set w [GetWindow [string tolower $canale] $id]
  if {!([info exists wid($w,text)]&&$w!=""&&[winfo exists $wid($w,text)])} {return}

  set nick [get_nick $buffer]
  set user [get_userid $buffer]
  set host [get_host $buffer]
  if {$icons(show)} {
    ImageText $w action
  }
  ColorText $w "[NickMode $nick $w]$nick $txt" $colsTXT(action) 1
  IRC::Event000 chanaction $me($id,net) id $id nick $nick user $user host $host chan [Reverse $canale] text $txt
  IfColorButton $w $id
}


proc RemoveList2 {lista one two} {
  set templist ""
  foreach item $lista {
    if {$item!=$one&&$item!=$two} {
      lappend templist $item
    }
  }

  return $templist
}

proc part_chan {w id} {
  global me canali destroycan clientMSG
  set canale [GetChannel $w $id]
  if {$destroycan!="0"&$me($id,conn)==1} {
    if {[catch {puts $me($id,sock) "PART [Reverse $canale] :$clientMSG(part)"} err]} {
       Disconnect $id
       return
    }
  }
  close_chan $w $id
}

proc close_chan { w id } {
  global me canali chan destroycan clientMSG log position timestamp history scroll chanlist logchan wid topic chan366
  set canale [GetChannel $w $id]
  set canali($id) [RemoveList2 $canali($id) $w [string tolower $canale]]

  array unset position $w
  array unset chanlist $w
  array unset chan366 $w
  array unset scroll $w
  array unset history $w
  array unset timestamp $w
  array unset log $w
  array unset wid $w
  array unset wid $w,modes
  array unset wid $w,text
  array unset wid $w,list
  array unset wid $w,command
  array unset wid $w,topic

  array unset chan $w,stat

  array unset topic $w
  if {[info exists logchan($w)]} {
  #fconfigure $logchan($w) -encoding utf-8
    catch {close $logchan($w)}
    array unset logchan $w
  }
}

proc close_query { w id } {
 global query history log timestamp logchan position wid scroll
 set lista $query($id)
 set indice [lsearch -exact $lista $w]
 incr indice -1
 set qnick [lindex $lista $indice]
 set query($id) [RemoveList2 $query($id) $w $qnick]
 array unset position $w
 array unset history $w
 array unset timestamp $w
 array unset log $w
 array unset wid $w
 array unset wid $w,titlebar
 array unset wid $w,text
 array unset wid $w,command
 array unset scroll $w


 if {[info exists logchan($w)]} {
    catch {close $logchan($w)}
    array unset logchan $w
 }
}


proc close_chat {w id} {
  global active chat colsTXT CHATsk me history timestamp log icons logchan wid position scroll
   set lista $chat($id)
   set indice [lsearch -exact $lista $w]
   set nick [lindex $lista [expr $indice-1]]

   set chat($id) [RemoveList2 $chat($id) $w $nick]
   array unset position $w
   array unset history $w
   array unset timestamp $w
   array unset log $w
   array unset wid $w
   array unset wid $w,titlebar
   array unset wid $w,text
   array unset wid $w,command
   array unset scroll $w

   if {[info exists logchan($w)]} {
     catch {close $logchan($w)}
     array unset logchan $w
   }

   if {$nick!=""} {
    if {$icons(show)} {
      ImageText status dcc
    }
    NormalText status "[format [mc "DCC chat with %s terminated"] [Reverse $nick]]" $colsTXT(ctcp) 1
    catch {close $CHATsk($nick)}
    IRC::Event000 chatclose $me($id,net) id $id nick [Reverse $nick] 
   }
}

proc get_command {w where} {
 global wid
 set stringa [$wid($w,command) get]
 set str [split $stringa "\n"]
 catch {
  $wid($w,command) delete 0 end
  SetSplitter $w
 }
 foreach stringa $str {
    get_command2 $w $where $stringa
 } 
}

proc get_command2 {w where stringa} {
 global active me misc wid
 if {[string first "/" $stringa]!=0} {
   if {$misc(history)} { catch {CmdHistoryPut $stringa} }
   set stringa [FormatColors $stringa]
   set stringa [string range $stringa 0 $misc(splitter)]
   if {[string trim "$stringa"]==""} {return}
   switch -glob $where {
     "channel" {
               write_text $w $stringa
               }
     "query" {
               write_query $w $stringa
               }
     "chat" {
               write_chat $w $stringa
               }
   }
 } else {
   if {$misc(historycmd)} { catch {CmdHistoryPut $stringa} }
   anacom [FormatColors $stringa] $w
 }

}



proc write_text { w stringa } {
 global me colsTXT icons
 if {$stringa!=""} {
   if {$icons(show)} {ImageText $w text}
   ColorText $w "<[NickMode [::savirc::getNick $me(id)] $w][Reverse [Convert [::savirc::getNick $me(id)]]]> $stringa" $colsTXT(mechan) 1
 }
 set canale [GetChannel $w $me(id)]
 if {[catch {puts $me($me(id),sock) "PRIVMSG [Reverse $canale] :$stringa"} err]} {
    Disconnect $me(id)
 }
}


proc Window {w} {
 global wid
 if {$w=="status"||$w=="."} {return}
 if {[string first "query" $w]!=0&&[string first "chat" $w]!=0} {
    return 0
 } elseif {[string first "query" $w]==0} {
    return 1
 } elseif {[string first "chat" $w]==0} {
    return 2
 }
 return
}


proc GetWinQuery { nick id } {
  global query
  set listquery [string tolower $query($id)]
  set nick [string tolower $nick]
  set indice [lsearch $listquery $nick]
  incr indice
  set w [lindex $listquery $indice]
  return $w
}

proc GetWinChat { nick id } {
  global chat
  set lista [string tolower $chat($id)]
  set nick [string tolower $nick]
  set indice [lsearch $lista $nick]
  incr indice
  set w [lindex $lista $indice]
  return $w
}


proc GetWinChan { chan id } {
  set w [GetWindow $chan $id]
  return $w
}


proc GetWindow { chan id } {
  global canali
  set chan [string tolower $chan]
  set n [lsearch $canali($id) $chan]
  if {$n==-1} {return}
  incr n
  set w [lindex $canali($id) $n]
  return $w
}


proc GetChannel { w id } {
 global canali
 set indice [lsearch -exact $canali($id) $w]
 incr indice -1
 set canale [lindex $canali($id) $indice]
 return $canale
}

proc GetQuery {w id} {
 global query
 set lista $query($id)
 set indice [lsearch -exact $lista $w]
 incr indice -1
 set nick [lindex $lista $indice]
 return [Reverse $nick]
}

proc GetChat {w id} {
 global chat
 set lista $chat($id)
 set indice [lsearch -exact $lista $w]
 incr indice -1
 set nick [lindex $lista $indice]
 return [Reverse $nick]

}



proc write_query { w stringa } {
 global query me colsTXT icons
 if {$stringa!=""} {
     if {$icons(show)} {
       ImageText $w text

    }
    ColorText $w "<[Reverse [Convert [::savirc::getNick $me(id)]]]> $stringa" $colsTXT(mequery) 1
 }
 set lista $query($me(id))
 set indice [lsearch -exact $lista $w]
 incr indice -1
 set qnick [lindex $lista $indice]
 set qnick [Reverse $qnick]
 if {[catch {puts $me($me(id),sock) "PRIVMSG $qnick :$stringa"} err]} {
    Disconnect $me(id)
 }
}


proc deflag { nick } {
  return [string trimleft $nick "@+%!"]
}



proc autorejoin { canale id } {
  global me misc
  if {$misc(rejoin)=="1"} {
    if {[catch {puts $me($id,sock) "JOIN [Reverse $canale]"} err]} {
      Disconnect $id
    }
  }
}


proc active_whois { buffer len_buff num id } {
 global me act active hostnick usernick colsTXT whois icons
        if {$act(whois)!=1} {
          set w status
        } else {
          set w $active($me(id))
        }
        switch -- $num {
	 309 {
	   set msg [join [lrange $buffer 4 end]]
	   set nick [lindex $buffer 3]
           if {$whois(309)==1} {
              if {$icons(show)} {
                ImageText $w info
              }
              NormalText $w "$nick $msg" $colsTXT(whois) 1
              #ColorText $w "$msg" $colsTXT(whois) 1
           }
           set whois(309) 1
	 }
         311 {
           set hostnick [lindex $buffer 5]
           set iniz [string first " :" $buffer]
           set realn [string range $buffer [expr $iniz+2] $len_buff]
           set usernick [lindex $buffer 4]
           set wnick [lindex $buffer 3]
           if {$whois(311)==1} {
              if {$icons(show)} {
                ImageText $w info
              }
              NormalText $w "[format [mc "%s is: %s"] $wnick $usernick@$hostnick]" $colsTXT(whois) 1
              if {$icons(show)} {
                ImageText $w info
              }
              NormalText $w "[format [mc "%s real name: "] $wnick ] $realn" $colsTXT(whois) 1
              #ColorText $w "$realn" $colsTXT(whois) 1
           }
           set whois(311) 1
         }
         312 {
           set iniz [string first " :" $buffer]
           set serv [string range $buffer [expr $iniz+2] $len_buff]
           set server [lindex $buffer 4]
           set wnick [lindex $buffer 3]
           if {$whois(312)==1} {
             if {$icons(show)} {
                ImageText $w info
             }
              NormalText $w "[format [mc "%s server: %s"] $wnick's $server] - $serv" $colsTXT(whois) 1
              #ColorText $w " $serv" $colsTXT(whois) 1
           }
	   set whois(312) 1
         }
         319 {
           set iniz [string first " :" $buffer]
           set wnick [lindex $buffer 3]
           set chans [string range $buffer [expr $iniz+2] $len_buff]
           if {$whois(319)==1} {
             if {$icons(show)} {
                ImageText $w info
             }
             NormalText $w "[format [mc "%s is on: %s"] $wnick $chans]" $colsTXT(whois) 1
	   }
	   set whois(319) 1
         }
         317 {
           set secs [lindex $buffer 4]
           set when [lindex $buffer 5]
           set wnick [lindex $buffer 3]
           if {[Isinteger $when]} {
	     set giorno [clock format $when -format %a]
  	     set mese [clock format $when -format %b]
  	     set ora [clock format $when -format %T]
	     set ngiorno [clock format $when -format %d]
             set signon "[format [mc "sign on: %s %s %s at %s"] $giorno $ngiorno $mese $ora]"
           } else {
             set signon [join [lrange $buffer 5 end]]
           }
           if {$whois(317)==1} {
             if {$icons(show)} {
                ImageText $w info
             }
             NormalText $w "[format [mc "%s has been idle: %s %s"] $wnick $secs $signon]" $colsTXT(whois) 1
	   }
	   set whois(317) 1
         }
         318 {
           set wnick [lindex $buffer 3]
           set iniz [string first " :" $buffer]
           set endw [string range $buffer [expr $iniz+2] $len_buff]
           if {$whois(318)==1} {
             if {$icons(show)} {
                ImageText $w info
             }
             NormalText $w "$wnick: $endw" $colsTXT(whois) 1
             #ColorText $w " $endw" $colsTXT(whois) 1
	   }
	   set whois(318) 1
         }
	 330 {
           if {$whois(330)==1} {
             set wnick [lindex $buffer 3]			
	     set login [lindex $buffer 4]			
             if {$icons(show)} {ImageText $w info}
             NormalText $w "[format [mc "%s is logged in as: %s"] $wnick $login]" $colsTXT(whois) 1
	   }
	   set whois(330) 1
	 }
       }
}



proc reduce_numnicks { w } {
       global wid chan
       catch {
	set label $chan($w,stat)
	set num [lindex $label 0]
	incr num -1
        set due [lindex $label 1]
        set tre [lindex $label 2]
        set chan($w,stat) "$num $due $tre"
       }
}

proc increase_numnicks { w } {
        global wid chan
        catch {
        set label $chan($w,stat)
        set num [lindex $label 0]
        incr num
	set due [lindex $label 1]
	set tre [lindex $label 2]
        set chan($w,stat) "$num $due $tre"     
        }

}

proc decrease_opnum { w } {
        global wid chan
        catch {

        set label $chan($w,stat)
        set num [lindex $label 0]
        set tre [lindex $label 2]
        set opnum [string trimleft [lindex $label 1] "\[o:"]
	incr opnum -1
        set chan($w,stat) "$num \[o:$opnum $tre"

        }
}

proc increase_opnum { w } {
        global wid chan
        catch {

        set label $chan($w,stat)
        set num [lindex $label 0]
        set tre [lindex $label 2]
        set opnum [string trimleft [lindex $label 1] "\[o:"]
        incr opnum
        set chan($w,stat) "$num \[o:$opnum $tre"
        }
}

proc increase_voicenum { w } {
        global wid chan
        catch {

        set label $chan($w,stat)
        set num [lindex $label 0]
        set due [lindex $label 1]
        set vnum [string trim [lindex $label 2] "v:\]"]
        incr vnum
        set chan($w,stat)  "$num $due v:$vnum\]"

        }
}



proc decrease_voicenum { w } {
        global wid chan 
        catch {

        set label $chan($w,stat)
        set num [lindex $label 0]
        set due [lindex $label 1]
        set vnum [string trim [lindex $label 2] "v:\]"]
        incr vnum -1
        set chan($w,stat)  "$num $due v:$vnum\]"

 }
}


proc ana_mode { buffer canale w id } {
  global me
  if {[string first "!" [lindex $buffer 0]]!=-1} {
    set nick  [get_nick $buffer]
    set host  [get_host $buffer]
    set user  [get_userid $buffer]
  } else {
    set nick [string trimleft [lindex $buffer 0] ":"]
    set host  ""
    set user  ""
  }
  set params [lindex $buffer 3]
  set rest [lrange $buffer 4 end]
  set add 1
  set count 0

  foreach c [split $params {}] {
    switch -- $c {
      "+" { set add 1 }
      "-" { set add 0 }
      "b" {
        incr count
      }
      "o" {
        if {$add} {
          set opnick [lindex $rest $count]
          remov_nick $w [Reverse $opnick]
          set opnick "@$opnick"
          addnick $w [Reverse $opnick]
          increase_opnum $w
          incr count
          IRC::Event000 op $me($id,net) id $id nick [Reverse $nick] user $user host $host chan $canale opper [Reverse $opnick]
        } else {
          set opnick [lindex $rest $count]
          remov_nick $w [Reverse $opnick]
          addnick $w [Reverse $opnick]
          incr count
          IRC::Event000 deop $me($id,net) id $id nick [Reverse $nick] user $user host $host chan $canale deopper [Reverse $opnick]
        }
      }
      "v" {
        if {$add} {
          set vnick [lindex $rest $count]
          if {[NickMode $vnick $w]==""} {
            remov_nick $w [Reverse $vnick]
            set vnick "+$vnick"
            addnick $w [Reverse $vnick]
            increase_voicenum $w
          }
          incr count
          IRC::Event000 voice $me($id,net) id $id nick [Reverse $nick] user $user host $host chan $canale voicer [Reverse $vnick]
        } else {
          set vnick [lindex $rest $count]
          if {[NickMode $vnick $w]=="+"} {
            remov_nick $w [Reverse $vnick]
            addnick $w [Reverse $vnick]
          }
          incr count
          IRC::Event000 devoice $me($id,net) id $id nick [Reverse $nick] user $user host $host chan $canale devoicer [Reverse $vnick]
        }
      }
      "h" { ;# 'halfops'
        if {$add} {
          set hnick [lindex $rest $count]
	  set nickmode [NickMode $hnick $w]
          if {$nickmode=="" || $nickmode=="+"} {
            remov_nick $w [Reverse $hnick]
            set hnick "%$hnick"
            addnick $w [Reverse $hnick]
          }
          incr count
          IRC::Event000 halfop $me($id,net) id $id nick [Reverse $nick] user $user host $host chan $canale halfopper [Reverse $hnick]
        } else {
          set hnick [lindex $rest $count]
          if {[NickMode $hnick $w]=="%"} {
            remov_nick $w [Reverse $hnick]
            addnick $w [Reverse $hnick]
          }
          incr count
          IRC::Event000 dehalfop $me($id,net) id $id nick [Reverse $nick] user $user host $host chan $canale dehalfopper [Reverse $hnick]
        }
      }
      "a" { ;# 'admin/founder'
        if {$add} {
          set anick [lindex $rest $count]
	  set nickmode [NickMode $anick $w]
          if {$nickmode=="" || $nickmode=="+" || $nickmode=="@"} {
            remov_nick $w [Reverse $anick]
            set anick "!$anick"
            addnick $w [Reverse $anick]
          }
          incr count
          IRC::Event000 admin $me($id,net) id $id nick [Reverse $nick] user $user host $host chan $canale admin [Reverse $anick]
        } else {
          set anick [lindex $rest $count]
          if {[NickMode $anick $w]=="!"} {
            remov_nick $w [Reverse $anick]
            addnick $w [Reverse $anick]
          }
          incr count
          IRC::Event000 deadmin $me($id,net) id $id nick [Reverse $nick] user $user host $host chan $canale deadmin [Reverse $anick]
        }
      }
    }
  }
}


proc count_vc { w } {
   global wid chan
   set numv 0
   set numc 0
   set list [$wid($w,list) get 0 end]
   foreach nick $list  {
	set firc [string index $nick 0]
	if {$firc=="+"} {
           incr numv
        } elseif {$firc=="@"} {
           incr numc
        }

  }
  catch {set chan($w,stat) "[llength $list] \[o:$numc v:$numv\]"}
}

proc AddColorTag2 {tag w id x y} {
   global me wid GUI
   set modes [$wid($w,modes) cget -text]
   set nikke "@[::savirc::getNick $id]"
   set lista [$wid($w,list) get 0 end]
   if {[lsearch -exact $lista $nikke]!=-1 || [string first "n" $modes]==-1} {
     bind $wid($w,topic) <KeyPress> "Preview $wid($w,topic)"
     $wid($w,topic) config -cursor $GUI(cursor);
     focus $wid($w,topic)
     if {$tag==""} {
      $wid($w,topic) insert insert ""
      ColorTip $x $y
     } else {
      $wid($w,topic) insert insert $tag
     }
  }
}



proc ToggleEdit { w id b } {
	global me wid GUI
	set modes [$wid($w,modes) cget -text]
   
        if {!$b} {
           bind $wid($w,topic) <FocusIn> "focus $wid($w,command)"
           bind $wid($w,topic) <KeyPress> "break"
        } else {
	 if {[NickMode [::savirc::getNick $id] $w]=="@"||[string first "n" $modes]==-1} {
           bind $wid($w,topic) <FocusIn> "break"
	   bind $wid($w,topic) <KeyPress> "Preview $wid($w,topic)"
           $wid($w,topic) config -cursor $GUI(cursor);
           focus $wid($w,topic)
         } else {
           tk_messageBox -message "[mc "You can edit the topic only if you are an OP"]\n[mc "or channel mode +t is not set!"]"
         }
        }
}

proc confirm_topic { w } {
	global canali me wid
        $wid($w,topic) config -cursor {};
        bind $wid($w,topic) <KeyPress> "break"
        set canale [GetChannel $w $me(id)]
        set topic [$wid($w,topic) get 1.0 end]
        if {[catch {puts $me($me(id),sock) "TOPIC [Reverse $canale] :[FormatColors $topic]"} err]} {
           Disconnect $me(id)
        }
	focus $wid($w,command)
}


proc convert_nick { var } {
  set newvar ""
  set add_two ""
  foreach c [split $var {}] {
        switch -- "$c" {
          "\{" { append newvar "\x90" }
          "\}" { append newvar "\x91" }
          "\[" { append newvar "\x92" ; set add_two 1 }
          "\]" { append newvar "\x93" }
          "\"" { append newvar "\x94" }
          default { append newvar "$c" }
        }
  }

  if {$add_two==1} {
    set nlen [string length $newvar]
    set newvar [string range $newvar 0 [expr $nlen-1]]
  }

  while {[string first "\\" $newvar]>=0} {
    set i [string first "\\" $newvar]
    set newvar "[string range $newvar 0 [expr $i-1]]\x95[string range $newvar [expr $i+1] end]"
  }
  return "$newvar"
}


proc reverse_nick { var } {
  set newvar ""
  foreach c [split $var {}] {
        switch -- "$c" {
          "\x90" { append newvar "\{" }
          "\x91" { append newvar "\}" }
          "\x92" { append newvar "\[" }
          "\x93" { append newvar "\]" }
          "\x94" { append newvar "\"" }
          "\x95" { append newvar "\\" }
          default { append newvar "$c" }
        }
  }
  return "$newvar"
}


proc IfColorButton { w id } {
   global active me wid

   if {![info exists wid($w)]} {return}
   if {$w!=$active($me(id))||[$wid($w) cget -state]=="withdrawn"} {
       if {[.buttonbar.buttonbar.$w cget -relief]!="raised"} {return}
       catch {.buttonbar.buttonbar.$w.t configure -foreground red}
   }
}

proc IfNotColorButton { w } {
  catch { .buttonbar.buttonbar.$w.t configure -foreground black }
}


proc NickMode {nick w} {
  global chan wid

  if {[Window $w]!=0} {return ""}
  
  set nick [Convert $nick]
  set nicklist [$wid($w,list) get 0 end]
  
  foreach n $nicklist {
    if {[Convert $n]=="@$nick"} {
      return @
    }
    if {[Convert $n]=="!$nick"} {
      return !
    }
    if {[Convert $n]=="%$nick"} {
      return %
    }
    if {[Convert $n]=="+$nick"} {
      return +
    }
  }
  return ""
}

proc IRCnick { buffer id } {
	global me active act canali colsTXT icons wid query
	if {$act(nick)} {
	 set win $active($id)
	} else {
	 set win status
	}
	set cnick [get_nick $buffer]
        set userid [get_userid $buffer]
        set host [get_host $buffer]

	set newnick [string trimleft [lindex $buffer 2] ":"]

        IRC::Event000 nick $me($id,net) id $id nick $cnick newnick $newnick
	        if {[Convert $cnick]==[Convert [::savirc::getNick $id]]} {
	          set menick 1
	          ::savirc::setNick $id [Reverse $newnick]
                  if {$me(id)==$id} {
                    set me(cserver) $me($id,server)
                    set me(cnick) [::savirc::getNick $id]
   		    if {[llength $me(sockslist)]>1} {
     		      set me(command) "$me(cnick) \[$me(cserver)\]"
	            } else {
     		      set me(command) $me(cnick)
                    }
                  }
                  if {$icons(show)} {ImageText $win nick}
                  ColorText $win "[format [mc "You are now known as %s"] [Reverse $newnick]]" $colsTXT(nick) 1
                  UpdateServerList
                  if {$id==$me(id)} {SetCurrents $id}
                } else {
                  set menick 0
                    set indice [lsearch [string tolower $query($id)] [string tolower [Convert $cnick]]]
                    if {$indice!=-1} {   
                      incr indice 

                        set win [lindex $query($id) $indice]
                        set query($id) [RemoveList2 $query($id) $win $cnick]
                        lappend query($id) "[Convert $newnick]" "$win"
                        if {$icons(show)} {ImageText $win nick}
                        ColorText $win "[format [mc "%s is now known as %s"] $cnick $newnick]" $colsTXT(nick) 1
                        $wid($win,titlebar) config -text "[format [mc "%s %s %s on %s"] $newnick - \[$userid@$host\] $me($id,server)]"
                        .buttonbar.buttonbar.$win.t configure -text $newnick
                        destroy $wid($win,text).menu
                        #query_menus $win [Convert $newnick]
                      
                    }
                }

                set listcan [MakeChanlist $id]
                foreach can $listcan {
                        set can [string tolower $can]
                        set w [GetWindow $can $id]
                        if {[info exists wid($w,text)]&&$w!=""&&[winfo exists $wid($w,text)]} {
                        set nicklist [$wid($w,list) get 0 end]
                        set numelem [lsearch -exact $nicklist $cnick]

			if {$numelem!=-1} {
                         remov_nick $w $cnick
			 addnick $w $newnick
			 if {!$menick} {
                            if {$icons(show)} {ImageText $w nick}
                            ColorText $w "[format [mc "%s is now known as %s"] $cnick $newnick]" $colsTXT(nick) 1
                         }
                         continue
                        }

                        set numelemc [lsearch -exact $nicklist "@$cnick"]

                        if {$numelemc!=-1} {
                         remov_nick $w "@$cnick"
			 addnick $w @$newnick
                         if {!$menick} {
                            if {$icons(show)} {ImageText $w nick}
                            ColorText $w "[format [mc "%s is now known as %s"] @$cnick @$newnick]" $colsTXT(nick) 1
                         }
                         continue
                        }

                        set numelemv [lsearch -exact $nicklist "+$cnick"]

                        if {$numelemv!=-1} {
                         remov_nick $w "+$cnick"
			 addnick $w +$newnick
                         if {!$menick} {
                           if {$icons(show)} {ImageText $w nick}
                            ColorText $w "[format [mc "%s is now known as %s"] +$cnick +$newnick]" $colsTXT(nick) 1
                         }
                        }
		       }
                }
                
}


proc ncomplete {} {
  global misc active me complist compini wid
  if {[string first "query" $active($me(id))]==0} return
  if {!$misc(ncompl)} return
  if {[$wid($active($me(id)),command) get]==""} return
  
  	set cmd [$wid($active($me(id)),command) get]
  	set icursor [$wid($active($me(id)),command) index insert]
    	incr icursor -1
  
  	set txt1 [string range $cmd 0 $icursor]
  	incr icursor
  
  set txt2 [string range $cmd $icursor end]
  set compl [Reverse [lindex [Convert $txt1] end]]
  set style 0
  
  	if {$txt1==$compl} {
    	set style 1
  	}
  
  if {$complist==""} {
     foreach nick [$wid($active($me(id)),list) get 0 end] {
       set nick [deflag $nick]
       if {[string first [string tolower $compl] [string tolower $nick]]==0} {
          lappend complist $nick
  	     }
    	}
     }
  
  if {$complist==""} {return}
  
  	set nick [lindex $complist 0]
  	set cend [expr [string length $txt1]-[string length $compl]]
  	incr cend -1
  
  if {$compini==1} {
     set txt1 ""
     set txt2 ""
     set cend "end"
     set style 1
  }
  
  set txt1 [string range $txt1 0 $cend]
  
  if {$style} {
    set add $misc(completion)
    regsub {%nick} $add $nick add
    set compini 1
  } else {
    set add $nick
  }
  
  append txt1 $add
  
  $wid($active($me(id)),command) delete 0 end
  $wid($active($me(id)),command) insert 0 "$txt1$txt2"
  $wid($active($me(id)),command) icursor [string length $txt1]
  
  set complist [lrange $complist 1 end]
  
  lappend complist $nick
  focus $wid($active($me(id)),command)
}



proc get_nick { buffer } {
 set iniz [string first "!" $buffer]
 incr iniz -1
 set nick [string range $buffer 1 $iniz]
 return $nick

}

proc get_host { buffer } {
 if {[catch {lindex $buffer 0} stringa]} {
  return "unknown"
 }
 set iniz [string first "@" $stringa]
 incr iniz
 set host [string range $stringa $iniz end]
 return $host
}

proc get_userid { buffer } {
  set chioc [string first "@" $buffer]
  set escl [string first "!" $buffer]
  incr chioc -1
  incr escl
  set userid [string range $buffer $escl $chioc]
  return $userid
}



proc ipPack {ip} {
    set val 0
    foreach x [split $ip .] { set val [expr {($val << 8) | ($x & 0xff)}] }
    return [format %u $val]
}

proc QueryNickC {nick} {
  global wid 

  PPreview $nick 0
  after 10 {
     set nick [PPreview "" 1]
     IRC::query $nick

  }
}


proc QueryByList {w} {
 global wid
 set ind [$wid($w,list) curselection]
 set nick [deflag [$wid($w,list) get $ind]]
 set nick [Convert $nick]
 IRC::query $nick
}



proc SelectNick { w nick } {
 global wid
  
 if {$nick==""} {
    if {![info exists wid($w,text)]} {
     tk_messageBox -message "[mc No!]"
     return
    }

    set nick [GetWordFromText $wid($w,text)]
    
 }


  set lnicks [$wid($w,list) get 0 end]
  set nick [Reverse $nick]
  set i [lsearch -exact $lnicks $nick]

  if {$i==-1} {
    set i [lsearch -exact $lnicks @$nick]
  }
  if {$i==-1} {
    set i [lsearch -exact $lnicks +$nick]
  }

    $wid($w,list) selection clear 0 end
    $wid($w,list) selection set $i
    $wid($w,list) see $i

}



proc OpenUrl {url} {
  global files active colsTXT me env tcl_platform
  if {$url==""} {return}
  
  set url [string trim $url "'\[\]();.:,\x93\""] ;#" - This quote is here to
  
  if {[::platform::isPlatformUnix]} {
    if {[info exists files(browser)]==0||$files(browser)==""} {
      tk_messageBox -message "[mc "Browser path has not been set."]"
      return
    }

    if {[catch {exec $files(browser) $url &} err]} {
      tk_messageBox -icon error -message "$err"
    }
  }
  
  if {[::platform::isPlatformWindows]} {
    if {$tcl_platform(os) == "Windows NT"} {
      set rc [catch {exec $env(COMSPEC) /c start $url &} emsg]
    } else {
      set rc [catch {open "|start $url"} emsg]
    }
    if {$rc} {
      tk_messageBox -icon error -message [format [mc "Error displaying %s in browser %s %s"] $url \n $emsg]
      return
    }  
  }
  
}


proc Ignore {buffer flag} {
 global ignore tempignore
 set buffer [Convert $buffer]
 if {[catch {lindex $buffer 0} buffer]} {
   return 0
 }
 set buffer [string trimleft $buffer ":"]
 if {[HandleIgnore $ignore $buffer $flag]} {
   return 1
 } else {
   return [HandleIgnore $tempignore $buffer $flag]
 }
}

proc HandleIgnore {ignore buffer flag} {
 foreach item $ignore {
   set mask [lindex $item 0]
   if {$mask!=""} {
     if {[string first "!" $mask]==-1&&[string first "@" $mask]==-1} {
       set mask "$mask!*@*"
     }
     set flags [lindex $item 1]
     if {[string match $mask $buffer]} {
        if {[string first $flag $flags]!=-1||$flags=="a"} {
            return 1
        }
     }
   }
 }
 return 0
}

proc DelIgnoreTemp {} {
  global tempignore me colsTXT active icons
  set int [clock seconds]
  set i 0
  foreach item $tempignore {
     set sec [lindex $item 2]
     if {$sec!=""&&[Isinteger $sec]&&$int>=$sec} {
       set tempignore [lreplace $tempignore $i $i]
       if {$icons(show)} {ImageText $active($me(id)) prog}
       NormalText $active($me(id)) "[format [mc "Removed %s %s from temporary ignore list"]. [lindex $item 0] ([lindex $item 1])]" $colsTXT(prog) 1
     }
     incr i
  }
}

proc AddIgnore {mask flags} {
  global files colsTXT active icons

  if {[catch {open $files(ignore) a+} fd]} {
     if {$icons(show)} {ImageText $active prog}
     NormalText $active $fd $colsTXT(prog) 1
     return
  }
# Add in utf-8 support?
# fconfigure $fd -encoding utf-8
  puts $fd "$mask $flags"
  catch {close $fd}
  LoadIgnoreList
}

proc BPS {} {
 global me bps
 after 1000 { BPS }
 if {[llength $me(sockslist)]==0} {
   return
 }
 .status.bps config -text "$bps bps"
 set bps 0
}

proc Convert {txt} {
  return [convert_nick $txt]
}

proc Reverse {txt} {
  return [reverse_nick $txt]
}

# This procedure is from the tclers wiki.
# Added this procedure; took care of the error when pasting. But pasting with the menu doesn't work at all.
# ctrl+v does work.
proc ::tk_textPaste w {
   global tcl_platform
   array set range {}
   if { [catch {$w tag ranges sel} ranges] } { return }
   foreach {first last} $ranges {
     set range($first) $last
     puts "set range($first) \[$last\]"
   }

   if { [catch {::tk::GetSelection $w CLIPBOARD} sel] } { return }

   set oldSeparator [$w cget -autoseparators]
   if { $oldSeparator } {
     $w configure -autoseparators 0
     $w edit separator
   }
   if { ![string equal [tk windowingsystem] "x11"] } {
     foreach first [lsort -decreasing [array names range]] {
       $w delete $first $range($first)
     }
   }
   $w insert insert $sel
   if { $oldSeparator } {
     $w edit separator
     $w configure -autoseparators 1
   }
}

proc Copy_Clipboard {} {
  global active me wid
  set w $active($me(id))
  if {![info exists wid($w,text)]} {return}
  tk_textCopy $wid($w,text)
}

proc Paste_Clipboard {} {
  global active me wid
  set w $active($me(id))
  if {![info exists wid($w,text)]} {return}

  tk_textPaste $wid($w,command)
}

proc ViewLog {f} {
  global me active GUI logchan wid font
  if {$f==""} {
  set tran $wid($active($me(id)),text)
  set w $active($me(id))
  if {$w=="status"} {return}
  set id [GetWindowID $w]
  set type [Window $w]
  catch {
     close $logchan($w)
     array unset logchan $w
  }
  switch $type {
    0 {
        set name [GetChannel $w $id]
        set dir [file join $me(home) config $me(profile) logs Channels]
      }
    1 {
        set name [GetQuery $w $id]
        set dir [file join $me(home) config $me(profile) logs Queries]
      }
    2 { set name [GetChat $w $id]
        set dir [file join $me(home) config $me(profile) logs Chats]
      }
  }
    set filename [file join $dir "$me($id,server) $name.log"]
    set title "Log for $name ($me($id,server))"
  } else {
    set filename $f
    set title "$f"
    set tran ".conf"
  }

  set filename [fix_filename $filename]

  if {[catch {open "$filename" r} log]} {
     tk_messageBox -icon error -message "[format [mc "%s not found."] $title]"
     return
  }

  fconfigure $log -encoding $me(encoding)
  set txt [read "$log"]
  
  close "$log"


  set w ".log"
  if {[winfo exists $w]} {return}
  toplevel $w -class Log
  wm title $w "$title"
  wm geometry $w +100+100
  wm resizable $w 0 0
  wm transient $w $tran

  frame $w.f
  text $w.f.text -yscrollcommand "$w.f.scroll set" -background white -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground)
  frame $w.f.bar
  
  xbutton $w.f.bar.close -text [mc Close] -command "destroy $w" -width 6 -font $font(button)
  if {[::platform::isPlatformWindows]} {
    xbutton $w.f.bar.edit -text [mc "Edit with NotePad"] -command "catch {exec notepad $filename &}" -font $font(button)
  }

  xscrollbar $w.f.scroll -command "$w.f.text yview"
  pack $w.f -fill both -expand yes -padx 5 -pady 5
  grid config $w.f.text -column 0 -row 0 -columnspan 1 -rowspan 1 -sticky "snew"
  grid config $w.f.scroll -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky "snew"
  grid config $w.f.bar -column 0 -row 1 -columnspan 2 -rowspan 1 -sticky "snw"
  
  pack $w.f.bar.close -side left -pady 5 -padx 10
  if {[::platform::isPlatformWindows]} {
    pack $w.f.bar.edit $w.f.bar.close -side left -pady 5 -padx 10
  }

  bind $w.f.bar.close <Return> "destroy $w"
  $w.f.text insert end $txt
  $w.f.text see end
  $w.f.text config -state disabled
  
  catch {grab $w}
  
  focus $w.f.bar.close
}


proc LogChannel {w} {
  global logchan log me misc colsTXT active fileLogName

  if {$w=="status"} {return}
  if {[catch {GetWindowID $w} id]} {return}
  if {[catch {Window $w} type]} {return}
  if {![info exists log($w)]} {return}

  switch $type {
    0 {
        if {[catch {GetChannel $w $id} name]} {return}
	set dir [file join $me(home) config $me(profile) logs Channels]
        if {!$misc(logchannel)&&!$log($w)} return
        catch {file mkdir $dir}
      }
    1 {
        if {[catch {GetQuery $w $id} name]} {return}
	set dir [file join $me(home) config $me(profile) logs Queries]
        if {!$misc(logquery)&&!$log($w)} return
        catch {file mkdir $dir}
      }
    2 {
        if {[catch {GetChannel $w $id} name]} {return}
	set dir [file join $me(home) config $me(profile) logs Chats]
        if {!$misc(logchat)&&!$log($w)} return
        catch {file mkdir $dir}
      }
  }

  set filename [file join $dir "$me($id,server) $name.log"]
  
  
  if {[catch {file size $filename} size]&&[file exists $filename]} {return}

  if {![file exists $filename]} { set size 0 }

  if {[expr $size/1024]>$misc(trunclog)} {
    set flags w
  } else {
    set flags a
  }


  set filename [fix_filename $filename]
  
  if {[catch {open $filename $flags} logchan($w)]} {
    
    fconfigure $logchan($w) -encoding $me(encoding)
     
     
     NormalText $active($me(id)) "[format [mc "Can not open log for %s: %s"] $name $logchan($w)]" colsTXT(prog) 1
     return
  }

}


proc PutLog { w text newline } {
  global log active me misc logchan fileLogName
  
  if {$w=="status"} {return}
  if {[catch {GetWindowID $w} id]} {return}
  if {[catch {Window $w} type]} {return}
  if {![info exists log($w)]} {return}

  switch $type {
    0 {
        if {[catch {GetChannel $w $id} name]} {return}
        if {!$misc(logchannel)&&!$log($w)} return
      }
    1 {
        if {[catch {GetQuery $w $id} name]} {return}
        if {!$misc(logquery)&&!$log($w)} return
      }
    2 {
        if {[catch {GetChannel $w $id} name]} {return}
        if {!$misc(logchat)&&!$log($w)} return
      }
  }

  if {![info exists logchan($w)]} {
      LogChannel $w
  } else {
      if {$logchan($w)==""} {
        LogChannel $w
      } elseif {[eof $logchan($w)]} {
        LogChannel $w
      }
  }
  if {$text=="start"} {
    set when [clock seconds]
    set giorno [clock format $when -format %A]
    set mese [clock format $when -format %B]
    set ora [clock format $when -format %T]
    set ngiorno [clock format $when -format %d]
    set text "__________________________________________________\n
    $giorno $ngiorno $mese  \[$ora\] \n
    [format [mc "Log file for %s on %s"] $name $me($id,server)]
    \n__________________________________________________"
  }

  if {$newline} {

  
  puts $logchan($w) "$text"
  fconfigure $logchan($w) -encoding $me(encoding)
 
  } else {  

    puts -nonewline $logchan($w) "$text"
    fconfigure $logchan($w) -encoding $me(encoding)
    
    }
}


proc fix_filename { var } {
  set newvar ""
  foreach c [split $var {}] {
    switch -- "$c" {
      "\{" { append newvar "'" }
      "\}" { append newvar "'" }
      "\[" { append newvar "'" }
      "\]" { append newvar "'" }
      "\"" { append newvar "'" }
      "\|" { append newvar "'" }
      default { append newvar "$c" }
    }
  }
  
  if {[::platform::isPlatformUnix]} {
    while {[string first "\\" $newvar]>=0} {
      set i [string first "\\" $newvar]
      set newvar "[string range $newvar 0 [expr $i-1]]'[string range $newvar [expr $i+1] end]"
    }
  }

  return $newvar
}


proc ImageText {w image} {
   global icons wid
   if {![info exists wid($w,text)]} {return}
   set widget $wid($w,text)
   catch {$widget image create end -image $icons($image)}
}


proc SvrSend {text id} {
   #puts "SvrSend text='$text'"
   #puts "SvrSend/reversed text='[Reverse $text]'"
   global me
   if {!$me($id,conn)} return
   if {[catch {puts $me($id,sock) [Reverse $text]}]} {
     Disconnect $id
   }
}


proc SetSplitter {w} {
  global misc wid
  if {$w!=""} {PPreview $wid($w,command) 0}
  after 10 {
    catch {
      set w [PPreview "" 1]
      set txt [$w get]
      set l [string length $txt]
      .status.splitter config -text "$l/$misc(splitter) [mc chars]"
      if {$l>$misc(splitter)} {
        set txt [string range $txt 0 [expr $misc(splitter)-1]]
        $w delete 0 end
        $w insert 0 $txt
        bell
        SetSplitter ""
      }
    }
  }
}



proc CPutColor {x w} {
   global me wid
   if {$x=="\x03"||$x==""||$x==""} {
     $wid($w,command) insert insert "$x"
     return
   }
   if {$me(cput)} {
     set pos [$wid($w,command) index insert]
     incr pos -1
     if {[string index [$wid($w,command) get] $pos]==""} {
       $wid($w,command) insert insert "$x" 
     } else {
       $wid($w,command) insert insert "$x"
     }
   } else {
     set x ",[string trimleft $x \"]"
     $wid($w,command) insert insert "$x"
   }
   set me(cput) 0
   after 1500 {set me(cput) 1}
}




proc UpdateScrollBox {} {
  update
  .buttonbar.buttonbar_scrollbox configure -scrollregion [list 0 0 [winfo reqwidth .buttonbar.buttonbar] [winfo reqwidth .buttonbar.buttonbar]]
  .buttonbar.buttonbar_scrollbox xview moveto 1
  update idletasks
}

proc IsIp {ip} {
   regsub -all {([0-9])} $ip "" ip
   if {$ip=="..."} {
     return 1
   } else {
     return 0
   }
}



#ifdef PLATFORM_WIN
proc NetMeeting {ip} {
   global me env tcl_platform
   set uls [file join $env(TEMP)/call.uls]
   set fd [open $uls w]
   puts $fd "<IULS><"
   puts $fd "\[res\]"
   puts $fd "hr=0"
   puts $fd "ip=$ip"
   puts $fd "port="
   puts $fd "mt=text/iuls"
   puts $fd "uid="
   puts $fd "url=action=resolve;uid=;appid=ms-netmeeting;protid=h323"
   puts $fd "></IULS>"
   close $fd
   if {$tcl_platform(os) == "Windows NT"} {
     set rc [catch {exec $env(COMSPEC) /c start $uls &} emsg]
   } else {
     set rc [catch {exec start $uls &} emsg]
   }
   if {$rc} {
     tk_messageBox -icon error -message [mc "Error opening netmeeting"]:\n$emsg"
     return
   }
}
#endif /* PLATFORM_WIN */


proc downloads {} {
   global files misc env
   
   if {[::platform::isPlatformUnix]} {
     if  {![info exists misc(downloads)]} {
         tk_messageBox -icon error -message [mc "Choose a program to open your download folder from the IRC configuration section."]
         return
     }
     set op $misc(downloads)
     regsub {%downloads} $op $files(incoming) op
     if {[catch {exec [lindex $op 0] [lrange $op 1 end] &} err]} {
       tk_messageBox -icon error -message "[mc "Error opening download folder"]:\n$err"
     }
     
   }
   
   if {[::platform::isPlatformWindows]} {
     if {[catch {exec $env(COMSPEC) /c start $files(incoming) &}]} {
       if {[catch {open "|start $files(incoming)" &}]} {
         catch {exec explorer $files(incoming) &}
       }
     }   
   }
}


proc RunOpenFile {file} {
   global misc env
   
   if {[::platform::isPlatformUnix]} {
     if  {![info exists misc(downloads)]} {
       tk_messageBox -icon error -message [mc "Choose a program to open incoming files from the IRC configuration section."]
           return
     }
     set op $misc(open_files)
     regsub {%file} $op $file op
     if {[catch {exec [lindex $op 0] [lrange $op 1 end] &} err]} {
         tk_messageBox -icon error -message "[mc "Error opening incoming file"]:\n$err"
     }
   }
   
   if {[::platform::isPlatformWindows]} {
     if {[catch {exec $env(COMSPEC) /c start $file &}]} {
         if {[catch {open "|start $file" &}]} {
             catch {exec explorer $file &}	      
         }
     }
   }
}
   
   
   
proc CmdHistoryPut {cmd} {
  global files misc

  if {[string first "/" $cmd]==0} {
     if {!$misc(historycmd)} return
  } else {
        if {!$misc(history)} return
  }

  if {![file exists $files(history)]} {
    set size 0
    set content ""
  } else {
    set size [file size $files(history)]
    set fd [open $files(history) r]
    set content [read $fd]
    close $fd
  }

  if {[expr $size/1024]>10} {
    set l [string length $content]
    incr l -9216
    set content [string range $content $l end]
    set fd [open $files(history) w]
    puts $fd $content
    close $fd
  }
  if {[lsearch -exact [split $content \n] "$cmd"]!=-1} {return}
  set fd [open $files(history) a]
  puts $fd $cmd
  close $fd
}

proc CmdHistory {k w} {
   global files misc complist compini wid
   set compini ""
   set complist ""
   if {[lsearch {Tab BackSpace Home End Shift_L Shift_R} $k]!=-1} return
   if {![file exists $files(history)]} return
   PPreview $wid($w,command) 0
   after 1 {
     catch {
       if {[catch {open $files(history) r} fd]} return
       set w [PPreview "" 1]
       set content [split [read $fd 10240] \n]
       close $fd
       set cmd [$w get]
       if {[string first "/" $cmd]==0} {
          if {!$misc(historycmd)} return
       } else {
          if {!$misc(history)} return
       }
       set len [llength $content]
       incr len -1
       set nfound 0
       set found ""
       for {set i $len} {$i >=0} {incr i -1} {
           set h [lindex $content $i]
           if {[string first $cmd $h]==0} {
              if {$h!=$found} {incr nfound}
              set found $h
           }
       }
       if {$nfound==1} {
           set lcmd [string length $cmd]
           $w insert end [string range $found $lcmd end]
           $w selection range $lcmd end
       }
    }
   }
}

proc AddressText {msg1 address msg2} {
  global misc
  set msg $msg1
  if {$misc(address)} {
     append msg " $address"
  }
  append msg $msg2
  return $msg
}

proc WhoList {win w} {
  global wholist whols
  if {!$wholist} {
    tk_messageBox -icon error -message [mc "Downloading users list, please wait."]
    return
  }
  if {[info exists whols($win)]} {
    $w.list delete 0 end
    $w.status.info config -text ""
    UpdateProgress 100 $w.bar.progress 0
    foreach user $whols($win) {
      $w.list insert end $user
    }
  }
}

proc SelectDomain {win w} {
 global wholist whols
 if {!$wholist} {
  tk_messageBox -icon error -message [mc "Downloading users list, please wait."]
  return
 }
 catch {
  set domain [$w.bar.country get]
  if {$domain==""} {return}
  if {[info exists whols($win)]} {
    WhoList $win $w
  }
  set users [$w.list get 0 end]
  set whols($win) $users
  set tot [llength $users]
  set f ""
  set i 0
  foreach user $users {
     set host [lindex $user 2]
     set ind [expr [string length $host]-[string length $domain]]

     if {[string last $domain $host]==$ind} {
        lappend f [lindex $users $i]
     }
     incr i
  }
  set found [llength $f]
  $w.list delete 0 end
  foreach h $f {
      $w.list insert end $h
  }
  UpdateProgress [proportion $tot $found] $w.bar.progress 0
  $w.status.info configure -text "[format [mc "found %s hosts out of %s for domain %s"] $found $tot $domain]"
 }
}

#rename proc _proc
#_proc proc {name args body} {
#   if {[info commands $name]!=""} {
#        tk_messageBox -icon warning -message "[info script] redefines procedure named $name, procedures must have unique names!"
#    }
#    _proc $name $args $body
#}


proc PPreview {w b} {
  global preview
  if {$b} {
    return $preview
  } else {
    set preview $w
  }
}

proc Preview {w} {
     global MIRCcols
     if {!$MIRCcols(preview)} {return}
     after 10 "Preview2 $w"
}

proc Preview2 {w} {
     global gw wid colsTXT
         if {[winfo class $w]=="Entry"} {
           set txt [$w get]
         } else {
           set txt [$w get 1.0 "end -1 chars"] 
         }
         .status.msg delete 1.0 end
         if {[string first "\x03" $txt]!=-1 || [string first "" $txt]!=-1 || [string first "" $txt]!=-1} {
           set gw .
           ColorText .status.msg [FormatColors [format [mc "Text Preview: %s"] $txt]] black 0
           .status.msg see end
         }
}

proc FindServerNet {server} {
  global files me

  if {[catch {open $files(servers) r} fd]} {return}
  set servers [split [read $fd] \n]
  set isin 0
  foreach line $servers  {
    if {[lindex $line 0]==$server} {
       set me(network) [lindex $line 2]
       return
    }
  }
  set me(network) [mc "Unknown"]
  catch { close $fd }
}

proc FindNet {id} {
  global files me 
  set fd2 [open $files(channels)] 
  set channels [split [read $fd2] "\n"]
  catch {close $fd2}
  set clist ""
  foreach chan $channels {
      if {$chan==""} {continue}
      if {([lindex $chan 2]==$me($id,net)||[lindex $chan 2]=="all")&&[lindex $chan 1]==1} {
         lappend clist [lindex $chan 0]
      }      
  }
  foreach c $clist {id $id join $c}
}


proc HistoryAdd {w} {
 global history me active wid
 set str [$wid($w,command) get]
 if {$str==""} {return}
 lappend history($w) $str
 set history(i,$w) [llength $history($w)]

}

proc HistoryGet {dir w} {
 global me active history wid
  catch {
   if {$dir=="back"} {
     set op -1
     if {$history(i,$w)==0} {bell;return}	
   } else {
     set op +1
     if {$history(i,$w)==[llength $history($w)]} {return}	
   }
   set i [expr $history(i,$w)$op]
   set str [lindex $history($w) $i]
   set history(i,$w) $i
   $wid($w,command) delete 0 end
   $wid($w,command) insert 0 $str
  }
}


proc chooseDirectory {args} {
   set choice [eval tk_chooseDirectory $args]
   if {$choice == {}} {
      return {}
   }
   if {$::tcl_platform(platform) == "windows"} {
      return [file attributes $choice -longname]
   } else {
      return $choice
   }
 }


proc def_winset {txt win} {
  global wid
  set winset "50 30 400 300"
  switch -glob $win {
    "status" {set winset "50 10 636 360"}
    "Channelslist" { set winset "30 20 545 300"}
    "Soundmanager" { set winset "16 16 345 300"}
    "ChannelsFolder" { set winset "219 68 305 284"}
    "can*" {set winset "{} {} 636 360"}
    "que*" {set winset "{} {} 500 300"}
    "cha*" {set winset "{} {} 500 300"}
    "DCC*" {set winset "290 200 275 130"}
  }  

  if {![catch {seek $wid(winsettings) 0 start} e]} {
     foreach win [split [read $wid(winsettings)] "\n"] {
        if {[lindex $win 0]==[Convert $txt]} {
          set winset [lrange $win 1 5]
        }
     }
  }
  return $winset
}

proc ClearText {w} {
  global wid
  if {[info exists wid($w,text)]} {
    $wid($w,text) delete 1.0 end
  }
}


proc ResetPlaying {} {
   global mp3

   array unset mp3 current
   set mp3(playing) 0

}

# needs fconfigure $file -encoding utf-8???
proc SaveBuffer {w} {
 global wid me
 set buffer [$wid($w,text) get 1.0 end]
 set file [tk_getSaveFile -defaultextension "log" -initialfile "[$wid($w) cget -icontext].log" -initialdir "$me(home)/config/$me(profile)/logs" -title [mc "Select a file"]:]
 if {$file==""} {return}
 if {![catch {open $file w+} err]} {
    puts $err $buffer
    close $err
 } else {
    tk_messageBox -icon error -message $err
 }
}

proc Deicony {} {
     global me icons task GUI
     if {$me(icony)==0} {return}
     wm deiconify .
     wm state . normal
     wm deiconify .
     update idletasks

     set me(icony) 0
     if {$task(chat)!=0||$task(chan)!=0} {
        if {[::platform::isPlatformUnix]} {
          $GUI(tray) configure -image $icons(tray1)
	  .f.tip add $GUI(tray) "$me(version)"
	}
	if {[::platform::isPlatformWindows]} {
          winico taskbar delete $icons(ico_savred)
          winico taskbar add $icons(ico_savirc) -callback "TaskMenu %m %i %X %Y" -text "savIRC"
        }
     }
     set task(chat) 0
     set task(chan) 0
     return
}

proc TaskMenu { msg ico x y } {
  global me clientMSG active task icons wid GUI
  if {$msg=="WM_LBUTTONDOWN"} {
    Deicony
    catch {wm geometry . $GUI(geometry)}
  } elseif {$msg=="WM_RBUTTONUP"} {

  update idletasks
  xmenu .taskm
  if {[llength $me(sockslist)]==0} {
    set any_conn 0
  } else {
    set any_conn 1
  }

  for {set i 0} { $i < [llength $me(sockslist)] } {incr i } {
     set id [lindex $me(sockslist) $i]
     if {[info exists wid($active($id))]&&$active($id)!=""} {
       set cmd "Switch $active($id)"
     } else {
       set cmd "Switch status"
     }

     .taskm add command -label "$me($id,server)" -command "set me(started) 0; $cmd ; SetCurrents $id; set me(started) 1; focus $wid(status,command)"
  }

  if {$any_conn} {
    .taskm add separator
    .taskm add cascade -label [mc Away] -menu .taskm.away
    catch {
      xmenu .taskm.away
      .taskm.away add command -label [mc "Set Away"] -command "IRC::away {$clientMSG(away)}"
      .taskm.away add command -label [mc "Set Back"] -command "IRC::away"
    }
  } else {
    .taskm add command -label [mc Connect] -command "Connect"
  }
  .taskm add separator
  .taskm add command -label [mc "Open Downloads"] -command "downloads"
  .taskm add separator
  .taskm add command -label [mc About] -command {About}
  .taskm add separator
  .taskm add command -label [mc Quit] -command "goto_exit"
  tk_popup .taskm $x $y
 }

}

proc list2string {l} {
   set txt ""
   foreach i $l {
      append txt "$i "
   }
   return $txt
}


proc ChangeActiveMp3List {} {
  set frame ".main.mp3.fr"
  LoadMp3Lists $frame.list $frame.status.lists
}

proc NewMp3List {lb cb} {
  global me mp3

  set i 1
  while {[file exists [file join $me(home)/config/ newlist$i.ini]]} {
    incr i
  }
  set default "newlist$i"

  set file [tk_getSaveFile -defaultextension "ini" -initialfile $default -initialdir [file join $me(home) config] -title [mc "Enter Filename"]]
  if {$file!=""} {
     if {[file dirname $file]!=[file join $me(home) config]} {
        tk_messageBox -icon error -message "[format [mc "File lists must be created in %s"] $me(home)]"
        return
     }
     set mp3(lists) "$mp3(lists) $file"
     set mp3(list) "[file tail $file]"
  }
   AddMp3Lists $cb
   LoadMp3Lists $lb $cb
   SaveMp3List $lb
}

proc DelMp3List {cb lb} {
   global mp3 me

   set ls [file join $me(home)config $mp3(list)]
   if {[file isdirectory $ls]} {return}
   if {[catch {file delete $ls} err]} {
      tk_messageBox -message "$err"
      return
   }

   RemoveMp3List $mp3(list)

   AddMp3Lists $cb
   LoadMp3Lists $lb $cb

}

proc RemoveMp3List {rem} {
   global mp3

   set tmp ""
   foreach fl $mp3(lists) {
      if {[file tail $fl]!=$rem} {
        set tmp "$tmp $fl"
      }
   }
   set mp3(lists) $tmp
   set mp3(list) ""

}


proc DelMp3Files {lb} {
   set i 0
   foreach i [$lb curselection] {
     $lb delete $i
   }
   incr i -1
   if {$i==-1} {set i 0}
   $lb selection set $i
}

proc SaveMp3List {lb} {
   global mp3 me

   if {$mp3(list)==""} {return}
   set files [$lb get 0 end]
   if {[catch {open [file join $me(home) config $mp3(list)] w} fd]} {
      tk_messageBox -icon error -message "$fd"
      return
   }

   foreach fl $files {
       puts $fd [lindex $fl 1]
   }

   close $fd
}

proc AddMp3File {lb} {
   global mp3 me files

   if {$mp3(list)==""} {
     tk_messageBox -message [mc "You need to create a list before adding files."]
     return
   }

   set tmp [tk_getOpenFile -title "[mc "Choose a file to add"]:" -initialdir $files(defaultdir)]
   if {$tmp==""} {return}
   set exts ".mp3 .mid .wav .au .wma"
   if {[lsearch $exts [file extension $tmp]]!=-1} {
     $lb insert end "{[file tail $tmp]} {$tmp} { [FormatSize [file size $tmp]]}"
   }
   set files(defaultdir) [file dirname $tmp]
   SaveMp3List $lb
}

proc AddMp3Dir {lb} {
   global mp3 me files

   if {$mp3(list)==""} {
     tk_messageBox -message [mc "You need to create a list before adding files."]
     return
   }

   set exts ".mp3 .mid .wav .au .wma"

   set tmp [tk_chooseDirectory -initialdir $files(defaultdir)]
   if {$tmp==""} {return}
   set files(defaultdir) $tmp
   if {[catch {glob -directory $tmp *} fs]} {return}
   foreach fl $fs {
       if {![file isdirectory $fl]&&[lsearch $exts [file extension $fl]]!=-1} {
         $lb insert end "{[file tail $fl]} {$fl} { [FormatSize [file size $fl]]}"
       }
   }
   SaveMp3List $lb
}

proc AddMp3Lists {cb} {
  global mp3

  $cb list delete 0 end

  foreach ls $mp3(lists) {
    set lname [file tail $ls]
    $cb list insert end $lname
  }
}


proc LoadMp3Lists {lb cb} {
  global mp3 me

  $lb delete 0 end


  if {$mp3(list)==""} {
     if {$mp3(lists)==""} {
       return
     } else {
       set mp3(list) [file tail [lindex $mp3(lists) 0]]
     }

  }

  set flist [file join $me(home) config $mp3(list)]

  if {![file exists $flist]} {
      return
  }

  if {[catch {open $flist} fd]} {
  }

  set exts ".mp3 .mid .wav .au .wma"

  update

  set mp3s [split [read $fd] "\n"]

  foreach fl $mp3s {
       if {[lsearch $exts [file extension $fl]]!=-1} {
         catch {$lb insert end "{[file tail $fl]} {$fl} { [FormatSize [file size $fl]]}"}
       }
  }
  close $fd
}


proc CheckMp3Lists {} {
   global me mp3

   foreach ls $mp3(lists) {
      if {![file exists $ls]} {
         RemoveMp3List [file tail $ls]
         if {[file tail $ls]==$mp3(list)} {
            if {[llength $mp3(lists)]==0} {
               set mp3(list) ""
            } else {
               set mp3(list) [lindex $mp3(lists) 0]
            }
         }
      }
   }

}


proc PlayMp3 {direction} {
   global mp3 me active colsTXT icons
   if {$mp3(playing)} {return}
   if {$mp3(list)==""} {
      tk_messageBox -message [mc "First you need to create a list, then add some files."]
      return
   }
   set flist [file join $me(home)/config/ $mp3(list)]

   if {![file exists $flist]} {
      set r [tk_messageBox -type yesno -message "[format [mc "%s none found in %s"] $mp3(list) $me(home)/config/\n] [format [mc "Create %s and save the current content of the list"]? $mp3(list)]"]
      if {$r=="yes"} {
        SaveMp3List .main.mp3.fr.list
      } else {
        return
      }
   }

   if {[catch {open $flist} fd]} {
      tk_messageBox -icon error -message "$fd"
      return
   }

   set files [split [string trim [read $fd]] "\n"]
   catch {close $fd}
   set tmp ""

   set exts ".mp3 .mid .wav .au .wma"

   foreach f $files {
      if {$f!=""&&![file isdirectory $f]} {
         lappend tmp $f
      }
   }

   set files $tmp
   if {[llength $files]==0} {
      tk_messageBox -message [mc "Add some files to the list first."]
      return
   }

   if {$mp3(mode)} {
      set num [random [llength $files]]
      set f [lindex $files $num]
   } else {
     if {[info exists mp3(current)]} {
      set ind [lsearch $files $mp3(current)]
      incr ind $direction
      set f [lindex $files $ind]
     } else {
      set f [lindex $files 0]
     }
   }

  if {![file exists $f]} {
     tk_messageBox -message "[file tail $f]: [format [mc "not found in %s"] [file dirname $f]]"
     return
  }

  if {[catch {snack::sound sound1} e]} {
     set msg ""
     if {[info exists me(snack_error)]} {
        append msg "$me(snack_error)"
     }
     tk_messageBox -message "$msg\n[mc "Can not play MP3's, check that Snack is installed on your system."]"
     return
  }
  set mp3(object) $e
  sound1 config -file $f
  if {[catch {sound1 play -command PlayNextMp3} err]} {
    tk_messageBox -message "[format [mc "Can not play %s"] [file tail $f]] :$err\n[mc "Is your hardware configured correctly?"]"
    return
  }
  set mp3(playing) 1
  set mp3(current) $f
  VerboseMp3 "sound1" $f
}

proc VerboseMp3 {s f} {
   global colsTXT icons mp3 active me

   if {$mp3(verbose)} {
     set t [$s length -units SECONDS]
     set t [expr {int($t)}]
     set mins [expr $t/60]
     set secs [expr $t%60]
     if {[string length $secs]==1} {
        set secs "0$secs"
     }
     catch {
       if {$icons(show)} {ImageText $active($me(id)) playing}
       NormalText $active($me(id)) "[format [mc "Playing %s %s %s"] [file tail $f] ([FormatSize [file size $f]]) \[$mins:$secs\]]" $colsTXT(prog) 1
     }
  }

}

proc PlayPreviousMp3 {} {
   global mp3
   catch {
     $mp3(object) destroy
     set mp3(playing) 0
     after 200 { PlayMp3 -1 }
   }
}

proc PlayNextMp3 {} {
   global mp3
   catch {
     $mp3(object) destroy
     set mp3(playing) 0
     after 200 { PlayMp3  1}
   }
}

proc PausaMp3 {} {
  global mp3
   if {[info exist mp3(object)]} {
      $mp3(object) pause
   }
}

proc StopMp3 {} {
   global mp3
   if {[info exist mp3(object)]} {
      if {$mp3(playing)} {
          $mp3(object) destroy
          array unset mp3 object
          array unset mp3 current
          set mp3(playing) 0
      }
   }
}

proc SoundSelected {w} {
   StopMp3
   if {[catch {sound [lindex [$w get [$w curselection]] 1]} err]} {
     tk_messageBox -message $err
   }

}

proc random {{range 100}} {
    return [expr {int(rand()*$range)}]
}


proc WinSet {} {
        global me wid files
        catch {close $wid(winsettings)}
        if {![catch {open $files(winfile) a+} wid(winsettings)]} {
          seek $wid(winsettings) 0 start
          set content [split [read $wid(winsettings)] "\n"]
          close $wid(winsettings)
          set added ""
          if {![catch {open $files(winfile) w+} wid(winsettings)]} {
            set l [llength $content]
            incr l -1
            for {set i $l} {$i>=0} {incr i -1} {
                 set line [lindex $content $i]
                 if {[lsearch $added [lindex $line 0]]==-1} {
                  if {$line!=""} {puts $wid(winsettings) $line}
                  lappend added [lindex $line 0]
                 }
            }
          }

        }
}


proc Strip {var c} {
  regsub $c $var {} var
  return $var
}

#ifndef PLATFORM_WIN
proc Browsers {} {
    set tmp ""
    foreach b {netscape mozilla konqueror galeon lynx} {
         if {[catch {exec which $b} out]} {continue}
	 if {[file exists $out]} {
	    lappend tmp "$out"
	 }
    }
    return $tmp
}

#endif /* ! PLATFORM_WIN */

proc PutTray {} {
  global misc icons clientMSG active task wid GUI me
  
  if {[::platform::isPlatformUnix]} {
    if {$GUI(tk_theme)!=1} {return}
    if {!$misc(trayuse)} {return}
    theme:frame .f -kdesystray
    tooltip .f.tip -delay 500 -yoffset -32 -xoffset -60
    pack [xmenubutton .f.b -bd 0 -image $icons(tray1) -direction above -highlightthickness 0 -padx 0 -pady 0 -menu .f.b.menu]
    set GUI(tray) ".f.b"
    .f.tip add .f.b "$me(version)"
    bind .f <Double-1> "Deicony"
    set taskm [xmenu .f.b.menu -tearoff 0]
    if {[llength $me(sockslist)]==0} {
      set any_conn 0
    } else {
      set any_conn 1
    }

    for {set i 0} { $i < [llength $me(sockslist)] } {incr i } {
      set id [lindex $me(sockslist) $i]
      if {[info exists wid($active($id))]&&$active($id)!=""} {
        set cmd "Switch $active($id)"
      } else {
        set cmd "Switch status"
      }

      $taskm add command -label "$me($id,server)" -command "set me(started) 0; $cmd ; SetCurrents $id; set me(started) 1; focus $wid(status,command)"
    } 

    if {$any_conn} {
      $taskm add separator
      $taskm add cascade -label [mc Away] -menu $taskm.away
      catch {
        xmenu $taskm.away
        $taskm.away add command -label [mc "Set Away"] -command "IRC::away {$clientMSG(away)}"
        $taskm.away add command -label [mc "Set Back"] -command "IRC::away"
      }
    } else {
      $taskm add command -label [mc Connect] -command "Connect"
    }
    $taskm add separator
    $taskm add command -label [mc "Open Downloads"] -command "downloads"
    $taskm add separator
    $taskm add command -label [mc About] -command {About}
    $taskm add separator
    $taskm add command -label [mc Quit] -command "goto_exit"
  }
  
  if {[::platform::isPlatformWindows]} {
    if {$misc(trayuse)} {
      catch {winico taskbar add $icons(ico_savirc) -callback "TaskMenu %m %i %X %Y" -text "savIRC"}
    }
  }

}


proc anacom { str w } {
  global me colsTXT active icons

  set str [Convert $str]

  set cmd [string range [lindex $str 0] 1 end]
  set params [lrange $str 1 end]
  
  if {$params!=""} {
    if {[catch {eval IRC::$cmd $params} err]} {
      if {$icons(show)} {ImageText $active($me(id)) prog}
      NormalText $active($me(id)) $err $colsTXT(prog) 1
    }
  } else {
    if {[catch {IRC::$cmd} err]} {
      if {[catch {IRC::$cmd ""}]} {
        if {$icons(show)} {ImageText $active($me(id)) prog}
        NormalText $active($me(id)) $err $colsTXT(prog) 1
      }
    }
  }
}


proc Connected {} {
   global me
   if {$me(sockslist)==""} {
     IRC::echo [mc "You are not connected!"]
     IRC::echo "[format [mc "Use the %s command to connect"]. /server]"
     IRC::echo e.g. /server <irc.dal.net> ?6667?
     return 0
   } else {return 1}
}


if {$misc(traymin)&&!$misc(trayuse)} {
   set misc(traymin) 0
}

WinSet
StartGUI

after 200 {set me(started) 1}

PutTray

SourceScripts "events"
SourceScripts "functions"
SourceScripts "variables"
SourceScripts "popups"


#server_menus
BPS
Notify 1

if {[::platform::isPlatformUnix]} {
  if {[catch {package require snack} me(snack_error)]} {}
}


if {![file exists $files(incoming)]} {
  #set files(incoming) "$me(home)/config/$me(profile)/Downloads"
  set files(incoming) [file join $me(home) config $me(profile) Downloads]
}

if {$me(ident_use)&&$me(ident_connect)==0} {
  Identd_Create
}


BgimageHow

IRC::Event000 start *

if {$misc(connect)} {
  Connect
}

focus $wid(status,command)

