
proc NormalText {w text color newline} {
 global font scroll misc timestamp GUI gw wid

   set clean_txt [CleanTopic $text]

   if {![info exists wid($w,text)]} {return}
   set widget $wid($w,text)
   set ora [clock format [clock seconds] -format %T]   

   if {$misc(logtimestamp)} {
       PutLog $w "\[$ora\] $clean_txt" $newline
       
   } else {
      PutLog $w "$clean_txt" $newline
   }

   if {$misc(timestamp)||([info exists timestamp($w)]&&$timestamp($w))} {
     set text "\[$ora\] $text"
     set clean_txt "\[$ora\] $clean_txt"
   }
   
   set fg $color
   set bg [$widget cget -background]
   set bold 0
   set underline 0

   set start [$widget index insert]

   $widget tag configure "$fg,$bg" -foreground $fg -background $bg

   $widget insert end "[Reverse $clean_txt]" "$fg,$bg"

   set end [$widget index insert]


   if {$newline} {$widget insert end "\n"}
   Scroll_Text $w $widget

   set id [GetWindowID $w]
   if {$w=="status"} {IfColorButton $w $id}
   UrlCaption $widget $start $end $id $w
   Limit_Buffer $w
}


proc Scroll_Text {w widget} {
   global scroll
   if {[info exists scroll($w)]} {
     if {$scroll($w)} {$widget see end}
   } else {
     catch {$widget see end}
   }
}


proc ColorText {w text color newline} {
 global font scroll misc timestamp GUI gw wid

   set clean_txt [CleanTopic $text]

   if {$gw==""} {
     if {![info exists wid($w,text)]} {return}
     set ora [clock format [clock seconds] -format %T]   
     set widget $wid($w,text)
     if {$misc(logtimestamp)} {
       PutLog $w "\[$ora\] $clean_txt" $newline
     } else {
       PutLog $w "$clean_txt" $newline
     }

     if {$misc(timestamp)||([info exists timestamp($w)]&&$timestamp($w))} {
       set text "\[$ora\] $text"
       set clean_txt "\[$ora\] $clean_txt"
     }

   } else {
     set widget $w
     set w $gw
     set gw ""
   }

   
   set fg $color
   set bg [$widget cget -background]
   set fg0 $fg
   set bg0 $bg

   set bold 0
   set underline 0

   set start [$widget index "end -1 chars"]

   $widget tag configure "$fg,$bg" -foreground $fg -background $bg

   $widget insert end [Reverse $clean_txt] "$fg,$bg"
   set end [$widget index "$start + [string length $clean_txt] chars"]

   set j 0

   for {set i 0} {$i < [string length $text]} {incr i} {

      set c [string index $text $i]
      set spacer 0
      switch -glob -- $c {
          "\x03" {
              set chars [string range $text [expr $i+1] [expr $i+5]]

              if {[regexp {^[0-9]{2},[0-9]{2}} $chars]} {
                set fg [GetColor [string range $chars 0 1] $fg0]
                set bg [GetColor [string range $chars 3 4] $bg0]
                set spacer 5
              } elseif {[regexp {^[0-9]{2},[0-9]} $chars]} {
                set fg [GetColor [string range $chars 0 1] $fg0]
                set bg [GetColor [string index $chars 3] $bg0]
                set spacer 4
              } elseif {[regexp {^[0-9],[0-9]{2}} $chars]} {
                set fg [GetColor [string index $chars 0] $fg0]
                set bg [GetColor [string range $chars 2 3] $bg0]
                set spacer 4
              } elseif {[regexp {^[0-9],[0-9]} $chars]} {
                set fg [GetColor [string index $chars 0] $fg0]
                set bg [GetColor [string index $chars 2] $bg0]
                set spacer 3
              } elseif {[regexp {^[0-9]{2}} $chars]} {
                set fg [GetColor [string range $chars 0 1] $fg0]
                set spacer 2
              } elseif {[regexp {^[0-9]} $chars]} {
                set fg [GetColor [string index $chars 0] $fg0]
                set spacer 1
              } else {
	      		set fg $fg0 ;# Lets normalize the colors.
	      		set bg $bg0

              }       
              incr i $spacer
              foreach t [$widget tag names] {
                if {[string match "*,*" $t]} {             
                 $widget tag remove $t "$start + $j chars" $end
                }
              }

              $widget tag configure "$fg,$bg" -foreground $fg -background $bg
              $widget tag add $fg,$bg "$start + $j chars" $end
              $widget tag raise $fg,$bg

          }

          "\x02" {
              if {$bold} {
                 set bold 0
                 set tag "no_bold"
              } else {
                 set bold 1
                 set tag "bold"
              }

              $widget tag remove bold "$start + $j chars" $end 
              $widget tag remove no_bold "$start + $j chars" $end 
              $widget tag add $tag "$start + $j chars" $end 
              $widget tag raise $tag
          }

          "\x0f" {
              if {$underline} {
                 set underline 0
                 set tag "no_underline"
              } else {
                 set underline 1
                 set tag "underline"
              }

              $widget tag remove underline "$start + $j chars" $end 
              $widget tag remove no_underline "$start + $j chars" $end 
              $widget tag add $tag "$start + $j chars" $end 
              $widget tag raise $tag
          }

          "\x1f" {
              if {$underline} {
                 set underline 0
                 set tag "no_underline"
              } else {
                 set underline 1
                 set tag "underline"
              }

              $widget tag remove underline "$start + $j chars" $end 
              $widget tag remove no_underline "$start + $j chars" $end 
              $widget tag add $tag "$start + $j chars" $end 
              $widget tag raise $tag
          }

          "\x096" {
              foreach t [$widget tag names] {
                if {[string match "*,*" $t]} {             
                 $widget tag remove $t "$start + $j chars" $end
                }
              }
              set fg $color
              set bg [$widget cget -background]
              $widget tag remove underline "$start + $j chars" $end 
              $widget tag remove no_underline "$start + $j chars" $end 
              $widget tag add $fg,$bg "$start + $j chars" $end 
              $widget tag raise $fg,$bg
          }

          "default" {
              incr j
          }

      }      
   }


   if {$newline} {$widget insert end "\n"}
   if {[info exists scroll($w)]} {
     if {$scroll($w)} {$widget see end}
   } else {
     $widget see end
   }

   set id [GetWindowID $w]
   if {$w=="status"} {IfColorButton $w $id}
   if {[Window $w]==0&&$misc(highlight)} {MeCaption $w $widget $start $end $id}
   UrlCaption $widget $start $end $id $w
   Limit_Buffer $w
}

proc Limit_Buffer {w} {
  global misc wid
  if {!$misc(buffer_limit)} {return}
  if {![info exists wid($w,text)]} {return}
  set nline [lindex [split [$wid($w,text) index end] "."] 0]
  if {$nline>$misc(buffer_lines)} {
    $wid($w,text) delete 1.0 50.end
  }
}


proc UrlCaption {w start end id win} {
   global wid me misc icons 
 
   set url "(http://(.*)\\.(.*)|w{3}\\.(.*)\\.(.*)|https://(.*)\\.(.*)|ftp://(.*)\\.(.*))"
   set txt [$w get $start $end] 
   if {![regexp -nocase $url $txt]} {return}
   set url_list ""
   set i 0
   set word ""
   foreach c [split $txt {}] {
      if {$c==" "} {
        if {[string index $txt [expr $i+1]]!=" "} {
          lappend url_list $i $word
          set word ""        
        }
      } else {
          if {$word==""} {
             lappend url_list $i
          }
          append word $c
      }  
      incr i
   }
   if {[string index $txt end]!=" "} {
      lappend url_list $i $word
   }
   if {$misc(urlscol)} {$w tag configure blu_url -foreground blue}
   foreach {s e word} $url_list {
     if {[regexp -nocase $url $word]} {         
         if {$misc(urlscol)} {$w tag add blu_url "$start +$s c" "$start +$e c"}
         AddUrl [$w get "$start +$s c" "$start +$e c"] $win $id
     }
   }
}


proc AddUrl {url win id} {
     global me wid
         if {[Isinteger $id]} {
            switch -- [Window $win] {
             "0" {
               set origin [GetChannel $win $id]
             }             
             "1" {
               set origin [GetQuery $win $id]
             } 
             "2" {
               set origin [GetChat $win $id]
             }
             "default" {
               set origin ""
             }
            }
            set server $me($id,server)
         } else {
            set server ""
            set origin ""
         }
         set url [string trim $url "();,:.\x93"]
         set allurls [$wid(status,url) get 0 end]
         set addurl 1
         foreach turl $allurls {
            if {[lindex $turl 0]==$url} { set addurl 0}
         }

         if {$addurl} {
              $wid(status,url) insert end [list "[string trimright [Reverse $url] "\]"]" " $origin " " $server"]
         }
}



proc MeCaption {win w start end id} {
   global wid me misc icons task GUI

   if {[Window $win]!=0} {return}

   set count ""
   set pos $start
   if {$id==""} {set id $me(id)}

   set result [$w search -nocase -forward -count count -- " [::savirc::getNick $id] " $pos $end]
   if {$result==""} {
     set result [$w search -nocase -forward -count count -- " [::savirc::getNick $id]\n" $pos $end]
   }

   $w tag configure me -background $misc(highlightc)
   set tray 0
   while {$result!=""} {
     set tray 1
     set pos "$result +[expr $count-1] c"
     $w tag add me "$result +1 c" $pos
     set result [$w search -nocase -forward -count count -- " [::savirc::getNick $id] " $pos $end]
     if {$result==""} {
       set result [$w search -nocase -forward -count count -- " [::savirc::getNick $id]\n" $pos $end]
     }
   }

   if {[::platform::isPlatformUnix]} {
     if {$GUI(tk_theme)==1} {
       if {$tray&&$me(icony)&&$misc(trayuse)} {
         if {$task(chat)==0&&$task(chan)==0} {
           incr task(chan)
  	   $GUI(tray) configure -image $icons(tray2)
	   .f.tip add $GUI(tray) "savIRC \[$task(chat) msgs - $task(chan) msgs in channels\]"
         } else {
           incr task(chan)
 	   $GUI(tray) configure -image $icons(tray2)
	   .f.tip add $GUI(tray) "savIRC \[$task(chat) msgs - $task(chan) msgs in channels\]"
	 }
       }
     }
   }
   
   if {[::platform::isPlatformWindows]} {
     if {$tray&&$me(icony)&&$misc(trayuse)} {
       if {$task(chat)==0&&$task(chan)==0} {
         incr task(chan)
         winico taskbar delete $icons(ico_savirc)
         winico taskbar add $icons(ico_savred) -callback "TaskMenu %m %i %X %Y" -text "savIRC \[$task(chat) msgs - $task(chan) msgs in channels\]"
       } else {
         incr task(chan)
         winico taskbar modify $icons(ico_savred) -text "savIRC \[$task(chat) msgs - $task(chan) msgs in channels\]"
       }
     }
   }

}



proc GetColor { num defcol } {
 global MIRCcols colsTXT
 set color $colsTXT(prog)
 if {$num==99} { 
    return $defcol
 } elseif {$num>15} { 
    set num [expr $num%16]
 }
 switch -- $num {
  00 { set color $MIRCcols(0) }
  0 { set color $MIRCcols(0) }
  1 { set color $MIRCcols(1) }
  01 { set color $MIRCcols(1) }
  2 { set color $MIRCcols(2) }
  02 { set color $MIRCcols(2) }
  3 { set color $MIRCcols(3) }
  03 { set color $MIRCcols(3) }
  4 { set color $MIRCcols(4) }
  04 { set color $MIRCcols(4) }
  5 { set color $MIRCcols(5) }
  05 { set color $MIRCcols(5) }
  6 { set color $MIRCcols(6) }
  06 { set color $MIRCcols(6) }
  7 { set color $MIRCcols(7) }
  07 { set color $MIRCcols(7) }
  7 { set color $MIRCcols(7) }
  8 { set color $MIRCcols(8) }
  08 { set color $MIRCcols(8) }
  9 { set color $MIRCcols(9) }
  09 { set color $MIRCcols(9) }
  10 { set color $MIRCcols(10) }
  11 { set color $MIRCcols(11) }
  12 { set color $MIRCcols(12) }
  13 { set color $MIRCcols(13) }
  14 { set color $MIRCcols(14) }
  15 { set color $MIRCcols(15) }
 }
 return $color
}

proc FormatColors {str} {
  return [string map {"" \x03 "" \x02 "" \x1f} $str]
}


proc mIRC_Text_Tag {widget} {
   global font 
   $widget tag configure "underline" -underline 1
   $widget tag configure "no_underline" -underline 0
   $widget tag configure "bold" -font $font(b)
   $widget tag configure "no_bold" -font $font(n)
}



set GUI(txt_current) ""


proc TextCaption {text w} {
     
       global wid GUI chanmenu

       $text tag raise sel
       set pointer [Convert [GetWordFromText $text]]    

       set word [Reverse [lindex $pointer 0]]
       if {$word==$GUI(txt_current)} {return}

       if {[Window $w]==0} {


         set nicks [$wid($w,list) get 0 end]

         if {[lsearch -exact $nicks [string trim $word "<>"]]!=-1||[lsearch -exact $nicks "@[string trim $word "<>"]"]!=-1||[lsearch -exact $nicks "+[string trim $word "<>"]"]!=-1} {
            set GUI(txt_current) $word
            $text tag add nick [lindex $pointer 1] [lrange $pointer 2 end]
            return
         }
       }

       if {[regexp -nocase "(http://(.*)\\.(.*)|^w{3}\\.(.*)\\.(.*)|https://(.*)\\.(.*)|ftp://(.*)\\.(.*))" $word]} {
            set GUI(txt_current) $word
            $text tag add url [lindex $pointer 1] [lrange $pointer 2 end]
            return
       }  

       if {[regexp "^(@#|\\+#|#)" $word]} {
            set word [string trimleft $word "+@"]
            if {[string length $word]<2} {return}
            set GUI(txt_current) $word
            $text tag add channel [lindex $pointer 1] [lrange $pointer 2 end]
            return
       } 

}


proc RemoveTags {w} {
  foreach tag {url nick} {
   $w tag remove $tag 1.0 end
  }
}

proc CaptionJoin {w} {
 set chan [lindex [Convert [GetWordFromText $w]] 0] 
 IRC::join [string trim $chan "+@:.,;()\[\]"]
}


proc CaptionOpenUrl {w} {
   set url [lindex [Convert [GetWordFromText $w]] 0] 
   OpenUrl $url
}

proc CaptionNicklist {w win x y} {
 global me
 set nick [lindex [Convert [GetWordFromText $w]] 0]
 set nick [string map {"<" "" ">" "" "+" "" "@" ""} $nick]
 popup_nicklist $win $x $y "click $nick" $me(id)
}

proc CaptionSelectNick {win w} {
 set nick [lindex [Convert [GetWordFromText $w]] 0] 
 set nick [string map {"<" "" ">" "" "+" "" "@" ""} $nick]
 SelectNick $win [Convert $nick]
}

proc CaptionQueryNick {w} {
 set nick [lindex [Convert [GetWordFromText $w]] 0]
 set nick [string map {"<" "" ">" "" "+" "" "@" ""} $nick]
 QueryNickC $nick
}

proc GetWordFromText {w} {

  set left [$w get "current linestart" "current"]
  set right [$w get "current" "current lineend"]
  set l [string last " " $left]
  if {$l==-1} {set l 0} 

  set r [string first " " $right]
  if {$r==-1} {set r end} 

  set left [string range $left $l end]
  set right [string range $right 0 $r]
  set Pos1 [$w search -nocase -forward -- "$left$right" "current -[string length $left] c" "current lineend"]
  set Pos2 "$Pos1 +[expr [string length "$left$right"]-1] c"
  return "$left$right $Pos1 $Pos2" 

}

