namespace eval IRC {

proc MenuCommand {args} {
    eval [::join $args]
} 

proc Event000 {event network args} {
	global on me active
	set network [string tolower $network]
	foreach {varname value} $args {set $varname $value}

        if {[info exists id]} {         
          set old000 $me(id)
          set me(id) $id
          set id_event000 1
        } else {
          set id_event000 0
        }    

	set i 0
	while {[info exists on($event$i,*)]} {
		if {[catch {eval $on($event$i,*)} e]} {
			echo [format [mc "Error in: on %s event. %s Error Message: %s"] $event \n $e]
		}
		incr i
	}
	set i 0
	while {[info exists on($event$i,$network)]} {
		if {$network!="*"} {
			if {[catch {eval $on($event$i,$network)} e]} {
				echo [format [mc "Error in: on %s event. %s Error Message: %s"] $event \n $e]
			}
		}
		incr i
	}

        if {$id_event000} {
	   set me(id) $old000	
        }
}

proc clear {} {
  global me active wid
  set w $active($me(id))
  catch { $wid($w,text) delete 1.0 end }
}

proc echo {args} {
  global colsTXT icons wid active me

  if {$args==""} {
	IRC::echo [mc "Invalid Arguments"]
        IRC::echo [mc "Syntax: /echo <text>"]
        return
  }
  set args [::join [FormatColors "$args"]]
  set w [lindex [Convert $args] 0]
  if {[info exists wid($w,text)]} {
    set text [::join [lrange [Convert $args] 1 end]]
  } else {
    set text [::join [lrange [Convert $args] 0 end]]
    set w $active($me(id))
  }
  if {$icons(show)} {ImageText $w prog}
  ColorText $active($me(id)) [Reverse $text] $colsTXT(prog) 1
}

proc nickserv {args} {
  if {![Connected]} {return}
  if {$args==""} {
  	IRC::echo [mc "Invalid Arguments"]
	IRC::echo [mc "Syntax: /nickserv <params>"]
	IRC::echo [mc "For more help try: /nickserv help"]
       return
  }
  eval quote nickserv $args
}

proc chanserv {args} {
  if {![Connected]} {return}
  if {$args==""} {
  	IRC::echo [mc "Invalid Arguments"]
	IRC::echo [mc "Syntax: /chanserv <params>"]
	IRC::echo [mc "For more help try: /chanserv help"]
       return   	
  }
  eval quote chanserv $args
}

proc memoserv {args} {
  if {![Connected]} {return}
  if {$args==""} {
  	IRC::echo [mc "Invalid Arguments"]
	IRC::echo [mc "Syntax: /memoserv <params>"]
	IRC::echo [mc "For more help try: /memoserv help"]
       return
  }
  eval quote memoserv $args
}

proc dccallow {args} {
  if {![Connected]} {return}
  if {$args==""} {
  	IRC::echo [mc "Invalid Arguments"]
       IRC::echo [mc "Syntax: /dccallow <params>"]
       return   	
  }
  eval quote dccallow $args
}


proc say {args} {
  global me active icons wid colsTXT
  if {![Connected]} {return}
  set syntax {
       IRC::echo [mc "Syntax: /say <channel> <text>"]
  }
  if {$args==""} {
       eval $syntax
       return   	
  }

  set args [Convert [::join $args]]
  if {[llength $args]<2} {
       IRC::echo [mc "Invalid Arguments"]
       eval $syntax 
       return
  }  
  set canale [Reverse [lindex $args 0]]
  set text [FormatColors [Reverse [::join [lrange $args 1 end]]]]
  set w [GetWinChan $canale $me(id)]
  if {[info exists wid($w,text)]&&$w!=""&&[winfo exists $wid($w,text)]} {
     if {$icons(show)} {ImageText $w text}
     ColorText $w "<[NickMode [::savirc::getNick $me(id)] $w][::savirc::getNick $me(id)]> $text" $colsTXT(mechan) 1
     SvrSend "PRIVMSG $canale :$text" $me(id)
  }

}


proc unload {args} {
   global me active   
   set file [lindex $args 0]
   if {$file==""} {
      set file [tk_getOpenFile -initialdir "$me(path)/scripts" -title [mc "Please choose a file to unload"]]
      if {$file==""} {return} 
      if {$file!=""} {
        if {[file dirname $file]!="$me(path)/scripts"} {
          IRC::echo [format [mc "You can only unload scripts from %s"] $me(path)/scripts]
          return
        }
      }
   }
   set sc [lindex $args 1]
   if {$sc==""} {
     set sc "functions"
   }

   UnloadScript [file tail $file] $sc

}


proc load {args} {
   global me active   
   set file [lindex $args 0]
   if {$file==""} {
      set file [tk_getOpenFile -initialdir "$me(path)/scripts" -title [mc "Please choose a file to load"]]
      if {$file==""} {return} 
      if {$file!=""} {
#        if {[file dirname $file]!="$me(path)/scripts"} {
#          IRC::echo [format [mc "Load new scripts only from %s"] $me(path)/scripts]
#          return
#        }
      }
   }
   set sc [lindex $args 1]
   if {$sc==""} {
     set sc "functions"
   }

   LoadScript $file $sc

}


proc quit {args} {
 global me icons colsTXT clientMSG
 if {![Connected]} {return}
 if {$args==""} {set args $clientMSG(quit)}
 SvrSend "QUIT :[FormatColors $args]" $me(id)

}




proc dns {args} {
 global me active whois hostnick files colsTXT icons
 if {![Connected]} {return}
 if {$args==""} {
   IRC::echo [mc "You may use either nick or host as the paramter"]
   IRC::echo [mc "Syntax: /dns <nick|host>"]
   return
 }
 set args [lindex $args 0]

 if {[string first "." $args]==-1} {
   set whois(352) 0
   puts $me($me(id),sock) "WHO [Reverse $args]"
   tkwait variable hostnick
   set target "[Reverse $args] ($hostnick)"

 } else {
   set hostnick $args
   set target $hostnick
 }

 if {$icons(show)} {ImageText $active($me(id)) motd}
 NormalText $active($me(id)) [format [mc "Looking up DNS for %s"] $target] $colsTXT(dns) 1

 if {[catch {exec $files(nslookup) $hostnick} dns]} { }

 set ip [lindex $dns end]
 if {[IsIp $ip]} {
   set dns [format [mc "%s resolved to %s"] $hostnick $ip]
   set resolved $ip
 } else {
   set dns [format [mc "Unable to resolve %s %s %s"] $hostnick - $dns]
   set resolved $hostnick
 }

 if {$icons(show)} {ImageText $active($me(id)) motd}
 NormalText $active($me(id)) $dns $colsTXT(dns) 1
 Event000 "dns" $me($me(id),net) id $me(id) "nick" $args "host" $hostnick "resolved" $resolved
}




proc asay {args} {
  global me active icons id canali wid colsTXT
  if {![Connected]} {return}
  if {$args==""} {
     IRC::echo [mc "Syntax: /asay <text>"]
     return
  }
  set args [Convert [::join $args]]
  set text [FormatColors  [Reverse $args]]
  foreach id $me(sockslist) {
     foreach chan $canali($id) {
        set w [GetWinChan $chan $id]
        if {[info exists wid($w,text)]&&$w!=""&&[winfo exists $wid($w,text)]} {
           if {$icons(show)} {ImageText $w text}
           ColorText $w "<[NickMode [::savirc::getNick $id] $w][::savirc::getNick $id]> $text" $colsTXT(mechan) 1
           SvrSend "PRIVMSG $chan :$text" $id
        }
     } 
  }

}


proc away {args} {
 global me icons colsTXT
 if {![Connected]} {return}
 if {$args!=""} {
    set args [Convert [::join $args]]
    set text [Reverse $args]
    SvrSend "AWAY : $text" $me(id)
 } else {
    SvrSend "AWAY" $me(id)
 }
}

proc back {} {
  away
}

proc ignore {args} {
 global colsTXT me active tempignore ignore icons

 if {![Connected]} {return}
 set syntax {
      IRC::echo [mc "Syntax: /ignore <mask or nick> ?flags? ?timer?"]
      IRC::echo [mc "Flags: Determines what to ignore (Use 'a' for all)"]
      IRC::echo [mc "Timer: Number of minutes the ignore will last"]
 }

 if {$args==""} {
      eval $syntax 
      return
 }
 set mask [lindex $args 0]
 set flags [lindex $args 1]
 set timer [lindex $args 2]
 if {[llength $args]>3} {
     IRC::echo Invalid arguments!
     eval $syntax
     return
 }
 if {[lsearch $ignore $mask]!=-1} {
   if {$icons(show)} {ImageText $active($me(id)) prog}
   NormalText $active($me(id)) [format [mc "%s is already in ignore list"] [Reverse $mask]] $colsTXT(prog) 1
   return
 }
 if {$flags==""} {set flags "a"}
 if {$timer==""} {
      AddIgnore $mask $flags
      if {$icons(show)} {ImageText $active($me(id)) prog}
      NormalText $active($me(id)) [format [mc "Added %s (%s flags) to ignore list"] [Reverse $mask] $flags] $colsTXT(prog) 1
 } else {
     if {[Isinteger $timer]} {
        set sec [expr $timer*60]
        lappend tempignore "$mask $flags [expr [clock seconds]+$sec]"
        if {$icons(show)} {ImageText $active($me(id)) prog}
        NormalText $active($me(id)) [format [mc "Ignoring %s (%s flags) for %s minute(s)"] [Reverse $mask] $flags $timer] $colsTXT(prog) 1
        after [expr $timer*60000] {
          DelIgnoreTemp
        }
     } else {
      if {$icons(show)} {ImageText $active($me(id)) prog}
      NormalText $active($me(id)) [mc "Ignore time must be an integer"] $colsTXT(prog) 1
      eval $syntax 
     }
 }
}


proc play {args} {
  global files active me colsTXT mp3
  set syntax "IRC::echo [mc "Syntax: /play ?filename?"]"
  set args [::join $args]
  if {$mp3(playing)} {
    IRC::echo Another file is currently being played!
    return
  }
  if {$args==""} {
    set args [tk_getOpenFile -title [mc "Please choose a file to play"]]
    if {$args==""} {return}
  }

  if {[file isdirectory $args]} {
    IRC::echo $args is a directory!
    eval $syntax
    return
  }
  if {[catch {snack::sound s -file $args} e]} {
     tk_messageBox -message [format [mc "Cannot play MP3, check that libsnack.dll is %s in %s"] \n $me(path)]
     return
  }
  set mp3(object) $e
  s play -command "ResetPlaying"
  set mp3(playing) 1
  set mp3(current) $args
  VerboseMp3 "s" $args
}

proc disconnect {args} {
  global me colsTXT icons
  if {![Connected]} {return}
  Disconnect $me(id)
}




proc server {args} {
 global me
 set syntax "IRC::echo [mc "Syntax: /server <server> ?port?"]"
 if {$args==""} {
      eval $syntax
      return   	
 } else {
   switch [llength $args] {
     1 {
        set me(server) [lindex $args 0]
        set me(port) "6667"
     }
     2 {
        set me(server) [lindex $args 0]
        set me(port) [lindex $args 1]
     }
     "default" {
	IRC::echo [mc "Invalid Arguments"]
        eval $syntax
        return   	
     }		
   }
 }
 FindServerNet $me(server)
 Connect
}


proc dcc {args} {
 global files 
 if {![Connected]} {return}
 set syntax {
      IRC::echo [mc "Syntax: /dcc <type> <nick> ?file?"]
      IRC::echo [mc "The value of <type> is send or chat"]
 }

 if {$args==""} {
      eval $syntax
      return   	
 } else {
  set args [Convert [::join $args]]
  switch [llength $args] {
      1 {
	IRC::echo Invalid arguments
        eval $syntax
        return   	
      }
      2 {
        set nick [Reverse [::join [lindex $args 1]]]
        set type [Reverse [::join [lindex $args 0]]]
	if {$type=="send"} {
          set file [tk_getOpenFile -initialdir $files(defaultdir) -title [mc "Please choose the file to send"]]
          if {$file==""} {return}
          DCCSend $nick $file
          set files(defaultdir) [file dirname $file]
          SaveSettings
 	} elseif {$type=="chat"} {
          DCCChat $nick	  	 
        } else {
   	  IRC::echo [format [mc "%s: DCC type not supported"] $type]
          eval $syntax         
        }  
      }
      3 {
        set nick [Reverse [::join [lindex $args 1]]]
        set type [Reverse [::join [lindex $args 0]]]
	if {$type=="send"} {
          set file [Reverse [::join [lindex $args 2]]]
          DCCSend $nick $file
          set files(defaultdir) [file dirname $file]
          SaveSettings          
 	} elseif {$type=="chat"} {
   	  IRC::echo [mc "Too many arguments for DCC chat"]
          eval $syntax         
        } else {
   	  IRC::echo [format [mc "%s: DCC type not supported"] $type]
          eval $syntax         
        }  

      }
      "default" {
   	  IRC::echo [mc "Invalid Arguments"]
          eval $syntax 
      }
  }
 }
}

proc mode {args} {
 global me 
 if {![Connected]} {return}
 set syntax {
  IRC::echo [mc "Syntax: /mode <args>"]
  IRC::echo "[mc see] http://www.savirc.com/IRC-Commands.htm#Heading647"
 }
 if {$args==""} {
  eval $syntax
  return   	
 } else {

  SvrSend "MODE [Reverse $args]" $me(id)
 }
}

proc who {args} {
  global me 
  if {![Connected]} {return}
  if {$args==""} {
      IRC::echo [mc "Syntax: /who <params>"]
      IRC::echo "[mc see] http://www.savirc.com/IRC-Commands.htm#Heading471"
      return   	
  }
  SvrSend "WHO $args" $me(id)
}

proc csay {args} {
  global CHATsk me colsTXT
  if {![Connected]} {return}
  set syntax {
     IRC::echo [mc "Syntax: /csay <id> <nick> <text>"]
  }
  if {$args==""} {
     eval $syntax
     return
  }

  if {$args==""||[llength $args]<3} {
     eval $syntax
     return
  }

  set args [Convert [::join $args]]
  set id [lindex $args 0]
  set nick [lindex $args 1]
  set text [FormatColors [Reverse [::join [lrange $args 2 end]]]]
  set w [GetWinChat $nick $id]
  ColorText $w "<[Reverse [Convert [::savirc::getNick $id]]]> $text" $colsTXT(mechat) 1
  puts $CHATsk($nick) "$text"

}

proc ame {args} {
  global me active icons id canali wid colsTXT CHATsk query chat

  if {![Connected]} {return}
  if {$args==""} {
     IRC::echo [mc "Syntax: /ame <text>"]
     return
  }
  set args [Convert [::join $args]]
  set text [FormatColors [Reverse $args]]

  foreach id $me(sockslist) {
     foreach chan $canali($id) {
        set w [GetWinChan $chan $id]
        if {[info exists wid($w,text)]&&$w!=""&&[winfo exists $wid($w,text)]} {
           if {$icons(show)} {ImageText $w action}
           ColorText $w "[NickMode [::savirc::getNick $id] $w][::savirc::getNick $id] $text" $colsTXT(action) 1
           SvrSend "PRIVMSG $chan :\001ACTION $text\001" $id
        }
     } 
     foreach chan $query($id) {
        set w [GetWinQuery $chan $id]
        if {[info exists wid($w,text)]&&$w!=""&&[winfo exists $wid($w,text)]} {
           if {$icons(show)} {ImageText $w action}
           ColorText $w "[::savirc::getNick $id] $text" $colsTXT(action) 1
           SvrSend "PRIVMSG $chan :\001ACTION $text\001" $id
        }
     }
     foreach chan $chat($id) {
        set w [GetWinChat $chan $id]
        if {[info exists wid($w,text)]&&$w!=""&&[winfo exists $wid($w,text)]} {
           if {$icons(show)} {ImageText $w action}
           ColorText $w "[::savirc::getNick $id] $text" $colsTXT(action) 1
           puts $CHATsk($chan) "\001ACTION $text\001"
        }
     } 

  }
}



proc me {args} {
 global me active colsTXT icons CHATsk mark

 if {![Connected]} {return}
 if {$args==""} {
 	IRC::echo [mc "Invalid Arguments"]
	IRC::echo [mc "Syntax: /me <text>"]
     return
 }
 set args [Convert [::join $args]]
 set text [FormatColors [Reverse $args]]
 set type [Window $active($me(id))]
 switch $type {
   0 {set what [GetChannel $active($me(id)) $me(id)]}
   1 {set what [GetQuery $active($me(id)) $me(id)]}
   2 {set what [GetChat $active($me(id)) $me(id)]}
   default {return}
 }
  if {$icons(show)} {ImageText $active($me(id)) action}
  if {$type==0} {set mark(nicks) "[Convert [::savirc::getNick $me(id)]]"}  
  
  ColorText $active($me(id)) "[NickMode [::savirc::getNick $me(id)] $active($me(id))][::savirc::getNick $me(id)] $text" $colsTXT(action) 1
  
  if {$type==0} {set mark(nicks) ""}

  if {$type!=2} {
    SvrSend "PRIVMSG $what :\001ACTION $text\001" $me(id)
  } else {
    puts $CHATsk($what) "\001ACTION $text\001"
  }
}

proc notice {args} {
  global me colsTXT icons
  if {![Connected]} {return}
  set syntax {
     IRC::echo [mc "Syntax: /notice <nick> <text>"]
  }	
  if {$args==""} {
     eval $syntax
     return
  }

  switch [llength $args] {
   2 {
     set nick [lindex $args 0]
     set text [Reverse [lrange $args 1 end]]
     SvrSend "NOTICE [Reverse $nick] :[FormatColors $text]" $me(id)
   }
   default {
     IRC::echo [mc "Invalid Arguments"]
     eval $syntax
   }
  }
}



proc amsg {args} {
  global me active icons id query chat wid colsTXT CHATsk
  if {![Connected]} {return}
  if {$args==""} {
     IRC::echo [mc "Syntax: /amsg <text>"]
     return
  }
  set args [Convert [::join $args]]
  set text [FormatColors [Reverse $args]]
  foreach id $me(sockslist) {
     foreach chan $query($id) {
        set w [GetWinQuery $chan $id]
        if {[info exists wid($w,text)]&&$w!=""&&[winfo exists $wid($w,text)]} {
           if {$icons(show)} {ImageText $w text}
           ColorText $w "<[::savirc::getNick $id]> $text" $colsTXT(mequery) 1
           SvrSend "PRIVMSG $chan :$text" $id
        }
     } 
     foreach chan $chat($id) {
        set w [GetWinChat $chan $id]
        if {[info exists wid($w,text)]&&$w!=""&&[winfo exists $wid($w,text)]} {
           if {$icons(show)} {ImageText $w text}
           ColorText $w "<[::savirc::getNick $id]> $text" $colsTXT(mechat) 1
           puts $CHATsk($chan) "$text"
        }
     } 

  }

}


proc msg {args} {
  global me colsTXT icons
  if {![Connected]} {return}
  set syntax {
     IRC::echo [mc "Syntax: /msg <nick> <text>"]
  }	
  if {$args==""} {
     eval $syntax
     return
  }
  set args [Convert [::join $args]]
  if {[llength $args]==1} {
     IRC::echo [mc "No text given"]
     eval $syntax
  } else {
     set msgnick [Reverse [lindex $args 0]]
     set text [Reverse [::join [lrange $args 1 end]]]
     SvrSend "PRIVMSG $msgnick :[FormatColors $text]" $me(id)
  }
}


proc whois {args} {
 global me colsTXT icons
 if {![Connected]} {return}
 if {$args==""} {
   IRC::echo [mc "Syntax: /whois <nick>"]
   return
 } 
 set whonick [lindex $args 0]
 SvrSend "WHOIS [Reverse $whonick]" $me(id)
}


proc join {chan args} {
  global me colsTXT icons
  if {![Connected]} {return}
  if {$chan ==""} {
   IRC::echo [mc "Syntax: /join <channel>"]
   return
  }
  if {$args != ""} {
      set key "$args"
	} else {
      set key ""
	}

	switch -regexp $chan {
		      ^& { SvrSend "JOIN $chan $key" $me(id) }
		      ^! { SvrSend "JOIN $chan $key" $me(id) }
		      ^# { SvrSend "JOIN $chan $key" $me(id) }
		      {^\+} { SvrSend "JOIN $chan $key" $me(id) }
		      default { SvrSend "JOIN #$chan $key" $me(id) }
		      }

}


proc part {args} {
  global me canali active colsTXT icons wid
  if {![Connected]} {return}
  set syntax {
   IRC::echo [mc "Syntax: /part channel ?id?"]
   IRC::echo [mc "?id? identifies the connection, it defaults to the current one"]
  }
  if {$args==""} {
    set w $active($me(id))
  } else {
    switch [llength $args] {
      1 {set w [GetWindow $args $me(id)]}      
      2 {set w [GetWindow [lindex $args 0] [lindex $args 1]]}
      default {
        IRC::echo [mc "Invalid Arguments"]
        eval $syntax
	return        
      }
    }
  }

 if {[Window $w]!=0} {
    IRC::echo [mc "Active window is not a channel"]
    eval $syntax
    return
 }
 if {![info exists wid($w)]} {return}
 $wid($w) close_win
}


proc query {args} {
   global query me active colsTXT icons wid
   if {![Connected]} {return}
   if {$args==""} {
    IRC::echo [mc "Syntax: /query  <nick>"]
    return
   }
   set lista [string tolower $query($me(id))]
   set querynick [lindex $args 0]
   set querynick [Convert $querynick]
   set qnicklow [string tolower $querynick]
   if {[lsearch -exact $lista $qnicklow]==-1} {
     winquery $querynick 0 "" "" $me(id)
   } else {
     set w [GetWinQuery $qnicklow $me(id)]
     catch {
      $wid($w) icon_cmd
      focus $wid($w,command)
     }
   }
}


proc ctcp {args} {
 global me ping colsTXT icons
 if {![Connected]} {return}
 set syntax {
   IRC::echo [mc "Syntax: /ctcp <nick> <type>"]  
 }
 if {$args==""} {
   eval $syntax
   return
 }

 set args [Convert [::join $args]]

 if {[llength $args]<2} {
       IRC::echo [mc "Invalid Arguments"]
       eval $syntax
       return
 }

 set nick [lindex $args 0]
 set type [Reverse [::join [lrange $args 1 end]]] 
 

 if {$type=="ping"} {
   set ping($nick) [clock seconds]
   set type "$type $ping($nick)"
 }
 SvrSend "PRIVMSG [Reverse $nick] :\001[FormatColors $type]\001" $me(id)
}


proc ban {args} {
 global whois hostnick usernick me colsTXT icons
 if {![Connected]} {return}
 set syntax {
   IRC::echo [mc "Syntax: /ban <channel> <nick> <mode> <kick>"]  
   IRC::echo [mc "mode: ban type:"]
   IRC::echo  1 nick!*@*
   IRC::echo  2 *!user@host
   IRC::echo  3 *!*@host
   IRC::echo kick: 0,1 [mc "kick nick after ban is set"]
 }
 if {$args==""} {
   eval $syntax
   return
 }
  
 switch [llength $args] {
    2 {
      set nick [lindex $args 1]
      set channel [lindex $args 0]
      set mode 3
      set kick 0
    }
    3 {
      set nick [lindex $args 1]
      set channel [lindex $args 0]
      set mode [lindex $args 2]
      if {$mode!=1&&$mode!=2&&$mode!=3} {
       IRC::echo [mc "Value for mode must be 1, 2 or 3"]
       eval $syntax
       return      
      }
      set kick 0
    }
    4 {
      set nick [lindex $args 1]
      set channel [lindex $args 0]
      set mode [lindex $args 2]
      set kick [lindex $args 3]
      if {$kick!=0&&$kick!=1} {
       IRC::echo [mc "Value for kick must be boolean, 0 or 1"]
       eval $syntax
       return      
      }
    }
    default {
       IRC::echo [mc "Invalid Arguments"]
       eval $syntax
       return      
    }   
 }

 set whois(309) 0
 set whois(330) 0
 set whois(311) 0
 set whois(312) 0
 set whois(319) 0
 set whois(318) 0
 set whois(317) 0

 SvrSend "WHOIS [Reverse $nick]" $me(id)
 if {$mode==1} {
   SvrSend "MODE $channel +b [Reverse $nick]!*@*" $me(id)
 } else {
    tkwait variable hostnick
    switch -- $mode {
      2 { SvrSend "MODE $channel +b *!$usernick@$hostnick" $me(id)}
      3 { SvrSend "MODE $channel +b *!*@$hostnick" $me(id)}
    }
 }
 if {$kick} {
   kick [::join $channel] [Reverse [::join $nick]]
 }
}

proc kick {args} {
 global me clientMSG colsTXT icons
 if {![Connected]} {return}
 set syntax {
   IRC::echo [mc "Syntax: /kick <channel> <nick> ?reason?"]
 }
 if {$args==""} {
    eval $syntax
    return
 }

 if {[llength $args]==2} {
   set nick [lindex $args 1]
   set channel [lindex $args 0]
   set reason $clientMSG(kick)
 } elseif {[llength $args]>2} {
   set nick [lindex $args 1]
   set channel [lindex $args 0]
   set reason [lrange $arg 2 end]    
 } else {
   IRC::echo [mc "Invalid Arguments"]
   eval $syntax
   return        
 }
 SvrSend "KICK $channel [Reverse $nick] : $reason" $me(id)
}

proc nick {args} {
 global me colsTXT icons
 if {![Connected]} {return}
 if {$args==""} {
    IRC::echo [mc "Syntax: /nick <nick>"]
    return
 }

 set newnick [lindex $args 0]
 if {!$me($me(id),registered)} { 
   ::savirc::setNick $me(id) $newnick
 }
 SvrSend "NICK [Reverse $newnick]" $me(id)
}

proc raw {args} {

   eval quote [::join $args]
}

proc quote {args} {
 global me colsTXT icons
 if {![Connected]} {return}
 if {$args==""} {
    IRC::echo [mc "Syntax: /quote <text>"]
    return
 }

 SvrSend "[Reverse [::join $args]]" $me(id)

}


proc invite {args} {
 global me colsTXT icons
 if {![Connected]} {return}
 set syntax {
    IRC::echo [mc "Syntax: /invite <nick> <channel>"]
 }
 if {$args==""} {
    eval $syntax
    return
 }
 switch [llength $args] {
   2 {
     set nick [lindex $args 0]
     set channel [lindex $args 1]
   }
   default {
     IRC::echo [mc "Invalid Arguments"]
     eval $syntax    
     return
   }
 }
 SvrSend "INVITE $nick $channel" $me(id)
}

proc cycle {args} {
 global active me colsTXT icons wid
 if {![Connected]} {return} 
 set id $me(id)
 set channel [GetChannel $active($me(id)) $id]

 $wid($active($me(id))) close_win
 id $id join $channel
}


proc run {args} {
 global active me colsTXT icons
 set syntax {
    IRC::echo [mc "Syntax: /run <program> ?params?"]
 }
 if {$args==""} {
    eval $syntax
    return
 }

 set prog [lindex $args 0] 
 set params [lrange $args 1 end]
 if {$icons(show)} {ImageText $active($me(id)) prog}
 NormalText $active($me(id)) [format [mc "Running %s ..."] $args] $colsTXT(prog) 1
 if {[catch {eval exec $prog $params &} output]} {
   if {$icons(show)} {ImageText $active($me(id)) prog}
   NormalText $active($me(id)) [format [mc "Error: %s"] $output] $colsTXT(prog) 1
 }
 if {$icons(show)} {ImageText $active($me(id)) prog}
 NormalText $active($me(id)) $output $colsTXT(prog) 1
}



proc help {} {
  global me
  help::init $me(path)/help/help.help
}

proc activeChan {} {
  global active me
  GetChannel $active($me(id)) $me(id)
}

proc op { args } {
  multi_mode "[activeChan]" "[concat $args]" "+" "o"
}

proc deop { args } {
  multi_mode "[activeChan]" "[concat $args]" "-" "o"
}

proc voice { args } {
  multi_mode "[activeChan]" "[concat $args]" "+" "v"
}

proc devoice { args } {
  multi_mode "[activeChan]" "[concat $args]" "-" "v"
}

proc halfop { args } {
  multi_mode "[activeChan]" "[concat $args]" "+" "h"
}

proc dehalfop { args } {
  multi_mode "[activeChan]" "[concat $args]" "-" "h"
}

proc multi_mode { chan userlist listmode type } {
  set range [lrange $userlist 0 5]
  set list $listmode
  foreach user $range {
    append list $type
  }
  raw mode $chan $list $range


  if {[llength $userlist] > 6} {
	set range1 [lrange $userlist 6 11]
	set list $listmode

	foreach user $range1 {
		append list $type
		}
	raw mode $chan $list $range1
	

	}
  if {[llength $userlist] > 12} {
	set range2 [lrange $userlist 12 17]
	set list $listmode

	foreach user $range2 {
		append list $type
		}
	raw mode $chan $list $range2

	}
  if {[llength $userlist] > 18} {
	echo [mc "Too many users are selected please choose less than 18"]
	}
}

proc links {} {
  raw links
}

proc names { args } {

  if {![Connected]} {return}
  
  if {$args == ""} {
  	IRC::echo [mc "Invalid Arguments"]
	IRC::echo [mc "Syntax: /names <channel>"]
	} else {
		raw names $args
		}
}

proc topic {args} {
  global me
  SvrSend "TOPIC [lindex $args 0] :[lrange $args 1 end]" $me(id) 
}

proc commands {} {
  echo [mc "List of Commands"]
  echo ame
  echo amsg
  echo asay
  echo away
  echo ban
  echo chanserv
  echo commands
  echo ctcp
  echo cycle
  echo dcc
  echo dccallow
  echo dehalfop
  echo deop
  echo devoice
  echo disconnect
  echo dns
  echo echo
  echo kick
  echo help
  echo halfop
  echo ignore
  echo invite
  echo join
  echo links
  echo load
  echo me
  echo memoserv
  echo mode
  echo msg
  echo names
  echo nick
  echo nickserv
  echo op
  echo part
  echo play
  echo query
  echo quit
  echo quote
  echo raw
  echo run
  echo say
  echo server
  echo topic
  echo unload
  echo voice
  echo who
  echo whois
  echo [mc "End of Command List"]
}

proc j {args} {
   join $args
}

proc w {args} {
   whois $args
}

proc n {args} {
   nick $args
}

proc q {args} {
   query $args
}

proc send {args} {
   dcc send $args
}

proc chat {args} {
   dcc chat $args
}

proc ns {args} {
   eval nickserv $args
}

proc ms {args} {
   eval memoserv $args
}

proc cs {args} {
   eval chanserv $args
}


} ;# end of IRC namespace
