array set DCCoffer ""
array set DCCresume ""

proc DCCSend { nick file } {
     global me DCC DCCoffer active colsTXT icons
     set nick [Convert $nick]
     if {![file exists $file]} {
        if {$icons(show)} {ImageText $active($me(id)) dcc}
        NormalText $active($me(id)) [format [mc "DCC SEND: %s file not found"]  \"$file\"] $colsTXT(ctcp) 1
        return
     }
     if {![file readable $file]} {
        if {$icons(show)} {ImageText $active($me(id)) dcc  }
        NormalText $active($me(id)) [format [mc "DCC SEND: Cannot read file %s"] \"$file\"] $colsTXT(ctcp) 1
	return
     }
     set xfile [file tail $file]
     set file [file join [file dirname $file] $xfile]
     set sizek [FormatSize [file size $file]]
     if {[catch {ipPack $me($me(id),ip)} myIp]} {return}
     if {!$DCC(passive)} {
        if {!$DCC(sock5)} {
   	    set sock [socket -server "acceptSend $me(id) $nick [list $file]" 0]
  	    if {[catch {fconfigure $sock -sockname} xx]} {
              if {$icons(show)} {ImageText $active($me(id)) dcc}
              NormalText $active($me(id)) [format [mc "DCC SEND: Cannot get port for server %s %s"] - $xx] $colsTXT(ctcp) 1
              return
	    }
            set port [lindex $xx 2]
    	    puts $me($me(id),sock) "PRIVMSG [Reverse $nick] :\001DCC SEND [RemoveSpace $xfile] $myIp [lindex $xx 2] [file size $file]\001"
        } else {
            set DCCoffer($nick) 0
            if {$icons(show)} {ImageText $active($me(id)) dcc}
	    # removed variable ($sizek) from sentence
            NormalText $active($me(id)) [format [mc "DCC SEND: Requesting permission to send %s to %s. Waiting for connection"] $xfile [Reverse $nick]] $colsTXT(ctcp) 1

            if {$me(sock5svr)==""} {
              if {$icons(show)} {ImageText $active($me(id)) dcc}
              NormalText $active($me(id)) [mc "DCC SEND: Can't connect to SOCK5 server, no server selected."] $colsTXT(ctcp) 1
              return
            }
            if {[catch {socket -async $me(sock5svr) $me(sock5port)} sock]} {
              if {$icons(show)} {ImageText $active($me(id)) dcc}
              NormalText $active($me(id)) [format [mc "DCC SEND %s: Connection Error %s %s"] \[SOCK5\] - $sock] $colsTXT(ctcp) 1
              return
            }
            if {$me(sock5user)==""&&$me(sock5pass)==""} {
               set auth 0
            } else {
               set auth 1
            }
            if {[catch {socks:bind $sock $me(ip) "2000" $auth "$me(sock5user)" "$me(sock5pass)" $me($me(id),sock) [Reverse $nick] [RemoveSpace $xfile] [file size $file] "send"} sock5]} {
              if {$icons(show)} {ImageText $active($me(id)) dcc}
              NormalText $active($me(id)) [format [mc "DCC SEND %s: Error Binding Socket %s"] \[SOCK5\] - $sock5] $colsTXT(ctcp) 1
              return
            }            
	    if {$sock5!="ok"} {
              if {$icons(show)} {ImageText $active($me(id)) dcc}
              NormalText $active($me(id)) [format [mc "DCC SEND %s: %s"] \[SOCK5\] $sock5] $colsTXT(ctcp) 1 
              return             
            }	
            acceptSend $me(id) $nick [join [list $file]] $sock $me(ip) "2000"
	    return
        }
     } else {
        set pID [clock seconds]
        set DCC(passive,$pID) "$nick [list $file]"
        puts $me($me(id),sock) "PRIVMSG [Reverse $nick] :\001DCC SEND [RemoveSpace $xfile] $myIp 0 [file size $file] $pID\001"
     }
     #set DCCoffer($nick[RemoveSpace $xfile]) "[RemoveSpace $xfile] 0"
     set DCCoffer($nick) 0
     if {$icons(show)} {ImageText $active($me(id)) dcc}
     NormalText $active($me(id)) [format [mc "DCC SEND: Requesting permission to send %s to %s. Waiting for connection"] $xfile [Reverse $nick]] $colsTXT(ctcp) 1
}


proc acceptSend { id nick file chan host port } {
    global tl cur active DCC colsTXT DCCoffer icons wid me
    set leng [file size $file]
    #set posn [lindex [lindex [array get DCCoffer $nick[RemoveSpace [file tail $file]]] 1] 1]
    set posn $DCCoffer($nick)
    incr leng -$posn

    if {[ catch {open $file RDONLY} r]} {
        if {$icons(show)} {
         ImageText $active($me(id)) dcc
        }
        NormalText $active($me(id)) [format [mc "DCC SEND: %s to %s has been interrupted. Can't read %s: %s"] $file [Reverse $nick] $file $r] $colsTXT(ctcp) 1
        return 0
    }

    if {[catch {seek $r $posn start} msg]} {
       if {$icons(show)} {
        ImageText $active($me(id)) dcc
       }
       NormalText $active($me(id)) [format [mc "DCC SEND: %s to %s has been interrupted. Can't seek %s: %s"] $file [Reverse $nick] $file $msg] $colsTXT(ctcp) 1
       close $r
       return 0
    }

    if {$leng == 0} {
	close $r
        if {$icons(show)} {
          ImageText $active($me(id)) dcc
        }
        NormalText $active($me(id)) [format [mc "DCC SEND: %s to %s has completed."] $file [Reverse $nick]] $colsTXT(ctcp) 1
	return 1
    }
    set st [clock seconds]
    array set cur "$chan 0 $chan.p 0 $chan.k 0 $chan.r 0 $chan.l $leng $chan.s [clock seconds] $chan.time 0"

    fconfigure $r -translation binary
    if {[catch {set buffer [read $r $DCC(block)]} msg]} {
        if {$icons(show)} {
          ImageText $active($me(id)) dcc
        }
	NormalText $active($me(id)) [format [mc "DCC SEND: %s to %s has been interrupted. Error reading %s: %s"] $file [Reverse $nick] $file $msg] $colsTXT(ctcp) 1
	catch {close $r}
	return 0
    }
    set tl($chan) [string length $buffer]
    fconfigure $chan -blocking 0 -buffering none -translation binary
    if {[catch {puts -nonewline $chan $buffer} msg]} {
        if {$icons(show)} {
         ImageText $active($me(id)) dcc
        }
	NormalText $active($me(id)) [format [mc "DCC SEND: %s to %s has been interrupted. Write error: %s"] $file [Reverse $nick] $msg] $colsTXT(ctcp) 1
	catch {close $r}
	return 0
    }
    set i 0
    while {[info exists wid(dcc$i,transfer)]} {
    incr i }
    set wget "dcc$i"

    DccTransfer $wget $file $chan $nick "SEND"
    IRC::Event000 sendstart $me($id,net) id $id nick [Reverse $nick] ip $host port $port file $file size $leng
    TransferTime $chan $wget
    if {![info exists wid($wget,progress)]} {return}    
    bind $wid($wget,progress) <Destroy> "CloseSocks $chan $r $wget"
    fileevent $chan readable "dccSendEvent $id [list $file] $chan $r $st $leng $nick $wget"

}



proc dccSendEvent {id file chan r st leng nick wget} {
    global cur colsTXT DCC tl me active icons wid files
    if {[eof $chan]} {
          if {$icons(show)} {ImageText $active($me(id)) dcc}
	  NormalText $active($me(id)) [format [mc "DCC SEND: %s to %s has been interrupted."] [file tail $file] [Reverse $nick]] $colsTXT(ctcp) 1
          IRC::Event000 sendfail $me($id,net) id $id nick [Reverse $nick] file [file tail $file] size $leng
          catch {close $r}
          $wid($wget) close_win
	  return
    }
    if {[catch {set l [read $chan 4]} msg]} {
           if {$icons(show)} {ImageText $active($me(id)) dcc}
	   NormalText $active($me(id)) [format [mc "DCC SEND: %s to %s has been interrupted. Error reading: %s"] [file tail $file] [Reverse $nick] $msg] $colsTXT(ctcp) 1
           IRC::Event000 sendfail $me($id,net) id $id nick [Reverse $nick] file [file tail $file] size $leng
       	   catch {close $r}
           $wid($wget) close_win           
     	   return
    }
    if {[string length $l] == 0} {
	 catch {close $r}
         if {$icons(show)} {ImageText $active($me(id)) dcc}
	 NormalText $active($me(id)) [format [mc "DCC SEND: %s to %s has been interrupted. Sync read error."] [file tail $file] [Reverse $nick]] $colsTXT(ctcp) 1
         IRC::Event000 sendfail $me($id,net) id $id nick [Reverse $nick] file [file tail $file] size $leng
         $wid($wget) close_win
	 return
    }

    set cl 0
    binary scan $l I1 cl
    if [eof $r] {
        if {[set st [expr {[clock seconds] - $st}]] == 0} {set st 1}
        catch {close $r}

        if {$icons(show)} {ImageText $active($me(id)) dcc}
        NormalText $active($me(id)) [format [mc "DCC SEND: %s to %s has completed."] [file tail $file] [Reverse $nick]] $colsTXT(ctcp) 1
        IRC::Event000 sendend $me($id,net) id $id nick [Reverse $nick] file [file tail $file] size $leng
        set cur($chan.k) [FormatSize $leng]
        set cur($chan.p) 100
        UpdateProgress $cur($chan.p) $wid($wget,progress) 0
        catch {.buttonbar.buttonbar.$wget.t config -text "[lrange [.buttonbar.buttonbar.$wget.t cget -text] 0 1] \[$cur($chan.p)%\]"}
        catch {close $chan}
	if {$DCC(autoclose_send)==1} {
          $wid($wget) close_win
        }
        return 1
    }
    if {[catch {set buffer [read $r $DCC(block)]} msg]} {
             if {$icons(show)} {ImageText $active($me(id)) dcc}
	     NormalText $active($me(id)) [format [mc "DCC SEND: %s to %s has been interrupted. Error reading %s: %s"] [file tail $file] [Reverse $nick] $file $msg] $colsTXT(ctcp) 1
             IRC::Event000 sendfail $me($id,net) id $id nick [Reverse $nick] file [file tail $file] size $leng
             $wid($wget) close_win
	     catch {
               close $r
             }
	     return 1
	 }
    if {[set lng [string length $buffer]] == 0} {
        if {[set st [expr {[clock seconds] - $st}]] == 0} {
	    set st 1
        }
	catch {close $r}
        if {$icons(show)} {ImageText $active($me(id)) dcc}
	NormalText $active($me(id)) [format [mc "DCC SEND: %s to %s has completed."] [file tail $file] [Reverse $nick]] $colsTXT(ctcp) 1
        IRC::Event000 sendend $me($id,net) id $id nick [Reverse $nick] file [file tail $file] size $leng
        set cur($chan.k) [FormatSize $leng]
        set cur($chan.p) 100
        catch {.buttonbar.buttonbar.$wget.t config -text "[lrange [.buttonbar.buttonbar.$wget.t cget -text] 0 1] \[$cur($chan.p)%\]"}
        UpdateProgress $cur($chan.p) $wid($wget,progress) 0
	
	if {$DCC(autoclose_send)==1} {
            $wid($wget) close_win
        }	

	catch {close $chan}
	return 1
    }
    incr tl($chan) $lng

    if {[catch {puts -nonewline $chan $buffer} msg]} {
           if {$icons(show)} {ImageText $active($me(id)) dcc}
 	   NormalText $active($me(id)) [format [mc "DCC SEND: %s to %s has been interrupted. Write error: %s"] [file tail $file] [Reverse $nick] [mc interrupted] $msg] $colsTXT(ctcp) 1
           IRC::Event000 sendfail $me($id,net) id $id nick [Reverse $nick] file [file tail $file] size $leng
           $wid($wget) close_win
	   catch {
 	     close $r
  	   }
	   return 1
    }

    set timediff [expr [clock seconds]-$st]
    incr cur($chan) $lng
    set differenza [lindex [array get cur $chan] 1]
    if {$timediff!=0} {
     set bps [expr $differenza/$timediff]
     set kps1 [expr $bps/1024]
     set kps2 [expr $bps%1024]
     set cur($chan.r) "$kps1.$kps2"
    }

    set cur($chan.k) [FormatSize [lindex [array get cur $chan] 1]]
    set cursize [lindex [array get cur $chan] 1]
    set cur($chan.p) [proportion $leng $cursize]
    catch {.buttonbar.buttonbar.$wget.t config -text "[lrange [.buttonbar.buttonbar.$wget.t cget -text] 0 1] ($cur($chan.p)%)"}
    UpdateProgress $cur($chan.p) $wid($wget,progress) 0

}


proc TransferTime {chan wget} {
    global wid cur
    if {![winfo exists $wid($wget)]||[FormatSize $cur($chan.l)]==$cur($chan.k)} {return}
    set diff [expr [clock seconds]-$cur($chan.s)]
    set secs [expr $diff%60]
    if {[string length $secs]==1} {set secs "0$secs"}
    set cur($chan.time) "[expr $diff/60]:$secs"
    after 1000 "TransferTime $chan $wget"
}


proc IsInChat {nick id} {
   global chat
   set lista [string tolower $chat($id)]
   set nick [string tolower $nick]
   set ischat [lsearch $lista $nick]
   if {$ischat!=-1} {
     return 1
   } else {
     return 0
   }
}

proc ChatRequestAccept {nick user host ip port} {
    global me from im_ok im_cancel font DCC

    if {$DCC(acceptChat)} {return "ok"}

    if {$me(icony)} {wm state . normal}
    set from ""
    set i 0
    while {[winfo exists ".dccgnotify$i"]} {
    incr i }
    set w ".dccgnotify$i"
    toplevel $w -class Dcc
    wm title $w [mc "Incoming DCC Chat Request"]
    wm geometry $w +200+200
    wm resizable $w 0 0
    wm transient $w .
    frame $w.top1 -border 1 -relief raised
    frame $w.top2

    message $w.top1.text -width 900 \
    -text [format [mc "%s %s %s requests a DCC in CHAT mode.%s The DCC target host will be %s on port %s.%s Do you accept?"] [Reverse $nick] \[$user@$host\] \n \n $ip $port \n]
    xbutton $w.top2.ok -image $im_ok -side left -text [mc Ok] -command "set from ok; destroy $w" -font $font(button)
    xbutton $w.top2.cancel -image $im_cancel -side left -text [mc Cancel] -command "set from cancel;destroy $w" -font $font(button)
    pack $w.top1 -expand yes -fill both -side top
    pack $w.top2 -side bottom
    pack $w.top1.text -padx 10 -pady 15 -expand yes -fill x
    pack $w.top2.ok $w.top2.cancel -side left -pady 10 -padx 15
    focus $w.top2.ok
    bind $w <Return> "set from ok; destroy $w"
    bind $w <Escape> "set from cancel;destroy $w"

    wm withdraw $w
    wm deiconify $w
    catch {grab $w}
    tkwait window $w
    return $from

}


proc ChatRead {sock nick id} {
    global chat colsTXT icons misc me wid task GUI
    catch {
       set w [GetWinChat $nick $id]
    }

    if {[catch {gets $sock} buffer] || ([string match {} $buffer] && [eof $sock])} {
      if {[info exists wid($w)]} {
        catch {close $sock}
        $wid($w) close_win
      } else {
        close_chat $w $id
        catch {close $sock}
      }
      IRC::Event000 chatclose $me($id,net) id $id nick [Reverse $nick]
      return
    }
    if {$icons(show)} {
        ImageText $w text
    }

    if {[regexp -nocase "\001ACTION (.*)\001" $buffer]==1} {
      set txt [Reverse [join [lrange [Convert $buffer] 1 end]]]
      set txt [string trimright $txt "\001"]
      ColorText $w "[Reverse $nick] $txt" $colsTXT(action) 1
      IRC::Event000 chataction $me($id,net) id $id nick [Reverse $nick] text $txt
    } else {
      ColorText $w "<[Reverse $nick]> $buffer" $colsTXT(chat) 1
      IRC::Event000 chattext $me($id,net) id $id nick [Reverse $nick] text $buffer
    }
    
    if {[::platform::isPlatformUnix]} {
      if {$GUI(tk_theme)==1} {
        if {$me(icony)&&$misc(trayuse)} {
          if {$task(chat)==0&&$task(chan)==0} {
            incr task(chat)
	    $GUI(tray) configure -image $icons(tray2)
            .f.tip add $GUI(tray) [format [mc "savIRC: %s msgs %s %s msgs in channels"] $task(chat) - $task(chan)]
          } else {
            incr task(chat)
            .f.tip add $GUI(tray) [format [mc "savIRC: %s msgs %s %s msgs in channels"] $task(chat) - $task(chan)]
          }
        }
      }
    }
    
    if {[::platform::isPlatformWindows]} {
      if {$me(icony)&&$misc(trayuse)} {
        if {$task(chat)==0&&$task(chan)==0} {
          incr task(chat)
          winico taskbar delete $icons(ico_savirc) 
          winico taskbar add $icons(ico_savred) -callback "TaskMenu %m %i %X %Y" -text "savIRC \[$task(chat) msgs - $task(chan) msgs in channels\]"
        } else {
          incr task(chat)
          winico taskbar modify $icons(ico_savred) -text "savIRC \[$task(chat) msgs - $task(chan) msgs in channels\]"
        }
      }
    }
    
    IfColorButton $w $id
}

proc write_chat { w stringa } {
 global me chat colsTXT CHATsk icons
 if {$stringa!=""} {
   if {$icons(show)} {
     ImageText $w text
   }
   ColorText $w "<[Reverse [Convert [::savirc::getNick $me(id)]]]> $stringa" $colsTXT(mechat) 1
 }
 set lista $chat($me(id))
 set indice [lsearch -exact $lista $w]
 set nick [Convert [lindex $lista [expr $indice-1]]]
 puts $CHATsk($nick) "[Reverse $stringa]"

}



proc StripLast {str} {
	 set len [string length $str]
	 set str [string range $str 0 [expr $len-2]]
	 return $str
}


proc fix_file { var } {
 set newvar ""
 foreach c [split $var {}] {
        switch -- "$c" {
          "\{" { append newvar "(" }
          "\}" { append newvar ")" }
          "\[" { append newvar "(" }
          "\]" { append newvar ")" }
          default { append newvar "$c" }
        }
 }

 return "$newvar"

}

proc ChatRequest { buffer id } {
  global active me CHATsk colsTXT DCC icons
  set nick [Convert [get_nick $buffer]]
  set host [get_host $buffer]
  set user [get_userid $buffer]
  set ip [lindex $buffer 6]
  set port [string trim [lindex $buffer 7] "\001"]
  set pID [string trim [lindex $buffer 8] "\001"]
  set chat_passive 0
  set just_connect 0

  if {[catch {dectonet $ip} ip]} { return }

  if {$pID!=""} {
      if {[info exists DCC(passive,$pID)]} {
        if {$DCC(passive,$pID)!=$nick} {return}
        array unset DCC "passive,$pID"
        set dlg "ok"
        set just_connect 1
      } elseif {![info exists DCC(passive,$pID)]&&$port==0} {
        set chat_passive 1
      } else {
	return
      }
  }
  if {!$just_connect} {
      if {$nick==[::savirc::getNick $id]} { return }
      puts "DCC(ignoreChat) = $DCC(ignoreChat)"
      if {$DCC(ignoreChat)} {
          if {$icons(show)} {ImageText $active($id) dcc}
	  set msg [format [mc "DCC CHAT: Request from %s %s: %s ignored"] [Reverse $nick] "\[$user@$host\]" \[$ip $port\]]
           NormalText $active($id) "$msg" $colsTXT(ctcp) 1
	  #NormalText $active($id) [AddressText "$msg" "\[$user@$host\]" "\[$ip $port\]"] $colsTXT(ctcp) 1
          return
      }
      if {$icons(show)} {ImageText status dcc}
      set msg [format [mc "DCC CHAT: Request from %s %s: %s ignored"] [Reverse $nick] "\[$user@$host\]" "\[$ip $port\]"]
      NormalText status "$msg" $colsTXT(ctcp) 1
      #NormalText status [AddressText "$msg" "\[$user@$host\]" "\[$ip $port\]"] $colsTXT(ctcp) 1
      
      IRC::Event000 dccchat $me($id,net) id $id nick $nick user $user host $host ip $ip port $port
      if {[IsInChat $nick $id]} {
          if {$icons(show)} {ImageText $active($id) dcc}
          NormalText $active($id) [format [mc "There is already a DCC CHAT session with %s, request ignored"] [Reverse $nick]] $colsTXT(ctcp) 1
          return
      }
      set dlg [ChatRequestAccept $nick $user $host $ip $port]
  }

  if {$dlg=="ok"} {
    if {!$chat_passive} {
       if {[catch {socket $ip $port} CHATsk($nick)]} {
         if {$icons(show)} {ImageText $active($id) dcc}
         NormalText $active($id) $CHATsk($nick) $colsTXT(ctcp) 1
         return
       }
       winchat $nick 0 $user $host $id
       after 10 "IRC::Event000 chatstart $me($id,net) id $id nick $nick ip $ip port $port"
       fileevent $CHATsk($nick) readable "ChatRead $CHATsk($nick) $nick $id"
       fconfigure $CHATsk($nick) -buffering line
    } else {
      if {[catch {ipPack $me($id,ip)} myIp]} {return} 
       set chan [socket -server "DCCPassiveChat $nick $user $host $id" 0]
       if {[catch {fconfigure $chan -sockname} xx]} {
           if {$icons(show)} {ImageText $active($id) dcc}
           NormalText $active($id) [format [mc "DCC CHAT (Passive): Can't get port for server %s %s"] - $xx] $colsTXT(ctcp) 1
           return
       }
       set myPort [lindex $xx 2]
       puts $me($id,sock) "PRIVMSG [Reverse $nick] :\001DCC CHAT chat $myIp $myPort $pID\001"       
    }
 }
}

proc DCCPassiveChat {nick user host id chan ip port} {
       global CHATsk me
       set CHATsk($nick) $chan
       winchat $nick 0 $user $host $id
       after 10 "IRC::Event000 chatstart $me($id,net) id $id nick $nick ip $ip port $port"
       fileevent $CHATsk($nick) readable "ChatRead $CHATsk($nick) $nick $id"
       fconfigure $CHATsk($nick) -buffering line
}


proc SendRequest { buffer id} {
  global me active DCC DCCresume colsTXT DCC cur files icons wid

  #debug
  puts "SendRequest: $buffer"
  
  set nick [Convert [get_nick $buffer]]
  set userid [get_userid $buffer]
  set host [get_host $buffer]
  set file [lindex $buffer 5]
  set porta [lindex $buffer 7]
  set leng [string trimright [lindex $buffer 8] "\001"]
  set pID [string trim [lindex $buffer 9] "\001"]
  if {[catch {dectonet [lindex $buffer 6]} indirizzo]} { return }
  # di default lui mi invia il file quindi sono io a dovermi
  # collegare a lui
  set passive_send 0
  if {$pID!=""} {
      if {[info exists DCC(passive,$pID)]} {
         # ha accettato la mia richiesta di send passivo
         if {[lindex $DCC(passive,$pID) 0]!=$nick} {return}
         set xfile [join [lrange $DCC(passive,$pID) 1 end]]
         array unset DCC "passive,$pID"
         if {[catch {socket -async $indirizzo $porta} chan]} {
           if {$icons(show)} {ImageText $active($id) dcc}
           NormalText $active($id) [format [mc "DCC SEND: Cannot initiate DCC file transfer with %s %s %s"] [Reverse $nick] - $chan] $colsTXT(ctcp) 1
         }
         acceptSend $id $nick $xfile $chan $indirizzo $porta
         return
     } elseif {![info exists DCC(passive,$pID)]&&$porta==0} {
         set passive_send 1
     } else {
         return
     }
  }
  set oldfile $file
  set file [fix_file $file]
  if {$file==""||$leng==""} {return}
  set sizek [FormatSize $leng]
  if {$DCC(ignoreSend)} {
   if {$icons(show)} {ImageText status dcc}
   NormalText status [AddressText [format [mc "DCC SEND: %s ignored %s on port %s"] [Reverse $nick] $file $porta]] $colsTXT(ctcp) 1
   return
  }

  set file_ext "[file extension $file]"
  set ext_list [string tolower [split $DCC(reject) ","]]
  if {[lsearch -exact $ext_list [string tolower $file_ext]]!=-1} {
    if {$icons(show)} {ImageText status dcc}
    NormalText status [format [mc "DCC SEND: Ignored %s from %s. Reason: Extension Rejected"] $file [Reverse $nick]] $colsTXT(ctcp) 1
    return
  }

  if {$icons(show)} {ImageText status dcc}
  NormalText status [format [mc "DCC SEND: Request from %s to send %s"] [Reverse $nick] $file] $colsTXT(ctcp) 1
  #NormalText status [AddressText [format [mc "DCC SEND: Request from %s to send %s"] [Reverse $nick] $file]] $colsTXT(ctcp) 1
  IRC::Event000 dccsend $me($id,net) id $id nick [Reverse $nick] user $userid host $host ip $indirizzo port $porta file $file size $leng

  set autoAccept 0
  if {!$DCC(acceptSend)} {
    set dueparam [SetFile $file $leng $nick $userid $host $indirizzo $porta]
  } else {
    if {$DCC(trust)} {
       set mask [string trimleft [lindex [Convert $buffer] 0] ":"]
       set matched 0
       foreach t $DCC(trusted) {
           if {[string match $t $mask]} {
              set dueparam "$files(incoming) $file"
              set autoAccept 1
              set matched 1
              break
           }
       }
       if {!$matched} {
           set dueparam [SetFile $file $leng $nick $userid $host $indirizzo $porta]
       }
    } else {    
       set dueparam "$files(incoming) $file"
       set autoAccept 1
    }
  }   

  set path [lindex $dueparam 0]
  set pos 0
  set u [string index $path end]
  if {$u!="/"} {
    set path "$path/"
  }

  set file [lindex $dueparam 1]
  if {$file==""} {return}
  set action "overw"
  if {[file exists $path$file]} {
    if {!$autoAccept} {
      set action [ShowFileOption $file $leng $path]
    } else {
      switch $DCC(ifexist) {
         Ask {set action [ShowFileOption $file $leng $path]}
         Overwrite {set action "overw"}
         Resume {set action "resume"}
         Rename {
            set xi 1
            while {[file exists $path$file$xi]} {incr xi}
            set file $file$xi  
            set action "overw"             
         }
         [mc Cancel] {
            NormalText status [AddressText [format [mc "Auto Accept of DCC SEND from %s %s cancelled: %s already exists in %s"] [Reverse $nick] $file $files(incoming)]] $colsTXT(ctcp) 1
            return
         }
      }
    }
  }
  if {$action=="rename"} {
    set file [RenameFile $file]
    if {$file==""} {return}
    set action "overw"
  }

  if {$action=="resume"} {
    set pos [file size $path$file]
    set DCCresume($porta) "$indirizzo $userid $host $porta $file $leng $path$file"
    if {$icons(show)} {
      ImageText $active($id) dcc

    }
    NormalText $active($id) [format [mc "DCC SEND: Requesting resume from %s for DCC file transfer of %s"] [Reverse $nick] $file]  $colsTXT(ctcp) 1
    puts $me($id,sock) "PRIVMSG [Reverse $nick] :\001DCC RESUME [RemoveSpace $file] $porta $pos\001"
    return
  }

  if {$action=="overw"} {
    if {!$passive_send} {
      if {[catch {socket -async $indirizzo $porta} sockf]} {
         if {$icons(show)} {ImageText $active($id) dcc}
         NormalText $active($id) [AddressText [format [mc "DCC SEND: Cannot initiate DCC file transfer with %s. Reason: %s"] [Reverse $nick] $sockf]] $colsTXT(ctcp) 1
         return 0
      } else {
         set i 0
         while {[info exists wid(dcc$i,transfer)]} {incr i }
         set wget "dcc$i"
         array set cur "$sockf $pos $sockf.p [proportion $leng $pos] $sockf.k [FormatSize $pos] $sockf.r 0 $sockf.l $leng $sockf.t [clock seconds] $sockf.time 0 $sockf.s [clock seconds]"
         DccTransfer $wget $path$file $sockf $nick "GET"
         IRC::Event000 getstart $me($id,net) id $id nick [Reverse $nick] ip $indirizzo port $porta file $file size $leng user $userid host $host
         TransferTime $sockf $wget
      }
      fconfigure $sockf -blocking 1
      fileevent $sockf writable "GetFile $id $wget $sockf $path$file $file $leng $nick $pos"
    } else {
        if {[catch {ipPack $me($id,ip)} myIp]} {return} 
         set chan [socket -server "DCCPassiveSend $nick $pos $leng $file $path $userid $host $id" 0]
	 if {[catch {fconfigure $chan -sockname} xx]} {
            if {$icons(show)} {ImageText $active($id) dcc}
            NormalText $active($id) [format [mc "DCC SEND (Passive): Cannot get port for server %s %s"] - $xx] $colsTXT(ctcp) 1
            return
	 }
         set myPort [lindex $xx 2]
  	 puts $me($id,sock) "PRIVMSG [Reverse $nick] :\001DCC SEND $oldfile $myIp $myPort $leng $pID\001"

    }
  }
}

proc DCCPassiveSend {nick pos leng file path userid host id chan myIp myPort} {
      global cur wid me
      set i 0
      while {[info exists wid(dcc$i,transfer)]} {incr i}
      set wget "dcc$i"
      array set cur "$chan $pos $chan.p [proportion $leng $pos] $chan.k [FormatSize $pos] $chan.r 0 $chan.l $leng $chan.t [clock seconds] $chan.time 0 $chan.s [clock seconds]"
      DccTransfer $wget $path$file $chan $nick "GET"
      IRC::Event000 getstart $me($id,net) id $id nick [Reverse $nick] ip $myIp port $myPort file $file size $leng user $userid host $host
      TransferTime $chan $wget
      fconfigure $chan -blocking 1
      fileevent $chan writable "GetFile $id $wget $chan $path$file $file $leng $nick $pos"
}


proc DCCResumeGet {id buffer} {
  global DCCresume cur colsTXT active me icons wid
  
  #debug
  puts "DCCResumeGet: $buffer"
  
  set nick [Convert [get_nick $buffer]]
  set pos [string trimright [lindex [Convert $buffer] end] "\001"]
  set port [lindex [Convert $buffer] end-1]
  set userid [lindex $DCCresume($port) 1]
  set host [lindex $DCCresume($port) 2]
  set ip [lindex $DCCresume($port) 0]
  set leng [lindex $DCCresume($port) 5]
  set pfile [lindex $DCCresume($port) 6]

  set DCCresume($porta)
  set file [file tail [Reverse $pfile]]
  if {[catch {socket -async $ip $port} sockf]} {
    if {$icons(show)} {
      ImageText $active($me(id)) dcc
    }
    NormalText $active($me(id)) [format [mc "DCC SEND: Cannot resume DCC file transfer with %s. Reason: %s"] [Reverse $nick] $sockf] $colsTXT(ctcp) 1
    return
  }
  set i 0
  while {[info exists wid(dcc$i,transfer)]} {
  incr i }
  set wget "dcc$i"
  array set cur "$sockf $pos $sockf.p [proportion $leng $pos] $sockf.k [FormatSize $pos] $sockf.r 0 $sockf.l $leng $sockf.t [clock seconds] $sockf.time 0 $sockf.s [clock seconds]"

  DccTransfer $wget $pfile $sockf $nick "GET"
  IRC::Event000 getstart $me($id,net) id $id nick [Reverse $nick] ip $ip port $porta file $file size $leng user $userid host $host
  fconfigure $sockf -blocking 1
  if {$icons(show)} {
      ImageText status dcc
  }
  NormalText status [format [mc "Resuming %s from %s"] $file $nick] $colsTXT(ctcp) 1
  fileevent $sockf writable "GetFile $id $wget $sockf $pfile $file $leng $nick $pos"
}


proc GetFile { id wget sk out file leng nick pos} {
 global cur irc_dir files colsTXT DCC wid active me colsTXT
 fileevent $sk writable {}
 fconfigure $sk -buffering none -blocking 0 -translation binary -buffersize $DCC(block)
 set flags [list WRONLY CREAT]

   if {![catch {open $out $flags} out]} {
     if {$pos != 0} {
	    if {[catch {seek $out $pos start} msg]} {
	    	close $out
		NormalText status "$r" $colsTXT(ctcp) 1
		return 0
	    }
     }

     if {![info exists wid($wget,progress)]} {return}
     bind $wid($wget,progress) <Destroy> "CloseSocks $sk $out $wget"
     fconfigure $out -translation binary
     fileevent $sk readable "DCCGetevent $id $sk $out $file $leng $wget $nick"
   } else {
     NormalText $active($me(id)) [format [mc "Cannot initiate DCC file transfer with %s%s %s"] [Reverse $nick] : $out] $colsTXT(ctcp) 1
     IRC::Event000 getfail $me($id,net) id $id nick [Reverse $nick] file $file size $leng
   }
}



proc DCCGetevent { id in out file leng wget nick} {
 global active cur me Sock fgotmsg fgot DCC colsTXT icons wid files

 if {[eof $in]} {
  if {[lindex [array get cur $in] 1] < $leng} {
     if {$icons(show)} {
      ImageText $active($me(id)) dcc
     }
     NormalText $active($me(id)) [format [mc "DCC SEND: Transmission of %s %s from %s interrupted"] $file ([FormatSize $leng]) [Reverse $nick]] $colsTXT(ctcp) 1
     IRC::Event000 getfail $me($id,net) id $id nick [Reverse $nick] file $file size $leng
     $wid($wget) close_win

  } elseif {[lindex [array get cur $in] 1] > $leng} {
     if {$icons(show)} {
      ImageText $active($me(id)) dcc
     }
     NormalText $active($me(id)) [format [mc "DCC SEND: Transmission of %s %s from %s interrupted: too much data transferred"] $file ([FormatSize $leng]) [Reverse $nick]] $colsTXT(ctcp) 1
     IRC::Event000 getfail $me($id,net) id $id nick [Reverse $nick] file $file size $leng
     $wid($wget) close_win

  } else {
     if {$icons(show)} {
      ImageText $active($me(id)) dcc
     }
     NormalText $active($me(id)) [format [mc "DCC SEND: Transmission of %s %s from %s completed"] $file ([FormatSize $leng]) [Reverse $nick]] $colsTXT(ctcp) 1
     IRC::Event000 getend $me($id,net) id $id nick [Reverse $nick] file [file tail $file] size $leng
  }
  Time 1
  if {$DCC(autoclose_get)==1} {
     $wid($wget) close_win
  } else {
     DCCOpenButton $wget $file     
  }
  if {$DCC(autoopen)} {RunOpenFile [file join $files(incoming) $file]}
  catch {close $in}
  catch {close $out}

 } else {
  if {![catch {set buffer [read $in]} msg]} {

    set timediff [expr [clock seconds]-[lindex [array get cur $in.t] 1]]
    incr cur($in) [set l [string length $buffer]]

    set differenza [lindex [array get cur $in] 1]
    if {$timediff!=0} {
     set bps [expr $differenza/$timediff]
     set kps1 [expr $bps/1024]
     set kps2 [expr $bps%1024]

     set cur($in.r) "$kps1.$kps2"
    }
    set cur($in.k) [FormatSize [lindex [array get cur $in] 1]]
   if {![catch {puts -nonewline $out $buffer} msg]} {
     set cursize [lindex [array get cur $in] 1]
     set cur($in.p) [proportion $leng $cursize]
     UpdateProgress $cur($in.p) $wid($wget,progress) 0
     catch {.buttonbar.buttonbar.$wget.t config -text "[lrange [.buttonbar.buttonbar.$wget.t cget -text] 0 1] \[$cur($in.p)%\]"}
     if {![catch {puts -nonewline $in [binary format I1 [lindex [array get cur $in] 1]]} msg]} {
       return
     }
   }
  }
 }
}


proc proportion { intero numero } {
 if {$intero==0} {return 100}
 return [expr abs(int(100*$numero.0/$intero.0))]

}



proc ShowFileOption { file leng path } {
   global action im_warning files font
   set i 0
   while {[winfo exists ".dccgopt$i"]} {
   incr i }
   set w ".dccgopt$i"
   array set action "$w none"
   toplevel $w -class Dcc
   wm title $w [mc "DCC Get file options"]
   wm geometry $w +200+170
   wm resizable $w 0 0
   wm transient $w .
   label $w.bm -image $im_warning -relief flat
   pack  $w.bm -pady 3 -side top -padx 10
   message $w.m -width 240 -text [format [mc "The file you are about to download already %s exists in %s %s What would you like to do? %s File: %s %s Size: %s %s"] \n $path \n \n\n $file \n [FormatSize $leng] \n\n] -relief flat
   pack  $w.m -pady 5 -side top -padx 20
   frame $w.f
   pack $w.f
   if {[file size $path$file]==$leng} {
     set st "disabled"
   } else {
     set st "normal"
   }

   xbutton $w.f.overw -text [mc Overwrite] -command "set action($w) overw; destroy $w" -font $font(button)
   xbutton $w.f.resume -state $st -text [mc Resume] -command "set action($w) resume; destroy $w" -font $font(button)
   xbutton $w.f.choose -text [mc Rename] -command "set action($w) rename; destroy $w" -font $font(button)
   pack $w.f.overw $w.f.resume $w.f.choose -side left -pady 5 -padx 5
   wm withdraw $w
   wm deiconify $w
   catch {grab $w}
   focus $w

   tkwait variable action($w)
   return [lindex [array get action $w] 1]

}


proc RenameFile { file} {
   global newfile frm GUI im_ok im_cancel font
   set frm ""
   set i 0
   while {[winfo exists ".dccren$i"]} {
   incr i }
   set w ".dccren$i"
   array set newfile "$w {}"

   toplevel $w -class Dcc
   wm title $w [mc "New Filename?"]
   wm geometry $w +200+200
   wm resizable $w 0 0
   wm transient $w .
   frame $w.f1
   pack $w.f1 -side top -pady 5
   label $w.f1.lab -text [mc "Enter the new file name:"]
   set newfile($w) $file
   entry $w.f1.ent -textvariable newfile($w) -background white -selectbackground $GUI(selectbackground) -selectforeground $GUI(selectforeground) -width 30
   bind $w.f1.ent <Return> "set frm ok; destroy $w"
   pack $w.f1.lab $w.f1.ent -side top -padx 5
   $w.f1.ent selection range 0 end
   focus $w.f1.ent
   frame $w.f
   pack $w.f
   xbutton $w.f.ok -image $im_ok -side left -text [mc Ok] -command "set frm ok; destroy $w" -font $font(button)
   xbutton $w.f.cancel -image $im_cancel -side left -text [mc Cancel] -command "set frm cancel; destroy $w" -font $font(button)
   bind $w.f.ok <Return> "set frm ok; destroy $w"
   bind $w <Escape> "set frm cancel;destroy $w"

   pack $w.f.ok $w.f.cancel -side left -pady 5 -padx 5
   wm withdraw $w
   wm deiconify $w
   catch {grab $w}

   focus $w

   tkwait window $w

   if {$frm=="ok"} {
    return "[lindex [array get newfile $w] 1]"
   } else {
    return
   }

}



proc SetFile {file size nick user host ip port} {
  global filename
  set filename $file
  return [GetAccept $file $size $nick $user $host $ip $port]
}

proc GetAccept {file size nick user host ip port} {
    global me from im_ok im_cancel files filename font DCC

    set i 0
    while {[winfo exists ".dccgnotify$i"]} {
    incr i }
    set w ".dccgnotify$i"
    if {$me(icony)} {wm state . normal}

    set from ""
    toplevel $w -class Dcc
    wm title $w [mc "Incoming DCC Send Request"]
    wm geometry $w +200+200
    wm resizable $w 0 0
    wm transient $w .
    frame $w.top -border 1 -relief raised
    frame $w.top1 -border 1 -relief raised
    frame $w.top2 -border 1 -relief raised
    frame $w.top3
    message $w.top1.text -width 900 \
    -text [format [mc "%s %s %s wants to send you a file named %s %s The DCC target host will be %s %s on port %s, do you accept?"] [Reverse $nick] \[$user@$host\] \n [ShortenFile $file] \n $ip \n $port]
    entry $w.top.ent  -width 17 -textvariable files(incoming)
    label $w.top.labent -text [mc "Destination directory"]
    entry $w.top2.fent -width 12
    $w.top2.fent insert end $file
    label $w.top2.labfent -text [mc FileName:]
    #$w.top2.fent selection range 0 end
    $w.top2.fent config -state disabled;

    bind $w.top.ent <Return> "set from ok; destroy $w"

    uplevel #0 set files(incoming) {}

    xbutton $w.top.btn -font {-size 8} -text "..." -command "fileDialog $w $w.top.ent"

    uplevel #0 set filename {}
    bind $w.top2.fent <Return> "set from ok; destroy $w"
    set fsize [FormatSize $size]
    entry $w.top2.sizent -width 12 -text ""

    label $w.top2.labsizent -text [mc Size:]
    $w.top2.sizent insert end "$fsize"
    $w.top2.sizent config -state disabled;

    pack $w.top1 -side top -fill x
    pack $w.top2 -fill x
    pack $w.top3 -side bottom
    pack $w.top1.text -side left -fill x -expand true
    pack $w.top2.labfent $w.top2.fent $w.top2.labsizent $w.top2.sizent -side left -padx 4 -pady 4
    pack $w.top.labent $w.top.ent $w.top.btn -side left -anchor s -padx 4 -pady 4

    xbutton $w.top3.ok -image $im_ok -side left -text [mc Ok] -command "set from ok; destroy $w" -font $font(button)
    xbutton $w.top3.cancel -image $im_cancel -side left -text [mc Cancel] -command "set from cancel;destroy $w" -font $font(button)
    bind $w <Escape> "set from cancel;destroy $w"
    bind $w.top3.ok <Return> "set from ok;destroy $w"
    bind $w.top2.fent <Return> "set from ok;destroy $w"
    pack $w.top -side top -fill both -expand yes
    pack $w.top3.ok $w.top3.cancel -side left -pady 10 -padx 10
    focus $w.top3.ok
    wm withdraw $w
    wm deiconify $w
    catch {grab $w   }
    tkwait window $w
    if {$from=="ok"} { return "$files(incoming) $file" }
}


proc PerToCol n {
    if {$n<0} {set n 0} elseif {$n>100} {set n 100}
    set red [expr $n>75? 60-($n*15/25) : 15]
    set green [expr $n<50? $n*15/50 : 15]
    return "[format "#%01x%01x0" $red $green]"
 } 


proc UpdateProgress {perc meter col} {
    if ![winfo exists $meter] {
	return
    }
    SetProgress $meter $perc 100
    if {$col} {
      $meter.l.fill config -background [PerToCol $perc]
      $meter.l.fill.l config -background [PerToCol $perc]
    }
}



proc DccTransfer { w file sock nick type } {
   global cur font DCC wid icons GUI

   set wid($w,transfer) 1
   if {$type=="SEND"} {
    set tit [format [mc "DCC Send to %s"] [Reverse $nick]]
    set icontext [mc "DCC Send"]
    set winset "DCCSend"
    set tooltip [format [mc "Sending %s to %s"]  [file tail $file] $nick]
   } else {
    set tit [format [mc "DCC Get from %s"] [Reverse $nick]]
    set icontext [mc "DCC Get"]
    set winset "DCCGet"
    set tooltip [format [mc "Getting %s from %s"] [file tail $file] $nick]
   }

   if {$DCC(minimize_send)} {
      set state "withdrawn"
   } else {
      if {$GUI(maximized)} {
       set state "maximized"
      } else {
       set state "normal"
      }
   }


   foreach {wid(x) wid(y) wid(width) wid(height)} [def_winset $winset $winset] {}
   if {[catch {document .main.$w -state $state -tooltip "$tooltip" -title "$tit" -icontext $icontext -image $icons(dccwin2) -width $wid(width) -height $wid(height) -minsize {280 130} -x $wid(x) -y $wid(y) -state $state} wid($w)]} {return}
   $wid($w) pack [frame .main.$w.fr -background white] -fill both -expand 1
   set frame ".main.$w.fr"

   set dccfont "Helvetica 12"
   if {[::platform::isPlatformWindows]} {
     set dccfont "Tahoma 10"
   } 
   
   entry $frame.file -font "$dccfont bold" -background white -width 34 -relief flat
   $frame.file insert end "[format [mc "File: %s"] [ShortenFile [file tail $file]]]"
   #$frame.file insert end "File: [ShortenFile [file tail $file]]"
   $frame.file config -state disabled


   label $frame.csizelab -font "$dccfont bold" -width 8 -text [mc Current]: -background white
   label $frame.csize -textvariable cur($sock.k) -width 8 -font "$dccfont" -relief flat -background white

   label $frame.kpslab -font "$dccfont bold" -width 8 -text [mc KB/s]: -background white
   label $frame.kps -textvariable cur($sock.r) -width 7 -font "$dccfont" -relief flat -relief flat -background white

   label $frame.sizelab -font "$dccfont bold" -width 8 -text [mc Size]: -background white
   label $frame.size -text "[FormatSize $cur($sock.l)]" -width 8 -font "$dccfont" -background white

   label $frame.timelab -font "$dccfont bold" -width 8 -text [mc Time]: -background white
   label $frame.time -textvariable cur($sock.time) -font "$dccfont" -width 7 -background white

   Progress $frame.progress -width 200

   bind $frame <Button-1> "$wid($w) raise"
   bind $frame.file <Button-1> "$wid($w) raise"
   bind $frame.csizelab <Button-1> "$wid($w) raise"
   bind $frame.csize <Button-1> "$wid($w) raise"
   bind $frame.kpslab <Button-1> "$wid($w) raise"
   bind $frame.kps <Button-1> "$wid($w) raise"
   bind $frame.sizelab <Button-1> "$wid($w) raise"
   bind $frame.size <Button-1> "$wid($w) raise"
   bind $frame.timelab <Button-1> "$wid($w) raise"
   bind $frame.time <Button-1> "$wid($w) raise"

   grid config $frame.file -column 0 -row 0 -columnspan 4 -rowspan 1 -sticky "snew"

   grid config $frame.csizelab -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky "snw"
   grid config $frame.csize -column 1 -row 1 -columnspan 1 -rowspan 1 -sticky "snew"
   grid config $frame.kpslab -column 2 -row 1 -columnspan 1 -rowspan 1 -sticky "snw"
   grid config $frame.kps -column 3 -row 1 -columnspan 1 -rowspan 1 -sticky "snw"

   grid config $frame.sizelab -column 0 -row 2 -columnspan 1 -rowspan 1 -sticky "snw"
   grid config $frame.size -column 1 -row 2 -columnspan 1 -rowspan 1 -sticky "snew"
   grid config $frame.timelab -column 2 -row 2 -columnspan 1 -rowspan 1 -sticky "snw"
   grid config $frame.time -column 3 -row 2 -columnspan 1 -rowspan 1 -sticky "snew"

   grid config $frame.progress -column 0 -row 3 -columnspan 4 -rowspan 1 -sticky "snew"

   set wid($w,transfer) 1
   set wid($w,progress) $frame.progress

}

proc DCCOpenButton {w file} {
   global files
   set f .main.$w.fr
   catch {
     destroy $f.progress
     button $f.open -text [mc Open] -command "RunOpenFile [file join $files(incoming) $file]" -font "Helvetica 12" -bd 2
     grid config $f.open -column 3 -row 3 -columnspan 1 -rowspan 1 -sticky ew
   }
}


proc FormatSize { size } {
  set size [lindex $size 0]
  if {$size > 1048576} {
    set size [format "%2.2fMB" [expr $size / 1048576.0]]
  } elseif {$size > 1024} {
    set size [format "%2.2fKB" [expr $size / 1024.0]]
  }
  return $size
}



proc Time { seconds } {
 set tempo1 [clock seconds]
 set tempo2 ""
 while {[expr $tempo2-$tempo1]!=$seconds} { set tempo2 [clock seconds] }
 return
}


proc fileDialog {w ent} {
    global files
    set file [chooseDirectory -initialdir $files(incoming) -parent $w]
    if [string compare $file ""] {
	$ent delete 0 end
	$ent insert 0 $file
	$ent xview end
    }
}


proc DCCChat { nick } {
  global me colsTXT active icons DCC
  set nick [Convert $nick]
  if {[IsInChat $nick $me(id)]} {
    if {$icons(show)} {
      ImageText $active($me(id)) dcc
    }
    NormalText $active($me(id)) [format [mc "There is already a DCC CHAT session with %s, request ignored"] [Reverse $nick]] $colsTXT(ctcp) 1
    return
  }

  if {[catch {ipPack $me($me(id),ip)} myIp]} {return}

  if {!$DCC(passive)} {
    if {!$DCC(sock5)} {
       set sock [socket -server "acceptChat $nick $me(id)" 0]
       if {[catch {fconfigure $sock -sockname} xx]} {
         if {$icons(show)} {ImageText $active($me(id)) dcc}
         NormalText $active($me(id)) [format [mc "DCC CHAT: Cannot get port for server %s %s, unable to initiate chat session with %s"] - $xx [Reverse $nick]] $colsTXT(ctcp) 1
         return
       }
       puts $me($me(id),sock) "PRIVMSG [Reverse $nick] :\001DCC CHAT chat $myIp [lindex $xx 2]\001"
    } else {
            if {$icons(show)} {ImageText $active($me(id)) dcc}
            NormalText $active($me(id)) [format [mc "DCC CHAT request sent to %s, waiting for connection"] [Reverse $nick]] $colsTXT(ctcp) 1
            if {$me(sock5svr)==""} {
              if {$icons(show)} {ImageText $active($me(id)) dcc}
              NormalText $active($me(id)) [mc "DCC CHAT: Cannot connect to SOCK5 server, no server selected."] $colsTXT(ctcp) 1
              return
            }
            if {[catch {socket -async $me(sock5svr) $me(sock5port)} sock]} {
              if {$icons(show)} {ImageText $active($me(id)) dcc}
              NormalText $active($me(id)) [format [mc "DCC CHAT \[SOCK5\]: Connection Error: %s"] $sock] $colsTXT(ctcp) 1
              return
            }
            if {$me(sock5user)==""&&$me(sock5pass)==""} {
               set auth 0
            } else {
               set auth 1
            }
            if {[catch {socks:bind $sock $me(ip) "2000" $auth "$me(sock5user)" "$me(sock5pass)" $me($me(id),sock) [Reverse $nick] "" "" "chat"} sock5]} {
              if {$icons(show)} {ImageText $active($me(id)) dcc}
              NormalText $active($me(id)) [format [mc "DCC CHAT \[SOCK5\]: Error Binding Socket: %s"] $sock5] $colsTXT(ctcp) 1
              return
            }            
	    if {$sock5!="ok"} {
              if {$icons(show)} {ImageText $active($me(id)) dcc}
              NormalText $active($me(id)) [format [mc "DCC CHAT \[SOCK5\]: %s"] $sock5] $colsTXT(ctcp) 1 
              return             
            }
            acceptChat $nick $me(id) $sock $me(ip) "2000"
	    return
    }
  } else { 
    set pID [clock seconds]
    set DCC(passive,$pID) $nick 
    puts $me($me(id),sock) "PRIVMSG [Reverse $nick] :\001DCC CHAT chat $myIp 0 $pID\001"
  }
  if {$icons(show)} {ImageText $active($me(id)) dcc}
  NormalText $active($me(id)) [format [mc "DCC CHAT request sent to %s, waiting for connection"] [Reverse $nick]] $colsTXT(ctcp) 1

}

proc acceptChat { nick id sock addr port } {
    global CHATsk me
    winchat $nick 0 "" "" $id
    set CHATsk([Convert $nick]) $sock
    after 10 "IRC::Event000 chatstart $me($id,net) id $id nick $nick ip $addr port $port"
    fileevent $CHATsk($nick) readable "ChatRead $CHATsk($nick) $nick $id"
    fconfigure $CHATsk($nick) -buffering line
}




proc DCCResume {buffer id} {
  global me colsTXT DCCoffer
  
  #debug
  puts "DCCResume: $buffer"
  
  set buffer [Convert $buffer]
  set nick [get_nick $buffer]
  set file [lindex $buffer 5]
  set posn [lindex $buffer 7]
  set posn [string trimright $posn "\001"]
  set port [lindex $buffer 6]
  set DCCoffer($nick) $posn
  puts $me($id,sock) "PRIVMSG [Reverse $nick] :\001DCC ACCEPT [Reverse $file] $port $posn\001"
}


proc CloseSocks {sock1 sock2 w} {
  global wid
  array unset wid $w,transfer
  array unset wid $w,progress
  catch {close $sock1}
  catch {close $sock2}  
}


proc dectonet {dec} {
    if {[string length $dec] == 10 && [set first [string index $dec 0]] > 1} {
	switch -- $first {
	    2 {set overflow "0 148 53 119"}
	    3 {set overflow "0 94 208 178"}
	    4 {set overflow "0 40 107 238"}
	}
	set dec [string range $dec 1 end]
    } else {
	set overflow {0 0 0 0}
    }

    scan [format "%08x" $dec] "%2x%2x%2x%2x" net(3) net(2) net(1) net(0)

    for {set part 0; set carry 0} {$part < 4} {incr part} {
	set sum [expr {$net($part) + [lindex $overflow $part] + $carry}]
	set internet($part) [expr {$sum % 256}]
	set carry [expr {$sum / 256}]
    }

    return "$internet(3).$internet(2).$internet(1).$internet(0)"
}



proc ShortenFile {file} {
  if {[string length $file]<27} {
    return $file
  } else {
    return "[string range $file 0 22]...[string range $file [expr [string length $file]-3] end]"

  }
}

proc SetMyIp {id} {
 global colsTXT me whois hostnick files icons active
 
 set whois(352) 0
 puts $me($me(id),sock) "WHO [::savirc::getNick $id]"
 tkwait variable hostnick
 
 if {[::platform::isPlatformUnix]} {
   if {[IsIp $hostnick]} {
             set me($id,ip) $hostnick
             if {$icons(show)} {ImageText $active($me(id)) prog}
    	     NormalText $active($me(id)) [format [mc "Local host resolved to %s"] $me($id,ip)] darkgreen 1
             return 1
   }
   if {[catch {exec $files(nslookup) $hostnick} dns]} {
	set me($id,ip) "0.0.0.0"
   } else {
        set ip [lindex $dns end]
        if {[IsIp $ip]} {
             set me($id,ip) $ip
             if {$icons(show)} {ImageText $active($me(id)) prog}
    	     NormalText $active($me(id)) [format [mc "Local host resolved to %s"] $ip] darkgreen 1
             return 1
        } else {
             set me($id,ip) "0.0.0.0"
        }
   }
   if {[IsIp $me(host)]} {
             set me($id,ip) $me(host)
             if {$icons(show)} {ImageText $active($me(id)) prog}
    	     NormalText $active($me(id)) [format [mc "Local host resolved to %s"] $me($id,ip)] darkgreen 1
             return 1
   }
   if {[catch {exec $files(nslookup) $me(host)} dns]} {
	   set me($id,ip) "0.0.0.0"
           if {$icons(show)} {ImageText $active($me(id)) prog}
  	   NormalText $active($me(id)) "[mc "Unable to resolve local host"]: $dns" darkgreen 1
	   return 0
   } else {
           set ip [lindex $dns end]
           if {[IsIp $ip]} {
  	     set me($id,ip) $ip
             if {$icons(show)} {ImageText $active($me(id)) prog}
    	     NormalText $active($me(id)) "[mc "Local host resolved to"] $ip" darkgreen 1
             return 1
           } else {
             set me($id,ip) "0.0.0.0"
             if {$icons(show)} {ImageText $active($me(id)) prog}
             NormalText $active($me(id)) "[mc "Unable to resolve local host"]" darkgreen 1
	     return 0
           }
   }
 
 }
 
 if {[::platform::isPlatformWindows]} {
 
   if {[catch {exec $files(nslookup) $hostnick} dns]} {
	set me($id,ip) "0.0.0.0"
   } else {
        set ip [lindex $dns end]
        if {[IsIp $ip]} {
             set me($id,ip) $ip
             if {$icons(show)} {ImageText $active($me(id)) prog}
    	     NormalText $active($me(id)) "[mc "Local host resolved to"] $ip" darkgreen 1
             return 1
        } else {
             set me($id,ip) "0.0.0.0"
        }
   }
   
   if {[catch {exec $files(nslookup) $me(host)} dns]} {
	     set me($id,ip) "0.0.0.0"
             if {$icons(show)} {ImageText $active($me(id)) prog}
    	     NormalText $active($me(id)) "[mc "Local host resolved to"] $me($id,ip)" darkgreen 1
  	     return 0
   } else {
           set ip [lindex $dns end]
           if {[IsIp $ip]&&$ip!="0.0.0.0"} {
  	     set me($id,ip) $ip
             if {$icons(show)} {ImageText $active($me(id)) prog}
    	     NormalText $active($me(id)) "[mc "Local host resolved to"] $me($id,ip)" darkgreen 1
             return 1
           }
   }
   
   if {[catch {exec $files(nslookup) "localhost"} dns]} {
	   set me($id,ip) "0.0.0.0"
           if {$icons(show)} {ImageText $active($me(id)) prog}
  	   NormalText $active($me(id)) [format [mc "Unable to resolve local host: %s"] $dns] darkgreen 1
	   return 0
   } 
   
   set me(host) [lindex $dns 0]
   SetCurrents $id
   
   if {[catch {exec $files(nslookup) $me(host)} dns]} {
	   set me($id,ip) "0.0.0.0"
           if {$icons(show)} {ImageText $active($me(id)) prog}
  	   NormalText $active($me(id)) "[mc "Unable to resolve local host"]: $dns" darkgreen 1
	   return 0
   } else {
           set ip [lindex $dns end]
           if {[IsIp $ip]} {
  	     set me($id,ip) $ip
             if {$icons(show)} {ImageText $active($me(id)) prog}
    	     NormalText $active($me(id)) [format [mc "Local host resolved to %s"] $ip] darkgreen 1
             return 1
           } else {
             set me($id,ip) "0.0.0.0"
             if {$icons(show)} {ImageText $active($me(id)) prog}
             NormalText $active($me(id)) [mc "Unable to resolve local host"] darkgreen 1
	     return 0
           }
   }
 }
}


proc RemoveSpace {file} {
    regsub -all { } $file {_} file
    return $file
}

