wm title . "$me(version)"
wm protocol . WM_DELETE_WINDOW "quitwin .quit"


catch { wm geometry . $GUI(geometry) }

if {[::platform::isPlatformUnix]} {
  catch { wm iconbitmap . @$me(path)/icons/savirc.xbm }
}


option add *highlightThickness 0
option add *Button.Pad 1
option add *Entry.BorderWidth 1
option add *Button.BorderWidth 1
option add *Menubutton.BorderWidth 1
option add *Menubutton.Pad 2
option add *Menu.BorderWidth 2
option add *Entry.disabledBackground white
option add *Menu.activeBorderWidth 1
option add *Message.padX 5
option add *Message.padY 2

if {[::platform::isPlatformUnix]} {
  option add *Menu.Font "helvetica 8"
  option add *Menubutton.Font "helvetica 12"
  option add *Listbox.Font "helvetica 12"
  option add *Label.Font "helvetica 12"
  option add *Checkbutton.Font "helvetica 12"
  option add *Radiobutton.Font "helvetica 12"
  option add *Text.Background $GUI(widgets_color)

  option add *Background $GUI(widgets_color)
  option add *Activebackground $GUI(widgets_color)
  option add *activeBackground $GUI(widgets_color)
  option add *activeForeground black

  option add *Menu.Background $GUI(widgets_color)
  option add *Checkbutton.Selectcolor [shade $GUI(widgets_color) "#000000" 0.1]
  option add *Radiobutton.Selectcolor [shade $GUI(widgets_color) "#000000" 0.1]
}

option add *background $GUI(widgets_color) widgetDefault;
option add *Activebackground [shade $GUI(widgets_color) "#000000" 0.1] widgetDefault;

option add *Label.BorderWidth 2
option add *Entry.BorderWidth 2
option add *Entry.padX 2


# Menubar
#
frame .menubar -bd 2 -relief raised

xmenubutton .menubar.bfile -text [mc File] -underline 2 -menu .menubar.bfile.m
set m [xmenu .menubar.bfile.m]

set co [$m cget -background]

#$m add command -image $im_bar -hidemargin 1 -columnbreak 0 -activeforeground $co -activebackground $co -foreground $co -background $co

$m add command -label [mc Connect] -columnbreak 1 -command "Connect"
$m add separator
$m add command -label [mc Settings] -command { config "" }
$m add command -label [mc "Script Center"] -command { ScriptCenter 0 }
$m add separator
$m add command -label [mc Quit] -command { quitwin .quite }

bind . <Alt-q> "quitwin .quite"

bind . <Alt-o> "Config 0"
bind . <Alt-i> "Config 1"
bind . <Alt-g> "Config 2"

xmenubutton .menubar.bservers -text [mc Servers] -underline 0 -state disabled -menu .menubar.bservers.m
set m [xmenu .menubar.bservers.m]

xmenu .servers1
MakeServerMenu .menubar.bservers.m

xmenubutton .menubar.bscript -text [mc Scripts] -underline 2 -menu .menubar.bscript.m
set m [xmenu .menubar.bscript.m]
$m add command -label [mc Functions]	-accelerator "<ALT+f>" -command { ScriptCenter 0 }
$m add command -label [mc Events]	-accelerator "<ALT+e>" -command { ScriptCenter 1 }
$m add command -label [mc Popups]	-accelerator "<ALT+p>" -command { ScriptCenter 2 }
$m add command -label [mc Variables]	-accelerator "<ALT+v>" -command { ScriptCenter 3 }

bind . <Alt-f> "ScriptCenter 0"
bind . <Alt-e> "ScriptCenter 1"
bind . <Alt-p> "ScriptCenter 2"
bind . <Alt-v> "ScriptCenter 3"
bind . <Alt-h> "IRC::help"

xmenubutton .menubar.win -text [mc Window] -underline 0 -menu .menubar.win.m
set m [xmenu .menubar.win.m]
  $m add command -label [mc "Tile Across"]       -command {Document::Arrange tile}
  $m add command -label [mc "Tile Horizontally"] -command {Document::Arrange horizontally}
  $m add command -label [mc Tile Vertically]     -command {Document::Arrange vertically}
  $m add separator
  $m add command -label [mc Cascade]		 -command {Document::Arrange cascade}

if {$GUI(maximized)} {.menubar.win config -state disabled}


xmenubutton .menubar.bhelp -text [mc Help] -menu .menubar.bhelp.m
set m [xmenu .menubar.bhelp.m]
$m add command -label [mc Contents] -accelerator "<ALT+h>" -command {IRC::help}
$m add separator
$m add command -label [mc About] -command {About}

pack .menubar.bfile .menubar.bservers .menubar.bscript .menubar.win .menubar.bhelp -side left

#
# Toolbar
#

toolbar .toolbar -state fixed

tooltip .toolbar.tip -delay 500
.toolbar.tip add [.toolbar add button c1 -image $im_connect -command "Connect"] [mc Connect]
.toolbar add separator sep1
.toolbar.tip add [.toolbar add button s1 -image $im_conset -command "config {}"] [mc "Connection Settings"]
.toolbar.tip add [.toolbar add button s14 -image $icons(server) -command "config {[mc /Configuration/Connection/Server]}"] [mc "Server Settings"]
.toolbar.tip add [.toolbar add button s2 -image $im_settings -command "config {[mc /Configuration/IRC/IRC-switches]}"] [mc "IRC Settings"]
.toolbar.tip add [.toolbar add button s3 -image $im_gui -command "config {[mc /Configuration/GUI/ColorMessages]}"] [mc "GUI Settings"]
.toolbar.tip add [.toolbar add button s13 -image $icons(dccwin) -command "config {[mc /Configuration/Dcc]}"] [mc "DCC Settings"]
.toolbar add separator sep2
.toolbar.tip add [.toolbar add button sc1 -image $im_functions -command "ScriptCenter 0"] [mc Functions]
.toolbar.tip add [.toolbar add button sc2 -image $im_events -command "ScriptCenter 1"] [mc Events]
.toolbar.tip add [.toolbar add button sc3 -image $im_menu -command "ScriptCenter 2"] [mc Popups]
.toolbar.tip add [.toolbar add button sc4 -image $im_variables -command "ScriptCenter 3"] [mc Variables]
.toolbar add separator sep3
.toolbar.tip add [.toolbar add button sc10 -image $icons(chanlist) -command "ChanFolder"] [mc "Channel Folder"]
.toolbar.tip add [.toolbar add button sc5 -image $icons(world) -command "ShowLIST {}"] [mc "List Channels"]
.toolbar.tip add [.toolbar add button sc11 -image $icons(links) -command "IRC::quote links"] [mc "Server Links"]
.toolbar add separator sep4
.toolbar.tip add [.toolbar add button sc6 -image $icons(tile) -command "Document::Arrange horizontally"] [mc "Tile Windows Horizontally"]
.toolbar.tip add [.toolbar add button sc7 -image $icons(cascade) -command "Document::Arrange cascade"] [mc "Cascade Windows"]
.toolbar add separator sep5
.toolbar.tip add [.toolbar add button sc12 -image $icons(music) -command "Mp3Editor"] [mc "Sound Manager"]
.toolbar add separator sep6
.toolbar.tip add [.toolbar add button sc8 -image $im_readme -command "IRC::help"] [mc Help]
.toolbar.tip add [.toolbar add button sc9 -image $icons(about) -command "About"] [mc "About savIRC"]


#
# Main Area
#

canvas .main -relief flat -bg $GUI(background)

bind .main <Button-2> "PopupMainMenu %X %Y"
bind .main <Button-3> "PopupMainMenu %X %Y"

#
##Button bar
#
#

frame .buttonbar -bd 2 -relief flat 

canvas .buttonbar.buttonbar_scrollbox -height 23 -xscrollcommand [list .buttonscroll set] -bd 0 -background $GUI(widgets_color)
frame .buttonbar.buttonbar
xscrollbar .buttonscroll -command [list .buttonbar.buttonbar_scrollbox xview] -orient horizontal

pack .buttonbar.buttonbar_scrollbox -fill x 
.buttonbar.buttonbar_scrollbox create window 0 0 -anchor nw -window .buttonbar.buttonbar


#
# Status Area
#
frame .status -bd 1 -relief flat
tooltip .status.tip -delay 500

text .status.msg -width 5 -selectforeground $GUI(selectforeground) \
 -selectbackground $GUI(selectbackground) -height 1 -bd 2 -relief sunken -font $font(n) -takefocus 0
mIRC_Text_Tag .status.msg
.status.tip add [label .status.command -relief sunken -bd 2 -textvariable me(command) -font $font(label)] [mc "Left click for server menu, Right click to disconnect"]
.status.tip add [label .status.bps -width 10 -relief sunken -bd 2 -text "0 bps" -font $font(label)] [mc "Bytes Per Second"]
.status.tip add [label .status.splitter -relief sunken -bd 2 -text "0/$misc(splitter) [mc chars]" -width 12 -font $font(label)] [mc "Send Splitter"]
#label .status.prod -relief sunken -bd 2 -text $me(version) -font $font(label)

bind .status.command <Button-1> "popup_servers .servers1"
#bind .status.command <Button-3> {IRC::disconnect}
#bind .status.command <Button-2> {IRC::disconnect}

bind .status.msg <KeyPress> "break; return"
bind .status.msg <Button-1> "break; focus .commandline.command"
bind .status.msg <Button-3> "break; focus .commandline.command"

pack  .status.command .status.bps .status.splitter -ipadx 5p -side left -fill both
pack  .status.msg -side left -anchor sw -expand true -fill both

set row 0
grid config .menubar -column 0 -row $row -columnspan 1 -rowspan 1 -sticky "snew"
incr row
grid config .toolbar -column 0 -row $row -columnspan 1 -rowspan 1 -sticky "snew" -padx 0
incr row

if {$GUI(buttonbar)=="top"} {
  grid config .buttonbar  -column 0 -row $row -columnspan 1 -rowspan 1 -sticky "snew"
  incr row
  autoscroll .buttonscroll "-in . -column 0 -row $row -columnspan 1 -rowspan 1 -ipadx 0 -ipady 0 -padx 0 -pady 0 -sticky nesw"
  incr row
}

grid config .main -column 0 -row $row -columnspan 1 -rowspan 1 -sticky "snew"
incr row

if {$GUI(buttonbar)=="bottom"} {
  grid config .buttonbar  -column 0 -row $row -columnspan 1 -rowspan 1 -sticky "snew"
  incr row
  autoscroll .buttonscroll "-in . -column 0 -row $row -columnspan 1 -rowspan 1 -ipadx 0 -ipady 0 -padx 0 -pady 0 -sticky nesw"
  incr row
}

grid config .status  -column 0 -row $row -columnspan 1 -rowspan 1 -ipadx 5p -sticky "snew"

grid columnconfigure . 0 -weight 1
grid rowconfigure . 2 -weight 0
grid rowconfigure . 0 -weight 0
grid rowconfigure . 1 -weight 0
if {$GUI(buttonbar)=="bottom"} {
  grid rowconfigure . 2 -weight 1
  grid rowconfigure . 3 -weight 0
  grid rowconfigure . 4 -weight 0
} else {
  grid rowconfigure . 4 -weight 1
  grid rowconfigure . 3 -weight 0
  grid rowconfigure . 2 -weight 0
}

grid rowconfigure . 5 -weight 0

xmenu .buttonbarm 
.buttonbarm add command -label [mc Top] -command "MoveButtonBar top 1"
.buttonbarm add command -label [mc Bottom] -command "MoveButtonBar bottom 1"
bind .buttonbar.buttonbar_scrollbox <Button-3> "tk_popup .buttonbarm %X %Y"
bind .buttonbar.buttonbar_scrollbox <Button-2> "tk_popup .buttonbarm %X %Y"

bind .buttonbar.buttonbar_scrollbox <Button-1> "DDbar %W %Y 1"
bind .buttonbar.buttonbar_scrollbox <ButtonRelease-1> "DDbar %W %Y 0"

proc DDbar {w y b} {
   if {$b} {
     $w config -cursor fleur
   } else {
     $w config -cursor {}
     set frameY [winfo y .main]
     set end [expr [winfo height .main]+$frameY+[winfo height $w]]     
     if {$y<[expr $frameY+50]&&$y>$frameY} {
        MoveButtonBar top 1
     } elseif {$y<$end&&$y>[expr $end-50]} {
        MoveButtonBar bottom 1
     }
   }
}


bind . <KeyPress> { destroy .coltip; kill_balloon }

bind . <Control-c> "Copy_Clipboard"
bind . <Control-v> "Paste_Clipboard"

for {set i 1} {$i < 10} {incr i} {
  bind . <F$i> "SwitchWin $i"
}

bind . <Unmap> {
 if {"%W"=="."&&$me(started)&&$misc(traymin)&&!$me(icony)} {
       wm withdraw .
       update idletasks
       set me(icony) 1
       set GUI(geometry) [winfo geometry .]

 }
}
update idletasks