array set menus ""

set menus(server) "xmenu .menu;"
set menus(query) "xmenu .menu;"
set menus(chat) "xmenu .menu;"
set menus(nicklist) "xmenu .menu;"
set menus(notify) "xmenu .menu;"
set menus(channel) "xmenu .menu;"


proc menus {menu args} {
  global menus	
  set menus($menu) $args
}

proc xmenu {w args} {
  global GUI font
  if {[winfo exists $w]} {destroy $w}
  eval "menu $w $args -tearoff 0 -activeborderwidth 0 -activeforeground $GUI(selectforeground) -activebackground $GUI(selectbackground) -font [list $font(menu)]"
}

proc xmenubutton {w args} {
  global GUI font
  if {[winfo exists $w]} {destroy $w}
  eval "menubutton $w $args -activeforeground $GUI(selectforeground) -activebackground $GUI(selectbackground) -font [list $font(menu)]"
}

proc PopupMainMenu {x y} {
  global GUI
  destroy .mainmenu
  set m [xmenu .mainmenu]
  if {$GUI(bgimage)==""} {
	set state "disabled"
  } else {
	set state "normal"
  }
  $m add command -label [mc "Set background image"] -command "SetBgImage x" 
  $m add command -label [mc "Remove background image"] -command "DelBgImage x" -state $state
  $m add separator
  $m add radiobutton -label [mc "Tile image"] -command "BgimageHow" -value "tile" -variable GUI(bgimage_how) -state $state
  $m add radiobutton -label [mc "Center image"] -command "BgimageHow" -value "center" -variable GUI(bgimage_how) -state $state
  tk_popup $m $x $y
  
}

proc popup_links {w l} {
 set x [winfo pointerx .links]
 set y [winfo pointery .links]
 set m ".linksmenu"
 destroy $m
 links_menus $m [file tail $l]

 tk_popup $m $x $y


}

# Windows specific code
proc OpenUrlNew {url} {
  global env
  if {$url==""} {return}
  set url [string trim $url "'\[\]();.:,\x93\""]
  if {[catch {exec start iexplore $url &}]} {catch {exec [file join "$env(ProgramFiles)/Internet Explorer" "IEXPLORE.EXE"]  $url &}}
}

# windows specific code
proc url_menu {w x y caption} {
   destroy .urlm

   xmenu .urlm
   if {$caption} {
    .urlm add command -label [mc "Open in current browser window"] -command "CaptionOpenUrl $w"
    .urlm add command -label [mc "Open in new browser window"] -command "OpenUrlNew {[lindex [GetWordFromText $w] 0]}"
       } else {
    .urlm add command -label [mc "Open in current browser window"] -command "OpenUrl {[lindex [$w get [$w curselection]] 0]}"
    .urlm add command -label [mc "Open in new browser window"] -command "OpenUrlNew {[lindex [$w get [$w curselection]] 0]}"
   }
   tk_popup .urlm $x $y
}



proc popup_menu {w m id} {
 global active me chanmenu
 if {$id==0} {set id $me(id)}
 if {!$me($id,conn)} {return}
 if {!$chanmenu} {
    set chanmenu 1
    return
 }

 switch [Window $w] {
    0 {channel_menus $w $m [GetChannel $w $id] $id}
    1 {query_menus $w $m [Convert [GetQuery $w $id]]}
    2 {chat_menus $w $m [Convert [GetChat $w $id]]}
    "default" {server_menus}
 }
 set x [winfo pointerx .]
 set y [winfo pointery .]
 tk_popup $m $x $y
}

proc popup_servers {m} {
  global me active
   servers_menus
   set x [winfo pointerx .]
   set y [winfo pointery .]
   tk_popup $m $x $y
}

proc popup_nicklist { w nx ny type id } {
 global me wid
 set x [winfo pointerx .]
 set y [winfo pointery .]
 if {$id==0} {set id $me(id)}
 if {![info exists wid($w,text)]} {return}
 focus $wid($w,list)
 if {[lindex $type 0]!="click"} {
   if {$type!="notify"} {
    $wid($w,list) selection clear 0 end
    $wid($w,list) activate @$nx,$ny
    $wid($w,list) selection set @$nx,$ny
   }
   set ind [$wid($w,list) curselection]
   if {$ind==""} {return}
   set nick [deflag [$wid($w,list) get $ind]]
 } else {
   set nick [lindex $type 1]
   set type "chan"
 }
 set nick [Convert $nick]

 destroy $wid($w,list).menu

 if {$type=="chan"} {
  nicklist_menus $w [GetChannel $w $id] $nick
 } else {
  set server [lindex $nick 1]
  for {set i 0} {$i < [llength $me(sockslist)]} {incr i} {
    set id [lindex $me(sockslist) $i]
    if {$me($id,server)==$server} {
       SetCurrents $id
       break
    }
  }
  notify_menus [lindex $nick 0] $id

 }
 tk_popup $wid($w,list).menu $x $y
}


proc popup_modes { w id} {
 global me modes wid
 set x [winfo pointerx .main]
 set y [winfo pointery .main]
 set nikke "@[::savirc::getNick $id]"
 set count [$wid($w,list) index end]
 set lista [$wid($w,list) get 0 $count]
 set num [lsearch -exact $lista $nikke]
 if {$num!=-1} {
  set modeLS {i m n p s t k l}
  set mode [$wid($w,modes) cget -text]

  foreach m $modeLS {
    if {[string first $m $mode]!=-1} {
       set modes($m) 1
    } else {
       set modes($m) 0
    }
  }

  tk_popup $wid($w,modes).menu $x $y
 }
}


proc links_menus {m lab} {
 if {[catch {xmenu $m}]} {return} 
 $m add command -label MOTD -command "IRC::quote motd $lab"
 $m add command -label [mc Time] -command "IRC::quote time $lab"
 $m add separator
 $m add command -label LUSERS -command "IRC::quote lusers $lab"
 $m add command -label [mc Admin]  -command "IRC::quote admin $lab"
 $m add separator
 $m add command -label [mc Info]   -command "IRC::quote info $lab"
 $m add command -label [mc Version] -command "IRC::quote version $lab"
 $m add command -label [mc Links] -command "IRC::quote links $lab"
 $m add separator
 $m add command -label [mc Help] -command "IRC::quote help $lab"

}



proc modes_menus { w id } {
 global modes me GUI wid
 xmenu $wid($w,modes).menu 

 $wid($w,modes).menu add check -label "+i [mc Invite]" -variable modes(i)   -command {PutMode $modes(i) i $me(id)}
 $wid($w,modes).menu add check -label "+m [mc Moderated]" -variable modes(m)  -command {PutMode $modes(m) m $me(id)}
 $wid($w,modes).menu add check -label "+n [mc "No Ext. msgs"]" -variable modes(n)  -command { PutMode $modes(n) n $me(id) }
 $wid($w,modes).menu add check -label "+p [mc Private]" -variable modes(p)  -command { PutMode $modes(p) p $me(id) }
 $wid($w,modes).menu add check -label "+s [mc Secret]" -variable modes(s)  -command { PutMode $modes(s) s $me(id) }
 $wid($w,modes).menu add check -label "+t [mc "Topic Limit"]" -variable modes(t)  -command { PutMode $modes(t) t $me(id) }
 $wid($w,modes).menu add check -label "+k [mc Key]" -variable modes(k)  -command { PutChanKey $modes(k) $me(id) }
 $wid($w,modes).menu add check -label "+l [mc "User Limit"]" -variable modes(l)  -command { PutChanLimit $modes(l) $me(id) }

}

proc servers_menus {} {
  destroy .servers
  destroy .servers1
  xmenu .servers
  xmenu .servers1
  MakeServerMenu .servers
}

proc MakeServerMenu {m} {
  global me active clientMSG wid GUI font
  if {[llength $me(sockslist)]==0} {
    set any_conn 0
  } else {
    set any_conn 1
  }

  if {$any_conn} {
    .servers1 add cascade -label [mc "Servers"] -menu .servers1.servers \
       -activeforeground $GUI(selectforeground) -activebackground $GUI(selectbackground) \
       -font $font(menu)
    xmenu .servers1.servers
  }
  for {set i 0} { $i < [llength $me(sockslist)] } {incr i } {
     set id [lindex $me(sockslist) $i]
     if {[info exists wid($active($id))]&&$active($id)!=""} {
       set cmd "Switch $active($id)"
     } else {
       set cmd "Switch status"
     }
     $m add cascade -label "$i $me($id,server)" -underline 0 -menu $m.s$i \
       -activeforeground $GUI(selectforeground) -activebackground $GUI(selectbackground) \
       -font $font(menu)
     .servers1.servers add command -label "$me($id,server)" -command "$cmd ; SetCurrents $id"
     xmenu $m.s$i
     $m.s$i add command -label [mc "Set as Active"] -command "$cmd ; SetCurrents $id"
     $m.s$i add command -label [mc "Get Links Tree"] -command "id $id raw links"
     $m.s$i add separator
     $m.s$i add command -label [mc Disconnect] -command "Disconnect $id"
  }
  if {! $any_conn} {
    .servers1 add command -label [mc Connect] -command "Connect"
  } else {
    # add user commands/options
    .servers1 add separator
    .servers1 add command -label "Away" -command "AwayDialog"
    .servers1 add command -label "Back" -command "IRC::away" 
    .servers1 add command -label "Change Nick" -command "ChangeNickDialog" 
    #.servers1 add command -label "Invisible" -command "IRC::echo Function Not Implemented" ;# NYI
  }
  #.servers1 add separator
  #.servers1 add command -label [mc "Open Downloads"] -command "downloads"
  #.servers1 add separator
  #.servers1 add command -label [mc "Colors Picker"] -command "Pack_Cols" ;# (temp) moved to Ctrl-A shortcut

}

proc ChangeNickDialog {} {
  set evt [sav_ui::TextInputWindow "Changing nickname" "Enter new nickname" newnick {ok cancel}]
  if {$evt=="ok"} {
    IRC::nick $newnick
  }
}

proc AwayDialog {} {
  set evt [sav_ui::TextInputWindow "Away" "Enter Away reason" reason {ok cancel}]
  if {$evt=="ok"} {
    IRC::away $reason
  }
}

proc PutChanKey {b id} {
  global me active
  set canale [GetChannel $active($id) $id]
  if {$b} {
    set k [DialogWin [mc "Set Channel Key"] [mc "Enter Channel Key:"]]
    puts $me($id,sock) "MODE [Reverse $canale] +k $k"
  } else {
   set k [DialogWin [mc "Remove Key"] [mc "Enter key name to remove:"]]
   puts $me($id,sock) "MODE [Reverse $canale] -k $k"
  }
}


proc PutChanLimit {b id} {
  global me active
  set canale [GetChannel $active($id) $id]
  if {$b} {
   set l [DialogWin [mc "Limit Channel"] [mc "Enter Number of Users:"]]
   puts $me($id,sock) "MODE [Reverse $canale] +l $l"
  } else {
   puts $me($id,sock) "MODE [Reverse $canale] -l"
  }
}


proc PutMode { b m id } {
 global me active
 set canale [GetChannel $active($id) $id]
 if {$b} {
  puts $me($id,sock) "MODE [Reverse $canale] +$m"
 } else {
  puts $me($id,sock) "MODE [Reverse $canale] -$m"
 }
}


proc server_menus {} {
 global active colsTXT wid
 set m "$wid(status,text).servlist"
 destroy $m
 if {[catch {xmenu $m}]} {return} 
 if {[catch {ServerPopup $m} err]} {
   tk_messageBox -icon error -message [format [mc "SERVER POPUP Error: %s"] $err]
 }
 focus $wid(status,command)
}


proc channel_menus {w m chan id} {
 global active colsTXT wid menus
 destroy $m
 if {[catch {xmenu $m}]} {return} 
 if {[catch {ChannelPopup $m $chan $w $id} err]} {
   tk_messageBox -icon error -message [format [mc "CHANNEL POPUP Error: %s"] $err]
 
 }	
 focus $wid($w,command)
}



proc notify_menus {nick id} {
 global active colsTXT wid
 set m $wid(status,list).menu
 if {[catch {xmenu $m}]} {return} 
 if {[catch {NotifyPopup $m $nick $id} err]} {
   tk_messageBox -icon error -message [format [mc "NOTIFY POPUP Error: %s"] $err]
 }
 focus $wid(status,command)
}


proc nicklist_menus {w chan nick} {
 global active colsTXT wid nicklist
 set m "$wid($w,list).menu"	
 if {[catch {xmenu $m}]} {return} 
 if {[catch {NicklistPopup $m $chan $nick [GetWindowID $w]} err]} {
   tk_messageBox -icon error -message [format [mc "NICKLIST POPUP Error: %s"] $err]
 }
 focus $wid($w,command)
}



proc chat_menus {w m nick} {
 global active colsTXT wid
 destroy $m
 if {[catch {xmenu $m}]} {return} 
 if {[catch {ChatPopup $m $nick [GetWindowID $w]} err]} {
   tk_messageBox -icon error -message [format [mc "CHAT POPUP Error: %s"] $err]
 }
 focus $wid($w,command)
}


proc query_menus {w m nick} {
 global active colsTXT wid
 destroy $m
 if {[catch {xmenu $m}]} {return} 
 if {[catch {QueryPopup $m $nick [GetWindowID $w]} err]} {
   tk_messageBox -icon error -message [format [mc "QUERY POPUP Error: %s"] $err]

 }
 focus $wid($w,command)
}



proc winmenu {m w} {
 global position log timestamp wid
 $m add cascade -label [mc Logging] -menu $m.log
 $m add cascade -label [mc Properties] -menu $m.pos
 $m add cascade -label [mc Buffer] -menu $m.buf

 xmenu $m.pos
 xmenu $m.log
 xmenu $m.buf

 $m.log add check -label [mc "Log Window"] -variable log($w)  
 $m.pos add check -label [mc Remember] -variable position($w) 
 $m.buf add command -label [mc "Save as..."] -command "SaveBuffer $w"
 $m.buf add command -label [mc Clear] -command "ClearText $w"

 $m.log add command -label [mc "View Log"] -command "ViewLog {}"
 $m add check -label [mc Timestamp]  -variable timestamp($w) 
 
}

proc FserveMenu {w x y} {
   global wid DCC
   if {!$DCC(fserve_menu)} {return}
   set sel [$wid($w,text) tag nextrange sel 1.0]
   if {$sel!=""} {
     set txt [eval $wid($w,text) get $sel]
   destroy .fserve
   xmenu .fserve   
   .fserve add command -label [mc "Change Directory"] -command "write_chat $w {cd $txt}"
   .fserve add command -label [mc "CD and List contents"] -command "write_chat $w {cd $txt};write_chat $w ls"
   .fserve add command -label [mc Download] -command "write_chat $w {get $txt}"     
   .fserve add separator
   .fserve add command -label [mc "List Contents"] -command "write_chat $w ls"
   .fserve add command -label "CD .." -command "write_chat $w {cd..}"
   .fserve add command -label [mc Rules] -command "write_chat $w rules"   
   .fserve add command -label [mc Help] -command "write_chat $w help"   
   tk_popup .fserve $x $y
  }
}


proc ServerPopup {m} {
  global menus me
  set id $me(id)
  regsub -all {\.menu} $menus(server) $m new
  regsub -all -- {-command \"} $new {-command "IRC::MenuCommand } new
  eval $new
}

proc NotifyPopup {m nick id} {
  global menus
  regsub -all {\.menu} $menus(notify) $m new
  regsub -all -- {-command \"} $new {-command "IRC::MenuCommand } new
  eval $new
}

proc NicklistPopup {m chan nick id} {
  global menus
  regsub -all {\.menu} $menus(nicklist) $m new
  regsub -all -- {-command \"} $new {-command "IRC::MenuCommand } new
  eval $new
}

proc QueryPopup {m nick id} {
 global log timestamp files position menus
 regsub -all {\.menu} $menus(query) $m new
 regsub -all -- {-command \"} $new {-command "IRC::MenuCommand } new
 eval $new
}


proc ChatPopup {m nick id} {
 global log timestamp position menus
 regsub -all {\.menu} $menus(chat) $m new
 regsub -all -- {-command \"} $new {-command "IRC::MenuCommand } new
 eval $new
}

proc ChannelPopup {m chan w id} {
  global menus
  regsub -all {\.menu} $menus(channel) $m new
  regsub -all -- {-command \"} $new {-command "IRC::MenuCommand } new
  eval $new	  
}

