set SearchDir "forwards"
set SearchString ""
set findcase ""
set script_load ""
array set script ""
array set on ""
array set cascades ""
array set elements ""
set elements(opened) ""


proc ScriptCenter { x } {
    global me im_ok im_cancel GUI font script_load script icons

    set script(load_list) ""
    set script(active,functions) ""
    set script(active,events) ""
    set script(active,popups) ""
    set script(active,variables) ""
    set script(active) ""


    set w ".script"
    if {[winfo exists $w]} {return}
    toplevel $w -class Script
 
    wm geometry $w 615x440
    #+70+40
    #wm resizable $w 0 0
    wm title $w [mc "savIRC Script Center"]
    wm transient $w .
    frame $w.menubar -bd 2 -relief raised
    frame $w.main -bd 2
    frame $w.bottom -bd 2

    xmenubutton $w.menubar.file -text [mc File] -underline 0 -menu $w.menubar.file.m
    set m [xmenu $w.menubar.file.m -tearoff 0 -activeborderwidth 0 -activebackground $GUI(selectbackground) -activeforeground $GUI(selectforeground)]

    xmenubutton $w.menubar.edit -text [mc Edit] -underline 0 -menu $w.menubar.edit.m
    set m [xmenu $w.menubar.edit.m -tearoff 0 -activeborderwidth 0 -activebackground $GUI(selectbackground) -activeforeground $GUI(selectforeground)]
    $m add command -label [mc Undo] -accelerator "<Ctrl+z>" -command "Undo"
    $m add separator
    $m add command -label [mc Copy] -accelerator "<Ctrl+c>" -command "Sc_Copy"
    $m add command -label [mc Paste] -accelerator "<Ctrl+v>" -command "Sc_Paste"
    $m add command -label [mc "Select All"] -command "SelectAll" -accelerator "<Ctrl+a>"
    $m add separator
    $m add command -label [mc Find] -accelerator "<Ctrl+f>" -command "FindWin"
    $m add command -label [mc "Find Next"] -accelerator "<F3>" -command "Find"
    $m add separator
    $m add command -label [mc Refresh] -accelerator "<Ctrl+r>" -command "Refresh"

    xmenubutton $w.menubar.view -text [mc View] -underline 0 -menu $w.menubar.view.m -state disabled
    xmenu $w.menubar.view.m -tearoff 0 -activebackground $GUI(selectbackground) -activeforeground $GUI(selectforeground) 

    pack $w.menubar.file $w.menubar.edit $w.menubar.view -side left

    tabcontrol $w.main.nb -width auto
    set nb $w.main.nb

    frame $nb.f0
    frame $nb.f1
    frame $nb.f2
    frame $nb.f3
    frame $nb.f4

    $nb insert functions 0 -text [mc Functions] -window $nb.f0 -command ""
    $nb insert events 0    -text [mc Events] -window $nb.f1 -command ""
    $nb insert popups 0    -text [mc Popups] -window $nb.f2 -command ""
    $nb insert variables 0 -text [mc Variables] -window $nb.f3 -command ""

    $nb tabconfigure functions -command "TabSelect 0"
    $nb tabconfigure events -command "TabSelect 1"
    $nb tabconfigure popups -command "TabPopupSelect"
    $nb tabconfigure variables -command "TabSelect 3"

    xbutton $w.bottom.ok -image $im_ok -side left -text [mc Ok] -command "SaveScript 0;destroy $w" -font $font(button)
    xbutton $w.bottom.cancel -image $im_cancel -side left -text [mc Cancel] -command "destroy $w" -font $font(button)

    toolbar $w.toolbar -state fixed

    tooltip $w.toolbar.tip -delay 500
    $w.toolbar.tip add [$w.toolbar add button c1 -image $icons(savelist) -command ""] [mc Save]
    set GUI(add_button) [$w.toolbar add button c6 -image $icons(add) -command ""]
    $w.toolbar add separator sep1
    $w.toolbar.tip add [$w.toolbar add button c2 -image $icons(cut) -command "Sc_Cut"] [mc Cut]
    $w.toolbar.tip add [$w.toolbar add button c3 -image $icons(copy) -command "Sc_Copy"] [mc Copy]
    $w.toolbar.tip add [$w.toolbar add button c4 -image $icons(paste) -command "Sc_Paste"] [mc Paste]
    $w.toolbar add separator sep2
    $w.toolbar.tip add [$w.toolbar add button c5 -image $icons(refresh) -command "Refresh"] [mc Refresh]

    grid config $w.menubar -column 0 -row 0 \
	-columnspan 1 -rowspan 1 -sticky "snew"
    grid config $w.toolbar -column 0 -row 1 \
	-columnspan 1 -rowspan 1 -sticky "snew"
    grid config $w.main -column 0 -row 2 \
	-columnspan 1 -rowspan 1 -sticky "snew"
    grid config $w.bottom -column 0 -row 3 \
	-columnspan 1 -rowspan 1 -sticky "snew" -pady 10

    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 0 -weight 0
    grid rowconfigure $w 1 -weight 0
    grid rowconfigure $w 2 -weight 1
    grid rowconfigure $w 3 -weight 0

    pack $w.main.nb -expand 1 -fill both -padx 1m -pady 1m
    pack $w.bottom.ok $w.bottom.cancel -side left -padx 10

    # Do these need [mc..] code?
    FTab $nb.f0 "functions"
    FTab $nb.f1 "events"
    FTab $nb.f3 "variables"
    TabPopups $nb.f2	
    ScriptTextMenu    
    switch $x {
	0 {$nb invoke "functions"	; TabSelect 0}
	1 {$nb invoke "events"		; TabSelect 1}
	2 {$nb invoke "popups"		; TabPopupSelect}
	3 {$nb invoke "variables"	; TabSelect 3}
    }	
    bind $w <KeyPress> { destroy .coltip }
}


proc InsertColorTag {tag} {
  global GUI script
  set text $GUI($script(active),text)
  $text insert insert $tag
}


proc SelectAll {} {
  global GUI script
  set w $GUI($script(active),text)
  set text [$w get 1.0 end]
  $w delete 1.0 end
  $w insert end $text sel
}

proc Undo {} {
  global GUI script
  set w $GUI($script(active),text)
  if {![winfo exists $w]} {return}
  catch {$w undo}

}

proc Sc_Paste {} {
  global GUI script
  if {![info exists GUI($script(active),text)]} {return}
  set w $GUI($script(active),text)
  if {![winfo exists $w]} {return}
  tk_textPaste $w
}

proc Sc_Cut {} {
  global GUI script
  if {![info exists GUI($script(active),text)]} {return}
  set w $GUI($script(active),text)
  if {![winfo exists $w]} {return}
  set sel [$w tag nextrange sel 1.0]
  if {$sel!=""} {
    tk_textCopy $w
    eval $w delete $sel
  }
}

proc UpFirst {txt} {
  return "[string toupper [string index $txt 0]][string range $txt 1 end]"
}



proc Sc_Copy {} {
  global GUI script
  if {![info exists GUI($script(active),text)]} {return}
  set w $GUI($script(active),text)
  if {![winfo exists $w]} {return}
  tk_textCopy $w
}


proc FindWin {} {
   global script me im_ok im_cancel GUI SearchDir SearchString findcase icons font
   set w ".find"
   if {[winfo exists $w]} {return}
   grab release .script
   toplevel $w -class Find
   set x [winfo x .script]
   set y [winfo y .script]

   wm title $w [mc Find]
   wm geometry $w +[expr $x+330]+[expr $y+100]
   wm resizable $w 0 0

   set txt $GUI($script(active),text)

   message $w.message -width 250 -text [mc "Enter your search string in the box below:"]
   entry $w.entry -width 10 -textvariable SearchString -background white -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground) -font $font(entry)
   xbutton $w.search -image $icons(search) -side left -text [mc Find] -command "Find; destroy $w"
   xbutton $w.cancel -text [mc Cancel] -command "destroy $w"

   set flab [LabelFrame:create $w.options -text [mc Options:]

   radiobutton $flab.up   -text [mc Up] -selectcolor white -variable SearchDir -value "backwards"
   radiobutton $flab.down -text [mc Down] -selectcolor white -variable SearchDir -value "forwards"
   checkbutton $flab.case -selectcolor white -text [mc "Case Sensitive"] -variable findcase

   grid config $flab.up	  -column 0 -row 0 -sticky "snw"
   grid config $flab.down -column 1 -row 0 -sticky "snw"
   grid config $flab.case -column 0 -row 1 -sticky "snw"


   grid config $w.message -column 0 -row 0 -columnspan 2 -sticky "snw"
   grid config $w.entry   -column 0 -row 1 -sticky "snew" -padx 5
   grid config $w.search  -column 1 -row 1 -sticky "snew" -padx 2
   grid config $w.options -column 0 -row 2 -sticky "snew"
   grid config $w.cancel  -column 1 -row 2 -sticky "new" -padx 2 -pady 10


   bind $w.entry <Return> "Find; destroy $w"
   bind $w <Escape> "destroy $w"

   wm transient $w .script
   tkTextSetCursor $txt 1.0
   focus $w.entry

}


proc Find {} {
  global GUI SearchString SearchDir findcase script
  set w $GUI($script(active),text)

  if {![winfo exists $w]} {return}
  focus $w
  set SearchPos insert
  if {$SearchString!=""} {

    if {$findcase=="1"} {
      set caset "-exact"
    } else {
      set caset "-nocase"
    }

    if {$SearchDir == "forwards"} {
      set limit end
    } else {
      set limit 1.0
    }
    set leng [string length $SearchString]
    set SearchPos [ $w search $caset -$SearchDir $SearchString $SearchPos $limit]

    if {$SearchPos != ""} {
        $w see $SearchPos

	if {$SearchDir == "forwards"} {
	 tkTextSetCursor $w "$SearchPos+$leng char"
	} else { tkTextSetCursor $w $SearchPos }

	$w tag add sel $SearchPos  "$SearchPos+$leng char"

    } else {
        tk_messageBox -icon info -message [mc "End of file has been reached"] -type ok
        if {$SearchDir == "forwards"} {
         set pos 1.0
        } else {
         set pos end
        }
        focus $w
        tkTextSetCursor $w $pos
    }

  }
}

proc ViewMenu {script_type} {
	global script

	set b ".script.menubar.view"
	$b config -state normal

	$b.m delete 0 end

	if {$script_type=="popups"} {
		foreach menu {Server Channel Nicklist Query Chat Notify} {
			$b.m add radiobutton -label "$menu" -command "SwitchScript $script_type $menu" \
			-variable script(active,$script_type) -value "$menu"
		}	
		return
	}

	foreach file $script($script_type) {
		$b.m add radiobutton -label "$file" -command "SwitchScript $script_type $file" \
		-variable script(active,$script_type) -value "$file"
	}
}


proc FileMenu {} {
    global script	

    set w ".script"
    set b "$w.menubar.file"
    $b config -state normal
    $b.m delete 0 end

    $b.m add command -label [mc "New Script"] -accelerator "<Ctrl+n>" -command "NewScript"
    if {$script(active)=="functions"} {
       $b.m add command -label [mc "New Function"] -accelerator "<Ctrl+n>" -command "NewFunctionWin"	
    }

    if {$script(active)=="events"} {
       $b.m add command -label [mc "New Event"] -accelerator "<Ctrl+n>" -command "NewEventWin"	
    }

    $b.m add separator
    $b.m add command -label [mc "Load Script"] -accelerator "<Ctrl+l>" -command "LoadScript {} {}"
    $b.m add command -label [mc "Unload Script"] -accelerator "<Ctrl+w>" -command "UnloadScript {} {}"
    $b.m add separator
    $b.m add command -label [mc Save] -accelerator "<Ctrl+s>" -command "SaveScript 1"
    $b.m add separator
    $b.m add command -label [mc Close] -accelerator "<Ctrl+q>" -command "destroy $w"

}

proc SwitchScript {script_type file} {
	global script me

	if {$script_type=="popups"} {
		set script(active,popups) [string tolower $file]
		set script(current) [format [mc "Editing Menu: %s"] [UpFirst $script(active,popups)]]
                set script(last,$script_type) [string tolower $file]
		InitPopup 
		return
	}

	set script(current) ""
	set script(active,$script_type) $file
	set script(last,$script_type) $file
	ShowScript $script_type

}

proc GetScriptType {n} {

	switch $n {
		0 {return "functions"}
		1 {return "events"}
		2 {return "popups"}
		3 {return "variables"}
	}
}

proc GetScriptNum {n} {

	switch $n {
		"functions" {return 0}
		"events" {return 1}
		"popups" {return 2}
		"variables" {return 3}
	}
}


proc TabPopupSelect {} {
	global script GUI

        set w ".script"
        .script.toolbar.tip forget $GUI(add_button)
        .script.toolbar.tip add $GUI(add_button) [mc "New Menu"]
        .script.toolbar itemconf c6 -command "BlankMenu"
	
	$w.menubar.edit config -state disabled;
        $w.toolbar itemconf c5 -state normal
        $w.toolbar itemconf c1 -command "SaveCurrentMenu"
        
	set b "$w.menubar.file"
        
	$b config ;#-state normal
        $b.m delete 0 end
	$b.m add command -label [mc "New Menu"] -command "BlankMenu"
	$b.m add command -label [mc Save] -command "SaveCurrentMenu"
        $b.m add separator
	$b.m add command -label [mc Close] -command "destroy $w"
   	
	# Does this need [mc..] code?
	set script(active) "popups"
	set script(current) [format [mc "Editing Menu: %s"] [UpFirst $script(active,popups)]]
	set script(cursor) ""
	
	ViewMenu $script(active)	
}


proc TabSelect {n} {
	global script me GUI

	set script(current) ""
	set script(cursor) ""
        
	.script.menubar.edit config -state normal
        .script.toolbar itemconf c1 -command "SaveScript 1"
        .script.toolbar itemconf c5 -state normal
        .script.toolbar.tip forget $GUI(add_button)
 	
	set script_type [GetScriptType $n]
        if {$script_type=="functions"} {
         .script.toolbar.tip add $GUI(add_button) "Add function"
         .script.toolbar itemconf c6 -command "NewFunctionWin"
        } elseif {$script_type=="events"} {
         .script.toolbar.tip add $GUI(add_button) "Add event"
         .script.toolbar itemconf c6 -command "NewEventWin"
        } else {
         .script.toolbar itemconf c6 -command ""          
        }
	if {[lsearch $script(load_list) $script_type]==-1} {
		lappend script(load_list) $script_type
		if {[info exists script(last,$script_type)]&&$script(last,$script_type)!=""&&[lsearch $script($script_type) $script(last,$script_type)]!=-1} {
                  if {[file exists $me(home)/config/$me(profile)/scripts/$script(last,$script_type)]} {
                     SwitchScript $script_type $script(last,$script_type)
		  } else {
                     SwitchScript $script_type [lindex $script($script_type) 0]
		  }
                } else {
		  SwitchScript $script_type [lindex $script($script_type) 0]
		}
	}
	
	set script(active) $script_type
	ViewMenu $script(active)
        FileMenu
	set path [file join $me(home) config $me(profile) scripts $script(active,$script_type)]
	if {$script(active,$script_type)!=""} {
  	  set script(current) "[format [mc "File: %s %s"] $script(active,$script_type) ([FormatSize [file size $path]])]"
	} else {
	  set script(current) ""
        }
	TreeOpen
}

proc DrawTree {w script_type} {
 global GUI

 Tree:create $w.f.tree -bd 2 -relief sunken -width 150 -yscrollcommand "$w.f.tscroll set"
 set GUI($script_type,tree) $w.f.tree
 $w.f.tree bind x <1> {
  set lbl [Tree:labelat %W %x %y]
  Tree:setselection %W $lbl
  FindItem $lbl
 }

 grid config $w.f.tree -column 0 -row 0 -columnspan 1 -rowspan 1 -sticky "snew"
}

proc ScriptTextMenu {} {
   destroy .scriptTxtMenu
   set m [xmenu .scriptTxtMenu]
   $m add command -label [mc Undo] -accelerator "<Ctrl+z>" -command "Undo"
   $m add separator
   $m add command -label [mc Copy] -accelerator "<Ctrl+c>" -command "Sc_Copy"
   $m add command -label [mc Paste] -accelerator "<Ctrl+v>" -command "Sc_Paste"
   $m add command -label [mc "Select All"] -command "SelectAll" -accelerator "<Ctrl+a>"
   $m add separator
   $m add command -label [mc Find] -accelerator "<Ctrl+f>" -command "FindWin"
   $m add command -label [mc "Find Next"] -accelerator "<F3>" -command "Find"
}

proc FTab {w script_type} {
 global GUI font script

 set GUI($script_type,frame) $w

 pack [frame $w.f] -fill both -expand y -padx 5 -pady 5

 if {[::platform::isPlatformUnix]} {
   set GUI($script_type,text) [Supertext::text $w.f.text -font "Helvetica 12" -yscrollcommand "$w.f.scrolly set" -exportselection 1 -xscrollcommand "$w.f.scrollx set" -background white -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground)]
 }
 if {[::platform::isPlatformWindows]} {
   set GUI($script_type,text) [Supertext::text $w.f.text -font "Helvetica 10" -yscrollcommand "$w.f.scrolly set" -exportselection 1 -xscrollcommand "$w.f.scrollx set" -background white -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground)]
 }
 # Isn't the following binding missing a color code?
 bind $w.f.text <Control-k> {InsertColorTag "\x03" ; ColorTip %X %Y ; break}
 bind $w.f.text <Control-b> {InsertColorTag "" ; break}
 bind $w.f.text <Control-u> {InsertColorTag "" ; break}
 bind $w.f.text <KeyPress> { destroy .coltip }
 bind $w.f.text <Button-3> "tk_popup .scriptTxtMenu %X %Y"
 bind $w.f.text <Button-2> "tk_popup .scriptTxtMenu %X %Y"

 DrawTree $w $script_type
 xscrollbar $w.f.tscroll -orient vertical -command "$w.f.tree yview"
 xscrollbar $w.f.scrolly -command "$w.f.text yview" -orient vertical;
 xscrollbar $w.f.scrollx -command "$w.f.text xview" -orient horizontal;

 frame $w.f.status
 label $w.f.status.lab1 -width 30 -relief flat -bd 1 -textvariable script(current)
 label $w.f.status.lab2 -width 15 -relief flat -bd 1
 label $w.f.status.lab3 -relief flat -bd 1
 label $w.f.status.lab4 -width 15 -relief flat -bd 1 -textvariable script(cursor)

 grid config $w.f.tscroll -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky "snew"
 grid config $w.f.text	  -column 2 -row 0 -columnspan 1 -rowspan 1 -sticky "snew"
 grid config $w.f.scrolly -column 3 -row 0 -columnspan 1 -rowspan 1 -sticky "snew"
 grid config $w.f.status  -column 0 -row 1 -columnspan 4 -rowspan 1 -sticky "snew"

 pack $w.f.status.lab1 $w.f.status.lab2 -side left
 pack $w.f.status.lab3 -side left -expand yes -fill x 
 pack $w.f.status.lab4 -side left

  
 bind $w.f.text <KeyPress> {
   after 10 {SetCursor %W}
 }

 bind $w.f.text <Button-1> {
   after 10 {SetCursor %W}
 }

 bind $w.f.text <FocusIn> {
   after 10 {SetCursor %W}
 }

 bind $w.f.text <Enter> {
   after 10 {SetCursor %W}
 }

 focus $w.f.text
 tkTextSetCursor $w.f.text "1.0"
 grid columnconfigure $w.f 0 -weight 0
 grid columnconfigure $w.f 1 -weight 0
 grid columnconfigure $w.f 2 -weight 1
 grid columnconfigure $w.f 3 -weight 0
 grid rowconfigure $w.f 0 -weight 1
 grid rowconfigure $w.f 1 -weight 0

 autoscroll $w.f.scrolly
 autoscroll $w.f.tscroll

}


proc on {event network code} {
	global on
	# provo a mettere un indice su ogni evento
	# in modo da avere + eventi dello stesso tipo
	set event [string tolower $event]
        set network [string tolower $network]
	set i 0
	while {[info exists on($event$i,$network)]} {incr i}
	set on($event$i,$network) $code
}


proc RemoveFile {file script_type} {
	global script
	set i [lsearch $script($script_type) $file]
	set script($script_type) [lreplace $script($script_type) $i $i]
}

proc RemoveFromList {l item} {
	set i [lsearch $l $item]
	return [lreplace $l $i $i]
	
}


proc SourceScripts {script_type} {
	global script me on me menus

	switch $script_type {
	   "events" {
		array unset on *
		set types "events"
           }
	   "popups" {
		if {![file exists [file join $me(home) config $me(profile) scripts popups.tcl]]} {
			# Remove if this doesn't pose a problem. DELETE popups.tcl to test!
#			set r [tk_messageBox -type "yesno" -message [format [mc "Can't load popups: %s popups.tcl not found in %s. %s Do you want savIRC to create a default popups file?"] \n [file join $me(home) config $me(profile) scripts] \n ] ]  
#                        if {$r=="yes"} {
                            set g [CreateDefaultScriptFile $me(profile) "popups_default_file" "popups.tcl"]
                            if {$g!=1} {
                               tk_messageBox -message [format [mc "Error creating popups file: %s"] $g]
              		       return
                            }
#                        } else {
#                            return
#                        } 
		}
                namespace eval IRC {
  	           if {[catch {source [file join $me(home) config $me(profile) scripts popups.tcl]} err]} {
			tk_messageBox -message [format [mc "Error loading popups: %s"] $err]
			continue
		   }		
                }
		return
	   }
	   "default" {
		set types "functions variables"
		namespace delete IRC
                source "$me(path)/tcl/commands.tcl"
	   }				 
        }

	foreach type $types {
	    foreach file $script($type) {

		set script(path) [file join $me(home) config $me(profile) scripts $file]
		if {![file exists $script(path)]} {
			RemoveFile $file "$type"
			continue
		}		
		namespace eval IRC {
			global script
			if {[catch {source $script(path)} err]} {                            
				tk_messageBox -message [format [mc "Error loading the script %s: %s"] [file tail $script(path)] $err]
				continue
			}
		}
	    }
       }  

}

proc ShowScript {script_type} {
	global script me GUI
	if {$script(active,$script_type)==""&&$script($script_type)==""} {
            if {![file exists [file join $me(home) config $me(profile) scripts $script_type.tcl]]} {
               set f [file join $me(home) config $me(profile) scripts $script_type.tcl]    
            } else {
	       set i 1 
               while {[file exists [file join $me(home) config $me(profile) scripts $script_type$i.tcl]]} {incr i}
               set f [file join $me(home) config $me(profile) scripts $script_type$i.tcl]    
            }
            if {[catch {open $f w} e]} {return}
            close $e
            set script(active,$script_type) [file tail $f]
            lappend script($script_type) [file tail $f]
            tk_messageBox -message [format [mc "No script found for %s. A blank file called %s has been automatically %s created and loaded into %s."] $script_type  \"[file tail $f]\" \n $script_type]
            TabSelect [GetScriptNum $script_type]
            
        }
	Tree:delitem $GUI($script_type,tree) /	
	$GUI($script_type,text) delete 1.0 end	

        if {[string trim $script(active,$script_type)]==""} {
           tk_messageBox -message "Nessuno script!"

        }

	set path [file join $me(home) config $me(profile) scripts $script(active,$script_type)]
	if {![file exists $path]} {	
		RemoveFile $script(active,$script_type) "$script_type"
		script(current) ""
		set script(active,$script_type) ""
		return
	}
	if {[catch {open $path} fd]} {
		tk_messageBox -message [format [mc "Error opening Events file: %s"] $fd]
		return
	}

	DrawTree $GUI($script_type,frame) $script_type
	Tree:newitem $GUI($script_type,tree) /$script_type -image i_folder

	set txt [split [string trim [read $fd]] "\n"]
	catch {close $fd}
	if {$script_type!="variables"} {
	  foreach line $txt {
		$GUI($script_type,text) insert end "$line\n"
		set cline [Convert $line]
		switch $script_type {
		  "functions" {
		     if {[string first "proc " $cline]==0} {
   			  Tree:newitem $GUI($script_type,tree) /$script_type/[lindex $cline 1] -image i_file			  
		     }				  
		  }
		  #"variables" {
		     #if {[string first "set " $cline]==0} {
   		     #	  Tree:newitem $GUI($script_type,tree) /$script_type/[lindex $cline 1] -image i_file			  
		     #}	
		      			  
		  #}

		  "events" {
      		     if {[lindex $cline 0]=="on"} {
                 	  set event "on [lindex $cline 1]"
			  set net [lindex $cline 2]
			  catch {Tree:newitem $GUI($script_type,tree) /$script_type/$event -image i_file}
  			  Tree:newitem $GUI($script_type,tree) /$script_type/$event/$net -image i_file
		     }
		  }	
               }
	  }
        } else {
		foreach v [info vars ::IRC::*] {
			if {$v=="::IRC::err"} {continue}
			if {[string first "::IRC::" $v]!=0} {continue}
			set varName [string range $v 7 end]			
			if {[array exists $v]} {
				set e [lsort -dictionary [array names $v]]
   			        catch {Tree:newitem $GUI($script_type,tree) /$script_type/$varName -image i_file}
				foreach subv $e {
   			                Tree:newitem $GUI($script_type,tree) /$script_type/$varName/$subv -image i_file
					set value [set $v\($subv)]
					$GUI($script_type,text) insert end "$varName\($subv\) $value\n"					
				}
			} else {
					set value [set $v]
					$GUI($script_type,text) insert end "$varName $value\n"	
                                        Tree:newitem $GUI($script_type,tree) /$script_type/$varName -image i_file
			}


		}
	}
	if {$script(active,$script_type)!=""} {
  	  set script(current) [format [mc "File: %s %s"] $script(active,$script_type) ([FormatSize [file size $path]])]
	} else {
	  set script(current) ""
        }
        ViewMenu $script_type
}

proc SetCursor {w} {
  global script
  catch {
   set c [split [$w index insert] .]
   set script(cursor) "Ln [lindex $c 0] Col [lindex $c 1]"  
  }
}


proc SaveScript {update} {
	global script GUI me

	set script_type $script(active)
	
	if {$script_type==""} {return}
	if {$script_type=="popups"} {SaveCurrentMenu;return}
	if {$script(active,$script_type)==""} {return}
	if {$script_type=="popups"} {return}
	
	set txt [string trim [$GUI($script_type,text) get 1.0 end]]
	set path [file join $me(home) config $me(profile) scripts $script(active,$script(active))]

	if {[catch {open $path w} fd]} {
		tk_messageBox -message [format [mc "Error saving script: %s"] $fd]
		return
	}
	if {$script_type!="variables"} {
		puts $fd $txt
	} else {
		set tmp ""
		foreach line [split $txt "\n"] {
			if {[string index $line 0]=="#"} {
				puts $fd $txt
				continue
			} 
			set vName [lindex $line 0]
			set value [lrange $line 1 end]
			if {[string match "*(*)" $vName]} {
				set i [string first "(" $vName]
				set aName [string range $vName 0 [expr $i-1]]
				set vName [string range $vName [expr $i+1] end-1]
				if {[lsearch $tmp $aName]==-1} {
					puts $fd "array set $aName \"\""
					lappend tmp $aName
				}
				puts $fd "set $aName\($vName\) [join $value]"
			} else {
				puts $fd "set $vName [join $value]"
			}
		}
	}
	close $fd	
	SourceScripts $script_type	
        if {$update} {Refresh}
}


proc TreeOpen {} {
   global script GUI
   catch {	
    set script_type $script(active)
    Tree:open $GUI($script_type,tree) /$script_type

   }
}

proc Refresh {} {
	global script GUI

	set script_type $script(active)
        if {$script_type=="popups"} {return}
	Tree:delitem $GUI($script_type,tree) /	
	DrawTree $GUI($script_type,frame) $script_type
	Tree:newitem $GUI($script_type,tree) /$script_type -image i_folder

	set txt [split [string trim [$GUI($script_type,text) get 1.0 end]] "\n"]


	foreach line $txt {
		set cline [Convert $line]
		switch $script_type {
		  "variables" {
   		     foreach v [info vars ::IRC::*] {
			if {$v=="::IRC::err"} {continue}
			if {[string first "::IRC::" $v]!=0} {continue}
			set varName [string range $v 7 end]			
			if {[array exists $v]} {
				set e [lsort -dictionary [array names $v]]
   			        catch {Tree:newitem $GUI($script_type,tree) /$script_type/$varName -image i_file}
				foreach subv $e {
   			                Tree:newitem $GUI($script_type,tree) /$script_type/$varName/$subv -image i_file
					set value [set $v\($subv)]
				}
			} else {
					set value [set $v]
                                        Tree:newitem $GUI($script_type,tree) /$script_type/$varName -image i_file
			}


		     }

		  }			  
		  "functions" {
		     if {[string first "proc " $cline]==0} {
   			  Tree:newitem $GUI($script_type,tree) /$script_type/[lindex $cline 1] -image i_file			  
		     }				  
		  }	
		  "events" {		
   		     if {[lindex $cline 0]=="on"} {
                	 set event "on [lindex $cline 1]"
			 set net [lindex $cline 2]
		 	 catch {Tree:newitem $GUI($script_type,tree) /$script_type/$event -image i_file}
		         Tree:newitem $GUI($script_type,tree) /$script_type/$event/$net -image i_file
		     }
		  }
		}
	}
	TreeOpen
}


proc FindItem {lbl} {
  global GUI script

  set w $GUI($script(active),text)
  if {![winfo exists $w]} {return}

  focus $w
  tkTextSetCursor $w "1.0"

  switch $script(active) {
     "functions" {	
  	set SearchString "proc [file tail $lbl] "
     }	

     "variables" {	
	set dirs [split $lbl "/"]
	if {[llength $dirs]==3} {
	  	set SearchString "[file tail $lbl] "
	} elseif {[llength $dirs]==4} {
	  	set SearchString "[lindex $dirs 2]([lindex $dirs 3]) "
	} else {
		return
	}
     }	

     "events" {	
  	set SearchString [string range $lbl 8 end]
	regsub -all {/} $SearchString { } SearchString     }	
  }

  if {$SearchString!=""} {
    set leng [string length $SearchString]
    set SearchPos [ $w search -nocase -forwards $SearchString 1.0 end]
    if {$SearchPos==""} return
    $w see $SearchPos
    tkTextSetCursor $w "$SearchPos+0 char"
  }

}

proc UnloadScript {file sc} {
	global script me GUI

	if {$file==""} {
          set script_type $script(active)
    	  set script_active $script(active,$script_type)
	  
	  if {$script_active==""} {return}
	  
	  RemoveFile $script_active $script_type
	  SourceScripts $script_type
          
	  set script($script_type,active) ""
   	  set script(last,$script_type) ""
          set script(load_list) [RemoveFromList $script(load_list) $script_type]
  	  
	  $GUI($script_type,text) delete 1.0 end 
   	  Tree:delitem $GUI($script_type,tree) /
          
	  set script(current) ""
	  set n [tk_messageBox -message [format [mc "The script %s has been unloaded, %s Do you want to delete the file as well?"] $script_active \n] -type yesno]
	  if {$n=="yes"} {
		if {[catch {file delete [file join $me(home) config $me(profile) scripts $script_active]} err]} {
			tk_messageBox -message [format [mc "Error deleting %s: %s"] $script_active $err]
			return
		}
		tk_messageBox -message [format [mc "File %s deleted"] $script_active]
	  }

	  TabSelect [GetScriptNum $script_type]
	} else {
	  set path [file join $me(home) config $me(profile) scripts $file]
	  if {![file exists $path]} {
		IRC::echo [format [mc "Cannot unload script, %s not found in %s"] $file [file join $me(home) config $me(profile) scripts]]
	        return
	  }
          if {$sc!="functions"&&$sc!="events"&&$sc!="variables"&&$sc!="popups"} {
                IRC::echo [format [mc "%s: Invalid script type. Must be Functions, Events, Popups or Variables"] $sc ]
                return
          }
	  if {[lsearch $script($sc) $file]==-1} {
                IRC::echo [format [mc "%s is not loaded in %s. Please confirm the script name, and retype the command"] $file $sc]
                return
	  }          		
	  RemoveFile $file $sc
	  SourceScripts $sc
  	  IRC::echo [format [mc "%s has been unloaded from %s"] $file $sc]
	  #IRC::echo $sc has been unloaded from $sc
	}
}


proc NewScript {} {
  global GUI script me

  set i 1
  while {[file exists "$me(home)/config/$me(profile)/scripts/script$i.tcl"]} {
    incr i
  }
  set file [tk_getSaveFile -defaultextension "tcl" -initialfile "script$i.tcl" -initialdir "$me(home)/config/$me(profile)/scripts" -title [mc "Enter Filename:"]]
  if {$file!=""} {
     if {[file dirname $file]!="$me(home)/config/$me(profile)/scripts"} {
        tk_messageBox -icon error -message [format [mc "Create new scripts in %s"] [file join $me(home) config $me(profile) scripts]]             
        return
     }
     if {[file exists $file]} {
        tk_messageBox -icon error -message [format [mc "There is already a script called %s"] [file tail $file]]             
        return
     }
     if {[catch {open $file w} e]} {
        tk_messageBox -icon error -message [format [mc "Can't create %s: %s"] [file tail $file] $e]
        return
     }

     set file [file tail $file]
     lappend script($script(active)) $file
     ViewMenu $script(active)
     SwitchScript $script(active) $file     
  }


}

proc LoadScript {file sc} {
  global GUI script me active

  if {$file==""} {
    set text $GUI($script(active),text)
    set tree $GUI($script(active),tree)
    set awin $active($me(id))
    if {![winfo exists $text]} {return}
    set file [tk_getOpenFile -initialdir [file join $me(home) config $me(profile) scripts] -title [mc "Please select a script to load"]]
    if {$file==""} {return}
#    if {[file dirname $file]!="$me(home)/config/$me(profile)/scripts"} {
#      tk_messageBox -message [format [mc "Load new scripts only from %s"] [file join $me(home) config $me(profile) scripts]]
#      return
#    }
    set sc $script(active)
    set center 1
  } else {
    if {![file exists [file join $me(home) config $me(profile) scripts $file]]} {
       IRC::echo [format [mc "Couldn't find %s in %s"] $file [file join $me(home) config $me(profile) scripts]]
       return
    }
    if {$sc!="functions"&&$sc!="events"&&$sc!="variables"&&$sc!="popups"} {
       IRC::echo [format [mc "%s: Invalid script type. Must be Functions, Events, Popups or Variables"] $sc]
       return
    }
    set center 0
  }

  set file [file tail $file]
  if {[lsearch [string tolower [join $script($sc)]] [string tolower $file]]!=-1} {
     if {$center} {
       tk_messageBox -message [format [mc "The %s appears to be loaded into %s already."] $file $sc]
     } else {
       IRC::echo [format [mc "The %s appears to be loaded in %s already."] $file $sc]
     }
     return
  }
  lappend script($sc) $file
  SourceScripts $sc   

  if {$center} {
    ViewMenu $script(active)
    SwitchScript $script(active) $file
  } else {
    IRC::echo [format [mc "Successfully loaded %s into %s"] $file $sc]
  }

}

proc NewEvent {w ftype fnet} {
  global script GUI

  set type [$ftype get]
  set net [$fnet get]
  if {$type!=""} {
    destroy $w
  } else {
    return	
  }
  if {$net==""} {set net "*"}
  set txt $GUI($script(active),text)
  set vars [GetEventVars $type] 
  $txt see end
  $txt insert end "\n\non $type $net \{\n" 
  if {$vars!=""} {$txt insert end "  [format [mc "#Available Variables: %s"] $vars\n\n]"}
  $txt insert end "\}\n"
  
  after 10 "focus .script; focus $txt; tkTextSetCursor $txt end"
  Refresh
}

proc EventTypeChange {e m} {
    set vars [GetEventVars [$e get]]
    if {$vars==""} {$m config -text ""; return}
    $m config -text [format [mc "Available variables for this event: %s"] \n$vars]
    
 }

proc GetEventVars {type} {
        global script
        set i [lsearch $script(event_types) $type]
        set tmp " [lindex $script(event_types) [expr $i+1]]"
        if {$tmp==" "} {return}        
        regsub -all { } $tmp { $} tmp
        return $tmp
}


proc NewEventWin {} {
   global script me im_ok im_cancel GUI icons font
   set w ".newevent"
   if {[winfo exists $w]} {return}
   toplevel $w -class NewEvent

   set x [winfo x .script]
   set y [winfo y .script]

   wm title $w [mc "New Event"]
   wm geometry $w +200+200
   wm resizable $w 0 0
   wm transient $w .


   frame $w.bottom

   set f [LabelFrame:create $w.top -text [mc "New Event:"] -ipadx 10 -ipady 30]
   label $f.ltype -text [mc Type:] -font $font(label)
   label $f.lnet -text [mc Network:] -font $font(label)


   combobox::combobox $f.type -background white -editable 0 -width 18 -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground) -command "EventTypeChange $f.type $f.msg"
   combobox::combobox $f.net  -background white -editable 0 -width 18 -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground) 
   foreach {type vars} $script(event_types) {
       $f.type list insert end $type
       #tk_messageBox -message $type
   }

   FillNetwork $f.net
   message $f.msg -text "" -width 200

   grid $f.ltype -column 0 -row 0 -sticky ew
   grid $f.type  -column 1 -row 0 -sticky nw
   grid $f.lnet  -column 0 -row 1 -sticky ew
   grid $f.net   -column 1 -row 1 -sticky nw
   grid $f.msg   -column 0 -row 2 -sticky snew -columnspan 2

   xbutton $w.bottom.ok -image $im_ok -side left -text [mc Ok] -command "NewEvent $w $f.type $f.net" -font $font(button)
   xbutton $w.bottom.cancel -image $im_cancel -side left -text [mc Cancel] -command "destroy $w" -font $font(button)


   pack $w.top -pady 5 -fill both -expand yes -padx 15 -pady 10 -side top
   pack $w.bottom -fill x -side bottom 	

   pack $w.bottom.ok $w.bottom.cancel -side left -padx 15 -pady 3
   
   bind $w <Return> "NewEvent $w $f.type $f.net"
   bind $w <Escape> "destroy $w"

   wm withdraw $w
   wm deiconify $w
   grab $w
}




proc NewFunction {w fname farg} {
  global script GUI

  set name [$fname get]
  set arg [$farg get]
  if {$name!=""&&$arg!=""} {
    destroy $w
  } else {
    return
  }
  set txt $GUI($script(active),text)
  $txt see end
  $txt insert end "\n\nproc $name \{$arg\} \{\n\n" 
  $txt insert end "\}\n"
  
  after 10 "focus .script; focus $txt; tkTextSetCursor $txt end"
  Refresh
}


proc NewFunctionWin {} {
  global script me im_ok im_cancel GUI icons font
  set w ".newfunc"
  if {[winfo exists $w]} {return}
  toplevel $w -class Newfunc

  set x [winfo x .script]
  set y [winfo y .script]

  wm title $w [mc "New Function"]
  wm geometry $w +200+200
  wm resizable $w 0 0
  wm transient $w .

  frame $w.bottom

  set f [LabelFrame:create $w.top -text [mc "New Function:"] -ipadx 10 -ipady 30]
  label $f.lname -text [mc Name:] -font $font(label)
  label $f.larg -text [mc "Argument List:"] -font $font(label)

  entry $f.name -bg white	
  entry $f.arg  -bg white

  grid $f.lname -column 0 -row 0 -sticky ew
  grid $f.name  -column 1 -row 0 -sticky nw
  grid $f.larg  -column 0 -row 1 -sticky ew
  grid $f.arg   -column 1 -row 1 -sticky nw

  set r ""
  xbutton $w.bottom.ok -image $im_ok -side left -text [mc Ok] -command "NewFunction $w $f.name $f.arg" -font $font(button)
  xbutton $w.bottom.cancel -image $im_cancel -side left -text [mc Cancel] -command "destroy $w" -font $font(button)

  pack $w.top -pady 5 -fill both -expand yes -padx 15 -pady 10 -side top
  pack $w.bottom -fill x -side bottom 	

  pack $w.bottom.ok $w.bottom.cancel -side left -padx 15 -pady 3
   
  bind $w	<Return> "NewFunction $w $f.name $f.arg"
  bind $f.name <Return> "NewFunction $w $f.name $f.arg"	
  bind $f.arg  <Return> "set r 1"	
  bind $w	<Escape> "destroy $w"

  wm withdraw $w
  wm deiconify $w
  grab $w
  focus $f.name
}



proc TabPopups {w} {
    global GUI script

    frame $w.status
    
    	label $w.status.lab1 -width 30 -relief flat -bd 1 -textvariable script(current)
    	label $w.status.lab2 -width 15 -relief flat -bd 1
    	label $w.status.lab3 -relief flat -bd 1
    	label $w.status.lab4 -width 15 -relief flat -bd 1
    
    	pack $w.status.lab1 $w.status.lab2 -side left
    	pack $w.status.lab3 -side left -expand yes -fill x 
    	pack $w.status.lab4 -side left
    	pack [frame $w.f -bg white -bd 2] -fill both -expand y -padx 5 -pady 5 -side top
    	pack $w.status -side bottom -fill x
    
    set GUI(popups,frame) $w.f	
    if {[info exists script(last,popups)]} {
      set script(active,popups) $script(last,popups)
    } else {
      #Does this need [mc..] code?
      set script(active,popups) "nicklist"	
    }
    InitPopup
}

proc InitPopup {} {
	global menus cascades elements script GUI

	set col 0
	set oldcol 0
	set id 0
        set script(current) [format [mc "Editing Menu: %s"] [UpFirst $script(active,popups)]]
	#puts "ScriptCurrent: $script(current)"
	
	foreach c [winfo children $GUI(popups,frame)] {destroy $c}
	
	array unset cascades 
	array unset elements 
	
	set elements(opened) ""
	set elements(last) ""
	set elements(root) ""

	foreach line [split $menus($script(active,popups)) ";"] {
		# evaluate [mc...] statements (exist in default popup definition)
		# nested statement will fail!
		while {[regexp {(.*)\[(mc\ [^\]]*)\](.*)} $line all pre stmt pst]} {
		  set line "$pre[eval $stmt]$pst"
		}
		set cmd [lindex $line 0]
		if {$cmd=="xmenu"} {continue}
		
		set col [expr [llength [split $cmd "."]]-2]
		if {[lindex $line 2]=="cascade"} {
			set cascades([lindex $line 6]) ""
			set mopen [lindex $line 6]
		
			} else {
				set mopen 0
			}
		
		if {[lindex $line 2]=="separator"} {
				lappend cascades($cmd) "$id $col $mopen separator"
		
			} else {
				lappend cascades($cmd) "$id $col $mopen [lindex $line 4]"

			}
		if {$col==0} {
		   set elements(root) $cmd
		}	
		
		set oldcol $col
		set elements($id) "$line"

		incr id
	}

	set elements(last) $id

	AddCascade "$elements(root)" 0

}


proc BlankMenu {} {
	global script menus GUI
	foreach item [grid slaves $GUI(popups,frame)] {
			destroy $item
	} 	

	set menus($script(active,popups)) {
		xmenu .menu;
		.menu add command -label [mc "New Command"] -command ""
	}	

	InitPopup
}


proc RemoveCascade {sub} {
	global cascades GUI	
	if {![info exists cascades($sub)]} {return}
	set col [lindex [lindex $cascades($sub) 0] 1]
	if {$col==""} {return}
	foreach item [grid slaves $GUI(popups,frame) -column $col] {
			destroy $item
	} 	
	incr col
	while {[grid slaves $GUI(popups,frame) -column $col]!=""} {
		foreach item [grid slaves $GUI(popups,frame) -column $col] {destroy $item}
		incr col
	}
}

proc GetItemOrder {sub next} {
	global cascades
	set i 0
	foreach item $cascades($sub) {
		if {[lindex $item 2]==$next} {return $i}
		incr i
	}
	return 0
}
proc UpdateCascade {} {
	global elements cascades GUI

	set active $elements(opened)
	foreach item [grid slaves $GUI(popups,frame)] {destroy $item} 	
	set elements(opened) ""
	set subs [split $active "."]
	set tmp ""
	set old ""
	foreach s $subs {
		if {$s==""} {continue}
		append tmp ".$s"
		if {$tmp==".menu"} {
			AddCascade $tmp 0
		} else {
			AddCascade $tmp [GetItemOrder $old $tmp]
		}
		set old $tmp
	}
}


proc AddCascade {sub start} {
	global cascades elements GUI

	set i $start
	set j [lsearch [array names cascades] $sub]
	set k 0
        catch {RemoveCascade $sub}
	if {$elements(opened)==$sub} {
		set elements(opened) "[string range $sub 0 [expr [string last "." $sub]-1]]"
		return
	}

	foreach item $cascades($sub) {
		set txt [lindex $elements([lindex $item 0]) 4]
		set itemID [lindex $item 0]
		set id "$i$j"
		set col [lindex $item 1]
		if {$txt==""} {
		  label $GUI(popups,frame).entry$id -fg "darkgray" -height 0 -bd 0 -width 17 -text "_________________"
		} else {
    		  label $GUI(popups,frame).entry$id -text $txt -width 17 -bd 0
		  if {[lindex $item 2]!=0} {
  		    bind $GUI(popups,frame).entry$id <Button-1> "AddCascade [lindex $item 2] $i"
		  }
		}
		bind $GUI(popups,frame).entry$id <Button-3>  "CascadeMenu $k $itemID $GUI(popups,frame).entry$id $col $sub %X %Y"
		bind $GUI(popups,frame).entry$id <Button-2>  "CascadeMenu $k $itemID $GUI(popups,frame).entry$id $col $sub %X %Y"
		if {$txt!=""} {
  		  bind $GUI(popups,frame).entry$id <Enter> "%W config -bg $GUI(selectbackground); %W config -fg white"
		  bind $GUI(popups,frame).entry$id <Leave> "%W config -bg $GUI(widgets_color); %W config -fg black"
		}
		grid $GUI(popups,frame).entry$id -column $col -row $i -sticky nw -padx 0 -pady 0
		incr i
		incr k
	}
	set elements(opened) $sub

}

proc CascadeMenu {k id w col sub x y} {
	global elements cascades GUI

	destroy $GUI(popups,frame).menu

	menu $GUI(popups,frame).menu -tearoff 0
	$GUI(popups,frame).menu add command -label [mc "Edit Item"]   -command "CascadeEdit $sub $id"
	$GUI(popups,frame).menu add command -label [mc "Remove Item"] -command "CascadeRemove $w $id $col $sub"
	$GUI(popups,frame).menu add separator
	$GUI(popups,frame).menu add command -label [mc "Add new item to menu"] -command "CascadeAdd {} $id $col $sub"
	if {[lindex $elements($id) 2]=="cascade"} {
    	   $GUI(popups,frame).menu add command -label [mc "Add new item to cascade"] -command "CascadeAdd [lindex $elements($id) 6] $id $col $sub"
	}
        $GUI(popups,frame).menu add command -label [mc "Add separator to menu"] -command "AddSeparator {} $id $col $sub"
	if {[lindex $elements($id) 2]=="cascade"} {
          $GUI(popups,frame).menu add command -label [mc "Add separator to cascade"] -command "AddSeparator [lindex $elements($id) 6] $id $col $sub"
	}
	$GUI(popups,frame).menu add separator
        $GUI(popups,frame).menu add command -label [mc "Move item up in menu"]   -command "CascadeMove $id $k $sub -1"
        $GUI(popups,frame).menu add command -label [mc "Move item down in menu"] -command "CascadeMove $id $k $sub +1"

	tk_popup $GUI(popups,frame).menu $x $y
}

proc CascadeMove {id k sub where} {
	global elements cascades GUI
	if {($where==-1&&$k==0)||($where==+1&&$k==[expr [llength $cascades($sub)]-1])} {return}

	set tmp1 [lindex $cascades($sub) [expr $k$where]]
	set newid [lindex $tmp1 0]
	set tmp2 $elements($newid)
	set elements($newid) $elements($id)
	set elements($id) $tmp2
	set tmp ""
	foreach item $cascades($sub) {
		set itemID [lindex $item 0]
		if {[lindex $item 0]==$newid} {
			lappend tmp "$newid [lrange [lindex $cascades($sub) $k] 1 end]"
		} elseif {[lindex $item 0]==$id} {
			lappend tmp "$id [lrange $tmp1 1 end]"
		} else {
			lappend tmp $item
		}
	}
	set cascades($sub) $tmp
        foreach m [winfo children $GUI(popups,frame)] {destroy $m}
	UpdateCascade
}


proc AddSeparator {tocascade id col sub} {
	global cascades elements GUI
	if {$tocascade!=""} {
		set sub $tocascade
		incr col
	}
	lappend cascades($sub) "$elements(last) $col 0 separator"
	set str "$sub add separator"
	set elements($elements(last)) $str
	incr elements(last)
        foreach m [winfo children $GUI(popups,frame)] {destroy $m}
	UpdateCascade
}


proc CascadeEdit {sub id} {
	global script cascades elements
	if {[lindex $elements($id) 2]=="cascade"} {
		set what "cascade"
	} else {
		set what "command"
	}

	set label [lindex $elements($id) 4]
	set command [lindex $elements($id) 6]
        set values [CascadeAddWin $what $label $command]
	set label [lindex $values 0]
	set command [lindex $values 1]
	if {$what=="cascade"} {
		if {$label==""} {tk_messageBox -message [mc "Couldn't modify item: Item's label can't be blank"] ;return}
		set tmp ""
		foreach item $cascades($sub) {
			if {[lindex $item 0]!=$id} {
				lappend tmp $item
			} else {
				lappend tmp "[lrange $item 0 2] \"$label\""
			}
		}
		set cascades($sub) $tmp
		set elements($id) "$sub add cascade -label \"$label\" -menu [lindex $elements($id) end]"
	} else {
		if {$label==""} {tk_messageBox -message [mc "Couldn't modify item: Item's label can't be blank"] ;return}
		regsub -all {\"} $command {\\"} command
		set tmp ""
		foreach item $cascades($sub) {
			if {[lindex $item 0]!=$id} {
				lappend tmp $item
			} else {
				lappend tmp "[lrange $item 0 2] \"$label\""
			}
		}
		set cascades($sub) $tmp
		set elements($id) "$sub add command -label \"$label\" -command \"$command\""				
	}
	UpdateCascade
}


proc CascadeAdd {tocascade id col sub} {
	global cascades elements CascadeAdd GUI
	set new [CascadeAddWin {} {} {}]

	if {$tocascade!=""} {
		set sub $tocascade
		incr col
	}
	set label [lindex $new 0]
	set command [lindex $new 1]

	if {$CascadeAdd=="command"} {
		if {$label==""} {set label [mc "New Command"]}
                if {$command==""} {
			set command "tk_messageBox -message {[format [mc "No command given for this item. %s Edit the menu to add one."] \n]}"
		} else {
			regsub -all {\"} $command {\\"} command
		}
		set str "$sub add command -label \"$label\" -command \"$command\""
		lappend cascades($sub) "$elements(last) $col 0 $label"
	} else {
		set i 0
                set j 0
    		set menu "$sub.cascade$i"
                while {$j==0} {
                   foreach item $cascades($sub) {
                     if {[lindex $item 2]==$menu} {
                        incr i
                        set menu "$sub.cascade$i"
                        break
                     }
                   }
                   set j 1                      
                }               

		if {$label==""} {set label "new cascade"}
		set str "$sub add cascade -label \"$label\" -menu $menu"
		lappend cascades($sub) "$elements(last) $col $menu $label"
		if {![info exists cascades($menu)]} {set cascades($menu) ""}
	}
	set elements($elements(last)) $str
	incr elements(last)
        foreach m [winfo children $GUI(popups,frame)] {destroy $m}
	UpdateCascade

} 

set CascadeAdd "command"

proc CheckAddCascade {f} {
   global CascadeAdd
   if {$CascadeAdd=="command"} {
	$f.lcom config -state normal
	$f.com config  -state normal
   } else {
	$f.lcom config -state disabled
	$f.com config  -state disabled
   }

}

proc CascadeAddWin {what label command} {
   global script me im_ok im_cancel GUI icons font CascadeAdd
   set w ".newcasc"
   if {[winfo exists $w]} {return}
   toplevel $w -class Newcasc


   wm title $w [mc "New Item"]
   wm geometry $w +200+200
   wm resizable $w 0 0
   wm transient $w .script
   wm withdraw $w
   wm deiconify $w
   #wm focusmodel .newcasc active
   
   #focus -force .newcasc
   #grab $w

   frame $w.bottom

   set f [LabelFrame:create $w.top -text [mc "New Item:"] -ipadx 10 -ipady 30]
   label $f.llab -text [mc Label:] 
   label $f.lcom -text [mc Command:] 
   entry $f.lab -bg white	
   entry $f.com -bg white

   radiobutton $f.menu -text [mc Cascade] -selectcolor white -variable CascadeAdd -value "cascade" -command "CheckAddCascade $f" 
   radiobutton $f.command -text [mc Command] -selectcolor white -variable CascadeAdd -value "command" -command "CheckAddCascade $f"

   if {$what!=""} {set CascadeAdd $what; $f.lab insert 0 $label}


   if {$what=="cascade"} {
	$f.command config -state disabled
   }	
   if {$what=="command"} {
	$f.menu config -state disabled
	$f.com insert end $command
   }	


   if {$CascadeAdd!="command"} {
	$f.lcom config -state disabled
	$f.com config -state disabled
   }	

   switch $script(active,popups) {
	"nicklist" {
		set vars [format [mc "%s: Current Channel %s %s: Selected Nick %s %s: Connection id"] \$chan \n \$nick \n \$id]
	}
	"notify" {
		set vars [format [mc "%s: Selected Nick %s %s: Connection id"] \$nick \n \$id]
	}
	"channel" {
		set vars [format [mc "%s: Current Channel %s %s: Connection id"] \$chan \n \$id]
	}
	"query" {
		set vars [format [mc "%s: Selected Nick %s %s: Connection id"] \$nick \n \$id]
	}
	"chat" {
		set vars [format [mc "%s: Selected Nick %s %s: Connection id"] \$nick \n \$id]
	}
	"server" {
	        set vars [format [mc "%s: Connection id"] \$id]
        }
   }	
   message $f.msg -text [format [mc "Available variables for this menu: %s %s"] \n $vars] -width 200

   grid $f.llab -column 0 -row 0 -sticky ew
   grid $f.lab  -column 1 -row 0 -sticky nw
   grid $f.lcom -column 0 -row 1 -sticky ew
   grid $f.com  -column 1 -row 1 -sticky nw
   grid $f.menu -column 0 -row 2 -sticky ew
   grid $f.command -column 1 -row 2 -sticky nw
   grid $f.msg -column 0 -row 3 -columnspan 2 -sticky nw	

   set r ""
   xbutton $w.bottom.ok -image $im_ok -side left -text [mc Ok] -command "set r 1" -font $font(button)
   xbutton $w.bottom.cancel -image $im_cancel -side left -text [mc Cancel] -command "destroy $w" -font $font(button)


   pack $w.top -pady 5 -fill both -expand yes -padx 15 -pady 10 -side top
   pack $w.bottom -fill x -side bottom 	

   pack $w.bottom.ok $w.bottom.cancel -side left -padx 15 -pady 3
   
   bind $w <Return> "set r 1"
   bind $f.lab <Return> "set r 1"	
   bind $f.com <Return> "set r 1"	
   bind $w <Escape> "destroy $w"
   focus $f.lab
	
   tkwait variable r
   if {[catch {$f.com get} cmd]} {return}
   if {[catch {$f.lab get} lab]} {return}
   after 10 "destroy $w"
   return [list "$lab" "$cmd"]	
}


proc CascadeRemove {w id col sub} {
	global elements cascades GUI

	if {[lindex $elements($id) 2]=="cascade"} {
		set cascade 1
	} else {
		set cascade 0
	}

	set tmp ""
	foreach item $cascades($sub) {
		if {[lindex $item 0]!=$id} {
			lappend tmp $item
		}
	}

	if {$cascade} {
		set menu [lindex $elements($id) 6]
		foreach m $cascades($menu) {
			array unset elements [lindex $m 0]
		}	
		if {$elements(opened)==$menu} {AddCascade $menu 0}
		array unset cascades $menu
		foreach m [winfo children $GUI(popups,frame)] {destroy $m}
                #set cascades($sub) $tmp
      	        #array unset elements $id
		#UpdateCascade	
	}

        set cascades($sub) $tmp
	array unset elements $id	
	destroy $w
	UpdateCascade
}

proc SaveCurrentMenu {} {
	global elements cascades script me menus
	
	set file [file join $me(home) config $me(profile) scripts popups.tcl]
	set fd [open $file w]

	foreach menu_type [array names menus] {

		puts $fd "\nset menus($menu_type) \{"
		if {$menu_type!=$script(active,popups)} {
			puts $fd [string trim $menus($menu_type)]
		} else {
			foreach cascade [lsort [array names cascades]] {
				if {$cascade==""} {continue}
				puts -nonewline $fd "\n xmenu $cascade;"
				foreach item $cascades($cascade) {
					puts -nonewline $fd " $elements([lindex $item 0]);"	
				}
			}	
		}
		puts $fd "\}\n"
		
	}
	close $fd
	SourceScripts "popups"

}


proc CreateDefaultScriptFile {user var filename} {
   global script me

   set file [file join $me(home) config $user scripts $filename]
   if {[catch {open $file w+} fd]} {return "$fd"}
   puts $fd $script($var)
   catch {close $fd}
   return 1
}


set script(event_types) {
	chanaction {id nick user host chan text} 
	chantext {id nick user host chan text} 
	chat {id nick user host ip port} 
	chataction {id nick text} 
	chatclose {id nick}
        chatstart {id nick ip port}
	chattext {id nick text} 
	connect {id} 
	ctcp {id nick user host type txt} 
	ctcpreply {id nick user host type reply} 
	deop {id nick user host chan deopper} 
	devoice {id nick user host chan devoicer} 
	disconnect {id} 
	dns {id nick host resolved}
 	getend {id nick file size}
	getfail {id nick file size}
	getstart {id nick user host ip port file size} 
	invite {id nick chan} 
	join {id nick user host chan} 
	kick {id nick chan kicker reason} 
	mode {id nick chan params} 
        nick {id nick newnick} 
	notice {id nick user host text} 
	notify {id nick}
	op {id nick user host chan opper} 
	part {id nick user host chan}  
	queryaction {id nick user host text} 
	querytext {id nick user host text}
	quit {id nick user host} 
	raw {id raw msg} 
	send {id nick user host ip port file size} 
        sendend {id nick file size}
        sendfail {id nick file size}
        sendstart {id nick ip port file size}
        servernotice {id text}
	serverping {id pong} 
	start {} 
	topic {id nick chan topic} 
	unotify {id nick}
	voice {id nick user host chan voicer} 
}




set script(popups_default_file) {

set menus(chat) {
  xmenu .menu; .menu add command -label "Whois" -command "whois $nick"; .menu add command -label "DNS" -command "dns $nick";    
  .menu add separator;    
  .menu add cascade -label [mc Ignore] -menu .menu.ignore;    
  .menu add separator;    
  .menu add cascade -label "CTCP" -menu .menu.ctcp;    
  .menu add cascade -label "DCC" -menu .menu.dcc;    
  xmenu .menu.ctcp;  .menu.ctcp add command -label [mc Version] -command "ctcp $nick version";  .menu.ctcp add command -label "Ping" -command "ctcp $nick ping";
  .menu.ctcp add separator;  .menu.ctcp add command -label "Userinfo" -command "ctcp $nick userinfo";  .menu.ctcp add command -label "Clientinfo" -command "ctcp $nick clientinfo";
  .menu.ctcp add separator;  .menu.ctcp add command -label [mc Time] -command "ctcp $nick time";
  xmenu .menu.dcc;  .menu.dcc add command -label [mc Send] -command "dcc send $nick";
  xmenu .menu.ignore;  .menu.ignore add command -label "1 [mc Minute]" -command "ignore $nick a 1";  .menu.ignore add command -label "5 [mc Minutes]" -command "ignore $nick a 5";  .menu.ignore add command -label "30 [mc Minutes]" -command "ignore $nick a 30";
  .menu.ignore add separator;  .menu.ignore add command -label [mc "Add to List"] -command "ignore $nick a";
}


set menus(channel) {
  xmenu .menu;
  .menu add cascade -label [mc Actions] -menu .menu.actions;
  .menu add separator;
  .menu add command -label [mc Settings] -command "winsetcan $chan $id";
  xmenu .menu.actions;
  .menu.actions add command -label [mc "Global WHO"] -command "IRC::who $chan";
  .menu.actions add separator;
  .menu.actions add command -label [mc Part] -command "IRC::part $chan";
  .menu.actions add command -label [mc Cycle] -command "IRC::cycle";
}


set menus(notify) {
  xmenu .menu;  .menu add command -label "Whois " -command "whois $nick"; .menu add command -label "DNS" -command "dns $nick"; .menu add command -label [mc Query] -command "query $nick";
  .menu add separator;
  .menu add cascade -label [mc Ignore] -menu .menu.ignore;
  .menu add separator;
  .menu add cascade -label "CTCP" -menu .menu.ctcp;
  .menu add cascade -label "DCC" -menu .menu.dcc;
  xmenu .menu.ctcp; .menu.ctcp add command -label [mc Version] -command "ctcp $nick version"; .menu.ctcp add command -label "Ping" -command "ctcp $nick ping";
  .menu.ctcp add separator; .menu.ctcp add command -label "Userinfo" -command "ctcp $nick userinfo"; .menu.ctcp add command -label "Clientinfo" -command "ctcp $nick clientinfo";
  .menu.ctcp add separator; .menu.ctcp add command -label [mc Time] -command "ctcp $nick time";
  xmenu .menu.dcc; .menu.dcc add command -label [mc Chat] -command "dcc chat $nick";
  .menu.dcc add separator; .menu.dcc add command -label [mc Send] -command "dcc send $nick";
  xmenu .menu.ignore; .menu.ignore add command -label "1 [mc Minute]" -command "ignore $nick a 1"; .menu.ignore add command -label "5 [mc Minutes]" -command "ignore $nick a 5"; .menu.ignore add command -label "30 [mc Minutes]" -command "ignore $nick a 30";
  .menu.ignore add separator; .menu.ignore add command -label [mc "Add to List"] -command "ignore $nick a";
}


set menus(nicklist) {
  xmenu .menu;     .menu add command -label "Whois" -command "whois $nick";  .menu add command -label "DNS" -command "dns $nick";
  .menu add command -label [mc Query] -command  "IRC::query $nick";
  .menu add separator;
  .menu add cascade -label [mc Control] -menu .menu.control;  .menu add separator;
  .menu add cascade -label "CTCP" -menu .menu.ctcp;
  .menu add cascade -label "DCC" -menu .menu.dcc;
  xmenu .menu.control;    .menu.control add command -label "Op" -command "mode $chan +o $nick";    .menu.control add command -label "Deop" -command "mode $chan -o $nick";
  .menu.control add separator;    .menu.control add command -label [mc Voice] -command "mode $chan +v $nick";    .menu.control add command -label [mc Devoice] -command "mode $chan -v $nick";
  .menu.control add separator;    .menu.control add command -label [mc Kick] -command "kick $chan $nick";    .menu.control add command -label [mc Kick/Ban] -command "ban $chan $nick 3 1";
  .menu.control add separator;    .menu.control add command -label "[mc Ban] (nick!*@*)" -command "ban $chan $nick 1 0";    .menu.control add command -label "[mc Ban] (*!user@host)" -command "ban $chan $nick 2 0";    .menu.control add command -label "[mc Ban] (*!*@host)" -command "ban $chan $nick 3 0";
  xmenu .menu.ctcp;    .menu.ctcp add command -label [mc Version] -command "ctcp $nick version";    .menu.ctcp add command -label "Ping" -command "ctcp $nick ping";
  .menu.ctcp add separator;   .menu.ctcp add command -label "Userinfo" -command "ctcp $nick userinfo";   .menu.ctcp add command -label "Clientinfo" -command "ctcp $nick clientinfo";
  .menu.ctcp add separator;   .menu.ctcp add command -label [mc Time] -command "ctcp $nick time";
  xmenu .menu.dcc;   .menu.dcc add command -label [mc "Send File"] -command "dcc send $nick";
  .menu.dcc add separator;   .menu.dcc add command -label [mc Chat] -command "dcc chat $nick";
}


set menus(query) {
  xmenu .menu; .menu add command -label "Whois" -command "whois $nick"; .menu add command -label "DNS" -command "dns $nick";
  .menu add separator;
  .menu add cascade -label [mc Ignore] -menu .menu.ignore;
  .menu add separator;
  .menu add cascade -label "CTCP" -menu .menu.ctcp;
  .menu add cascade -label "DCC" -menu .menu.dcc;
  xmenu .menu.ctcp; .menu.ctcp add command -label [mc Version] -command "ctcp $nick version"; .menu.ctcp add command -label "Ping" -command "ctcp $nick ping";
  .menu.ctcp add separator; .menu.ctcp add command -label "Userinfo" -command "ctcp $nick userinfo"; .menu.ctcp add command -label "Clientinfo" -command "ctcp $nick clientinfo";
  .menu.ctcp add separator; .menu.ctcp add command -label [mc Time] -command "ctcp $nick time";
  xmenu .menu.dcc; .menu.dcc add command -label [mc Send] -command "dcc send $nick";
  .menu.dcc add separator; .menu.dcc add command -label [mc Chat] -command "dcc chat $nick";
  xmenu .menu.ignore; .menu.ignore add command -label "1 [mc Minute]" -command "ignore $nick a 1"; .menu.ignore add command -label "5 [mc Minutes]" -command "ignore $nick a 5"; .menu.ignore add command -label "30 [mc Minutes]" -command "ignore $nick a 30";
  .menu.ignore add separator; .menu.ignore add command -label [mc "Add to List"] -command "ignore $nick a";
}


set menus(server) {
 xmenu .menu;  .menu add command -label "MOTD" -command "quote motd";  .menu add command -label [mc Time] -command "quote time";
 .menu add separator;  .menu add command -label "LUSERS" -command "quote lusers";  .menu add command -label "Admin" -command "quote admin";
 .menu add separator;  .menu add command -label "Info" -command "quote info";  .menu add command -label "Version" -command "quote version";  .menu add command -label "Links" -command "quote links";
 .menu add separator; .menu add command -label "Help" -command "quote help";
}

}






set script(functions_default_file) {

proc j {args} {
   join #$args
}

proc w {args} {
   whois $args
}

proc n {args} {
   nick $args
}

proc q {args} {
   query $args
}

proc send {args} {
   dcc send $args
}

proc chat {args} {
   dcc chat $args
}

proc ns {args} {
   eval nickserv $args
}

proc ms {args} {
   eval memoserv $args
}

proc cs {args} {
   eval chanserv $args
}

}
