package require mkWidgets

source [file join $me(path) lib progress.tcl]
source [file join $me(path) lib scrollgrid.tcl]
source [file join $me(path) lib dkffont.tcl]
source [file join $me(path) lib mclistbox.tcl]
source [file join $me(path) lib flist.tcl]
source [file join $me(path) lib autoscroll.tcl]
source [file join $me(path) lib xbutton.tcl]
source [file join $me(path) lib tree.tcl]
source [file join $me(path) lib balloon.tcl]
source [file join $me(path) lib supertext.tcl]
source [file join $me(path) lib combobox.tcl]
source [file join $me(path) lib labelframe.tcl]
source [file join $me(path) help help.tcl]

if {[::platform::isPlatformUnix]} {
  source [file join $me(path) lib cscrollbar.tcl]
}

package require mclistbox 1.02
catch {namespace import mclistbox::*}

package require autoscroll
namespace import ::autoscroll::autoscroll


proc SetGUIDefaults {} {
  global colsTXT GUI font
  set colsTXT(prog) #000000
  set colsTXT(raw) #9e38ae
  set colsTXT(serv) black
  set colsTXT(chan) black
  set colsTXT(mechan) black
  set colsTXT(query) black
  set colsTXT(mequery) black
  set colsTXT(chat) black
  set colsTXT(mechat) black
  set colsTXT(notice) #82140c
  set colsTXT(whois) #1834ff
  set colsTXT(ctcp) red
  set colsTXT(invite) #0c8816
  set colsTXT(join) #0c8816
  set colsTXT(part) #0c8816
  set colsTXT(quit) #0c147c
  set colsTXT(mode) #0c8816
  set colsTXT(topic) #0c8816
  set colsTXT(kick) #ff0000
  set colsTXT(ban) red
  set colsTXT(action) #df0edf
  set colsTXT(dns) #df0edf
  set colsTXT(nick) #6a1816
  set colsTXT(motd) #8e8c96
  set colsTXT(notify) #0c147c
  set GUI(scrollbar_bg) #1488ff
  set GUI(scrollbar_slider) #1400e6
  set GUI(scrollbar_gradient1) white
  set GUI(scrollbar_gradient2) #c0f2f8
  set GUI(selectforeground) white
  set GUI(selectbackground) #0a0a8e
  set GUI(entry_bg) white
  set GUI(listbox_bg) white
  set GUI(text_bg) white
  set GUI(entry_fg) black
  set GUI(listbox_fg) black
  set GUI(text_fg) black
 
  if {[::platform::isPlatformUnix]} {
    set font(n) "Helvetica 12"
    set font(listbox) "Helvetica 12"
    set font(entry) "Helvetica 14 bold"
    set font(button) "Helvetica 12"
    set font(label) "Helvetica 12"
    set font(menu) "Helvetica 8"
  }
  if {[::platform::isPlatformWindows]} {
    set font(n) "Tahoma 10"
    set font(listbox) "Tahoma 10"
    set font(entry) "Tahoma 12 bold"
    set font(button) "Tahoma 8"
    set font(label) "Tahoma 8"
    set font(menu) "Tahoma 8"
  }
  set GUI(properties) 1
  set GUI(tooltips) 1
  set GUI(titlebar) darkblue
  set GUI(tforeground) white
  set GUI(file_IconMin) ""
  set GUI(file_IconMax) ""
  set GUI(file_IconRestore) ""
  set GUI(file_IconClose) ""
  set GUI(file_IconMin_pressed) ""
  set GUI(file_IconMax_pressed) ""
  set GUI(file_IconRestore_pressed) ""
  set GUI(file_IconClose_pressed) ""
  set GUI(file_IconMin_over) ""
  set GUI(file_IconMax_over) ""
  set GUI(file_IconRestore_over) ""
  set GUI(file_IconClose_over) ""
  set GUI(buttonbar) bottom 
  set GUI(background) darkgray 
  set GUI(widgets_color) #d8d8d8 
  set GUI(bgimage) ""
  set GUI(bgimage_how) tile 
}


proc SetConfigDefaults {} {
 global me env act clientMSG misc DCC files GUI MIRCcols mp3 script icons
 set me(encoding) utf-8
 set me(lang) en_us
 set me(server) "irc.undernet.org"
 set me(network) "Undernet"
 set me(port) 6667
 if {[info exists env(USERNAME)]} {
  set me(nick) "$env(USERNAME)"
  set me(altnick) "$env(USERNAME)-"
 } else {
  set me(nick) "savircuser"
  set me(altnick) "savircuser-"
 }
 set me(userid) "savirc"
 set me(realname) "Your realname here"
 set me(sock5svr) ""
 set me(sock5port) ""
 set me(sock5user) ""
 set me(sock5pass) ""
 set me(sock5use) 0
 set act(nick) 1
 set act(whois) 1
 set act(notice) 1
 set act(ctcp) 1
 set act(invite) 1
 set act(notify) 1
 set clientMSG(part) "bye!"
 set clientMSG(quit) "savIRC - The Cross-Platform IRC Client"
 set clientMSG(kick) "go out.."
 set clientMSG(userinfo) "savIRC - http://www.savirc.com"
 set clientMSG(away) "I'm away"
 set misc(rejoin) 1
 set misc(join) 0
 set misc(invite) 1
 set misc(ncompl) 1
 set misc(completion) "%nick"
 set misc(notify) 1
 set misc(notifyupdate) 5
 set misc(ping) 1
 set misc(timestamp) 0
 set misc(logchat) 0
 set misc(logchannel) 0
 set misc(logquery) 0
 set misc(trunclog) 100
 set misc(connect) 0
 set misc(splitter) 430
 set misc(history) 0
 set misc(historycmd) 1
 set misc(address) 1
 set misc(short) 0
 set misc(highlightc) #ffff00
 set misc(highlight) 1
 set misc(showtopic) 1
 if {[::platform::isPlatformUnix]} {
   #set misc(traymin) 1
   set misc(traymin) 0
 }
 if {[::platform::isPlatformWindows]} {
   set misc(traymin) 0
 }
 #set misc(trayuse) 1
 set misc(trayuse) 0
 set misc(urlscol) 0
 set misc(chanpopup) 0
 set misc(logtimestamp) 0
 set misc(buffer_limit) 1
 set misc(buffer_lines) 800
 if {[::platform::isPlatformUnix]} {
   set misc(downloads) "konqueror %downloads"
   set misc(open_files) "konqueror %file"
 }
 set DCC(sock5) 0
 set DCC(passive) 0
 set DCC(autoclose_get) 0
 set DCC(autoclose_send) 1
 set DCC(block) 4096
 set DCC(acceptSend) 0
 set DCC(acceptChat) 0
 set DCC(ignoreSend) 0
 set DCC(ignoreChat) 0
 set DCC(minimize_send) 0
 set DCC(fserve_menu) 1
 set DCC(reject) ".exe,.com,.bat,.vbs,.pif,.ini,.shs,.js"
 set DCC(ifexist) Rename
 set DCC(trust) 0
 set DCC(trusted) ""
 set DCC(autoopen) 0
 set files(defaultdir) "c:\\"
 if {[::platform::isPlatformUnix]} {
   set files(browser) mozilla
 }
 if {[::platform::isPlatformWindows]} {
   set files(browser) explorer
 }
 set files(incoming) [file join $me(home) config $me(profile) Downloads]
 set GUI(listbox_ratio) .80
 set GUI(geometry) 800x553+-4+-4
 set GUI(maximized) 0
 set GUI(tooltips) 1
 set GUI(properties) 1
 set MIRCcols(win) 1
 set MIRCcols(preview) 1
 set MIRCcols(0) #ffffff
 set MIRCcols(1) #000000
 set MIRCcols(2) #00007F
 set MIRCcols(3) #009000
 set MIRCcols(4) #FF0000
 set MIRCcols(5) #7F0000
 set MIRCcols(6) #9F009F
 set MIRCcols(7) #FF7F00
 set MIRCcols(8) #FFFF00
 set MIRCcols(9) #00F800
 set MIRCcols(10) #00908F
 set MIRCcols(11) #00FFFF
 set MIRCcols(12) #0000FF
 set MIRCcols(13) #FF00FF
 set MIRCcols(14) #7F7F7F
 set MIRCcols(15) #CFD0CF
 set icons(show) 1
 set me(colbut) 1
 set mp3(mode) 1
 set mp3(verbose) 0
 set mp3(lists) ""
 set mp3(list) ""
 set script(functions) functions.tcl
 set script(events) events.tcl
 set script(variables) variables.tcl
 set me(ident_port) 113
 set me(ident_system) UNIX
 set me(ident_connect) 1
 set me(ident_use) 1
 set me(ident_show) 0
 set mcLanguage en_us
 set GUI(theme) [file join $me(home) config $me(profile) default.thm]
 
}



proc scrolled {type name args} {
    frame $name
    $type $name.$type \
            -xscrollcommand [list scroll? $name.x \
            [list grid $name.x -row 1 -column 0 -sticky we]]\
            -yscrollcommand [list scroll? $name.y \
            [list grid $name.y -row 0 -column 1 -sticky ns]]
    eval $name.$type configure $args
    xscrollbar $name.x -ori h -command "$name.$type xview"
    xscrollbar $name.y -ori v -command "$name.$type yview"
    grid $name.$type $name.y -sticky news
    grid $name.x -sticky news
    grid rowconfigure $name 0 -weight 1
    grid columnconfigure $name 0 -weight 1
    return $name.$type
}

proc scroll? {bar cmd offset size} {
  if {$offset!=0.0 || $size!=1.0} {
      eval $cmd; $bar set $offset $size
  } else {
      [lindex $cmd 0] forget $bar
  }
}

proc LoadSettings { } {
  global files env me GUI colsTXT MIRCcols font act clientMSG misc DCC MIRCcols icons mp3 script
  
  SetConfigDefaults
  
  if {[catch {open $files(settings) r} fd]} {
    # commented out. gives error. GUI procs are not defined when this proc is called
    #IRC::echo 
    # I removed [mc..] because the msgCat code doesn't get called until LoadLanguage is executed.
    puts  "Could not load settings, using defaults"
    return
  }

  set settings [split [read $fd] \n]
  foreach line $settings  {
    set setting [lrange [split $line] 1 end]
    set setting [string trim $setting "{}"]
    set setting [string trim $setting]
    set [lindex [split $line] 0] $setting
  }
  catch {close $fd}
  
  LoadNotifyList
  LoadIgnoreList
  LoadGUISettings ;# this is loaded twice? once in savirc.tcl line: 336 - Which one to delete?
  LoadLanguage $me(lang)
  
}

proc Isinteger {int} {
   if {$int==""} {
     return 0
   } else {
     return [regexp {^[0-9]*$} $int]
   }
}


proc Fix_Font {font} {
   return [string map {"\\" ""} $font]
}

proc ReLoadSettings {} {
   global GUI
   set GUI(dont_move_buttonbar) ""
   LoadGUISettings
}


proc LoadGUISettings {} {
  global files env me GUI colsTXT MIRCcols font act clientMSG misc DCC MIRCcols icons mp3 script
  
  # first set sane defaults
  SetGUIDefaults
  
  if {[catch {open $GUI(theme) r} fd]} {
     set GUI(theme) [file join $me(home) config $me(profile) default.thm]
     #set GUI(theme) "$me(home)/config/$me(profile)/default.thm"
     if {[catch {open $GUI(theme) r} fd]} {
       catch {IRC::echo [mc "GUI Config not found, using defaults"]}
       
       if {[catch {open $GUI(theme) w+} fd]} {
         return
       }
       #immediately write out the defaults
       SaveGUISettings
     } 
  }

  set settings [split [read $fd] \n]
  foreach line $settings  {
    set setting [lrange [split $line] 1 end];
    set setting [string trim $setting "{}"];
    set setting [string trim $setting];
    set [lindex [split $line] 0] $setting;
  }

  foreach ftype {n listbox entry button label} {
    set font($ftype) [string map {"\\" ""} $font($ftype)]
  }

  catch {close $fd}
  if {$GUI(file_IconMin)!=""} {
     MDIIconCreate IconMin $GUI(file_IconMin) b 1
  } else {
     MDIIconCreate IconMin {} b $GUI(pIconMin)
  }
  if {$GUI(file_IconMax)!=""} {
     MDIIconCreate IconMax $GUI(file_IconMax) b 1
  } else {
     MDIIconCreate IconMax {} b $GUI(pIconMax)
  }
  if {$GUI(file_IconRestore)!=""} {
     MDIIconCreate IconRestore $GUI(file_IconRestore) b 1
  } else {
     MDIIconCreate IconRestore {} b $GUI(pIconRestore)
  }
  if {$GUI(file_IconClose)!=""} {
     MDIIconCreate IconClose $GUI(file_IconClose) b 1
  } else {
     MDIIconCreate IconClose {} b $GUI(pIconClose)
  }
 
  if {$GUI(file_IconClose_pressed)!=""} {
     MDIIconCreate IconClose_pressed $GUI(file_IconClose_pressed) b 1
  } else {
     MDIIconCreate IconClose_pressed {} b $GUI(pIconClose_pressed)
  }
 
  if {$GUI(file_IconClose_over)!=""} {
    MDIIconCreate IconClose_over $GUI(file_IconClose_over) b 1
  } else {
    MDIIconCreate IconClose_over {} b $GUI(pIconClose_over)
  }

  if {$GUI(file_IconMax_pressed)!=""} {
     MDIIconCreate IconMax_pressed $GUI(file_IconMax_pressed) b 1
  } else {
     MDIIconCreate IconMax_pressed {} b $GUI(pIconMax_pressed)
 
  }
  if {$GUI(file_IconMax_over)!=""} {
     MDIIconCreate IconMax_over $GUI(file_IconMax_over) b 1
  } else {
     MDIIconCreate IconMax_over {} b $GUI(pIconMax_over)
  }
 
  if {$GUI(file_IconMin_pressed)!=""} {
     MDIIconCreate IconMin_pressed $GUI(file_IconMin_pressed) b 1
  } else {
     MDIIconCreate IconMin_pressed {} b $GUI(pIconMin_pressed)
  }
  
  if {$GUI(file_IconMin_over)!=""} {
     MDIIconCreate IconMin_over $GUI(file_IconMin_over) b 1
  } else {
     MDIIconCreate IconMin_over {} b $GUI(pIconMin_over)
  }
 
  if {$GUI(file_IconRestore_pressed)!=""} {
     MDIIconCreate IconRestore_pressed $GUI(file_IconRestore_pressed) b 1
  } else {
    MDIIconCreate IconRestore_pressed {} b $GUI(pIconRestore_pressed)
  }
  
  if {$GUI(file_IconRestore_over)!=""} {
     MDIIconCreate IconRestore_over $GUI(file_IconRestore_over) b 1
  } else {
     MDIIconCreate IconRestore_over {} b $GUI(pIconRestore_over)
  }

  if {![info exists GUI(dont_move_buttonbar)]} {
    MoveButtonBar $GUI(buttonbar) 0
  } else {
    array unset GUI dont_move_buttonbar
  }
}


proc NewTheme {w} {
 global me GUI
 set file [tk_getSaveFile -defaultextension "thm" -initialfile "untitled.thm" -initialdir [file join $me(home) config $me(profile)] -title "Enter filename" -parent $w]
 if {$file==""} {return}
 if {[file dirname $file]!=[file join $me(home) config $me(profile)]} {
   tk_messageBox -message [format [mc "You can only create theme files in %s"] [file join $me(home) config $me(profile)]]
   return
 }
 if {[file extension $file]!=".thm"} {
   tk_messageBox -message [mc "Theme files must have .thm extension"]
   return
 }

 set dir [file dirname $file]
 set filename [file tail $file]
 regsub -all { } $filename {_} filename
 set file [file join $dir $filename]

 if {[catch {open $file w+} fd]} {
   tk_messageBox -message [format [mc "Error creating new theme file: %s"] $fd]
   return
 }
 
 set GUI(theme) "$file"
 
 SaveGUISettings
 FillThemes $w
}

proc ApplyTheme {w l fromTHEME} {
  global me GUI font

  if {$fromTHEME} {
    set sel [$w curselection]
    if {$sel==""} {return}
    set theme [$w get $sel $sel]
    if {$GUI(theme)==[file join $me(home) config $me(profile) $theme]} {return}
    set GUI(theme) [file join $me(home) config $me(profile) $theme]
  } 
  LoadGUISettings

  ConfigGroundColor . Entry $GUI(entry_fg) -foreground
  ConfigGroundColor . Entry $GUI(entry_bg) -background
  ConfigGroundColor . Listbox $GUI(listbox_fg) -foreground
  ConfigGroundColor . Listbox $GUI(listbox_bg) -background
  ConfigGroundColor . Text $GUI(text_fg) -foreground
  ConfigGroundColor . Text $GUI(text_bg) -background
  ConfigSetColor . -selectforeground $GUI(selectforeground)
  ConfigSetColor . -selectbackground $GUI(selectbackground)
  ConfigTitleColor titlebar
  ConfigTitleColor tforeground
  ConfigFont Entry $font(entry) .
  ConfigFont Listbox $font(listbox) .  
  ConfigFont Label $font(label) .
  ConfigFont Button $font(button) .
  ConfigFont Text $font(n) .
  BgimageHow
  catch {$l config -text [format [mc "Active Theme: %s"] [file tail $GUI(theme)]] }
}

proc FillThemes {w} {
  global me
  $w delete 0 end
  if {[catch {glob -directory [file join $me(home) config $me(profile)] *.thm} e]} {return}
  foreach theme $e {
    $w insert end [file tail $theme]
  }
}

proc DeleteTheme {w l} {
  global me GUI
  set sel [$w curselection]
  if {$sel==""} {return}
  set theme [$w get $sel $sel]
  set r [tk_messageBox -message [format [mc "Are you sure you want to delete %s?"] $theme] -type "yesno"]
  if {$r=="yes"} {
     if {[catch {file delete [file join $me(home) config $me(profile) "$theme"]} e]} {
        tk_messageBox -message [format [mc "Couldn't delete %s %s %s"] $theme : $e]
        return
     } 
     FillThemes $w
  }  
  if {[string tolower [file tail $GUI(theme)]]==[string tolower $theme]} {
     $w selection set 0 0
     ApplyTheme $w $l 1
  }
}


proc MDIIconConf {icon b f} {
   global files
   set file [tk_getOpenFile -initialdir $files(defaultdir) -title [mc "Select a GIF image:"] -parent $f]
   if {$file==""} {return}
   if {[string tolower [file extension $file]]!=".gif"} {
      tk_messageBox -message [mc "You can only use .gif files for window icons"]
      return
   }
   set files(defaultdir) [file dirname $file]
   MDIIconCreate $icon $file $b 1
}


proc MDIIconCreate {icon file b create} {
   global GUI wid

   if {$create==1} {
     if {[catch {image create photo -file $file} create]} {
        tk_messageBox -message [format [mc "Error creating image: %s"] $create]
        set GUI(file_$icon) ""
        MDIIconCreate $icon {} b $GUI(p$icon)
        return
     }
     set GUI(file_$icon) $file
   } else {
     set GUI(file_$icon) ""
   }
   set GUI($icon) $create
   catch {$b config -image $create}


   switch -glob -- $icon {
     "IconMin*"		{ set w "head.minb" }
     "IconMax*"		{ set w "head.maxb" }
     "IconRestore*"	{ set w "head.maxb" }
     "IconClose*"	{ set w "head.clob" }
   }   

   if {![info exists wid(status)]} {return}
   foreach doc [$wid(status) Alldocs] {
          $doc image_conf $w "p$icon" $GUI($icon)

   }
}

proc MDIDefaultIcon {b1 b2 b3 b4} {
  global GUI

  set GUI(file_IconMin) ""
  set GUI(file_IconMax) ""
  set GUI(file_IconClose) ""
  set GUI(file_IconRestore) ""

  set GUI(file_IconMin_over) ""
  set GUI(file_IconMax_over) ""
  set GUI(file_IconClose_over) ""
  set GUI(file_IconRestore_over) ""

  set GUI(file_IconMin_pressed) ""
  set GUI(file_IconMax_pressed) ""
  set GUI(file_IconClose_pressed) ""
  set GUI(file_IconRestore_pressed) ""



  MDIIconCreate IconMax_pressed {} "" $GUI(pIconMax_pressed)
  MDIIconCreate IconMin_pressed {} "" $GUI(pIconMin_pressed)
  MDIIconCreate IconRestore_pressed {} "" $GUI(pIconRestore_pressed)
  MDIIconCreate IconClose_pressed {} "" $GUI(pIconClose_pressed)

  MDIIconCreate IconMax {} $b1 $GUI(pIconMax)
  MDIIconCreate IconMin {} $b2 $GUI(pIconMin)
  MDIIconCreate IconRestore {} $b3 $GUI(pIconRestore)
  MDIIconCreate IconClose {} $b4 $GUI(pIconClose)

  set GUI(IconMin_over) $GUI(IconMin)
  set GUI(IconMax_over) $GUI(IconMax)
  set GUI(IconClose_over) $GUI(IconClose)
  set GUI(IconRestore_over) $GUI(IconRestore)

}


proc LoadIgnoreList {} {
 global files ignore colsTXT
 if {[catch {open $files(ignore) r} fd]} {
     if {[catch {open $files(ignore) w} fd]} {
        catch {puts [format [mc "Cannot create ignore file: %s"] $fd]}
        return
     }
    return
 }

 set settings [split [read $fd] \n]
 set ignore ""
 foreach line $settings  {
   set setting [lrange [split $line] 1 end];
   set setting [string trim $setting "{}"];
   set setting [string trim $setting];
   if {[lindex [split $line] 0]!=""} {
     if {[lindex [split $line] 0]!=""&&[lindex [split $line] 1]!=""} {
        lappend ignore "[lrange [split $line] 0 end]"
     }
   }
 }
 catch {close $fd}
}


proc LoadNotifyList {} {
 global files colsTXT ison isonMSG
 if {[catch {open $files(notify) r} fd]} {
    if {[catch {open $files(notify) w} fd]} {
       catch {puts [format [mc "Cannot create notify file: %s"] $fd]}
       return
    }
    return
 }
  
 array unset ison
 array unset isonMSG

 set settings [split [read $fd] \n]
 set i 0
 foreach line $settings  {
   set setting [lrange [split $line] 1 end];
   set setting [string trim $setting "{}"];
   set setting [string trim $setting];
   if {[lindex [split $line] 0]!=""} {
     set ison($i) [lindex [split $line] 0]
     set isonMSG($i) [lrange [split $line] 1 end]
     incr i
   }
 }
 catch {close $fd}
}


proc ConfigTitleColor {opt} {
   global wid GUI
   set wFocus [$wid(status) wFocus]
   if {$opt=="titlebar"} {
     $wFocus.head.text configure -background $GUI($opt)
     $wFocus.head      configure -background $GUI($opt)
     $wFocus.head.icon configure -background $GUI($opt)
   } else {
     $wFocus.head.text configure -foreground $GUI($opt) 
     $wFocus.head.icon configure -foreground $GUI($opt) 
   }
  
   foreach doc [$wid(status) Alldocs] {
       if {$opt=="titlebar"} {
          $doc configure -background $GUI($opt)
       } else {
          $doc configure -foreground $GUI($opt)
       }
   }

}

proc SetTitlebarColor {opt w w2} {
   global GUI wid   
   set tmpCOL [tk_chooseColor -initialcolor $GUI($opt) -title [mc "Please choose a color:"] -parent $w2]
   if {$tmpCOL==""} { return }
   $w config -foreground $tmpCOL
   set GUI($opt) $tmpCOL
   ConfigTitleColor $opt 
}

proc SetColor {name font ini w} {
 global colsTXT
 set tmpCOL [tk_chooseColor -initialcolor $ini -title [mc "Please choose a color:"] -parent $w]
 if {$tmpCOL==""} { return }
 set colsTXT($name) $tmpCOL
 $font configure -foreground $colsTXT($name)

}

proc MoveButtonBar {where b} {
    global GUI
    if {$where==$GUI(buttonbar)&&$b} {return}
    if {![winfo exists .main]} {return}
    destroy .buttonscroll
    if {$where=="bottom"} {
       xscrollbar .buttonscroll -command [list .buttonbar.buttonbar_scrollbox xview] -orient horizontal
       grid config .main -row 2
       grid config .status -row 5
       grid config .buttonbar  -column 0 -row 3 
       grid config .buttonscroll  -column 0 -row 4 -sticky snew
       autoscroll .buttonscroll

       grid rowconfigure . 2 -weight 1
       grid rowconfigure . 3 -weight 0
       grid rowconfigure . 4 -weight 0
       grid rowconfigure . 0 -weight 0
       grid rowconfigure . 1 -weight 0
       grid rowconfigure . 5 -weight 0
       UpdateScrollBox
       set GUI(buttonbar) "bottom"        
    } else {
       xscrollbar .buttonscroll -command [list .buttonbar.buttonbar_scrollbox xview] -orient horizontal
       grid config .main -row 4
       grid config .status -row 5
       grid config .buttonbar  -column 0 -row 2 
       grid config .buttonscroll  -column 0 -row 3 -sticky snew
       autoscroll .buttonscroll
       grid rowconfigure . 2 -weight 0
       grid rowconfigure . 3 -weight 0
       grid rowconfigure . 4 -weight 1
       grid rowconfigure . 5 -weight 0
       grid rowconfigure . 0 -weight 0
       grid rowconfigure . 1 -weight 0
       UpdateScrollBox
       set GUI(buttonbar) "top"        
    }    
    SaveGUISettings
}


proc SetMircColor {i label w} {
 global MIRCcols
 set tmpCOL [tk_chooseColor -initialcolor $MIRCcols($i) -title [mc "Please choose a color:"] -parent $w]
 if {$tmpCOL==""} { return }
 set MIRCcols($i) $tmpCOL
 $label configure -background $MIRCcols($i)

}

proc DefaultMircColors {label} {
 global MIRCcols
 set MIRCcols(0) #ffffff
 set MIRCcols(1) #000000
 set MIRCcols(2) #00007F
 set MIRCcols(3) #009000
 set MIRCcols(4) #FF0000
 set MIRCcols(5) #7F0000
 set MIRCcols(6) #9F009F
 set MIRCcols(7) #FF7F00
 set MIRCcols(8) #FFFF00
 set MIRCcols(9) #00F800
 set MIRCcols(10) #00908F
 set MIRCcols(11) #00FFFF
 set MIRCcols(12) #0000FF
 set MIRCcols(13) #FF00FF
 set MIRCcols(14) #7F7F7F
 set MIRCcols(15) #CFD0CF

 for {set x 0} {$x <= 15} {incr x} {
   $label$x configure -background $MIRCcols($x)
 }

}


proc SetSelColor {name font ini w} {
 global GUI
 set tmpCOL [tk_chooseColor -initialcolor $ini -title [mc "Please choose a color:"] -parent $w]
 if {$tmpCOL==""} { return }
 set GUI($name) $tmpCOL
 $font configure -foreground $GUI($name)
 ConfigSetColor . "-$name" $GUI($name)
}

proc ConfigSetColor {s option color} {
  foreach w  [winfo children $s] {

     if {[lsearch "Text Entry Listbox" [winfo class $w]]!=-1} {
       $w configure $option "$color"
     } elseif {[winfo class $w]=="Menu"} {
       regsub {select} $option {active} option2
       $w configure $option2 "$color"
     } elseif {[winfo class $w]=="Combobox"} {
       $w configure $option "$color"
     }
     ConfigSetColor $w $option $color
  }
}

proc SetGround {w var class option w2} {
  global GUI

  set tmpCOL [tk_chooseColor -initialcolor $GUI($var) -title [mc "Please choose a color:"] -parent $w2]
  if {$tmpCOL==""} { return }
  set GUI($var) $tmpCOL
  $w configure -foreground $GUI($var)
  if {$class=="Scrollbar"} {return}
  ConfigGroundColor . $class $tmpCOL $option
}

proc ConfigGroundColor {s class color option} {

  foreach w [winfo children $s] {
     if {[winfo class $w]==$class&&$w!=".status.msg"&&([string match "*canale*-*" $w]||[string match "*status*" $w])} {
       $w configure $option "$color"
     } elseif {$class=="Listbox"&&[winfo class $w]=="Mclistbox"&&([string match "*canale*-*" $w]||[string match "*status*" $w])} {
       $w configure $option "$color"
     } elseif {[winfo class $w]=="Text"&&$class=="Entry"&&[string first "topbar.topic" $w]!=-1} {
       $w configure $option "$color"
     } elseif {[winfo class $w]=="Label"&&$class=="Entry"&&[string first ".topbar" $w]!=-1&&[string match "*canale*-*" $w]} {
       $w configure $option "$color"
     }
     if {[winfo class $w]!="Combobox"} { 
         ConfigGroundColor $w $class $color $option
     } else {
        if {$class=="Listbox"} {
          $w.top.list configure $option "$color"
        } elseif {$class=="Entry"} {
          $w configure $option "$color"
        }
     }
  }

}


proc SetFont {name w} {
 global font
 set fontTMP [dkf_chooseFont -initialfont $font($name) -parent ".conf"]
 if {$fontTMP==""} {return}
 set font($name) $fontTMP
 $w configure -font $font($name)

 switch $name {
   "n"		{set class "Text"}
   "label"	{set class "Label"}
   "entry"	{set class "Entry"}
   "listbox"	{set class "Listbox"}
   "button"	{set class "Button"}
   "menu"	{
   			ConfigFont Menubutton $fontTMP "."
   			set class "Menu"
   		}
 }
 
 ConfigFont $class $fontTMP "."

}


proc ConfigFont {class font s} {
  global wid
  foreach w  [winfo children $s] {

     if {[winfo class $w]==$class&&([string match "*canale*-*" $w]||[string match "*status*" $w]||$class=="Menu"||$class=="Menubutton")} {
        if {![catch {winfo class [string range $w 0 end-6]} c]} {
           if {$c=="Combobox"} {continue}
        }
        $w configure -font "$font"
        puts "w: $w  ---  class: [winfo class $w] --- font: $font"
     }

     if {[winfo class $w]!="Mclistbox"&&[winfo class $w]!="Combobox"} {ConfigFont $class $font $w}
  }
}

proc SetIncoming {w} {
  global files me
  set tmp [tk_chooseDirectory -initialdir $files(incoming) -parent $w]
  if {$tmp!=""} {
    set files(incoming) $tmp
    if {[::platform::isPlatformWindows]} {
      $w.t config -text [ShortenEnd $files(incoming) 40]
    }
    if {[::platform::isPlatformWindows]} {
      $w.t config -text [ShortenEnd [file join $me(path) $files(incoming)] 40]
    }
  }
}

proc SetBrowser { w } {
    global files
    set file [tk_getOpenFile -initialdir [pwd] -title [mc "Select Browser"] -parent $w]
    if {$file!=""} {
      set files(browser) $file

    }
}

proc SetHighlightC {w} {
 global misc
 set tmp [tk_chooseColor -initialcolor $misc(highlightc) -title [mc "Please choose a color:"] -parent $w]
 if {$tmp==""} { return }
 set misc(highlightc) $tmp
}




proc AddIgnoreWin {ig} {
  global im_ok im_cancel GUI font
  set w ".newignorenick"
  if {[winfo exists $w]} {return}
  toplevel $w -class Config
  wm geometry $w +131+100
  wm resizable $w 0 0
  wm title $w [mc "New Ignore"]
  wm transient $w .conf

  set f [LabelFrame:create $w.not -text [mc "New Ignore:"] -ipadx 10 -ipady 15]

  frame $w.bottom
  label $f.mask   -text [mc "Mask or Nick to Ignore:"]
  label $f.flags  -text [mc Flags:]
  entry $f.emask  -background white -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground)
  entry $f.eflags -background white -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground) -vcmd "CheckFlags %W %S %d" -validate key

  xbutton $w.bottom.ok -image $im_ok -side left -text [mc Ok] -command "NewIgnore $w $f $ig"  -font $font(button)
  xbutton $w.bottom.cancel -image $im_cancel -side left -text [mc Cancel] -command "destroy $w"  -font $font(button)

  grid $w.not -column 0 -row 0 -sticky "snew" -padx 10 -pady 10
  xgrid $w.bottom 0 1 1 1 "snew"

  pack $w.bottom.ok $w.bottom.cancel -side left -padx 15 -pady 10

   grid $f.mask -column 0 -row 0 -sticky "sne" -pady 2
   grid $f.emask -column 1 -row 0 -sticky "snw" -pady 2
   grid $f.flags -column 0 -row 1 -sticky "sne" -pady 2
   grid $f.eflags -column 1 -row 1 -sticky "snw" -pady 2

   bind $w <Return> "NewIgnore $w $f $ig"
   bind $w <Escape> "destroy $w"
   catch {grab $w}
   focus $f.emask
}

proc CheckFlags {w s d} {
  if {$d==1} {
    switch $s {
      "q" {return 1}
      "n" {return 1}
      "c" {return 1}
      "d" {return 1}
      "a" {return 1}
      "default" {
         tk_messageBox -message [format [mc "Only the following ignore flags%s(or a combination of them) are allowed:"] \n]


            a = all
            q = query
            n = notice
            c = CTCP
            d = DCC
         
         return 0
      }
    }  
  } else {
    return 1
  }
}

proc AddSockWin {f} {
  global im_ok im_cancel GUI font
  set w ".newsocksvr"
  if {[winfo exists $w]} {return}
  toplevel $w -class Config
  wm geometry $w +131+100
  wm resizable $w 0 0
  wm title $w [mc "New SOCK5 Server"]
  wm transient $w .conf

  set g [LabelFrame:create $w.not -text [mc "New SOCK5 Server"]: -ipadx 10 -ipady 20]

  frame $w.bottom
  label $g.host -text [mc Host]
  label $g.port -text [mc Port]
  label $g.user -text [mc Username]
  label $g.pass -text [mc Password]

  entry $g.ehost  -background white -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground)
  [entry $g.eport -background white -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground)] insert end 1080
  entry $g.euser  -background white -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground)
  entry $g.epass  -background white -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground)

  xbutton $w.bottom.ok -image $im_ok -side left -text [mc Ok] -command "NewSock $w $f $g" -font $font(button)
  xbutton $w.bottom.cancel -image $im_cancel -side left -text [mc Cancel] -command "destroy $w" -font $font(button)

  grid $w.not -column 0 -row 0 -sticky "snew" -padx 10 -pady 10
  xgrid $w.bottom 0 1 1 1 "snew"	        	

  pack $w.bottom.ok $w.bottom.cancel -side left -padx 15 -pady 10

   grid $g.host  -column 0 -row 0 -sticky "snw" -pady 2	        	
   grid $g.ehost -column 1 -row 0 -sticky "snw" -pady 2
   grid $g.port  -column 0 -row 1 -sticky "snw" -pady 2	        	
   grid $g.eport -column 1 -row 1 -sticky "snw" -pady 2	        	
   grid $g.user  -column 0 -row 2 -sticky "snw" -pady 2	        	
   grid $g.euser -column 1 -row 2 -sticky "snw" -pady 2	        	
   grid $g.pass  -column 0 -row 3 -sticky "snw" -pady 2
   grid $g.epass -column 1 -row 3 -sticky "snw" -pady 2	        	
   bind $w <Escape> "destroy $w"
   bind $w <Return> "NewSock $w $f $g"
   wm withdraw $w
   wm deiconify $w
   catch {grab $w}
   focus $g.ehost
}


proc NewNotifyNickWin {lb} {
  global im_ok im_cancel GUI font
  set w ".newnotifynick"
  if {[winfo exists $w]} {return}
  toplevel $w -class Config
  wm geometry $w +131+100
  wm resizable $w 0 0
  wm title $w [mc "New Notify Nick:"]
  wm transient $w .
  
  
  set f [LabelFrame:create $w.not -text [mc "Notify Nick:"] -ipadx 10 -ipady 20]
  frame $w.bottom
  label $f.nick  -text [mc "Nick Name"]
  label $f.desc  -text [mc Description]
  entry $f.enick -background white -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground)
  entry $f.edesc -background white -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground)

  xbutton $w.bottom.ok -image $im_ok -side left -text [mc Ok] -command "NewNotifyNick $w $lb $f"  -font $font(button)
  xbutton $w.bottom.cancel -image $im_cancel -side left -text [mc Cancel] -command "destroy $w"  -font $font(button)

  grid $w.not -column 0 -row 0 -sticky "snew" -pady 15 -padx 10
  xgrid $w.bottom 0 1 1 1 "snew"

  pack $w.bottom.ok $w.bottom.cancel -side left -padx 15 -pady 10

   grid config $f.nick -column 0 -row 0 \
	-columnspan 1 -rowspan 1 -sticky "snw" -pady 5
   grid config $f.enick -column 1 -row 0 \
	-columnspan 1 -rowspan 1 -sticky "snw" -pady 5
   grid config $f.desc -column 0 -row 1 \
	-columnspan 1 -rowspan 1 -sticky "snw" -pady 5
   grid config $f.edesc -column 1 -row 1 \
	-columnspan 1 -rowspan 1 -sticky "snw" -pady 5

   bind $w <Return> "NewNotifyNick $w $lb $f"
   bind $w <Escape> "destroy $w"

   wm withdraw $w
   wm deiconify $w
   catch {grab $w}
   focus $f.enick
}


proc NewSock {w f g} {
  global me files active colsTXT icons

  set host [$g.ehost get]
  set port [$g.eport get]
  set user [$g.euser get]
  set pass [$g.epass get]

  if {$host==""} { return }
  if {$port==""} { set port "1080" }

  if {[catch {open $files(socks) a+} fd]} {
     if {$icons(show)} {ImageText $active prog}
     NormalText $active $fd $colsTXT(prog) 1
     return
  }

  puts $fd "$host $port $user $pass"
  catch {close $fd}
  destroy $w
  FillSock $f
}



proc NewIgnore {w f ig} {
  global me files active colsTXT icons

  set mask [$f.emask get]
  set flags [$f.eflags get]

  if {$mask==""} { return }
  if {$flags==""} { set flags "a" }

  if {[catch {open $files(ignore) a+} fd]} {
     if {$icons(show)} {ImageText $active($me(id)) prog}
     NormalText $active($me(id)) $fd $colsTXT(prog) 1
     return
  }

  puts $fd "$mask $flags"
  catch {close $fd}
  destroy $w
  FillIgnore $ig 
}


proc NewNotifyNick {w lb f} {
  global me files active colsTXT icons

  set nick [$f.enick get]
  set desc [$f.edesc get]

  if {$nick==""} { return }
  if {$desc==""} { return }

  if {[catch {open $files(notify) a+} fd]} {
     if {$icons(show)} {ImageText $active($me(id)) prog}
     NormalText $active($me(id)) $fd $colsTXT(prog) 1
     return
  }

  puts $fd "$nick $desc"
  catch {close $fd}
  destroy $w
  AddNotifyNicks $lb
  LoadNotifyList
}


proc DelSock {w} {
  global colsTXT me active files icons

  if {[catch {open $files(socks) r} fd]} {
     if {$icons(show)} {ImageText $active($me(id)) prog}
     NormalText $active($me(id)) $fd $colsTXT(prog) 1
     return
  }
  catch {set sel [$w.socks curselection]}
  if {$sel==""} {return}

  set host [lindex [$w.socks get $sel] 0]
  set socks [split [read $fd] \n]
  catch {close $fd}

  if {[catch {open $files(socks) w+} fd]} {
     if {$icons(show)} {ImageText $active($me(id)) prog}
     NormalText $active($me(id)) $fd $colsTXT(prog) 1
     return
  }

  foreach line $socks  {
    if {[lindex $line 0]!=$host} {
       puts $fd $line
    }
  }
  $w.socks delete $sel
  incr sel -1
  if {$sel==-1} {set sel 0}
  catch {
     $w.socks selection set $sel

  }
  catch {close $fd}
}


proc DelIgnore {w} {
  global colsTXT me active files icons

  if {[catch {open $files(ignore) r} fd]} {
     if {$icons(show)} {ImageText $active($me(id)) prog}
     NormalText $active($me(id)) $fd $colsTXT(prog) 1
     return
  }
  set sel [$w curselection]
  if {$sel==""} {return}

  set mask [lindex [$w get $sel] 0]
  set mask [convert_nick $mask]
  set ignores [split [read $fd] \n]
  catch {close $fd}

  if {[catch {open $files(ignore) w+} fd]} {
     if {$icons(show)} {ImageText $active($me(id)) prog}
     NormalText $active($me(id)) $fd $colsTXT(prog) 1
     return
  }

  foreach line $ignores  {
    if {[lindex $line 0]!=$mask} {
       puts $fd $line
    }
  }
  $w delete $sel
  $w selection set 0
  catch {close $fd}
}


proc DelNotifyNick {w} {
  global colsTXT me active files icons

  if {[catch {open $files(notify) r} fd]} {
     if {$icons(show)} {ImageText $active($me(id)) prog}
     NormalText $active($me(id)) $fd $colsTXT(prog) 1
     return
  }
  catch {set sel [$w curselection]}
  if {$sel==""} {return}

  set nick [lindex [$w get $sel] 0]
  set nicks [split [read $fd] \n]
  catch {close $fd}

  if {[catch {open $files(notify) w+} fd]} {
     if {$icons(show)} {ImageText $active($me(id)) prog}
     NormalText $active($me(id)) $fd $colsTXT(prog) 1
     return
  }

  foreach line $nicks  {
    if {[lindex $line 0]!=$nick} {
       puts $fd $line
    }
  }
  $w delete $sel
  catch {
     $w selection set 0
  }
  catch {close $fd}
  LoadNotifyList
}

proc AddNotifyNicks {w} {
  global files colsTXT active me icons
  $w delete 0 end
  if {![file exists $files(notify)]} {return}
  if {[catch {open $files(notify) r} fd]} {
     if {$icons(show)} {ImageText $active($me(id)) prog}
     NormalText $active($me(id)) $fd $colsTXT(prog) 1
     return
  }
  set nicks [split [read $fd] \n]
  $w delete 0 end


  foreach line $nicks  {
     if {[lindex $line 0]!=""} {
      catch {$w insert end [list [lindex $line 0] [lrange $line 1 end]]}
     }
  }
  catch { close $fd }
  $w selection set 0


}



proc sort {w id} {
    set data [$w get 0 end]
    set index [lsearch -exact [$w column names] $id]

    set result [lsort -dictionary -index $index $data]

    $w delete 0 end

    eval $w insert end $result
}



proc FillSock {w} {
  global files me colsTXT active
  if {[catch {open $files(socks) r} fd]} {
     if {[catch {open $files(socks) w} fd]} {
       catch {puts [format [mc "Cannot create SOCK5 file: %s"] $fd]}
      return
     }
     return
  }

  set socks [split [read $fd] \n]
  $w.socks delete 0 end


  foreach line $socks  {
     if {[lindex $line 0]!=""} {
      catch {$w.socks insert end [list [lindex $line 0] [lindex $line 1] [lindex $line 2] [lindex $line 3]]}
     }
  }
  catch { close $fd }
  $w.socks selection set 0

}


proc FillIgnore {w} {
  global files colsTXT active me icons
  if {[catch {open $files(ignore) r} fd]} {
     if {$icons(show)} {ImageText $active($me(id)) prog}
     NormalText $active($me(id)) $fd $colsTXT(prog) 1
     return
  }
  set ignores [split [read $fd] \n]
  $w.ignore delete 0 end


  foreach line $ignores  {
     if {[lindex $line 0]!=""} {
      catch {$w.ignore insert end [list [reverse_nick [lindex $line 0]] [lindex $line 1]]}
     }
  }
  catch { close $fd }
  $w.ignore selection set 0


}



proc FillNetwork {w} {
  global active me files colsTXT icons

  if {[catch {open $files(servers) r} fd]} {
     if {[catch {open $files(servers) w} fd]} {
         if {$icons(show)} {ImageText $active($me(id)) prog}
         NormalText $active($me(id)) [format [mc "Cannot create server file: %s"] $fd] $colsTXT(prog) 1
         return
     }
     return
  }
  set net ""
  set servers [split [read $fd] \n]
  foreach line $servers  {
   set network [lindex $line 2]
   if {[lsearch $net $network]==-1&&$network!=""} { lappend net $network }
  }
  set net [lsort -dictionary $net]
  for {set i 0} {$i < [llength $net]} {incr i} {
    $w list insert end [lindex $net $i]
  }

  catch { close $fd }
}



proc FillServer {w} {
  global me files colsTXT active icons
  if {[catch {open $files(servers) r} fd]} {
     if {$icons(show)} {ImageText $active($me(id)) prog}
     NormalText $active($me(id)) $fd $colsTXT(prog) 1
     return
  }

  set servers [split [read $fd] \n]
  $w.server delete 0 end

  foreach line $servers  {
    if {[lindex $line 2]==$me(network)} {
      catch {$w.server insert end [list " [lindex $line 0]" [lindex $line 1] [lrange $line 3 end]]}
    }
  }

  $w.server selection set end end

  catch { close $fd }

}

proc AddServer {w f g} {
  global me files active colsTXT icons

  set host [$g.ehost get]
  set port [$g.eport get]
  set net [$g.enet get]
  regsub -all { } $net {} net
  set desc [$g.edesc get]
  if {$host==""} { return }
  if {$port==""} { set port 6667 }
  if {$net==""} { set net [mc Unknown] }
  if {$desc==""} { set desc " " }

  if {[catch {open $files(servers) a+} fd]} {
     if {$icons(show)} {ImageText $active($me(id)) prog}
     NormalText $active($me(id)) $fd $colsTXT(prog) 1
     return
  }

  puts $fd "$host $port $net $desc"
  catch {close $fd}
  destroy $w
  set me(server) $host
  set me(port) $port
  set me(network) $net
  ClearSelection
  DefaultServer $f

}

proc ClearSelection {} {
  catch {.config.main.nb.f0.server.c.server selection clear 0 end}
}

proc AddServerWin {f} {
  global im_ok im_cancel GUI font me
  set w ".newsvr"
  if {[winfo exists $w]} {return}
  toplevel $w -class Config
  wm geometry $w +131+100
  wm resizable $w 0 0
  wm title $w [mc "New Server"]
  wm transient $w .conf
  set g [LabelFrame:create $w.svr -text [mc "Server Details:"] -ipadx 10 -ipady 20]

  frame $w.bottom
  label $g.host -text [mc Host]:
  label $g.port -text [mc Port]:
  label $g.net  -text [mc Network]:
  label $g.desc -text [mc Description]:
  entry $g.ehost -background white -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground)
  entry $g.eport -background white -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground)
  combobox::combobox $g.enet -editable 1 -width 18 -background white -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground)
  $g.enet insert 0 $me(network)
  entry $g.edesc -background white -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground)

  xbutton $w.bottom.ok -image $im_ok -side left -text [mc Ok] -command "AddServer $w $f $g"  -font $font(button)
  xbutton $w.bottom.cancel -image $im_cancel -side left -text [mc Cancel] -command "destroy $w"  -font $font(button)

  grid $w.svr -column 0 -row 0 -sticky "snew" -padx 10 -pady 10	        	 
  xgrid $w.bottom 0 1 1 1 "snew"	        	

  pack $w.bottom.ok $w.bottom.cancel -side left -padx 15 -pady 10

   grid $g.host  -column 0 -row 0 -sticky "sne" -pady 2
   grid $g.ehost -column 1 -row 0 -sticky "snw" -pady 2	        	
   grid $g.port  -column 0 -row 1 -sticky "sne" -pady 2	        	
   grid $g.eport -column 1 -row 1 -sticky "snw" -pady 2
   grid $g.net   -column 0 -row 2 -sticky "sne" -pady 2	        	
   grid $g.enet  -column 1 -row 2  -sticky "snw" -pady 2	        	
   grid $g.desc  -column 0 -row 3 -sticky "sne" -pady 2
   grid $g.edesc -column 1 -row 3 -sticky "snw" -pady 2
   bind $w <Escape> "destroy $w"
   bind $w <Return> "AddServer $w $f $g"
   FillNetwork $g.enet
   wm withdraw $w
   wm deiconify $w
   catch {grab $w }
   focus $g.ehost
}


proc DeleteServer {w} {
  global colsTXT me active files icons

  if {[catch {open $files(servers) r} fd]} {
     if {$icons(show)} {ImageText $active($me(id)) prog}
     NormalText $active($me(id)) $fd $colsTXT(prog) 1
     return
  }
  catch {set i [$w.server curselection]}
  if {$i==""} {return}
  set sel [$w.server get $i]
  set svr "[lindex $sel 0] [lindex $sel 1] $me(network) [lindex $sel 2]"

  set servers [split [read $fd] \n]
  catch {close $fd}

  if {[catch {open $files(servers) w+} fd]} {
     if {$icons(show)} {ImageText $active($me(id)) prog}
     NormalText $active($me(id)) $fd $colsTXT(prog) 1
     return
  }

  foreach line $servers  {
    if {$line==""} {continue}
    if {[string compare -nocase [string trim $line] [string trim $svr]]!=0} {      
       puts $fd $line
    }
  }
  $w.server delete $i
  incr i -1
  if {$i==-1} {set i 0}
  catch {
     $w.server selection set $i
  }

  if {$me(server)==[lindex $svr 0]&&$me(network)==[lindex $svr 2]} {
     set me(server) ""
     set me(network) ""	
  }
  catch {close $fd}
}


proc DefaultServer {w} {
  global me files colsTXT icons

  if {$me(server)==""} {return}

  if {[catch {open $files(servers) r} fd]} {
     if {$icons(show)} {ImageText $active($me(id)) prog}
     NormalText $active($me(id)) $fd $colsTXT(prog) 1
     return
  }

  set servers [split [read $fd] \n]
  set isin 0
  foreach line $servers  {
    if {[lindex $line 0]==$me(server)} {
       set me(network) [lindex $line 2]
       set isin 1
       FillServer $w
       break
    }
  }

  catch { close $fd }

  if {!$isin} {
    set me(network) Unknown
    catch {$w.server insert end [list $me(server) $me(port) " "]}

    if {[catch {open $files(servers) a} fd]} {
     NormalText $active($me(id)) $fd $colsTXT(prog) 1
     return
    }
    catch { puts $fd "$me(server) $me(port) $me(network) " }
    catch { close $fd }
  }
  set svrlst ""
  for {set i 0} {$i < [$w.server size]} {incr i} {
    lappend svrlst [string trim [lindex [$w.server get $i] 0]]
  }
  set svrlst [join $svrlst]
  set svrind [lsearch $svrlst $me(server)]
  $w.server selection clear 0 end
  after 10 "$w.server selection set $svrind;$w.server see $svrind"
}



proc DefaultSock {w} {
  global me files colsTXT

  set svrlst [$w.socks get 0 end]
  set svrind [lsearch $svrlst $me(sock5svr)]
  catch {$w.s1 selection clear 0 end}
  catch {$w.s2 selection clear 0 end}
  catch {$w.s3 selection clear 0 end}
  catch {$w.s4 selection clear 0 end}

  $w.socks selection set $svrind

}

proc SaveSettings {} {
 global script me files colsTXT active font act clientMSG misc DCC GUI MIRCcols icons mp3
 if {$misc(traymin)&&!$misc(trayuse)} {
   set misc(traymin) 0
 }

 if {[::platform::isPlatformWindows]} {
   PutTray
 }
 
 if {![catch {.conf.f.nb.f0.f.f.f.server curselection} svrind]} {
   if {$svrind!=""} {
     set me(server) [string trim [lindex [.conf.f.nb.f0.f.f.f.server get $svrind] 0]]
   }
 }

 if {![catch {.conf.f.nb.f1.f.f.f.socks curselection} sckind]} {
   if {$sckind!=""} {
     set me(sock5svr) [lindex [.conf.f.nb.f1.f.f.f.socks get $sckind] 0]
     set me(sock5port) [lindex [.conf.f.nb.f1.f.f.f.socks get $sckind] 1]
     set me(sock5user) [lindex [.conf.f.nb.f1.f.f.f.socks get $sckind] 2]
     set me(sock5pass) [lindex [.conf.f.nb.f1.f.f.f.socks get $sckind] 3]
   }
 }


 if {[catch {open $files(settings) w} fd]} {
     if {$icons(show)} {ImageText $active($me(id)) prog}
     NormalText $active($me(id)) $fd $colsTXT(prog) 1
     return
 }
 puts $fd "me(encoding) $me(encoding)"
 puts $fd "me(lang) $me(lang)"
 puts $fd "me(server) $me(server)"
 puts $fd "me(network) $me(network)"
 puts $fd "me(port) $me(port)"
 puts $fd "me(nick) $me(nick)"
 puts $fd "me(altnick) $me(altnick)"
 puts $fd "me(userid) $me(userid)"
 puts $fd "me(realname) $me(realname)"
 puts $fd "me(sock5svr) $me(sock5svr)"
 puts $fd "me(sock5port) $me(sock5port)"
 puts $fd "me(sock5user) $me(sock5user)"
 puts $fd "me(sock5pass) $me(sock5pass)"
 puts $fd "me(sock5use) $me(sock5use)"
 puts $fd "act(nick) $act(nick)"
 puts $fd "act(whois) $act(whois)"
 puts $fd "act(notice) $act(notice)"
 puts $fd "act(ctcp) $act(ctcp)"
 puts $fd "act(invite) $act(invite)"
 puts $fd "act(notify) $act(notify)"
 puts $fd "clientMSG(part) $clientMSG(part)"
 puts $fd "clientMSG(quit) $clientMSG(quit)"
 puts $fd "clientMSG(kick) $clientMSG(kick)"
 puts $fd "clientMSG(userinfo) $clientMSG(userinfo)"
 puts $fd "clientMSG(away) $clientMSG(away)"
 puts $fd "misc(rejoin) $misc(rejoin)"
 puts $fd "misc(join) $misc(join)"
 puts $fd "misc(invite) $misc(invite)"
 puts $fd "misc(ncompl) $misc(ncompl)"
 puts $fd "misc(completion) $misc(completion)"
 puts $fd "misc(notify) $misc(notify)"
 puts $fd "misc(notifyupdate) $misc(notifyupdate)"
 puts $fd "misc(ping) $misc(ping)"
 puts $fd "misc(timestamp) $misc(timestamp)"
 puts $fd "misc(logchat) $misc(logchat)"
 puts $fd "misc(logchannel) $misc(logchannel)"
 puts $fd "misc(logquery) $misc(logquery)"
 puts $fd "misc(trunclog) $misc(trunclog)"
 puts $fd "misc(connect) $misc(connect)"
 puts $fd "misc(splitter) $misc(splitter)"
 puts $fd "misc(history) $misc(history)"
 puts $fd "misc(historycmd) $misc(historycmd)"
 puts $fd "misc(short) $misc(short)"
 puts $fd "misc(address) $misc(address)"
 puts $fd "misc(highlight) $misc(highlight)"
 puts $fd "misc(highlightc) $misc(highlightc)"
 puts $fd "misc(showtopic) $misc(showtopic)"
 puts $fd "misc(urlscol) $misc(urlscol)"
 puts $fd "misc(traymin) $misc(traymin)"
 puts $fd "misc(trayuse) $misc(trayuse)"
 puts $fd "misc(chanpopup) $misc(chanpopup)"
 puts $fd "misc(logtimestamp) $misc(logtimestamp)"
 puts $fd "misc(buffer_limit) $misc(buffer_limit)"
 puts $fd "misc(buffer_lines) $misc(buffer_lines)"
 if {[::platform::isPlatformUnix]} {
   puts $fd "misc(downloads) $misc(downloads)"
   puts $fd "misc(open_files) $misc(open_files)" 
 }
 puts $fd "DCC(passive) $DCC(passive)"
 puts $fd "DCC(sock5) $DCC(sock5)"
 puts $fd "DCC(autoclose_get) $DCC(autoclose_get)"
 puts $fd "DCC(autoclose_send) $DCC(autoclose_send)"
 puts $fd "DCC(block) $DCC(block)"
 puts $fd "DCC(ignoreSend) $DCC(ignoreSend)"
 puts $fd "DCC(ignoreChat) $DCC(ignoreChat)"
 puts $fd "DCC(acceptSend) $DCC(acceptSend)"
 puts $fd "DCC(acceptChat) $DCC(acceptChat)"
 puts $fd "DCC(minimize_send) $DCC(minimize_send)"
 puts $fd "DCC(fserve_menu) $DCC(fserve_menu)"
 puts $fd "DCC(reject) $DCC(reject)"
 puts $fd "DCC(trust) $DCC(trust)"
 puts $fd "DCC(ifexist) $DCC(ifexist)"
 puts $fd "DCC(trusted) $DCC(trusted)"
 puts $fd "DCC(autoopen) $DCC(autoopen)"
 puts $fd "files(defaultdir) $files(defaultdir)"
 puts $fd "files(incoming) $files(incoming)"
 puts $fd "files(browser) $files(browser)"
 puts $fd "GUI(listbox_ratio) $GUI(listbox_ratio)"
 puts $fd "GUI(geometry) $GUI(geometry)"
 puts $fd "GUI(tooltips) $GUI(tooltips)"
 puts $fd "GUI(properties) $GUI(properties)"
 puts $fd "GUI(maximized) $GUI(maximized)"
 puts $fd "MIRCcols(win) $MIRCcols(win)"
 puts $fd "MIRCcols(preview) $MIRCcols(preview)"
 puts $fd "icons(show) $icons(show)"
 puts $fd "me(colbut) $me(colbut)"
 for {set i 0} { $i < 16} {incr i} {
   puts $fd "MIRCcols($i) $MIRCcols($i)"
 }
 puts $fd "mp3(lists) $mp3(lists)"
 puts $fd "mp3(list) $mp3(list)"
 puts $fd "mp3(mode) $mp3(mode)"
 puts $fd "mp3(verbose) $mp3(verbose)"
 puts $fd "script(functions) $script(functions)"
 puts $fd "script(events) $script(events)"
 puts $fd "script(variables) $script(variables)"
 foreach n {variables popups functions events} {
   if {[info exists script(last,$n)]} {
      puts $fd "script(last,$n) $script(last,$n)"
   }
 }

 puts $fd "me(ident_port) $me(ident_port)"
 puts $fd "me(ident_system) $me(ident_system)"
 puts $fd "me(ident_connect) $me(ident_connect)"
 puts $fd "me(ident_use) $me(ident_use)"
 puts $fd "me(ident_show) $me(ident_show)"
 puts $fd "GUI(theme) $GUI(theme)"
 catch {close $fd}
 SaveGUISettings
 LoadNotifyList
 LoadIgnoreList
}


proc SaveGUISettings {} {
 global script me files colsTXT active font act clientMSG misc DCC GUI MIRCcols icons mp3

 if {[catch {open $GUI(theme) w} fd]} {
   if {$icons(show)} {ImageText $active($me(id)) prog}
   NormalText $active($me(id)) $fd $colsTXT(prog) 1
   return
 }

 puts $fd "colsTXT(prog) $colsTXT(prog)"
 puts $fd "colsTXT(raw) $colsTXT(raw)"
 puts $fd "colsTXT(serv) $colsTXT(serv)"
 puts $fd "colsTXT(chan) $colsTXT(chan)"
 puts $fd "colsTXT(mechan) $colsTXT(mechan)"
 puts $fd "colsTXT(query) $colsTXT(query)"
 puts $fd "colsTXT(mequery) $colsTXT(mequery)"
 puts $fd "colsTXT(chat) $colsTXT(chat)"
 puts $fd "colsTXT(mechat) $colsTXT(mechat)"
 puts $fd "colsTXT(notice) $colsTXT(notice)"
 puts $fd "colsTXT(whois) $colsTXT(whois)"
 puts $fd "colsTXT(ctcp) $colsTXT(ctcp)"
 puts $fd "colsTXT(invite) $colsTXT(invite)"
 puts $fd "colsTXT(join) $colsTXT(join)"
 puts $fd "colsTXT(part) $colsTXT(part)"
 puts $fd "colsTXT(quit) $colsTXT(quit)"
 puts $fd "colsTXT(mode) $colsTXT(mode)"
 puts $fd "colsTXT(topic) $colsTXT(topic)"
 puts $fd "colsTXT(kick) $colsTXT(kick)"
 puts $fd "colsTXT(ban) $colsTXT(ban)"
 puts $fd "colsTXT(action) $colsTXT(action)"
 puts $fd "colsTXT(dns) $colsTXT(dns)"
 puts $fd "colsTXT(nick) $colsTXT(nick)"
 puts $fd "colsTXT(motd) $colsTXT(motd)"
 puts $fd "colsTXT(notify) $colsTXT(notify)"
 puts $fd "font(n) $font(n)"
 puts $fd "font(listbox) $font(listbox)"
 puts $fd "font(entry) $font(entry)"
 puts $fd "font(label) $font(label)"
 puts $fd "font(button) $font(button)"
 puts $fd "font(menu) $font(menu)"
 puts $fd "GUI(scrollbar_bg) $GUI(scrollbar_bg)"
 puts $fd "GUI(scrollbar_slider) $GUI(scrollbar_slider)"
 puts $fd "GUI(scrollbar_gradient1) $GUI(scrollbar_gradient1)"
 puts $fd "GUI(scrollbar_gradient2) $GUI(scrollbar_gradient2)"
 puts $fd "GUI(selectforeground) $GUI(selectforeground)"
 puts $fd "GUI(selectbackground) $GUI(selectbackground)"
 puts $fd "GUI(titlebar) $GUI(titlebar)"
 puts $fd "GUI(tforeground) $GUI(tforeground)"
 puts $fd "GUI(entry_bg) $GUI(entry_bg)"
 puts $fd "GUI(listbox_bg) $GUI(listbox_bg)"
 puts $fd "GUI(text_bg) $GUI(text_bg)"
 puts $fd "GUI(entry_fg) $GUI(entry_fg)"
 puts $fd "GUI(listbox_fg) $GUI(listbox_fg)"
 puts $fd "GUI(text_fg) $GUI(text_fg)"
 puts $fd "GUI(file_IconMin) $GUI(file_IconMin)"
 puts $fd "GUI(file_IconMax) $GUI(file_IconMax)"
 puts $fd "GUI(file_IconClose) $GUI(file_IconClose)"
 puts $fd "GUI(file_IconRestore) $GUI(file_IconRestore)"
 puts $fd "GUI(file_IconMin_pressed) $GUI(file_IconMin_pressed)"
 puts $fd "GUI(file_IconMax_pressed) $GUI(file_IconMax_pressed)"
 puts $fd "GUI(file_IconClose_pressed) $GUI(file_IconClose_pressed)"
 puts $fd "GUI(file_IconRestore_pressed) $GUI(file_IconRestore_pressed)"
 puts $fd "GUI(file_IconMin_over) $GUI(file_IconMin_over)"
 puts $fd "GUI(file_IconMax_over) $GUI(file_IconMax_over)"
 puts $fd "GUI(file_IconClose_over) $GUI(file_IconClose_over)"
 puts $fd "GUI(file_IconRestore_over) $GUI(file_IconRestore_over)"
 puts $fd "GUI(buttonbar) $GUI(buttonbar)"
 puts $fd "GUI(background) $GUI(background)"
 puts $fd "GUI(widgets_color) $GUI(widgets_color)" 
 puts $fd "GUI(bgimage) $GUI(bgimage)"
 puts $fd "GUI(bgimage_how) $GUI(bgimage_how)"
 catch {close $fd}
}

