
proc socks:init {sck addr port auth user pass} {
global socks_freeid socks_idlist

#  if { [catch {fconfigure $sck}] != 0 } {return "ERROR:Connection closed with Socks Server!"}    ;# Socket doesn't exist

  set ver "\x05"               ;
  if {$auth==0} {set method "\x00"; set nmethods "\x01"} \
	elseif {$auth==1} {set method "\x00\x02"; set nmethods "\x02"} \
	else {return "ERROR:"}
  set nomatchingmethod "\xFF"  ;

  set cmd_connect "\x01"  ;
  set rsv "\x00"          ;
  set atyp "\x03"         ;
  set dlen "[binary format c [string length $addr]]" ;
  set port [binary format S $port] ;

  set authver "\x01"  ;
  set ulen "[binary format c [string length $user]]"  ;
  set plen "[binary format c [string length $pass]]"  ;

  set a ""

  set socks_idlist(stat,$sck) 0
  set socks_idlist(data,$sck) ""

  fconfigure $sck -translation {binary binary} -blocking 0
  fileevent $sck readable "socks:readable $sck"

  puts -nonewline $sck "$ver$nmethods$method"
  flush $sck

  vwait socks_idlist(stat,$sck)

  set a $socks_idlist(data,$sck)
  if {[eof $sck]} {catch {close $sck}; return [mc "ERROR: Connection closed with SOCKS Server"]}

  set serv_ver ""; set method $nomatchingmethod
  binary scan $a "cc" serv_ver smethod

  if {$serv_ver!=5} {catch {close $sck}; return [mc "ERROR: SOCKS Server isn't version 5"]}

  if {$smethod==0} {} \
  elseif {$smethod==2} {  ;
	if {$auth==0} {catch {close $sck}; return [mc "ERROR: Method not supported by SOCKS Server"]}

	puts -nonewline $sck "$authver$ulen$user$plen$pass"
	flush $sck

	vwait socks_idlist(stat,$sck)
	set a $socks_idlist(data,$sck)
	if {[eof $sck]} {catch {close $sck}; return [mc "ERROR: Connection closed with SOCKS Server"]}

	set auth_ver ""; set status "\x00"
	binary scan $a "cc" auth_ver status

	if {$auth_ver!=1} {catch {close $sck}; return [mc "ERROR: Authentication isn't supported with this version"]}
	if {$status!=0} {catch {close $sck}; return [mc "ERROR: Wrong username or password"]}

  } else {
	fileevent $sck readable {}
	unset socks_idlist(stat,$sck)
	unset socks_idlist(data,$sck)
	catch {close $sck}
	return [mc "ERROR: Method not supported by SOCKS Server"]
  }

  puts -nonewline $sck "$ver$cmd_connect$rsv$atyp$dlen$addr$port"
  flush $sck

  vwait socks_idlist(stat,$sck)
  set a $socks_idlist(data,$sck)
  if {[eof $sck]} {catch {close $sck}; return [mc "ERROR: Connection closed with SOCKS Server"]}

  fileevent $sck readable {}
  unset socks_idlist(stat,$sck)
  unset socks_idlist(data,$sck)

  set serv_ver ""; set rep ""
  binary scan $a cc serv_ver rep
  if {$serv_ver!=5} {catch {close $sck}; return [mc "ERROR: SOCKS Server isn't version 5"]}

  set reply [socks:reply $rep $sck]
  if {$reply=="ok"} {fconfigure $sck -translation {auto auto}; return "OK"}
  return $reply
}

proc socks:readable {sck} {
global socks_idlist
  incr socks_idlist(stat,$sck)
  catch {set socks_idlist(data,$sck) [read $sck]}
}



proc socks:bind {sck addr port auth user pass sendsock nick file size dcc_type} {
global socks_freeid socks_idlist
  set ver "\x05"               ;
  if {$auth==0} {set method "\x00"; set nmethods "\x01"} \
	elseif {$auth==1} {set method "\x00\x02"; set nmethods "\x02"} \
	else {return "ERROR:"}
  set nomatchingmethod "\xFF"  ;

  set cmd_bind "\x02"  ;
  set rsv "\x00"          ;
  set atyp "\x03"         ;
  set dlen "[binary format c [string length $addr]]" ;
  set port [binary format S $port] ;

  set authver "\x01"  ;
  set ulen "[binary format c [string length $user]]"  ;
  set plen "[binary format c [string length $pass]]"  ;

  set a ""

  set socks_idlist(stat,$sck) 0
  set socks_idlist(data,$sck) ""
  fconfigure $sck -translation {binary binary} -blocking 0
  fileevent $sck readable "socks:readable $sck"

  puts -nonewline $sck "$ver$nmethods$method"
  flush $sck

  vwait socks_idlist(stat,$sck)

  set a $socks_idlist(data,$sck)
  if {[eof $sck]} {catch {close $sck}; return [mc "ERROR: Connection closed with SOCKS Server"]}

  set serv_ver ""; set method $nomatchingmethod
  binary scan $a "cc" serv_ver smethod

  if {$serv_ver!=5} {catch {close $sck}; return [mc "ERROR: SOCKs Server isn't version 5"]}

  if {$smethod==0} {} \
  elseif {$smethod==2} {  ;
	if {$auth==0} {catch {close $sck}; return [mc "ERROR: Method not supported by SOCKS Server"]}

	puts -nonewline $sck "$authver$ulen$user$plen$pass"
	flush $sck

	vwait socks_idlist(stat,$sck)
	set a $socks_idlist(data,$sck)
	if {[eof $sck]} {catch {close $sck}; return [mc "ERROR: Connection closed with SOCKS Server"]}

	set auth_ver ""; set status "\x00"
	binary scan $a "cc" auth_ver status

	if {$auth_ver!=1} {catch {close $sck}; return [mc "ERROR: Authentication isn't supported with this version"]}
	if {$status!=0} {catch {close $sck}; return [mc "ERROR: Wrong username or password"]}

  } else {
	fileevent $sck readable {}
	unset socks_idlist(stat,$sck)
	unset socks_idlist(data,$sck)
	catch {close $sck}
	return [mc "ERROR: Method not supported by SOCKS Server"]
  }
  puts -nonewline $sck "$ver$cmd_bind$rsv$atyp$dlen$addr$port"
  flush $sck

  vwait socks_idlist(stat,$sck)
  set a $socks_idlist(data,$sck)
  if {[eof $sck]} {catch {close $sck}; return [mc "ERROR: Connection closed with SOCKS Server"]}

  set serv_ver ""; set rep ""
  binary scan $a cccccccccc serv_ver rep rsv atyp ip1 ip2 ip3 ip4 port1 port2

  if {$serv_ver!=5} {catch {close $sck}; return [mc "ERROR: SOCKS Server isn't version 5"]}

  set reply [socks:reply $rep $sck]
  if {$reply!="ok"} {
     return $reply
  }

  set ip1 [socks:bin2dec $ip1]
  set ip2 [socks:bin2dec $ip2]
  set ip3 [socks:bin2dec $ip3]
  set ip4 [socks:bin2dec $ip4]
  set port1 [socks:bin2dec $port1]
  set port2 [socks:bin2dec $port2]
  
  if {$dcc_type=="send"} {
    puts $sendsock "PRIVMSG $nick :\001DCC SEND $file [ipPack $ip1.$ip2.$ip3.$ip4] [expr ($port1*256)+$port2] $size\001"
  } else {
    puts $sendsock "PRIVMSG $nick :\001DCC CHAT chat [ipPack $ip1.$ip2.$ip3.$ip4] [expr ($port1*256)+$port2]\001"
  }
  vwait socks_idlist(stat,$sck)
  set a $socks_idlist(data,$sck)
  unset socks_idlist(stat,$sck)
  unset socks_idlist(data,$sck)
  fconfigure $sck -translation {auto auto}
  fileevent $sck readable {}
  binary scan $a cccccccccc serv_ver rep rsv atyp ip1 ip2 ip3 ip4 port1 port2
  set reply [socks:reply $rep $sck]
  if {$reply!="ok"} {
     return $reply
  } else {
     return "ok"
  }  
}

proc socks:reply {rep sck} {
   switch $rep {
     0 {return "ok"}
     1 {catch {close $sck}; return [format [mc "ERROR: SOCKS server responded:%sGeneral SOCKS server failure"] \n]}
     2 {catch {close $sck}; return [format [mc "ERROR: SOCKS server responded:%sConnection not allowed by ruleset"] \n]}
     3 {catch {close $sck}; return [format [mc "ERROR: SOCKS server responded:%sNetwork unreachable"] \n]} 
     4 {catch {close $sck}; return [format [mc "ERROR: SOCKS server responded:%sHost unreachable"] \n]} 
     5 {catch {close $sck}; return [format [mc "ERROR: SOCKS server responded:%sConnection refused"] \n]} 
     6 {catch {close $sck}; return [format [mc "ERROR: SOCKS server responded:%sTTL expired"] \n]} 
     7 {catch {close $sck}; return [format [mc "ERROR: SOCKS server responded:%sCommand not supported"] \n]} 
     8 {catch {close $sck}; return [format [mc "ERROR: SOCKS server responded:%sAddress type not supported"] \n]} 
     "default" {catch {close $sck}; return [mc "ERROR: SOCKS server responded:%sUnknown Error"] \n]}
   }
}

proc socks:bin2dec {b} {
   return [expr ( $b + 0x100 ) % 0x100]
} 

