proc UrlsScrollX {args} {
   global wid
   catch { $wid(status).fr.tab.urls.urls $args }
}

proc RaiseWin {w} {
   global me active
       IfNotColorButton $w
       set id [GetWindowID $w]
       set active($id) $w
       set me(id) $id
       set active(status) 0
       catch {SetCurrents $me(id)}
}

proc Switch {w} {
   global wid GUI

   if {[$wid($w) cget -state]=="withdrawn"} {
        if {$GUI(maximized)} {
            set state "maximized"
        } else {
            set state "normal"
        }
        $wid($w) configure -state $state
   }

   $wid($w) raise
}

proc StartGUI {} {
 global GUI me font wid active info icons misc GUI chanmenu

 if {$GUI(maximized)} {
   set state "maximized"
 } else {
   set state "normal"
 }


 foreach {wid(x) wid(y) wid(width) wid(height)} [def_winset "status" "status"] {}
 set wid(status) [document .main.status -tooltip [mc Status] -title [mc Status] -icontext [mc Status] -image $icons(status) -active 1 -closable 0 -minsize {495 320} -state $state]
 $wid(status) pack [frame .main.status.fr] -fill both -expand 1
 set f ".main.status.fr"

 set scroll(status) 1

 tabcontrol $f.tab -width auto
 set frame $f.tab
 frame $f.top
 frame $frame.main
 frame $frame.notify
 frame $frame.urls
 frame $f.command

 $f.tab insert main 0 -text [mc Server] -window $frame.main
 $f.tab insert notify 0 -text [mc Notify List] -window $frame.notify
 $f.tab insert urls 0 -text Urls -window $frame.urls

 $f.tab invoke main
 pack $f.tab -fill both -expand 1


 text $frame.main.text -width 20 -background $GUI(text_bg) -selectbackground $GUI(selectbackground) -selectforeground $GUI(selectforeground) -font $font(n) -wrap char -yscrollcommand "$frame.main.texscroll set"
 mIRC_Text_Tag $frame.main.text

 if {[catch {$frame.main.text config -cursor $GUI(cursor)}]} {
   set GUI(cursor) "hand2"
 }

 $frame.main.text config -cursor {}
 xscrollbar $frame.main.texscroll -command "$frame.main.text yview" -orient vertical;


 xscrollbar $frame.notify.scrollist -command "$frame.notify.listbox yview"


 xmclistbox $frame.notify.listbox -width 36 -fillcolumn nick -yscrollcommand [list $frame.notify.scrollist set]

 $frame.notify.listbox column add nick -label [mc "Notify Nick"] -width 16
 $frame.notify.listbox column add server -label [mc Server] -width 20
 $frame.notify.listbox label bind nick <ButtonPress-1> "sort %W nick"
 $frame.notify.listbox label bind server <ButtonPress-1> "sort %W server"


 set flab [LabelFrame:create $frame.notify.notify -text [mc "Notify List:"]]

 frame $flab.upbar
 checkbutton $flab.upbar.notify  -text [mc "Enable Notify"] -variable misc(notify)
 combobox::combobox $flab.upbar.update -editable 0 -width 4 -textvariable misc(notifyupdate) -background $GUI(entry_bg) -foreground $GUI(entry_fg) -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground)
 $flab.upbar.update list insert end 1
 $flab.upbar.update list insert end 3
 $flab.upbar.update list insert end 5
 $flab.upbar.update list insert end 10
 $flab.upbar.update list insert end 30
 label $flab.upbar.lupdate -text [mc "Update Every Minute"]

 
 grid $flab.upbar.notify  -column 0 -row 0 -sticky nw
 grid $flab.upbar.lupdate -column 0 -row 1 -sticky nw
 grid $flab.upbar.update  -column 1 -row 1 -padx 3p -sticky nw
 

 xmclistbox $flab.lnotify -width 38 -height 4 -fillcolumn nick -yscrollcommand [list $flab.scroll set]

 $flab.lnotify column add nick -label [mc Nick] -width 14
 $flab.lnotify column add description -label [mc Description] -width 20

 xscrollbar $flab.scroll -command [list $flab.lnotify yview]


 AddNotifyNicks $flab.lnotify

 frame $flab.bar

 xbutton $flab.bar.add -image $icons(select) -side left -text [mc Add] -command "NewNotifyNickWin $flab.lnotify"
 xbutton $flab.bar.delete -image $icons(delete) -side left -text [mc Delete] -command "DelNotifyNick $flab.lnotify"

 pack $flab.bar.add -side left
 pack $flab.bar.delete -side left -padx 4

 grid config $flab.upbar -column 0 -row 0 \
	-columnspan 1 -rowspan 1 -sticky "snw" -pady 15
 grid config $flab.lnotify -column 0 -row 1 \
	-columnspan 2 -rowspan 1 -sticky "snw"
 autoscroll $flab.scroll "-in $flab -column 3 -row 1 -columnspan 1 -rowspan 1 -ipadx 0 -ipady 0 -padx 0 -pady 0 -sticky ns"
 grid config $flab.bar -column 0 -row 2 \
	-columnspan 3 -rowspan 1 -sticky "snw" -pady 5



 grid config $frame.notify.listbox -column 0 -row 0 -sticky "snew"
 autoscroll $frame.notify.scrollist "-in $frame.notify -column 1 -row 0 -columnspan 1 -rowspan 1 -ipadx 0 -ipady 0 -padx 0 -pady 0 -sticky ns"
 grid config $frame.notify.notify -column 2 -row 0 -sticky "snew"

 grid columnconfigure $frame.notify 0 -weight 1
 grid columnconfigure $frame.notify 0 -weight 0
 grid columnconfigure $frame.notify 2 -weight 1
 grid rowconfigure $frame.notify 0 -weight 1


 checkbutton $frame.urls.col  -text [mc "Color URLs as HTML links"] -variable misc(urlscol)

 xscrollbar $frame.urls.xurls  -command "UrlsScrollX xview" -orient horizontal
 xscrollbar $frame.urls.yurls  -command "$frame.urls.urls yview"

 xmclistbox $frame.urls.urls -width 30 -fillcolumn urls -yscrollcommand [list $frame.urls.yurls set] -xscrollcommand [list $frame.urls.xurls set]


 $frame.urls.urls column add urls -label URL -width 30
 $frame.urls.urls column add origin -label [mc Origin] -width 20
 $frame.urls.urls column add server -label [mc Server] -width 16

 $frame.urls.urls label bind urls <ButtonPress-1> "sort %W urls"
 $frame.urls.urls label bind origin <ButtonPress-1> "sort %W origin"
 $frame.urls.urls label bind server <ButtonPress-1> "sort %W server"


 if {[::platform::isPlatformWindows]} {
   bind $frame.urls.urls <Button-2> "url_menu $frame.urls.urls %X %Y 0"
   bind $frame.urls.urls <Button-3> "url_menu $frame.urls.urls %X %Y 0"
 }


 grid config $frame.urls.urls -column 0 -row 0 -sticky "snew"
 autoscroll $frame.urls.yurls "-in $frame.urls -column 1 -row 0 -columnspan 1 -rowspan 1 -ipadx 0 -ipady 0 -padx 0 -pady 0 -sticky ns"
 autoscroll $frame.urls.xurls "-in $frame.urls -column 0 -row 1 -columnspan 2 -rowspan 1 -ipadx 0 -ipady 0 -padx 0 -pady 0 -sticky ew"
 grid config $frame.urls.col -column 0 -row 2 -sticky "w"
 


 grid columnconfigure $frame.urls 0 -weight 1
 grid columnconfigure $frame.urls 1 -weight 0
 grid rowconfigure $frame.urls 0 -weight 1


 grid config $frame.main.text -column 0 -row 0 -sticky "snew"
 #grid config $frame.main.texscroll -column 1 -row 0 -sticky "sn"

 grid columnconfigure $frame.main 0 -weight 1
 grid columnconfigure $frame.main 0 -weight 1
 grid rowconfigure $frame.main 0 -weight 1


 grid $f.top -row 0 -column 0 -sticky snew -columnspan 1 -rowspan 1
 grid $f.tab -row 1 -column 0 -sticky snew -columnspan 1 -rowspan 1 -pady 3
 grid $f.command -row 2 -column 0 -sticky snew -columnspan 1 -rowspan 1

 grid columnconfigure $f 0 -weight 1
 grid rowconfigure $f 0 -weight 0
 grid rowconfigure $f 1 -weight 1
 grid rowconfigure $f 2 -weight 0


 combobox::combobox $f.top.info -editable 0 -textvariable info -background $GUI(entry_bg) -foreground $GUI(entry_fg) -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground) -command "UpdateCurrentServer" 

 pack $f.top.info -expand yes -fill x -side left
 xentry $f.command.command -background $GUI(entry_bg) -foreground $GUI(entry_fg)


 set wid(status,tab) $f.tab
 set wid(status,text) $frame.main.text
 set wid(status,command) $f.command.command
 set wid(status,url) $frame.urls.urls
 set wid(status,notify) $frame.notify.listbox
 set wid(status,list) $wid(status,notify)
 set wid(status,info) $f.top.info
 set wid(status,frame) $f
 set active($me(id)) "status"


 if {$me(colbut)} {
   Pack_Cols
 } else {
   pack $f.command.command -side left -expand yes -fill x
 }

 $f.tab invoke main

 $frame.main.text tag bind url <Any-Enter> "$frame.main.text configure -cursor $GUI(cursor)"
 $frame.main.text tag bind url <Any-Leave> "$frame.main.text configure -cursor {}; RemoveTags $frame.main.text; set GUI(txt_current) {}"
 $frame.main.text tag bind url <Double-1> "CaptionOpenUrl $frame.main.text; focus $frame.main.text"
 if {[::platform::isPlatformUnix]} {
   $frame.main.text tag bind url <Button-2> "set chanmenu 0;  focus $frame.main.text"
   $frame.main.text tag bind url <Button-3> "set chanmenu 0;  focus $frame.main.text"
 }
 if {[::platform::isPlatformWindows]} {
   $frame.main.text tag bind url <Button-2> "set chanmenu 0; url_menu $frame.main.text %X %Y 1; focus $frame.main.text"
   $frame.main.text tag bind url <Button-3> "set chanmenu 0; url_menu $frame.main.text %X %Y 1; focus $frame.main.text"
 }

 $frame.main.text tag bind channel <Any-Enter> "$frame.main.text configure -cursor $GUI(cursor)"
 $frame.main.text tag bind channel <Any-Leave> "$frame.main.text configure -cursor {}; RemoveTags $frame.main.text; set GUI(txt_current) {}"
 $frame.main.text tag bind channel <Double-1> "CaptionJoin $frame.main.text; focus $frame.main.text"

 bind $frame.main.text <Motion> "TextCaption %W status"
 bind $wid(status,command) <Control-k> {$wid(status,command) insert insert "\x03" ; ColorTip %X %Y ; Preview $wid(status,command); break}
 bind $wid(status,command) <Control-b> {$wid(status,command) insert insert "" ; Preview $wid(status,command); break}
 bind $wid(status,command) <Control-u> {$wid(status,command) insert insert "" ; Preview $wid(status,command); break}

 bind $wid(status,command) <Control-a> "Pack_Cols; break"

 bind $wid(status,command) <Return> { HistoryAdd "status"; get_command "status" 0; .status.msg delete 1.0 end }
 bind $wid(status,command) <Down> "HistoryGet forth {status}; .status.msg delete 1.0 end"
 bind $wid(status,command) <Up> "HistoryGet back {status}; .status.msg delete 1.0 end"
 bind $wid(status,command) <KeyPress> "SetSplitter {status}; catch {CmdHistory %K {status}}; Preview $wid(status,command)"
 bind . <KeyPress> { destroy .coltip }
 bind $wid(status,notify) <Button-2> {popup_nicklist "status" %x %y "notify" 0}
 bind $wid(status,notify) <Button-3> {popup_nicklist "status" %x %y "notify" 0}
 bind $wid(status,notify) <Double-1> "QuerySelected $wid(status,notify)"

 bind $wid(status,url) <Double-1> {OpenUrl [lindex [$wid(status,url) get [$wid(status,url) curselection]] 0]}
 bind $wid(status,text) <KeyPress> "break; return"
 bind $wid(status,text) <ButtonRelease> "Copy_Clipboard; focus $wid(status,command)"
 bind $wid(status,text) <Button-3> "popup_menu status $wid(status,text).servlist $me(id)"
 bind $wid(status,text) <Button-2> "popup_menu status $wid(status,text).servlist $me(id)"
 
 bind . <Control-c> "Copy_Clipboard"
 bind . <Control-v> "Paste_Clipboard"
 
 bind .status.msg <KeyPress> "break; return"
 bind .status.msg <Button-1> "break;focus $wid(status,command)"
 bind .status.msg <Button-3> "break;focus $wid(status,command)"
 bind $wid(status,text) <Button-1> "$wid(status) raise"
 bind $wid(status,notify) <Button-1> "$wid(status) raise"
 bind $wid(status,url) <Button-1> "$wid(status) raise"
 bind $wid(status,info) <Button-1> "$wid(status) raise"
 bind $wid(status,command) <Button-1> "$wid(status) raise"
 bind $f.tab <Button-1> "$wid(status) raise"

 bind $frame.main.texscroll <Button-1> "$wid(status) raise"
 bind $frame.main.texscroll <ButtonPress> "$wid(status) raise"
 bind $frame.main.texscroll <ButtonRelease> "ReleaseScroll $frame.main.texscroll status"

 autoscroll $frame.main.texscroll "-in .main.status.fr.tab.main -column 1 -row 0 -columnspan 1 -rowspan 1 -ipadx 0 -ipady 0 -padx 0 -pady 0 -sticky ns"


 set active($me(id)) "status"
 set active(status) 1
 focus $wid(status,command)

}

proc AutoScroll {s uno due} {
  $s set $uno $due   
  if {($uno==0&&$due==1)||($uno=="0.5"&&$due=="0.5")} {
    pack forget $s
  } else {
    pack $s -fill y -side left
  }
}

proc wincan { canale id } {
        global history GUI canali chan font me active scroll log timestamp history icons wid chanlist position chanmenu
	
        set chanpos [lsearch $canali($id) "[string tolower [Convert $canale]]"]
	if {$chanpos!=-1} {
	    return
	}
        
	set i 0
        while {[lsearch $canali($id) "canale$id-$i"]!=-1} {incr i}
        set w "canale$id-$i"
        lappend canali($id) "[string tolower [Convert $canale]]" "$w"

        set history($w) ""
        set scroll($w) 1
        set log($w) 0
        set timestamp($w) 0
        set position($w) 0

        if {$GUI(maximized)} {
          set state "maximized"
        } else {
          set state "normal"
        }
        
	set winset [def_winset $canale "canale"]
        
	foreach {wid(x) wid(y) wid(width) wid(height)} $winset {}
        if {$GUI(maximized)} {
           set wid(x) ""
           set wid(y) ""
        }
	
        set wid($w) [document .main.$w -tooltip [format [mc "%s on %s"] [Reverse $canale] $me($id,server)] -title [format [mc "%s on %s"] [Reverse $canale] $me($id,server)] -active 1 -icontext $canale -callback "part_chan $w $id" -callmenu winmenu -image $icons(channel) -state $state]

        $wid($w) pack [frame .main.$w.fr] -fill both -expand 1
        set frame ".main.$w.fr"

        frame $frame.topbar
        frame $frame.main
        frame $frame.command
        frame $frame.main.sx
        frame $frame.main.dx

        xentry $frame.command.command -background $GUI(entry_bg) -foreground $GUI(entry_fg) 
        
	text $frame.main.sx.text -width 1 -font $font(n) -selectbackground $GUI(selectbackground) -selectforeground $GUI(selectforeground) -wrap word -background $GUI(text_bg) -yscrollcommand "AutoScroll $frame.main.sx.texscroll" -takefocus 0
        
	mIRC_Text_Tag $frame.main.sx.text
        
	xscrollbar $frame.main.dx.scrolist -command "$frame.main.dx.listbox yview"
        xscrollbar $frame.main.sx.texscroll -command "$frame.main.sx.text yview" -orient vertical;
        
	listbox $frame.main.dx.listbox -width 1 -font $font(listbox) -selectmode browse -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground) -background $GUI(listbox_bg) -foreground $GUI(entry_fg) -yscrollcommand "AutoScroll $frame.main.dx.scrolist"
        label $frame.topbar.modes -font $font(label) -text [mc Modes:] -width 8 -background $GUI(entry_bg) -foreground $GUI(entry_fg) -relief sunken
        label $frame.topbar.stat -font $font(label) -textvariable chan($w,stat) -width 14 -background $GUI(entry_bg) -foreground $GUI(entry_fg) -relief sunken
        text $frame.topbar.topic -foreground $GUI(entry_fg) -background $GUI(entry_bg) -width 10 -height 1 -font $font(n) -selectbackground $GUI(selectbackground) -selectforeground $GUI(selectforeground)
        
	mIRC_Text_Tag $frame.topbar.topic
        set_balloon $frame.topbar.modes [mc "Click to get Modes Menu"]
        set_balloon $frame.topbar.topic [mc "Double-Click to Edit"]

        set wid($w,modes) $frame.topbar.modes
        set wid($w,text) $frame.main.sx.text
        set wid($w,list) $frame.main.dx.listbox
        set wid($w,command) $frame.command.command
        set wid($w,topic) $frame.topbar.topic

        if {$me(colbut)} {
          Pack_Cols
        } else {
          pack $frame.command.command -side left -expand yes -fill x
        }


        xgrid $frame.topbar 0 0 1 1 ew 
        xgrid $frame.main 0 1 1 1 snew 
        xgrid $frame.command 0 2 1 1 ew 

        grid columnconfigure $frame 0 -weight 1
        grid rowconfigure $frame 0 -weight 0
        grid rowconfigure $frame 1 -weight 1
        grid rowconfigure $frame 2 -weight 0


        pack $frame.topbar.topic -expand yes -side left -fill both
        pack $frame.topbar.modes $frame.topbar.stat -side left -fill y

        pane $frame.main.pane -width 2 -resize both
        grid $frame.main.pane -column 0 -row 0 -sticky snew

        $frame.main.pane pack first $frame.main.sx -fill both -expand yes
        $frame.main.pane pack second $frame.main.dx -fill both -expand yes

        pack $frame.main.sx.text -side left -fill both -expand yes
	pack $frame.main.dx.listbox -side left -fill both -expand yes
        
        grid columnconfigure $frame.main 0 -weight 1
        grid rowconfigure $frame.main 0 -weight 1

        $frame.topbar.topic tag bind nick <Any-Enter> "$frame.topbar.topic configure -cursor $GUI(cursor)"
	$frame.topbar.topic tag bind nick <Any-Leave> "$frame.topbar.topic configure -cursor {}; RemoveTags $frame.topbar.topic; set GUI(txt_current) {}"
	$frame.topbar.topic tag bind nick <ButtonPress> "CaptionSelectNick $w $frame.topbar.topic"
        $frame.topbar.topic tag bind nick <Double-1> "CaptionQueryNick $frame.topbar.topic;after 10 {ToggleEdit $w $id 0}"
        $frame.topbar.topic tag bind nick <Button-2> "set chanmenu 0; CaptionNicklist $frame.topbar.topic $w %x %y"
	$frame.topbar.topic tag bind nick <Button-3> "set chanmenu 0; CaptionNicklist $frame.topbar.topic $w %x %y"

        $frame.topbar.topic tag bind channel <Any-Enter> "$frame.topbar.topic configure -cursor $GUI(cursor)"
        $frame.topbar.topic tag bind channel <Any-Leave> "$frame.topbar.topic configure -cursor {}; RemoveTags $frame.topbar.topic; set GUI(txt_current) {}"
        $frame.topbar.topic tag bind channel <Double-1> "CaptionJoin $frame.topbar.topic;after 10 {ToggleEdit $w $id 0}"

        $frame.topbar.topic tag bind url <Any-Enter> "$frame.topbar.topic configure -cursor $GUI(cursor)"
        $frame.topbar.topic tag bind url <Any-Leave> "$frame.topbar.topic configure -cursor {}; RemoveTags $frame.topbar.topic; set GUI(txt_current) {}"
        if {[::platform::isPlatformUnix]} {
          $frame.topbar.topic tag bind url <Button-2> "set chanmenu 0"
          $frame.topbar.topic tag bind url <Button-3> "set chanmenu 0"
        }
        if {[::platform::isPlatformWindows]} {
          $frame.topbar.topic tag bind url <Button-2> "set chanmenu 0; url_menu $frame.topbar.topic %X %Y 1"
          $frame.topbar.topic tag bind url <Button-3> "set chanmenu 0; url_menu $frame.topbar.topic %X %Y 1"
        }
        $frame.topbar.topic tag bind url <Double-1> "CaptionOpenUrl $frame.topbar.topic;after 10 {ToggleEdit $w $id 0}"
        bind $frame.topbar.topic <Motion> "TextCaption %W $w;SeeShift %W %x %X %Y {TextCaption %W $w} {}"

        $wid($w,text) tag bind nick <Any-Enter> "$wid($w,text) configure -cursor $GUI(cursor)"
	$wid($w,text) tag bind nick <Any-Leave> "$wid($w,text) configure -cursor {}; RemoveTags $wid($w,text); set GUI(txt_current) {}"
	$wid($w,text) tag bind nick <ButtonPress> "CaptionSelectNick $w $wid($w,text)"
        $wid($w,text) tag bind nick <Double-1> "CaptionQueryNick $wid($w,text); focus $wid($w,text)"
        $wid($w,text) tag bind nick <Button-2> "set chanmenu 0; CaptionNicklist $wid($w,text) $w %x %y"
	$wid($w,text) tag bind nick <Button-3> "set chanmenu 0; CaptionNicklist $wid($w,text) $w %x %y"

        $wid($w,text) tag bind channel <Any-Enter> "$wid($w,text) configure -cursor $GUI(cursor)"
        $wid($w,text) tag bind channel <Any-Leave> "$wid($w,text) configure -cursor {}; RemoveTags $wid($w,text); set GUI(txt_current) {}"
        $wid($w,text) tag bind channel <Double-1> "CaptionJoin $wid($w,text); focus $wid($w,text)"

        $wid($w,text) tag bind url <Any-Enter> "$wid($w,text) configure -cursor $GUI(cursor)"
        $wid($w,text) tag bind url <Any-Leave> "$wid($w,text) configure -cursor {}; RemoveTags $wid($w,text); set GUI(txt_current) {}"
        
	if {[::platform::isPlatformUnix]} {
          $wid($w,text) tag bind url <Button-2> "set chanmenu 0; focus $wid($w,text)"
          $wid($w,text) tag bind url <Button-3> "set chanmenu 0; focus $wid($w,text)"
        }
        
	if {[::platform::isPlatformWindows]} {
          $wid($w,text) tag bind url <Button-2> "set chanmenu 0; url_menu $wid($w,text) %X %Y 1; focus $wid($w,text)"
          $wid($w,text) tag bind url <Button-3> "set chanmenu 0; url_menu $wid($w,text) %X %Y 1; focus $wid($w,text)"
        }
        
	$wid($w,text) tag bind url <Double-1> "CaptionOpenUrl $wid($w,text); focus $wid($w,text)"

        bind $wid($w,text) <Motion> "TextCaption %W $w"

        bind $wid($w,command) <Control-k> "$wid($w,command) insert insert {\x03} ; ColorTip %X %Y ; Preview $wid($w,command); break"
        bind $wid($w,command) <Control-b> "$wid($w,command) insert insert {} ; Preview $wid($w,command); break"
        bind $wid($w,command) <Control-u> "$wid($w,command) insert insert {} ; Preview $wid($w,command); break"

        bind $wid($w,command) <Control-a> "Pack_Cols; break"

        bind $wid($w,command) <Return> "HistoryAdd $w; get_command $w {channel}; .status.msg delete 1.0 end"
        bind $wid($w,command) <Down> "HistoryGet forth $w; .status.msg delete 1.0 end"
        bind $wid($w,command) <Up> "HistoryGet back $w; .status.msg delete 1.0 end"
        bind $wid($w,command) <KeyPress> "SetSplitter $w; catch {CmdHistory %K $w}; Preview $wid($w,command)"
        bind $wid($w,command) <Tab> { ncomplete; break }
        bind $frame.topbar.topic <KeyPress> "Preview $frame.topbar.topic; break; return"
        bind $frame.topbar.topic <ButtonRelease> "Copy_Clipboard"
        bind $wid($w,text) <Double-1> "focus $wid($w,command)"
        bind $wid($w,text) <KeyPress> "break; return"
        bind $wid($w,text) <ButtonRelease> "Copy_Clipboard; focus $wid($w,command)"
        bind $wid($w,list) <Double-1> "QueryByList $w"
	bind $wid($w,list) <Button-2> "popup_nicklist $w %x %y chan $id"
        bind $wid($w,list) <Button-3> "popup_nicklist $w %x %y chan $id"
	bind $wid($w,text) <Button-2> "popup_menu $w $wid($w,text).chanlist $id"
	bind $wid($w,text) <Button-3> "popup_menu $w $wid($w,text).chanlist $id"

        bind $frame.topbar.modes <Button-1> "popup_modes $w $id"
        bind $frame.topbar.modes <Button-3> "popup_modes $w $id"
        bind $frame.topbar.modes <Button-2> "popup_modes $w $id"

	bind $frame.topbar.topic <FocusIn> "focus $wid($w,command)"
	bind $frame.topbar.topic <Double-1> "ToggleEdit $w $id 1"
	bind $frame.topbar.topic <Button-1> "$wid($w) raise;SeeShift 1 2 3 4 5 %X"
	bind $frame.topbar.topic <ButtonRelease-1> "SeeShift 1 2 3 4 5 0"

        bind $frame.topbar.topic <Down> ".status.msg delete 1.0 end"
        bind $frame.topbar.topic <Up> ".status.msg delete 1.0 end"
	bind $frame.topbar.topic <Return> "confirm_topic $w; .status.msg delete 1.0 end"

        bind $frame.topbar.topic <Control-k> "AddColorTag2 {\x03} $w $id %X %Y; Preview $frame.topbar.topic; break"
        bind $frame.topbar.topic <Control-b> "AddColorTag2 {} $w $id %X %Y; Preview $frame.topbar.topic; break"
        bind $frame.topbar.topic <Control-u> "AddColorTag2 {} $w $id %X %Y; Preview $frame.topbar.topic; break"

        bind $wid($w,command) <Control-a> "Pack_Cols; break"

        bind $wid($w,text) <Button-1> "$wid($w) raise"
        bind $wid($w,command) <Button-1> "$wid($w) raise"
        bind $wid($w,list) <Button-1> "$wid($w) raise"
        bind $wid($w,modes) <Button-1> "$wid($w) raise"
        bind $frame.topbar.stat <Button-1> "$wid($w) raise"

        bind $frame.main.sx.texscroll <Button-1> "$wid($w) raise"
        bind $frame.main.sx.texscroll <ButtonPress> "$wid($w) raise"
        bind $frame.main.sx.texscroll <ButtonRelease> "ReleaseScroll $frame.main.sx.texscroll $w"
        bind $frame.main.sx.texscroll <Motion> "ReleaseScroll $frame.main.sx.texscroll $w"
        bind $frame.main.sx.texscroll <Enter> ". config -cursor {}"
        bind $frame.main.sx.texscroll <Leave> ". config -cursor {}"
        bind $wid($w,list) <Enter> "$wid($w,list) config -cursor {}"
        bind $frame.main.dx.scrolist <Button-1> "$wid($w) raise"

        focus $wid($w,command)
        modes_menus $w $id
        put_list2 $w
        PutLog $w start 1
        get_topic $w 1 1
        get_topicdate $w $id 1
        set active($id) $w
        set me(id) $id
        set active(status) 0
        SetCurrents $me(id)
	SvrSend "MODE [Reverse $canale]" $me(id)
}



set seeshift 0
proc SeeShift {w x X Y cmd b} {
   global seeshift
   if {$b!=""} {
      if {$b!=0} {
        set seeshift $b
      } else {
        set seeshift 0
      }
      return
   }   
   if {$seeshift!=0} {
    if {$X>$seeshift} {
      $w see "@$X,$Y +1 chars"
    } else {
      $w see 1.0     
    }
    bind $w <Motion> ""
    after 1000 "bind $w <Motion> {$cmd; SeeShift %W %x %X %Y {$cmd} {}}"
   }
}

proc ReleaseScroll {sbar w} {
   global scroll
   if {[lindex [$sbar get] 1]=="1.0"} {
      set scroll($w) 1
   } else {
      set scroll($w) 0
   }
}

proc winquery { nick iconify userid host id} {
        global font query active GUI log timestamp me history wid position icons scroll chanmenu
        set i 0
        while {[lsearch $query($id) "query$id-$i"]!=-1} {incr i}
        set w "query$id-$i"
        lappend query($id) "$nick" "$w"
        set history($w) ""
        set log($w) 0
        set timestamp($w) 0
        set position($w) 0
        set scroll($w) 1

        if {$userid!=""&$host!=""} {
          set text [format [mc "%s %s %s is on %s"] [Reverse $nick] - \[$userid@$host\] $me($id,server)]
        } else {
          set text [format [mc "%s is on %s"] [Reverse $nick] $me($id,server)]
        }

        if {$iconify} {
          set state "withdrawn"
        } else {
          if {$GUI(maximized)} {
            set state "maximized"
          } else {
            set state "normal"
          }
        }

        set winset [def_winset $nick "query"]
        foreach {wid(x) wid(y) wid(width) wid(height)} $winset {}
        if {$GUI(maximized)} {
           set wid(x) ""
           set wid(y) ""
        }
        set wid($w) [document .main.$w  -tooltip [format [mc "%s is on %s"] [Reverse $nick] $me($id,server)] -title $text -icontext $nick -active 1 -state $state -callback "close_query $w $id" -callmenu winmenu -image $icons(query)]
        if {$iconify} {$wid($w) configure -state "withdrawn"}
        $wid($w) pack [frame .main.$w.fr] -fill both -expand 1
        set frame ".main.$w.fr"

        frame $frame.main
        frame $frame.command

        text $frame.main.text -selectbackground $GUI(selectbackground) -selectforeground $GUI(selectforeground) -font $font(n) -wrap char -background $GUI(text_bg) -yscrollcommand "$frame.main.texscroll set"        
        mIRC_Text_Tag $frame.main.text
        xscrollbar $frame.main.texscroll -command "$frame.main.text yview" -orient vertical;
        xentry $frame.command.command -background $GUI(entry_bg) -foreground $GUI(entry_fg)

        set wid($w,titlebar) ".main.$w.head.text"
        set wid($w,text) $frame.main.text
        set wid($w,command) $frame.command.command

        xgrid $frame.main 0 0 1 1 snew 
        xgrid $frame.command 0 1 1 1 ew 
        grid columnconfigure $frame 0 -weight 1
        grid rowconfigure $frame 0 -weight 1
        grid rowconfigure $frame 1 -weight 0
        if {$me(colbut)} {
          Pack_Cols
        } else {
          pack $frame.command.command -side left -expand yes -fill x
        }
        xgrid $frame.main.text 0 0 1 1 snew
        autoscroll $frame.main.texscroll "-in $frame.main -column 1 -row 0 -columnspan 1 -rowspan 1 -ipadx 0 -ipady 0 -padx 0 -pady 0 -sticky ns"
        grid columnconfigure $frame.main 0 -weight 1
        grid rowconfigure $frame.main 0 -weight 1


        bind $frame.main.texscroll <Button-1> "$wid($w) raise"
        bind $frame.main.texscroll <ButtonPress> "$wid($w) raise"
        bind $frame.main.texscroll <ButtonRelease> "ReleaseScroll $frame.main.texscroll $w"

        $frame.main.text tag bind channel <Any-Enter> "$frame.main.text configure -cursor $GUI(cursor)"
        $frame.main.text tag bind channel <Any-Leave> "$frame.main.text configure -cursor {}; RemoveTags $frame.main.text; set GUI(txt_current) {}"
        $frame.main.text tag bind channel <Double-1> "CaptionJoin $frame.main.text; focus $frame.main.text"

        $frame.main.text tag bind url <Any-Enter> "$frame.main.text configure -cursor $GUI(cursor)"
        $frame.main.text tag bind url <Any-Leave> "$frame.main.text configure -cursor {}; RemoveTags $frame.main.text; set GUI(txt_current) {}"
        
	if {[::platform::isPlatformUnix]} {
          $frame.main.text tag bind url <Button-2> "set chanmenu 0;  focus $frame.main.text"
          $frame.main.text tag bind url <Button-3> "set chanmenu 0;  focus $frame.main.text"
        }
        
	if {[::platform::isPlatformWindows]} {
          $frame.main.text tag bind url <Button-2> "set chanmenu 0; url_menu $frame.main.text %X %Y 1; focus $frame.main.text"
          $frame.main.text tag bind url <Button-3> "set chanmenu 0; url_menu $frame.main.text %X %Y 1; focus $frame.main.text"
        }
        
	$frame.main.text tag bind url <Double-1> "CaptionOpenUrl $frame.main.text; focus $frame.main.text"

        bind $frame.main.text <Motion> "TextCaption %W $w"

        bind $wid($w,command) <Button-1> "$wid($w) raise"
        bind $wid($w,command) <Return> "HistoryAdd $w; get_command $w {query}; .status.msg delete 1.0 end"
        bind $wid($w,command) <Control-k> "$wid($w,command) insert insert {\x03} ; ColorTip %X %Y ; Preview $wid($w,command); break"
        bind $wid($w,command) <Control-b> "$wid($w,command) insert insert {} ; Preview $wid($w,command); break"
        bind $wid($w,command) <Control-u> "$wid($w,command) insert insert {} ; Preview $wid($w,command); break"

        bind $wid($w,command) <Control-a> "Pack_Cols; break"

        bind $wid($w,command) <Down> "HistoryGet forth $w; .status.msg delete 1.0 end"
        bind $wid($w,command) <Up> "HistoryGet back $w; .status.msg delete 1.0 end"
        bind $wid($w,command) <KeyPress> "SetSplitter $w; catch {CmdHistory %K $w}; Preview $wid($w,command)"
        bind $wid($w,text) <Button-1> "$wid($w) raise"
        bind $wid($w,text) <KeyPress> "break; return"
        bind $wid($w,text) <ButtonRelease> "Copy_Clipboard; focus $wid($w,command)"
        bind $wid($w,text) <FocusOut> "IfNotColorButton $w"
        bind $wid($w,text) <Map> "IfNotColorButton $w"
        bind $wid($w,text) <Unmap> "IfNotColorButton $w"
	bind $wid($w,text) <Button-2> "popup_menu $w $wid($w,text).menu $id"
	bind $wid($w,text) <Button-3> "popup_menu $w $wid($w,text).menu $id"

        if {$iconify!=1} {
         set active($id) $w
         set me(id) $id
         set active(status) 0
         SetCurrents $me(id)
        }

        PutLog $w start 1
        focus $wid($w,command)

}

proc DelFserveMenu {w} {
   global wid 
   bind $wid($w,text) <Double-1> "focus $wid($w,command);break"
   after 200 "bind $wid($w,text) <Double-1> {focus $wid($w,command);FserveMenu $w %X %Y}"         
}

proc winchat { nick iconify userid host id} {
   global chat active font GUI log timestamp history me wid position icons scroll chanmenu
        set i 0
        while {[lsearch $chat($id) "chat$id-$i"]!=-1} {incr i}
        set w "chat$id-$i"
        lappend chat($id) "$nick" "$w"
        set history($w) ""
        set log($w) 0
        set timestamp($w) 0
        set position($w) 0
        set scroll($w) 1

        if {$userid!=""&$host!=""} {
          set text [format [mc "Connected to %s %s %s on %s"] [Reverse $nick] - \[$userid@$host\] $me($id,server)]
        } else {
          set text [format [mc "Connected %s on %s"] [Reverse $nick] $me($id,server)]
        }

        if {$GUI(maximized)} {
            set state "maximized"
        } else {
            set state "normal"
        }

        set winset [def_winset $nick "chat"]
        foreach {wid(x) wid(y) wid(width) wid(height)} $winset {}
        if {$GUI(maximized)} {
           set wid(x) ""
           set wid(y) ""
        }
        set wid($w) [document .main.$w  -tooltip [format [mc "%s is on %s"] [Reverse $nick] $me($id,server)] -title $text -active 1 -icontext $nick -callback "close_chat $w $id" -callmenu winmenu -image $icons(query) -state $state]
        $wid($w) pack [frame .main.$w.fr] -fill both -expand 1
        set frame ".main.$w.fr"
        frame $frame.main
        frame $frame.command

        text $frame.main.text -selectbackground $GUI(selectbackground) -selectforeground $GUI(selectforeground) -font $font(n) -wrap word -background $GUI(text_bg) -yscrollcommand "$frame.main.texscroll set"
        mIRC_Text_Tag $frame.main.text
        xscrollbar $frame.main.texscroll -command "$frame.main.text yview" -orient vertical;
        xentry $frame.command.command -background $GUI(entry_bg) -foreground $GUI(entry_fg)

        set wid($w,titlebar) ".main.$w.head.text"
        set wid($w,text) $frame.main.text
        set wid($w,command) $frame.command.command

        xgrid $frame.main 0 0 1 1 snew
        xgrid $frame.command 0 1 1 1 ew
        grid columnconfigure $frame 0 -weight 1
        grid rowconfigure $frame 0 -weight 1
        grid rowconfigure $frame 1 -weight 0
        if {$me(colbut)} {  
          Pack_Cols 
        } else {
          pack $frame.command.command -side left -expand yes -fill x
        }
        xgrid $frame.main.text 0 0 1 1 snew
        autoscroll $frame.main.texscroll "-in $frame.main -column 1 -row 0 -columnspan 1 -rowspan 1 -ipadx 0 -ipady 0 -padx 0 -pady 0 -sticky ns"
        grid columnconfigure $frame.main 0 -weight 1
        grid rowconfigure $frame.main 0 -weight 1

        bind $frame.main.texscroll <Button-1> "$wid($w) raise"
        bind $frame.main.texscroll <ButtonPress> "$wid($w) raise"
        bind $frame.main.texscroll <ButtonRelease> "ReleaseScroll $frame.main.texscroll $w"


        $frame.main.text tag bind channel <Any-Enter> "$frame.main.text configure -cursor $GUI(cursor)"
        $frame.main.text tag bind channel <Any-Leave> "$frame.main.text configure -cursor {}; RemoveTags $frame.main.text; set GUI(txt_current) {}"
        $frame.main.text tag bind channel <Double-1> "CaptionJoin $frame.main.text; focus $frame.main.text;DelFserveMenu $w"

        $frame.main.text tag bind url <Any-Enter> "$frame.main.text configure -cursor $GUI(cursor)"
        $frame.main.text tag bind url <Any-Leave> "$frame.main.text configure -cursor {}; RemoveTags $frame.main.text; set GUI(txt_current) {}"
        if {[::platform::isPlatformUnix]} {
          $frame.main.text tag bind url <Button-2> "set chanmenu 0;  focus $frame.main.text"
          $frame.main.text tag bind url <Button-3> "set chanmenu 0;  focus $frame.main.text"
        }
        if {[::platform::isPlatformWindows]} {
          $frame.main.text tag bind url <Button-2> "set chanmenu 0; url_menu $frame.main.text %X %Y 1; focus $frame.main.text"
          $frame.main.text tag bind url <Button-3> "set chanmenu 0; url_menu $frame.main.text %X %Y 1; focus $frame.main.text"
        }
        $frame.main.text tag bind url <Double-1> "CaptionOpenUrl $frame.main.text; focus $frame.main.text;DelFserveMenu $w"

        bind $frame.main.text <Motion> "TextCaption %W $w"

        bind $wid($w,command) <Button-1> "$wid($w) raise"
        bind $wid($w,command) <Return> "HistoryAdd $w; get_command $w {chat}; .status.msg delete 1.0 end"
        bind $wid($w,command) <Control-k> "$wid($w,command) insert insert {\x03} ; ColorTip %X %Y ; Preview $wid($w,command); break"
        bind $wid($w,command) <Control-b> "$wid($w,command) insert insert {} ; Preview $wid($w,command); break"
        bind $wid($w,command) <Control-u> "$wid($w,command) insert insert {} ; Preview $wid($w,command); break"

        bind $wid($w,command) <Control-a> "Pack_Cols; break"

        bind $wid($w,command) <Down> "HistoryGet forth $w; .status.msg delete 1.0 end"
        bind $wid($w,command) <Up> "HistoryGet back $w; .status.msg delete 1.0 end"
        bind $wid($w,command) <KeyPress> "SetSplitter $w; catch {CmdHistory %K $w}; Preview $wid($w,command)"
        bind $wid($w,text) <Button-1> "$wid($w) raise"
        bind $wid($w,text) <KeyPress> "break; return"
        bind $wid($w,text) <ButtonRelease-1> "Copy_Clipboard; focus $wid($w,command);FserveMenu $w %X %Y" 
        bind $wid($w,text) <Double-1> "focus $wid($w,command);FserveMenu $w %X %Y"         
        #bind $wid($w,text) <Double-3> "focus $wid($w,command);FserveMenu $w %X %Y"         

        bind $wid($w,text) <FocusOut> "IfNotColorButton $w"
        bind $wid($w,text) <Map> "IfNotColorButton $w"
        bind $wid($w,text) <Unmap> "IfNotColorButton $w"
	bind $wid($w,text) <Button-2> "popup_menu $w $wid($w,text).menu $id"
	bind $wid($w,text) <Button-3> "popup_menu $w $wid($w,text).menu $id"

        if {$iconify!=1} {
         set active($id) $w
         set me(id) $id
         set active(status) 0
         SetCurrents $me(id)
        }

        PutLog $w start 1
        focus $wid($w,command)
}


proc GetWindowID {w} {
   set i [string first "-" $w]
   set w [string range $w 0 [expr $i-1]]
   set id [string trimleft $w "canalequerychat"]
   return $id
}

proc Pack_Cols {} {
 global me im_b im_c im_u MIRCcols wid icons
 foreach slave $wid(winlist) {
   catch {
     set f [frame $slave.fr.command.col]
     set im [image create photo -width 5 -height 5]
     frame $f.bar
     button $f.bar.x -image $icons(col) -command "CPutColor {} [$slave get_win]"
     button $f.bar.b -image $im_b -command "CPutColor  [$slave get_win]"
     button $f.bar.u -image $im_u -command "CPutColor  [$slave get_win]"
     button $f.bar.c -image $im_c -command "set me(colbut) 0; destroy $f"
     set_balloon $f.bar.c [mc Close]
     set_balloon $f.bar.b [mc Bold]
     set_balloon $f.bar.u [mc Underline]

     set y 0
     for {set x 0; set j 0} {$x < 16} {incr x; incr j} {
         if {$x==8} {set y 1; set j 0}
         button $f.col$x -command "CPutColor $x [$slave get_win]" -background $MIRCcols($x) -image $im -borderwidth 0 -highlightthickness 0 -padx 0 -pady 0
         grid config $f.col$x -column $j -row $y -padx 0 -pady 0 -columnspan 1 -rowspan 1 -sticky "new"
     }

     xgrid $f.bar 0 3 8 1 snew 
     pack forget $slave.fr.command.command
     pack $f.bar.c $f.bar.u $f.bar.b $f.bar.x -padx 1 -side right
     pack $f -side left
     pack $slave.fr.command.command -side left -fill x -expand yes
   }
 }
 set me(colbut) 1
}

proc About {} {
   global me im_ok font icons files
  set w .about
  
  if {$me(icony)} {wm state . normal}
  if {[winfo exists $w]} {return}  
   
   
   toplevel $w -class About
   wm title $w [mc "About savIRC"]
   #wm resizable $w 0 0
   wm transient $w .
   
   set width [winfo reqwidth .]
   set height [winfo reqheight .]
   set x [expr { ( [winfo vrootwidth  .] - $width  ) / 2 }]
   set y [expr { ( [winfo vrootheight .] - $height ) / 2 }]
   
   wm geometry $w 500x325+${x}+${y}
   
   

   
   # top frame, icon and version
   frame $w.f -bd 2
   label $w.f.savirc -image $icons(savirc)
   message $w.f.version -relief flat -width 400 -text "$me(version)" -font $font(n)
   pack $w.f.savirc -side left -padx 5 -pady 5
   pack $w.f.version -side left -padx 5 -pady 5

   # tab sheet
   tabcontrol $w.tabs -width auto
   set tabs $w.tabs
   
   # hardcoded size, because I can;t get autolayout to work (tabcontrol gets 0x0)
   frame $tabs.savirc	    ;#-width 500 -height 300
   frame $tabs.contributors ;#-width 500 -height 300
   frame $tabs.license	    ;#-width 500 -height 300

   pack $w.tabs -fill both -expand yes
   #pack $tabs.savirc	   -fill both -expand yes
   #pack $tabs.contributors -fill x -expand yes
   #pack $tabs.license	   -fill both -expand yes

   $w.tabs insert savirc 0	-text savIRC -window $tabs.savirc
   $w.tabs insert contributors 0  -text [mc Contributors] -window $tabs.contributors
   $w.tabs insert license 0	-text [mc License] -window $tabs.license
   
   #tab 1
   message $tabs.savirc.msg1 -aspect 10000 -text [mc "TCL/TK based scripted multi-server IRC client"]
   message $tabs.savirc.msg2 -aspect 10000 -text "\u00a9 [format [mc {%s %s The savIRC Development Team}] $me(year) -]"

   grid $tabs.savirc.msg1 -column 0 -row 0 -sticky nsew
   grid $tabs.savirc.msg2 -column 0 -row 1 -sticky nsew
   
   grid columnconfigure $tabs.savirc  0 -weight 1
   
   #tab 2
   message $tabs.contributors.msg1 -anchor nw -aspect 10000 -text "Casey Ackels\n  casey@savirc.com\n  [mc {Web Site Maintainer, Bug Tracker Maintainer, Code Monkey (GUI)}]"
   message $tabs.contributors.msg2 -anchor nw -aspect 10000 -text "Sander van Grieken\n  sander@savirc.com\n  [mc {Subversion Maintainer, Code Monkey (Protocol and Internals)}]"
   message $tabs.contributors.msg3 -anchor nw -aspect 10000 -text "Saverio Castellano\n  saverio@savirc.com\n  [mc {Original Author}]"

   pack $tabs.contributors.msg1 -side top -fill x -expand yes
   pack $tabs.contributors.msg2 -side top -fill x -expand yes
   pack $tabs.contributors.msg3 -side top -fill x -expand yes
   
   #tab 3
   text $tabs.license.message -foreground black -background white -font $font(n) -wrap none \
     -yscrollcommand "$tabs.license.yscroller set" \
     -xscrollcommand "$tabs.license.xscroller set"
   if {[catch {
     if {![file exists $files(license)]} {
       $tabs.license.message insert end [mc "GPL v2 License file not found"]
     } else {
       set license_file [open $files(license) "r"]
       fconfigure $license_file -encoding $me(encoding)
       set license_content [read $license_file]
       $tabs.license.message insert end "$license_content"
     }
   } out] } {
     $tabs.license.message insert end [format [mc "Error loading GPL v2 License file %s"] '$files(license)']
   }
   xscrollbar $tabs.license.yscroller -command "$tabs.license.message yview" -orient vertical
   xscrollbar $tabs.license.xscroller -command "$tabs.license.message xview" -orient horizontal
   
   grid $tabs.license.message -column 0 -row 0 -sticky nsew
   grid $tabs.license.yscroller -column 1 -row 0 -sticky nsew
   grid $tabs.license.xscroller -column 0 -columnspan 2 -row 1 -sticky nsew
   grid columnconfigure $tabs.license 0 -weight 1
   grid rowconfigure $tabs.license 0 -weight 1

   # editing the license huh..
   bind $tabs.license.message <KeyPress> "break"
         
   #button
   frame $w.ok -bd 2
   xbutton $w.ok.button -image $im_ok -side left -text [mc Ok] -command "destroy $w" -font $font(button)
   pack $w.ok.button

   grid $w.f -column 0 -row 0 -sticky snew
   grid $w.tabs -column 0 -row 1 -sticky snew -pady 5p
   grid $w.ok -column 0 -row 2 -sticky snew -pady 5p
   grid rowconfigure $w 1 -weight 1
   grid columnconfigure $w 0 -weight 1 

   $tabs invoke savirc
   
   catch {grab $w}
   focus $w.ok
   bind $w <Escape> "destroy $w"
   bind $w <Return> "destroy $w"
}


proc ChanFolder {} {
     global me icons files GUI colsTXT misc wid

        set w "chanfolder"
        if {[winfo exists .main.$w]} {return}

        if {$GUI(maximized)} {
          set state "maximized"
        } else {
          set state "normal"
        }

        foreach {wid(x) wid(y) wid(width) wid(height)} [def_winset "ChannelsFolder" "ChannelsFolder"] {}
        set wid($w) [document .main.$w -tooltip [mc "Channels Folder"] -title [mc "Channels Folder"] -icontext [mc "Channels Folder"] -image $icons(chanlist2) -callback CloseChanFolder -minsize {305 200} -state $state]
 
        $wid($w) pack [frame .main.$w.fr] -fill both -expand 1
        set frame .main.$w.fr
 
   
   if {[::platform::isPlatformUnix]} {
     xmclistbox $frame.list -fillcolumn desc -yscrollcommand [list $frame.scrolly set] \
	    -bd 0 \
            -labelbg $GUI(widgets_color) \
	    -columnrelief flat \
	    -labelanchor w \
            -background white \
	    -columnborderwidth 0 \
	    -selectmode browse \
	    -selectforeground $GUI(selectforeground) \
	    -selectbackground $GUI(selectbackground) \
	    -labelborderwidth 2
   }     
   if {[::platform::isPlatformWindows]} {
     mclistbox $frame.list -fillcolumn desc -yscrollcommand [list $frame.scrolly set] \
	    -bd 0 \
            -labelbg $GUI(widgets_color) \
	    -columnrelief flat \
	    -labelanchor w \
            -background white \
	    -columnborderwidth 0 \
	    -selectmode browse \
	    -selectforeground $GUI(selectforeground) \
	    -selectbackground $GUI(selectbackground) \
	    -labelborderwidth 2
   }
   $frame.list column add chan -label [mc Channel] -width 20
   $frame.list column add net -label  [mc Network] -width 10
   $frame.list column add desc -label [mc Description] -width 2

   foreach item "chan net desc" {
    $frame.list label bind $item <ButtonPress-1> "sort %W $item"
   }

   bind $frame.list <Double-1> "JoinSelected $frame.list"

   xscrollbar $frame.scrolly -orient vertical -command "$frame.list yview" 

   set wid($w,list) $frame.list
   
   frame $frame.toolbar 
   tooltip $frame.toolbar.tip -delay 500

   toolbar $frame.toolbar.toolbar -state fixed
   $frame.toolbar.tip add [$frame.toolbar.toolbar add button c1 -image $icons(add) -command "NewChanfolderWin $frame.list {} {} {} {} {}"] [mc "Add Channel"]
   $frame.toolbar.toolbar add separator sep1
   $frame.toolbar.tip add [$frame.toolbar.toolbar add button c2 -image $icons(edit) -command "ModifyChanFolder $frame.list"] [mc "Edit Channel"]
   $frame.toolbar.toolbar add separator sep2
   $frame.toolbar.tip add [$frame.toolbar.toolbar add button c3 -image $icons(del) -command "DelChanFolder $frame.list {}"] [mc "Delete Channel"]
   
   pack $frame.toolbar.toolbar -fill x -expand yes

   frame $frame.status -bd 1 -relief flat

   checkbutton $frame.status.popup  -text [mc "Popup channels folder on connect"] -variable misc(chanpopup)

   pack $frame.status.popup -side left
   
   bind $frame.list <Button-1> "$wid($w) raise"
   bind $frame.toolbar <Button-1> "$wid($w) raise"
   bind $frame.status <Button-1> "$wid($w) raise"
   bind $frame.status.popup <Button-1> "$wid($w) raise"
     

   xgrid $frame.toolbar 0 0 2 1 snew
   xgrid $frame.list 0 1 1 1 snew
   autoscroll $frame.scrolly "-in $frame -column 1 -row 1 -columnspan 1 -rowspan 1 -ipadx 0 -ipady 0 -padx 0 -pady 0 -sticky nesw"
   xgrid $frame.status 0 2 2 1 snew


   grid rowconfigure $frame 0 -weight 0
   grid rowconfigure $frame 1 -weight 1
   grid rowconfigure $frame 2 -weight 0
   grid rowconfigure $frame 3 -weight 0
   grid columnconfigure $frame 0 -weight 1
   grid columnconfigure $frame 1 -weight 0
   
   LoadChannelsFolder $frame.list
   update idletasks
}

proc CheckChanFolderFile {} {
   global files

   if {![file exists $files(channels)]} {
       if {[catch {open $files(channels) a+} err]} {
         tk_messageBox -icon error -message "$err"
       } else {
         catch {close $files(channels)}
       }
   }
}

proc LoadChannelsFolder {w} {
   global files
   $w delete 0 end
   CheckChanFolderFile
   if {[catch {open $files(channels)} fd]} {
      tk_messageBox -icon error -message "$fd"      
      return
   }  
   set channels [split [read $fd] "\n"]   
   foreach item $channels {
      set chan [lindex $item 0]    
      if {$chan==""} {continue}
      set net [lindex $item 2]
      set desc [lrange $item 3 end]
      $w insert end "$chan $net {$desc}"      
   }
   sort $w "chan"

}

proc NewChanfolderWin {lb chan join net desc sel} {
  global im_ok im_cancel GUI font me bool
  set w ".newchanfolder"
  if {[winfo exists $w]} {return}
  toplevel $w -class Config
  wm geometry $w +131+100
  wm resizable $w 0 0
  wm title $w [mc "New Channel"]
  wm transient $w .
  set flab [LabelFrame:create $w.not -text [mc "New Channel:"] -ipadx 15 -ipady 15]

  frame $w.bottom
  label $flab.chan -text [mc Channel]
  label $flab.net  -text [mc Network]
  label $flab.desc -text [mc Description]
  entry $flab.echan -background white -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground) 
  combobox::combobox $flab.enet -background white -editable 0 -width 18 -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground) 
  entry $flab.edesc -background white -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground)
  set bool 0
  checkbutton $flab.join  -text [mc "Join on Connect"] -variable bool
  set replace 0
  if {$chan!=""} {
     $flab.echan insert end $chan
     $flab.enet.entry config -state normal
     $flab.enet.entry insert end $net
     $flab.enet.entry config -state disabled
     $flab.edesc insert end $desc
     set bool $join 
     set replace 1
  }

  xbutton $w.bottom.cancel -image $im_cancel -side left -text [mc Cancel] -command "destroy $w"  -font $font(button)
  xbutton $w.bottom.ok -image $im_ok -side left -text [mc Ok] -command "NewChanfolder $w $lb $replace {$sel} $flab"  -font $font(button)

  grid $w.not -column 0 -row 0 -sticky snew -padx 5 -pady 5
  xgrid $w.bottom 0 1 1 1 snew 

  pack $w.bottom.ok $w.bottom.cancel -side left -padx 15 -pady 10

   grid config $flab.chan -column 0 -row 0 \
	-columnspan 1 -rowspan 1 -sticky "snw" -pady 5
   grid config $flab.echan -column 1 -row 0 \
	-columnspan 1 -rowspan 1 -sticky "snw" -pady 5
   grid config $flab.net -column 0 -row 1 \
	-columnspan 1 -rowspan 1 -sticky "snw" -pady 5
   grid config $flab.enet -column 1 -row 1 \
	-columnspan 1 -rowspan 1 -sticky "snw" -pady 5
   grid config $flab.desc -column 0 -row 2 \
	-columnspan 1 -rowspan 1 -sticky "snw" -pady 5
   grid config $flab.edesc -column 1 -row 2 \
	-columnspan 1 -rowspan 1 -sticky "snw" -pady 5
   grid config $flab.join -column 0 -row 3 \
	-columnspan 2 -rowspan 1 -sticky "snw" -pady 5

   bind $w <Return> "NewChanfolder $w $lb $replace {$sel} $flab"
   bind $w <Escape> "destroy $w"

   $flab.enet list insert end ""
   FillNetwork $flab.enet
   wm withdraw $w
   wm deiconify $w
   catch {grab $w   }
   focus $flab.echan
}

proc NewChanfolder {w lb replace sel flab} {
  global me files active colsTXT icons bool

  if {$replace} {DelChanFolder $lb $sel}

  set chan [$flab.echan get]
  set net [$flab.enet get]
  if {$net==""} {set net "all"}
  set desc [$flab.edesc get]
  set join $bool
  set bool 0

  if {$chan==""} { return }

  if {[catch {open $files(channels) a+} fd]} {
     if {$icons(show)} {ImageText $active($me(id)) prog}
     NormalText $active($me(id)) $fd $colsTXT(prog) 1
     return
  }

  puts $fd "$chan $join $net $desc"
  catch {close $fd}
  destroy $w
  LoadChannelsFolder $lb
  if {$replace} {$lb selection set $sel}

}


proc ModifyChanFolder {w} {
   global files
   set sel [$w curselection]
   set channel [lindex [$w get $sel] 0]
   if {$channel==""} {return}
   set net [lindex [$w get $sel] 1]

   CheckChanFolderFile
   if {[catch {open $files(channels)} fd]} {
      tk_messageBox -icon error -message "$fd"      
      return
   }  
   set channels [split [read $fd] \n]
   close $fd
   foreach line $channels  {
    if {[lindex $line 0]==$channel&&[lindex $line 2]==$net} {
      break
    }
   }   
   NewChanfolderWin $w [lindex $line 0] [lindex $line 1] [lindex $line 2] [lrange $line 3 end] $sel
}

proc DelChanFolder {w sel} {
   global wid files me active
   if {$sel==""} {
    set sel [$w curselection]
   }
   set channel [lindex [$w get $sel] 0]
   if {$channel==""} return
   set net [lindex [$w get $sel] 1]

   CheckChanFolderFile
   if {[catch {open $files(channels)} fd]} {
      tk_messageBox -icon error -message "$fd"
      return
   }  
   set channels [split [read $fd] \n]
   close $fd

  if {[catch {open $files(channels) w+} fd]} {
     if {$icons(show)} {ImageText $active($me(id)) prog}
     NormalText $active($me(id)) $fd $colsTXT(prog) 1
     return
  }
  set dumped ""
  foreach line $channels  {
    if {[lindex $line 0]!=$channel||[lindex $line 2]!=$net&&[lindex $line 0]!=""} {
       puts $fd $line
    } else {
       set dumped $line
    }
  }
  $w delete $sel
  incr sel -1
  catch {
     $w selection set $sel
  }
  catch {close $fd}
  return $dumped
}


proc CloseChanFolder {} {
  global wid
  array unset wid "chanfolder"
  array unset wid "chanfolder,list"

}


proc ShowLIST {id} {
        global me icons GUI wid LIST font colsTXT
        if {![Connected]} {return}
        if {$id==""} {set id $me(id)}
        set w "chanlist$id"
        if {[winfo exists .main.$w]} {return}
        if {$GUI(maximized)} {
          set state "maximized"
        } else {
          set state "normal"
        }

        foreach {wid(x) wid(y) wid(width) wid(height)} [def_winset "Channelslist" "Channelslist"] {}
        set wid($w) [document .main.$w -tooltip [format [mc "Channels list for %s"] $me($id,server)] -title [format [mc "Channels list for %s"] $me($id,server)] -icontext [mc "Channels List"] -image $icons(world2) -minsize {545 200} -callback "UnsetShowLIST $w" -state $state]

        $wid($w) pack [frame .main.$w.fr] -fill both -expand 1
        set frame .main.$w.fr


   xmclistbox $frame.list \
            -labelbg $GUI(widgets_color) \
            -fillcolumn topic -yscrollcommand "$frame.scrolly set" \
            -xscrollcommand "$frame.scrollx set" -bd 0 -columnrelief flat \
	    -labelanchor w -foreground $GUI(listbox_fg) -background $GUI(listbox_bg) -columnborderwidth 0 \
	    -selectmode browse -selectforeground $GUI(selectforeground) \
            -selectbackground $GUI(selectbackground) -labelborderwidth 2

   $frame.list column add chan -label  [mc Channel] -width 20
   $frame.list column add users -label [mc Users] -width 10
   $frame.list column add topic -label [mc Topic] -width 50

   foreach item "chan users topic" {
     $frame.list label bind $item <ButtonPress-1> "sort %W $item"
   }

   bind $frame.list <Double-1> "JoinSelected $frame.list $id"

   xscrollbar $frame.scrolly -orient vertical -command "$frame.list yview"
   xscrollbar $frame.scrollx -orient horizontal -command "$frame.list xview"

   set wid($w,list) $frame.list

   if {[info exists LIST($w)]} {
     foreach chan $LIST($w) {
       $wid($w,list) insert end "{[lindex $chan 0]} {[lindex $chan 1]} {[lindex $chan 2]}"
     }
     array unset LIST $w
     $wid($w) config -closable 0
   }

   frame $frame.toolbar
   frame $frame.status -bd 1 -relief flat

   label $frame.status.info -relief sunken -width 30 -text ""
   label $frame.status.info2 -relief sunken -text ""

   pack $frame.status.info -side left
   pack $frame.status.info2 -expand yes -fill x -side left

   set wid($w,info) $frame.status.info
   set wid($w,info2) $frame.status.info2

   spinentry $frame.toolbar.min -width 8 -onerror "return" -background white -minimum 0 -step 10 -speed 75 -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground)
   spinentry $frame.toolbar.max -width 8 -onerror "return" -background white -minimum 0 -step 10 -speed 75 -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground)
   label $frame.toolbar.lmin -text [mc Minimum]
   label $frame.toolbar.lmax -text [mc Maximum]

   label $frame.toolbar.lchan -text [mc "Channel Match"]
   entry $frame.toolbar.chan -width 10 -background white -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground)
   label $frame.toolbar.ltopic -text [mc Topic]
   entry $frame.toolbar.topic -width 10 -background white -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground)

   xbutton $frame.toolbar.get -image $icons(getlist) -text [mc "Get List"] -side left -font $font(button) -command "GetIRClist $frame $id"
   bind $wid($w) <Return> "GetIRClist $frame $id"

   bind $frame.toolbar.lchan  <Button-1> "$wid($w) raise"
   bind $frame.toolbar.chan   <Button-1> "$wid($w) raise"
   bind $frame.toolbar.ltopic <Button-1> "$wid($w) raise"
   bind $frame.toolbar.topic  <Button-1> "$wid($w) raise"

   bind $frame.list <Button-1> "$wid($w) raise"
   bind $frame.toolbar <Button-1> "$wid($w) raise"
   bind $frame.status <Button-1> "$wid($w) raise"
   bind $frame.status.info <Button-1> "$wid($w) raise"
   bind $frame.status.info2 <Button-1> "$wid($w) raise"


   pack $frame.toolbar.lchan $frame.toolbar.chan $frame.toolbar.ltopic $frame.toolbar.topic $frame.toolbar.lmin $frame.toolbar.min $frame.toolbar.lmax $frame.toolbar.max -side left
   pack $frame.toolbar.get -side right -padx 2

   grid config $frame.toolbar -column 0 -row 0 -columnspan 2 -sticky "snew" -pady 2
   xgrid $frame.list 0 1 1 1 snew
   autoscroll $frame.scrolly "-in $frame -column 1 -row 1 -columnspan 1 -rowspan 1 -ipadx 0 -ipady 0 -padx 0 -pady 0 -sticky nesw"
   autoscroll $frame.scrollx "-in $frame -column 0 -row 2 -columnspan 2 -rowspan 1 -ipadx 0 -ipady 0 -padx 0 -pady 0 -sticky nesw"
   xgrid $frame.status 0 3 2 1 snew
  

   focus $frame.toolbar.chan

   grid rowconfigure $frame 0 -weight 0
   grid rowconfigure $frame 1 -weight 1
   grid rowconfigure $frame 2 -weight 0
   grid rowconfigure $frame 3 -weight 0
   grid columnconfigure $frame 0 -weight 1
   grid columnconfigure $frame 1 -weight 0
   
   update idletasks
}

proc GetIRClist {w id} {
   global LIST wid
   $wid(chanlist$id) config -closable 0
   $w.status.info2 config -text ""
   $w.list delete 0 end
   set min [$w.toolbar.min get]
   set max [$w.toolbar.max get]
   set chan [string tolower [$w.toolbar.chan get]]
   set topic [string tolower [$w.toolbar.topic get]]
   if {$topic==""} { set topic "*" }
   if {$chan==""} { set chan "*" }
   set LIST(channel-match-$id) $chan
   set LIST(topic-match-$id) $topic
   $w.status.info config -text [mc "Getting list..."]
   if {$min==""&&$max==""} {
     IRC::raw list
   } elseif {$max!=""&&$min==""} {
     IRC::raw list <$max
   } elseif {$max==""&&$min!=""} {
     IRC::raw list >$min
   } else {
     IRC::raw list <$max,>$min
   }
}

proc UnsetShowLIST {w} {
 global wid
 array unset wid $w
 array unset wid $w,info
 array unset wid $w,info2
 array unset wid $w,list
}


proc ShowWHO {win} {
   global me GUI font icons wholist whols
   if {$me(icony)} {wm state . normal}
   set w ".showWHO$win"
   if {[winfo exists $w]} {return}
   set wholist 0
   if {$win!="x@normal"} {
     set id [GetWindowID $win]
     set channel [GetChannel $win $id]
   }
   toplevel $w -class ShowWho
   if {$win!="x@normal"} {
    wm title $w [format [mc "Global WHO for %s:"] $channel]
   } else {
    wm title $w [mc "WHO Response:"]
   }
   #wm geometry $w 583x297+100+140
   #wm resizable $w 0 0
   pack [frame $w.f] -fill both -expand yes
   frame $w.f.bar
   combobox::combobox $w.f.bar.country -editable 1 -width 4 -text "" -background white -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground)
   
   foreach domain {.com .net .edu .ar .at .au .br .ca .de .dk .do .ec .ei .es .fi .fo .gr .ho .hu .il .it .is .jp .my .mx .nl .no .nz .po .ro .ru .se .si .tk .uk } {
     $w.f.bar.country list insert end "$domain"
   }

 
   xbutton $w.f.bar.button -border 2 -font $font(button) -image $icons(select) -side left -text [mc Select] -state disabled -command "SelectDomain $win $w.f"
   xbutton $w.f.bar.update -border 2 -font $font(button) -image $icons(getlist) -side left -text [mc List] -state disabled -command "WhoList $win $w.f"
   Progress $w.f.bar.progress
   $w.f.bar.progress.l.fill.l config -foreground white
   pack $w.f.bar.country $w.f.bar.button $w.f.bar.update -side left -pady 2 -padx 2
   pack $w.f.bar.progress -expand yes -fill x -side left -padx 3
   frame $w.f.status -bd 1 -relief flat
   label $w.f.status.info -relief sunken -bd 2 -text "" -font $font(label)
   pack $w.f.status.info -expand yes -fill x -side left


   xmclistbox $w.f.list -height 12 -width 80 -fillcolumn name \
            -labelbg $GUI(widgets_color) \
            -yscrollcommand "$w.f.scroll set" -xscrollcommand "$w.f.xscroll set" \
            -bd 2 -columnrelief flat \
	    -labelanchor w -columnborderwidth 0 \
	    -selectmode browse -selectforeground $GUI(selectforeground) \
            -selectbackground $GUI(selectbackground) -labelborderwidth 2
   
   $w.f.list column add nick -label [mc Nick] -width 12
   $w.f.list column add user -label [mc User] -width 10
   $w.f.list column add host -label [mc Host] -width 30
   $w.f.list column add name -label [mc "Real Name"] -width 26
   $w.f.list column add serv -label [mc Server] -width 25

   foreach item "nick user host name serv" {
    $w.f.list label bind $item <ButtonPress-1> "sort %W $item"
   }

   bind $w.f.list <Double-1> "QuerySelected $w.f.list"
   bind $w <Destroy> "array unset whols $win"
   bind $w.f.bar.country <Return> "SelectDomain $win $w.f"
   
   xscrollbar $w.f.scroll -orient vertical -command "$w.f.list yview" 
   xscrollbar $w.f.xscroll -orient horizontal -command "$w.f.list xview"

   xgrid $w.f.bar 0 0 2 1 snew
   xgrid $w.f.list 0 1 1 1 snew
   autoscroll $w.f.scroll "-in $w.f -column 1 -row 1 -columnspan 1 -rowspan 1 -ipadx 0 -ipady 0 -padx 0 -pady 0 -sticky ns"
   autoscroll $w.f.xscroll "-in $w.f -column 0 -row 2 -columnspan 2 -rowspan 1 -ipadx 0 -ipady 0 -padx 0 -pady 1 -sticky nesw"
   xgrid $w.f.status 0 3 2 1 snew 

   grid rowconfigure $w.f 1 -weight 1
   grid columnconfigure $w.f 0 -weight 1
   
   if {$win=="x@normal"} {
    UpdateProgress 100 $w.f.bar.progress 0
   }
   bind $w <Escape> "destroy $w"
   update
   wm transient $w .
   focus $w

}

proc JoinSelected {args} {
   set w [lindex $args 0]
   set id [lindex $args 1]
   set chan [lindex [$w get [$w curselection]] 0]
   if {$id==""} {
     catch {IRC::join $chan}
   } else {
     catch {id $id join $chan}
   }
}

proc QuerySelected {w} {
   catch {IRC::query [lindex [$w get [$w curselection]] 0]}
}



proc ShowLinks {id} {
   global GUI tlinks me
   if {$me(icony)} {wm state . normal}
   set w ".links"
   if {[winfo exists $w]} {return}
   toplevel $w -class Links
   wm title $w [format [mc "Links tree for %s"] $me($id,server)]
   #wm geometry $w +200+100
   #wm resizable $w 0 0
   wm transient $w .
   pack [frame $w.f] -expand true -fill both
   
   xmclistbox $w.f.list -height 2 -fillcolumn desc \
            -labelbg $GUI(widgets_color) \
            -bd 0 -columnrelief flat \
	    -labelanchor w -columnborderwidth 0 \
	    -selectmode browse -selectforeground $GUI(selectforeground) \
            -selectbackground $GUI(selectbackground) -labelborderwidth 2

   $w.f.list column add hops -label [mc Hops] -width 6
   $w.f.list column add desc -label [mc Description] -width 19

   Tree:create $w.f.tree -width 400 -yscrollcommand "$w.f.tscroll set"
   xscrollbar $w.f.tscroll -orient vertical -command "$w.f.tree yview"

   xgrid $w.f.tree 0 0 1 1 snew
   xgrid $w.f.tscroll 1 0 1 1 snew
   xgrid $w.f.list 0 1 2 1 snew

   grid rowconfigure $w.f 0 -weight 1
   grid columnconfigure $w.f 0 -weight 1

   $w.f.tree bind x <1> {
     set lbl [Tree:labelat %W %x %y]
     Tree:setselection %W $lbl
     LinksInfo $lbl
   }

   $w.f.tree bind x <3> {
     set lbl [Tree:labelat %W %x %y]
     Tree:setselection %W $lbl
     popup_links %W $lbl
   }

   bind $w <Destroy> "set tlinks {};"
   bind $w <Escape> "destroy $w"

   focus $w
}

proc DialogWin { title ltxt } {
   global GUI im_ok im_cancel var font
   
   # Check to see if window exists, if it does, exit.
   if {[winfo exists .dialogWin]} {return}
   
   toplevel .dialogWin -class Dialog
   wm title .dialogWin $title
   #wm geometry .dialogWin +200+200
   wm transient .dialogWin .
   
   set width [winfo reqwidth .]
   set height [winfo reqheight .]
 
   set x [expr { ( [winfo vrootwidth  .] - $width  ) / 2 }]
   set y [expr { ( [winfo vrootheight .] - $height ) / 2 }]
 
   wm geometry .dialogWin +${x}+${y}

   focus .dialogWin
   
   set var ""
   set ok ""
   
	frame .dialogWin.top -relief groove
		label .dialogWin.top.text -text $ltxt
		entry .dialogWin.top.entry -textvariable var -background white \
					-width 30 \
					-selectbackground $GUI(selectbackground) \
					-selectforeground $GUI(selectforeground)
					
	grid .dialogWin.top.text -column 0 -row 0  -padx 3p -pady 5p -sticky nse
	grid .dialogWin.top.entry -column 1 -row 0 -padx 3p -pady 5p -sticky nsw
	
	pack .dialogWin.top -side top -fill both -expand yes -pady 5p -padx 5p
	
	frame .dialogWin.bottom 
	
		button .dialogWin.bottom.cncl -text [mc Cancel] -bd 2 -command "destroy .dialogWin" -font $font(button)
		button .dialogWin.bottom.ok   -text [mc Ok] -bd 2 -command "set ok 1; destroy .dialogWin" -font $font(button)
		#xbutton .dialogWin.bottom.cncl -image $im_cancel -text [mc Cancel] -command "destroy .dialogWin" -font $font(button)
		#xbutton .dialogWin.bottom.ok   -image $im_ok -text [mc Ok] -command "set ok 1; destroy .dialogWin" -font $font(button)

	grid .dialogWin.bottom.cncl -column 0 -row 0 -padx 5p -pady 5p -ipadx 4p -ipady 2p -sticky nes
	grid .dialogWin.bottom.ok   -column 1 -row 0 -padx 5p -pady 5p -ipadx 6p -ipady 2p -sticky nes  
	
	pack .dialogWin.bottom -side bottom  -anchor se -pady 5p -padx 5p ;#-fill both -expand yes
	
	# Now we want to put the focus on the entryWidget.
	focus .dialogWin.top.text
	# gotta wait, or else we'll get an error
	tkwait variable ok
	return $var
	
	# Now make the bindings for the keyboard adept users.
	bind $w <Return> "set ok 1; destroy .dialogWin"
	bind $w <Escape> "destroy .dialogWin"
}
	

proc quitwin { w } {
        global im_ok im_cancel im_warning GUI font
        if {[winfo exists $w]} {return}
        set GUI(geometry) [winfo geometry .]
        SaveSettings
        set i 0
        set dcc 0
        while {$i<100} {
          if {[winfo exists ".dccget$i"]} {set dcc 1}
          incr i
        }
        if {!$dcc} {
           goto_exit
           return
        }
        toplevel $w -class Dialog
        wm title $w [mc "Quit savIRC"]
        wm geometry $w +200+200
        wm resizable $w 0 0
        wm transient $w .
        label $w.bm -image $im_warning -relief flat
        pack  $w.bm -pady 10 -side top -padx 10
        message $w.m -width 400 -aspect 300 \
                -text [format [mc "There are some DCC transfers in progress. %s Are you sure you want to quit?"] \n] -relief flat
        pack  $w.m -pady 10 -side top -padx 10
        set oldFocus [focus]
        frame $w.f
        xbutton $w.f.back -image $im_ok \
                -side left -text [mc Ok] -command "goto_exit" -font $font(button)
        xbutton $w.f.canc -image $im_cancel \
                -side left -text [mc Cancel] -command "destroy $w; focus $oldFocus" -font $font(button)
        pack $w.f.back $w.f.canc -side left -pady 5 -padx 45
        pack $w.f -pady 10 -side bottom -padx 5 -anchor w
        focus $w.f.back
        catch {grab $w}
        focus $w
}


proc GetChanKey {modes} {
 set i [string first "k:" $modes]
 set key ""
 if {$i!=-1} {
   set key [string range $modes [expr $i+2] end]
 }
 return $key
}

proc GetChanLimit { modes } {
 set i [string first "l:" $modes]
 set num ""
 if {$i!=-1} {
   set modes [string range $modes $i end]
   set k [string first "k" $modes]
   if {$k==-1} {
     set k "end"
   } else {
     incr k -2
   }
   set num [string range $modes 2 $k]
 }
 return $num
}




proc PutChanMode {state w m chan id} {
  global me modes active
  if {$state!="disabled"} {


  set limit [$w.f.modes.c.lf.limit get]
  set key [$w.f.modes.c.kf.key get]

  if {$modes($m)} {
     if {$m=="l"} {
        if {[string is integer -strict $limit]} {
           lappend m $limit
        } else {
           set modes(l) 0
           return
        }
     }
     if {$m=="k"} {
        if {$key!=""} {
           lappend m $key
        } else {
           set modes(k) 0
           return
        }
     }
     puts $me($id,sock) "MODE [Reverse $chan] +$m"
  } else {
     if {$m=="k"} {
       catch {
         set mode [.topbar.modes$active cget -text]
         set key [GetChanKey $mode]
         lappend m $key
       }
     }
     puts $me($id,sock) "MODE [Reverse $chan] -$m"
  }
  }
}

proc DelChanBan {state w chan id} {
  global me
  if {$state!="disabled"} {
     set ind [$w.listbox curselection]
     if {$ind==""} {return}
     set ban [$w.listbox get $ind]
     if {$ban!=""} {
        puts $me($id,sock) "MODE [Reverse $chan] -b $ban"
        $w.listbox delete 0 end
        IRC::mode $chan b
     }
  }
}


proc AddChanBan {state fb chan id} {
  global me
  if {$state!="disabled"} {
  set ban [Convert [$fb.entry get]]
  $fb.entry delete 0 end
  puts $me($id,sock) "MODE $chan +b [Reverse $ban]"
  $fb.listbox delete 0 end
  IRC::mode $chan b
  }
}

proc winsetcan { chan id } {
        global modes me active im_ok im_cancel GUI icons wid font
        set w ".chanset"
        if {[winfo exists $w]} {return}
        toplevel $w -class chanset
        wm title $w [format [mc "%s Settings"] [Reverse $chan]]
	wm resizable $w 0 0
        
	set opnick "@[::savirc::getNick $id]"
        set wchan [GetWindow $chan $id]
        $wid($wchan) raise
 
        if {[NickMode [::savirc::getNick $id] $active($id)]=="@"} {
          set state "normal"
        } else {
          set state "disabled"
        }

        set modeLS {i m n p s t}
        set mode [$wid($active($id),modes) cget -text]
        set md [lindex $mode 0]
        set limit [GetChanLimit $mode]
        set active_modes ""
        if {$limit!=""} { 
           set modes(l) 1
           lappend active_modes "l"
        } else {
           set modes(l) 0
        }

        set key [GetChanKey $mode]

        if {$key!=""} { 
           set modes(k) 1
           lappend active_modes "k"
        } else {
           set modes(k) 0
        }
        foreach m $modeLS {
          if {[string first $m $md]!=-1} {
              set modes($m) 1
              lappend active_modes "$m"
          } else {
              set modes($m) 0
          }
        }
        set topic [string trimright [$wid($active($id),topic) get 1.0 end] "\n"]

        pack [frame $w.f -bd 2] -fill x -expand yes
        frame $w.f.bar -bd 2

        set fm [LabelFrame:create $w.f.modes -text [mc "Channel Modes:"] -ipadx 5]
        set fb [LabelFrame:create $w.f.bans -text [mc "Channel Bans:"] -ipadx 5]

        frame $fm.lf
        frame $fm.kf
        set topic [CleanTopic $topic]  
        entry $w.f.topic -state disabled -background white -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground)
        $w.f.topic config -state normal
        $w.f.topic insert end $topic 
        $w.f.topic config -state $state
        checkbutton $fm.i  -state $state -text [mc "+i Invite"] -variable modes(i)
        checkbutton $fm.m  -state $state -text [mc "+m Moderated"] -variable modes(m)
        checkbutton $fm.n  -state $state -text [mc "+n No Ext. Messages"] -variable modes(n)
        checkbutton $fm.p  -state $state -text [mc "+p Private"] -variable modes(p)
        checkbutton $fm.s  -state $state -text [mc "+s Secret"] -variable modes(s)
        checkbutton $fm.t  -state $state -text [mc "+t Topic Limit"] -variable modes(t)
        checkbutton $fm.lf.l  -state $state -text [mc "+l User Limit"] -variable modes(l)
        set width [$fm.lf.l cget -width]
        checkbutton $fm.kf.k  -width $width -state $state -text [mc "+k Key"] -variable modes(k) 

        entry $fm.kf.key -state $state -width 14 -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground) -background white  
        entry $fm.lf.limit -state $state -width 10 -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground) -background white  
        $fm.kf.key config -state normal
        $fm.kf.key insert end $key
        $fm.kf.key config -state $state
        $fm.lf.limit config -state normal
        $fm.lf.limit insert end $limit
        $fm.lf.limit config -state $state

        frame $fb.bar

        listbox $fb.listbox -width 20 \
          -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground) \
          -xscrollcommand "$fb.lx set" -yscrollcommand "$fb.ly set" \
	  -foreground black -background white 

        xscrollbar $fb.lx -orient horizontal -command "$fb.listbox xview"
        xscrollbar $fb.ly -orient vertical -command "$fb.listbox yview"

        entry $fb.entry -state $state \
	  -foreground black -background white \
	  -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground)

        xbutton $fb.bar.add -state $state -image $icons(select) -side left -text [mc Add] -command "AddChanBan $state $fb $chan $id"
        xbutton $fb.bar.del -state $state -image $icons(delete) -side left -text [mc Remove] -command "DelChanBan $state $fb $chan $id"

        set_balloon $fb.bar.add [mc "Add the mask in the entry"]
        set_balloon $fb.bar.del [mc "Delete selected mask"]

        xbutton $w.f.bar.ok -image $im_ok -side left -text [mc Ok] -command "UpdateChanSet $w $chan $state {$topic} {$active_modes} {$key} $id; destroy $w $id" -font $font(button)

        grid config $w.f.topic -padx 5 -pady 5 -column 0 -row 0 -columnspan 2 -rowspan 1 -sticky "new"
        xgrid $w.f.modes 0 1 1 1 snw
        xgrid $w.f.bans 1 1 1 1 snew 
        grid config $w.f.bar -padx 5 -pady 5 -column 0 -row 2 -columnspan 2 -rowspan 1 -sticky "snew"

	grid rowconfigure $w.f 0 -weight 1
	grid rowconfigure $w.f 1 -weight 1
	grid columnconfigure $w.f 0 -weight 1
	grid columnconfigure $w.f 1 -weight 1

        xgrid $fm.i 0 1 1 1 snw
        xgrid $fm.m 0 2 1 1 snw
        xgrid $fm.n 0 3 1 1 snw
        xgrid $fm.p 0 4 1 1 snw
        xgrid $fm.s 0 5 1 1 snw
        xgrid $fm.t 0 6 1 1 snw
        xgrid $fm.kf 0 7 1 1 snw
        xgrid $fm.lf 0 8 1 1 snw
        pack $fm.lf.l $fm.lf.limit -side left
        pack $fm.kf.k $fm.kf.key -side left


        xgrid $fb.listbox 0 0 1 1 snew
        autoscroll $fb.lx "-in $fb -column 0 -row 1 -columnspan 1 -rowspan 1 -ipadx 0 -ipady 0 -padx 0 -pady 0 -sticky nesw"
        autoscroll $fb.ly "-in $fb -column 1 -row 0 -columnspan 1 -rowspan 1 -ipadx 0 -ipady 0 -padx 0 -pady 0 -sticky nesw"

        xgrid $fb.entry 0 2 2 1 snew
        grid config $fb.bar -column 0 -row 3 -columnspan 2 -rowspan 1 -sticky "snew" -pady 3


        pack $fb.bar.add -side left
        pack $fb.bar.del -side left -padx 4

        pack $w.f.bar.ok -pady 3 -side left
        bind $w.f.topic <Double-1> "ChanEditTopic $w $state"
        bind $w <Escape> "destroy $w"
        focus $w.f.bar.ok
        catch {grab $w}
        after 200 "IRC::mode $chan b"
}


proc UpdateChanSet {w chan state old_topic active_modes key id} {
      global modes

      if {$state=="disabled"} {return}

     set fm ".chanset.f.modes.f.f"
     set topic [$w.f.topic get]
     if {$topic!=$old_topic} {SvrSend "TOPIC [Reverse $chan] :$topic" $id}

     set key [$fm.kf.key get]
     set limit [$fm.lf.limit get]
     set mode ""
     set nomode ""
     foreach m $active_modes {
       if {!$modes($m)} {append nomode $m}
     }

     foreach m {i m n p s t k l} {
       if {$modes($m)} {
         append mode $m
       }
     }
     if {$modes(k)&&$key!=""} {
       lappend mode $key
     }

     if {$modes(l)&&$limit!=""} {
       lappend mode $limit
     }
  
     set change_mode "-$nomode+$mode"  
     if {[string first "k" $nomode]!=-1} {
        lappend change_mode $key
     }
     
     SvrSend "MODE [Reverse $chan] $change_mode" $id
}


proc ChanPutTopic {w chan state id} {
      global me
      if {$state!="disabled"} {
	 set topic [$w.f.topic get]

	 $w.f.topic config -cursor left_ptr
	 $w.f.topic config -state disabled
         puts $me($id,sock) "TOPIC [Reverse $chan] :$topic"
     }
}


proc ChanEditTopic {w state} {
      if {$state!="disabled"} {
      	
	 $w.f.topic config -state normal
	 $w.f.topic config -background white
         $w.f.topic config -foreground black
         $w.f.topic config -cursor hand2
         focus $w.f.topic
     }
}



proc goto_exit {} {
 global me icons wid
 set me(started) 0
 foreach id $me(sockslist) {
   catch {Disconnect $id}
 }

 catch {winico delete $icons(ico_savirc) }
 catch {winico delete $icons(ico_savred)} 

 if {[info exists me(help_pid)]} {
   catch { exec kill -9 $me(help_pid) }
 }
 $wid(status) config -closable 1
 $wid(status) close_win
 after 10 {
  exit
 }
}
  


proc Debug { w } {
        global debug
        toplevel $w -class Dialog
        wm title $w [mc "Debug Window"]
        #wm geometry $w +900+400
        wm resizable $w 0 0
        frame $w.fr
        text $w.fr.text -background "white" -yscrollcommand "$w.fr.texscroll set"
        xscrollbar $w.fr.texscroll -command "$w.fr.text yview" -orient vertical;
        pack $w.fr $w.fr.text $w.fr.texscroll -side left -fill y
       .debug.fr.text config -state disabled;

}


proc ColorTip {x y} {
    global MIRCcols
    if {!$MIRCcols(win)} {return}
    set w ".coltip"
    if {[winfo exists $w]} {return}
    toplevel $w -class Colortip
    wm overrideredirect $w 1
    pack [frame $w.f -bd 1]
    set y 0
    for {set x 0; set j 0} {$x < 16} {incr x; incr j} {
      if {$x==8} {set y 1; set j 0}
      label $w.f.c$x -width 2 -foreground white -background $MIRCcols($x) -text $x
      grid config $w.f.c$x -column $j -row $y -padx 1 -pady 1 -columnspan 1 -rowspan 1 -sticky "snw"
    }
    wm geometry $w +131+398
    wm resizable $w 0 0
    bind <KeyPress> .commandline.command { destroy $w }
}

if {$debug==1} {
   Debug ".debug"
}


proc SwitchWin {i} {
  global wid
  set wlist ""
  set wlist [winfo children .buttonbar.buttonbar]
  set w [lindex [split [lindex $wlist $i] "."] end]
  if {[info exists wid($w,text)]} {
     $wid($w) icon_cmd
  }
}



proc Mp3Editor {} {
     global me icons files GUI colsTXT misc mp3 wid

        set w "mp3"
        if {[winfo exists .main.$w]} {return}

        if {$GUI(maximized)} {
          set state "maximized"
        } else {
          set state "normal"
        }

        foreach {wid(x) wid(y) wid(width) wid(height)} [def_winset "Soundmanager" "Soundmanager"] {}
        set widm [document .main.$w -tooltip [mc "Sound Manager"] -title [mc "Sound Manager"] -icontext [mc "Sound Manager"] -image $icons(music2) -callback CloseChanFolder -minsize {345 200} -callback CheckMp3Lists -state $state]
        $widm pack [frame .main.$w.fr] -fill both -expand 1
        set frame .main.$w.fr

   if {[::platform::isPlatformUnix]} {
     xmclistbox $frame.list -fillcolumn file -yscrollcommand [list $frame.scrolly set] \
	    -bd 0 \
            -labelbg $GUI(widgets_color) \
	    -columnrelief flat \
	    -labelanchor w \
            -background white \
	    -columnborderwidth 0 \
	    -selectmode browse \
	    -selectforeground $GUI(selectforeground) \
	    -selectbackground $GUI(selectbackground) \
	    -labelborderwidth 2
   }
   if {[::platform::isPlatformWindows]} {
     mclistbox $frame.list -fillcolumn file -yscrollcommand [list $frame.scrolly set] \
	    -bd 0 \
            -labelbg $GUI(widgets_color) \
	    -columnrelief flat \
	    -labelanchor w \
            -background white \
	    -columnborderwidth 0 \
	    -selectmode browse \
	    -selectforeground $GUI(selectforeground) \
	    -selectbackground $GUI(selectbackground) \
	    -labelborderwidth 2
   }

   $frame.list column add file		-label [mc File] -width 20
   $frame.list column add filename	-label [mc Filename] -width 20 -visible 0
   $frame.list column add size		-label [mc Size] -width 12

   foreach item "file size" {
    $frame.list label bind $item <ButtonPress-1> "sort %W $item"
   }

   bind $frame.list <Double-1> "SoundSelected $frame.list"

   xscrollbar $frame.scrolly -orient vertical -command "$frame.list yview" 


   
   frame $frame.toolbar 
   tooltip $frame.toolbar.tip -delay 500

   toolbar $frame.toolbar.toolbar -state fixed
   $frame.toolbar.tip add [$frame.toolbar.toolbar add button c2 -image $icons(savelist) -command "SaveMp3List $frame.list"] [mc "Save List"]
   $frame.toolbar.tip add [$frame.toolbar.toolbar add button c1 -image $icons(addlist) -command "NewMp3List $frame.list $frame.status.lists"] [mc "New List"]
   $frame.toolbar.tip add [$frame.toolbar.toolbar add button c3 -image $icons(dellist) -command "DelMp3List $frame.status.lists $frame.list"] [mc "Delete current list"]
   $frame.toolbar.toolbar add separator sep3
   $frame.toolbar.tip add [$frame.toolbar.toolbar add button c6 -image $icons(adddir) -command "AddMp3Dir $frame.list"] [mc "Add directory to list"]
   $frame.toolbar.tip add [$frame.toolbar.toolbar add button c8 -image $icons(addfile) -command "AddMp3File $frame.list"] [mc "Add file to list"]
   $frame.toolbar.tip add [$frame.toolbar.toolbar add button c7 -image $icons(del) -command "DelMp3Files $frame.list"] [mc "Delete selected files"]
   $frame.toolbar.toolbar add separator sep4

   $frame.toolbar.tip add [$frame.toolbar.toolbar add button c12 -image $icons(previous) -command "PlayPreviousMp3"] [mc Previous]
   $frame.toolbar.tip add [$frame.toolbar.toolbar add button c9 -image $icons(play) -command "PlayMp3 1"] [mc Play]
   $frame.toolbar.tip add [$frame.toolbar.toolbar add button c10 -image $icons(pausa) -command "PausaMp3"] [mc Pause]
   $frame.toolbar.tip add [$frame.toolbar.toolbar add button c11 -image $icons(stop) -command "StopMp3"] [mc Stop]
   $frame.toolbar.tip add [$frame.toolbar.toolbar add button c13 -image $icons(next) -command "PlayNextMp3"] [mc Next]

   
   pack $frame.toolbar.toolbar -fill x -expand yes 

   frame $frame.status -bd 1 -relief flat



   combobox::combobox $frame.status.lists -editable 0 -width 14 -textvariable mp3(list) -background white -selectforeground $GUI(selectforeground) -selectbackground $GUI(selectbackground) -command "ChangeActiveMp3List;"
   checkbutton $frame.status.mode -text [mc Random]  -variable mp3(mode)
   checkbutton $frame.status.verbose -text [mc Verbose]  -variable mp3(verbose)

   label $frame.status.list -text [mc "Current List:"] 


   bind $frame.list <Button-1> "$widm raise"
   bind $frame.toolbar <Button-1> "$widm raise"
   bind $frame.status.list <Button-1> "$widm raise"
   bind $frame.status.lists <Button-1> "$widm raise"
   bind $frame.status.verbose <Button-1> "$widm raise"
   bind $frame.status.mode <Button-1> "$widm raise"


   pack $frame.status.list $frame.status.lists -side left
   pack $frame.status.verbose $frame.status.mode -side right
   
   

   xgrid $frame.toolbar 0 0 2 1 snew
   xgrid $frame.list 0 1 1 1 snew
   autoscroll $frame.scrolly "-in $frame -column 1 -row 1 -columnspan 1 -rowspan 1 -ipadx 0 -ipady 0 -padx 0 -pady 0 -sticky nesw"
   xgrid $frame.status 0 2 2 1 snew


   grid rowconfigure $frame 0 -weight 0
   grid rowconfigure $frame 1 -weight 1
   grid rowconfigure $frame 2 -weight 0
   grid rowconfigure $frame 3 -weight 0
   grid columnconfigure $frame 0 -weight 1
   grid columnconfigure $frame 1 -weight 0


   AddMp3Lists $frame.status.lists
   LoadMp3Lists $frame.list $frame.status.lists

   update idletasks

}


proc GroupBSeparator {name} {
    if {[winfo exists .buttonbar.buttonbar.separator$name]} {return} 	 
    frame .buttonbar.buttonbar.separator$name -border 1 -relief sunken -width 2 -height 20
}

proc GroupButtons {} {
  global me GUI

  array set windows ""
  set windows(misc) ""
  foreach w [winfo children .buttonbar.buttonbar] {
	set win [lindex [split $w "."] end]
        if {$win=="status"} {continue}
	pack forget $w
        set id [GetWindowID $win]
	if {![Isinteger $id]} {
		if {[string first "separator" $win]!=0} {lappend windows(misc) $w}
	} else {
		if {![info exists windows($id)]} {set windows($id) ""}
		lappend windows($id) $w
        }	
  }
   
  foreach id $me(sockslist) {
	if {![info exists windows($id)]} {continue}
	if {[llength $windows($id)]==0} {continue}
        GroupBSeparator $id
        pack .buttonbar.buttonbar.separator$id -side left -padx 2 -pady 3 
	foreach w $windows($id) {
            pack $w -side left -padx 2 -pady 0
	}
  } 	 
  if {$windows(misc)!=""} {
    GroupBSeparator "misc"
    pack .buttonbar.buttonbar.separatormisc -side left -padx 2 -pady 3 
    foreach w $windows(misc) {
  	pack $w -side left -padx 2 -pady 0
    } 
  } 
}


##### created separate namespace for savirc tool widgets

namespace eval sav_ui {
  proc TextInputWindow {title text retvar buttons} {
    # returns one of the supplied button names,
    # or 'close' when the window was not closed by one of the user-suplpied buttons (wm)

    set w .textinput
    if {[winfo exists $w]} {return}  
    
    global me
    variable textinput_result 
    variable textinput_event

    upvar $retvar upretvar
    
    set textinput_event "close" ;#default when no specified button pressed
    set textinput_result ""
   
    toplevel $w -class TextInput
    wm title $w $title
    wm transient $w .

    set width [winfo reqwidth .]
    set height [winfo reqheight .]
    set x [expr { ( [winfo vrootwidth  .] - $width  ) / 2 }]
    set y [expr { ( [winfo vrootheight .] - $height ) / 2 }]
  
    wm geometry $w +${x}+${y}

    frame $w.top
    frame $w.edit
    frame $w.bottom
   
    label $w.top.text -text $text
    pack $w.top.text -side top -fill both -padx 15 -pady 10

    entry $w.edit.entry -textvariable sav_ui::textinput_result -background white
    pack $w.edit.entry -side top -fill both -padx 5 -pady 5
  
    grid $w.bottom
    set i 0
    foreach button $buttons {
      xbutton $w.bottom.$button -padx 2 -pady 2 -text "$button" -command "set sav_ui::textinput_event $button; destroy $w" \
      pack $w.bottom.$button -side left -padx 1
    
      grid config $w.bottom.$button -column $i -row 0 -sticky "snew"
      incr i
    }

    grid rowconfigure $w.bottom 0 -weight 1
    
    pack $w.top -fill both -expand 1
    pack $w.edit -fill both -expand 1
    pack $w.bottom -pady 5 -fill x -expand 1
    
    focus $w.edit.entry
    grab $w
    tkwait window $w
    
    set upretvar $textinput_result
    
    return $textinput_event
  }
}

